#!/bin/csh -f 

#
# Dump.csh - dump registration info for a built model whose source code is the arg file
# 

#
# Initialization
#
setenv CLSI /usr/local/clsi
setenv VTIP $CLSI/vtip
setenv RVCGR $CLSI/rvcgr
setenv LM_LICENSE_FILE $VTIP/license/license.dat
source $VTIP/com/setupvtip
source $RVCGR/setuprvcgr.csh

set CmdName=`basename ${0} .csh`

#
#
#	Check parameter and set file names
#
if ( $#argv != 1 ) then
	echo "Error: $CmdName requires VHDL source file as parameter"
	exit 1
endif
set VHDLFile=$1
set ModelName=`basename $VHDLFile .vhdl`
set ModelName=`basename $ModelName .vhd`

#
# dump model
#
$ModelName.sim -dump |& /users/projects/vsim/com/sifilter | cat

exit 0

