#!/bin/csh -f 

#
# Simulate.csh - select top level unit for given VHDL source and link with kernel
# for a VHDL file which has been compiled
# 

#
# Initialization
#
setenv CLSI /usr/local/clsi
setenv VTIP $CLSI/vtip
setenv RVCGR $CLSI/rvcgr
setenv LM_LICENSE_FILE $VTIP/license/license.dat
source $VTIP/com/setupvtip
source $RVCGR/setuprvcgr.csh

set CmdName=`basename ${0} .csh`

#
#
#	Check parameter and set file names
#
if ( $#argv != 1 ) then
	echo "Error: $CmdName requires VHDL source file as parameter"
	exit 1
endif
set VHDLFile=$1
set ModelName=`basename $VHDLFile .vhdl`
set ModelName=`basename $ModelName .vhd`

#
# simulate model
#
$ModelName.sim

exit 0

