#ifndef VLCodeIntfP_H
#define VLCodeIntfP_H
/* *******************************************************************
*
* Copyright (c) 1989 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* HEADER FILE: VLCodeIntfP.h
*
* DESCRIPTION:  
*	Public (to generated code) interface for RVCG run-time library 
*	support routines for generated code interface module of VKI 
*	(VKCodeIntf).
*
* CONSTANTS:
*	<constants>	<constants defined in this header file >
*
* TYPES:
*	<types>		<types defined in this header file >
*
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this header file >
*
* ROUTINES:
*	...
*
* HISTORY:
* 	12-APR-91 DSB	Created
*	17-MAY-91 DSB	Added VL_tResumptionPoint (from old VLProcCtrlP.h)
*
* SCCS ID: @(#)VLCodeIntfP.h	35.1 12/24/91
*
******************************************************************* */

#include "VKI.h"
#include "VKCodeIntf.h"		/* for VC_ResolveSignal/VC_ConvertSignal 
					decls.; for PCB types */

/* Note: VKI contains interface definition for VC_RunProcess_Function */

typedef int VL_tResumptionPoint;

/* *******************************************************************
*
* Process context management macros for generated code
*
* NOTES:
*	Used by generated code; PRIVATE with respect to kernel
*
******************************************************************* */

#define VL_SetCurrentProc(pcp, exec_func, exec_LARP) \
	(((pcp)->function = (VK_tExecFnPtr) exec_func), \
	((pcp)->act_rec_ptr = (VK_tLARHeaderPtr) exec_LARP))
					/* set current procedure or process */

#define VL_CreateProcessContext(rootaddr, callee_function, callee_LARP) \
	(VL_SetCurrentProc(rootaddr, callee_function, callee_LARP), \
	(rootaddr)->suspended = False, \
	rootaddr)			/* initialize process context block */

#define VL_SetCall(pcp, save_addr, callee_function, callee_LARP) \
	(((save_addr)->function = (pcp)->function), \
	((save_addr)->act_rec_ptr = (pcp)->act_rec_ptr), \
	(VL_SetCurrentProc(pcp, callee_function, callee_LARP)))
					/* save and set for procedure call */

#define VL_SetReturn(pcp, save_addr) \
	VL_SetCurrentProc(pcp, (save_addr)->function, \
		(save_addr)->act_rec_ptr)
					/* restore for procedure return */

#define VL_SetWait(pcp) ((pcp)->suspended = True)
					/* set suspension bit for wait */





#endif /* VLCodeIntfP_H */
