#ifndef VLMathOpsP_H
#define VLMathOpsP_H
/* ******************************************************************
* 
* Copyright 1987-90 by CAD Language Systems, Inc.  All rights reserved. 
* 
* HEADER FILE:	VLMathOpsP.h
* 
* DESCRIPTION:
* 	<Description>
* 
* CONSTANTS:
* 	<Constants>
*
* TYPES:
* 	<Types>
*
* GLOBAL VARIABLES:
* 	<Global Vars>
* 
* ROUTINES:
*   Module-external:
* 	<Routines>
* 
*   Module-internal:
* 	<Routines>
* 
* HISTORY:
* 	14-SEP-90 GJB	Created
*	12-APR-91 DSB	Applied VK_tIntegerValue (vs. VK_tIntegerData)
*	30-APR-91 DSB	Changed old VL_tIntegerType to VK_tIntegerData/-Value
*	30-APR-91 DSB	Added VL_TypeConvFloatToInt to fix neg. rounding bug
*	12-JUN-91 DSB	??
*	05-AUG-91 DSB	Added RTL functions for many more VHDL operations
*	05-NOV-91 DSB	Added missing declarations to header file
*
* SCCS ID: @(#)VLMathOpsP.h	35.1 12/24/91
* 
****************************************************************** */

#include "VLConfigP.h"		/* for VK_ANSI_FN_PROTOS */
#include "VLDataP.h"		/* ... */

VK_tIntegerValue VL_PredefIntPlusInt(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerValue left,
	VK_tIntegerValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tIntegerValue VL_PredefPhysPlusPhys(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerValue left,
	VK_tIntegerValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tFloatingValue VL_PredefFloatPlusFloat(
#ifdef VK_ANSI_FN_PROTOS
	VK_tFloatingValue left,
	VK_tFloatingValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

void VL_PredefLargePlusLarge(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr sum_addr,
	VK_tLargeAddr left_addr,
	VK_tLargeAddr right_addr
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tIntegerValue VL_PredefIntMinusInt(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerValue left,
	VK_tIntegerValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tIntegerValue VL_PredefPhysMinusPhys(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerValue left,
	VK_tIntegerValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tFloatingValue VL_PredefFloatMinusFloat(
#ifdef VK_ANSI_FN_PROTOS
	VK_tFloatingValue left,
	VK_tFloatingValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

void VL_PredefLargeMinusLarge(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr diff_addr,
	VK_tLargeAddr left_addr,
	VK_tLargeAddr right_addr
#endif /* VK_ANSI_FN_PROTOS */
	);


VK_tIntegerValue VL_PredefIntTimesInt(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerValue left,
	VK_tIntegerValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tFloatingValue VL_PredefFloatTimesFloat(
#ifdef VK_ANSI_FN_PROTOS
	VK_tFloatingValue left,
	VK_tFloatingValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tIntegerValue VL_PredefPhysTimesInt(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerValue left,
	VK_tIntegerValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tIntegerValue VL_PredefIntTimesPhys(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerValue left,
	VK_tIntegerValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tIntegerValue VL_PredefPhysTimesFloat(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerValue left,
	VK_tFloatingValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tIntegerValue VL_PredefFloatTimesPhys(
#ifdef VK_ANSI_FN_PROTOS
	VK_tFloatingValue left,
	VK_tIntegerValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

void VL_PredefLargeTimesInt(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr product_addr,
	VK_tLargeAddr large_addr,
	VK_tIntegerValue integer
#endif /* VK_ANSI_FN_PROTOS */
	);

void VL_PredefIntTimesLarge(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr product_addr,
	VK_tIntegerValue integer,
	VK_tLargeAddr large_addr
#endif /* VK_ANSI_FN_PROTOS */
	);

void VL_PredefLargeTimesFloat(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr product_addr,
	VK_tLargeAddr large_addr,
	VK_tFloatingValue real
#endif /* VK_ANSI_FN_PROTOS */
	);

void VL_PredefFloatTimesLarge(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr product_addr,
	VK_tFloatingValue real,
	VK_tLargeAddr large_addr
#endif /* VK_ANSI_FN_PROTOS */
	);


VK_tIntegerValue VL_PredefIntModInt(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerValue left,
	VK_tIntegerValue right
#endif /* VK_ANSI_FN_PROTOS */
	);


VK_tIntegerValue VL_PredefIntRemInt(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerValue left,
	VK_tIntegerValue right
#endif /* VK_ANSI_FN_PROTOS */
	);


VK_tIntegerValue VL_PredefIntDivInt(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerValue left,
	VK_tIntegerValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tFloatingValue VL_PredefFloatDivFloat(
#ifdef VK_ANSI_FN_PROTOS
	VK_tFloatingValue left,
	VK_tFloatingValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tIntegerValue VL_PredefPhysDivPhys(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerValue left,
	VK_tIntegerValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tIntegerValue VL_PredefPhysDivInt(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerValue left,
	VK_tIntegerValue right
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tIntegerValue VL_PredefPhysDivFloat(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerValue dividend,
	VK_tFloatingValue divisor
#endif /* VK_ANSI_FN_PROTOS */
	);

void VL_PredefLargeDivLarge(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerData * quotient_addr,
	VK_tLargeAddr dividend_addr,
	VK_tLargeAddr divisor_addr
#endif /* VK_ANSI_FN_PROTOS */
	);

void VL_PredefLargeDivInt(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr quotient_addr,
	VK_tLargeAddr dividend_addr,
	VK_tIntegerValue divisor
#endif /* VK_ANSI_FN_PROTOS */
	);

void VL_PredefLargeDivFloat(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr quotient_addr,
	VK_tLargeAddr dividend_addr,
	VK_tFloatingValue divisor
#endif /* VK_ANSI_FN_PROTOS */
	);


VK_tIntegerValue VL_PredefIntExpInt(
#ifdef VK_ANSI_FN_PROTOS
	VK_tIntegerValue base,
	VK_tIntegerValue exp
#endif /* ANSI_FN_PROTOS */
);


VK_tFloatingValue VL_PredefFloatExpInt(
#ifdef VK_ANSI_FN_PROTOS
	VK_tFloatingValue base,
	VK_tIntegerValue exp
#endif /* VK_ANSI_FN_PROTOS */
	);

/*
  VL_TypeConvFloatToInt - do VHDL type conversion from floating to integer type
  DESCRIPTION:
	Macro to round reals to integer for a type conversion to a floating
	type.
	(Macro for now; later, probably function to report errors.)
  ALGORITHM:
	Save expression value to avoid multiple evaluation.
	If value is positive, add 0.5 and truncate using C type cast.
	If value is negative, subtract 0.5 and truncate (toward zero) using
	C type cast.
  DECLARATION:
    VK_tIntegerValue VL_TypeConvFloatToInt(
	&VK_FloatingData temp, 		-- lvalue(?) for temporary
	VK_tFloatingValue float_expr)	-- floating type expression

*/
#define VL_TypeConvFloatToInt(temp, float_expr) \
	((temp) = (float_expr), \
	(temp) >= 0 ? ((VK_tIntegerValue) (float_expr + 0.5)) : \
		     ((VK_tIntegerValue) (float_expr - 0.5)) )



void VL_CvtIntegerToLarge(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr out_addr,
	VK_tIntegerValue in
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tIntegerValue VL_CvtLargeToInteger(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr in_addr
#endif /* VK_ANSI_FN_PROTOS */
	);

void VL_PredefLargeNegate(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr out_addr,
	VK_tLargeAddr in_addr
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tBoolean VL_LargeEqualTo(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr left_addr,
	VK_tLargeAddr right_addr
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tBoolean VL_LargeNotEqual(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr left_addr,
	VK_tLargeAddr right_addr
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tBoolean VL_LargeLessThan(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr left_addr,
	VK_tLargeAddr right_addr
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tBoolean VL_LargeLessEqual(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr left_addr,
	VK_tLargeAddr right_addr
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tBoolean VL_LargeGreaterThan(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr left_addr,
	VK_tLargeAddr right_addr
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tBoolean VL_LargeGreaterEqual(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr left_addr,
	VK_tLargeAddr right_addr
#endif /* VK_ANSI_FN_PROTOS */
	);

void VL_PredefLargeAbs(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr out_addr,
	VK_tLargeAddr in_addr
#endif /* VK_ANSI_FN_PROTOS */
	);

VK_tBoolean VL_CvtStringToLarge(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLargeAddr out_addr,
	VK_tCString in
#endif /* VK_ANSI_FN_PROTOS */
	);

void VL_CvtLargeToString(
#ifdef VK_ANSI_FN_PROTOS
	VK_tCString out_addr,		/* address of C string (length 21) */
	VK_tLargeAddr in_addr
#endif /* VK_ANSI_FN_PROTOS */
	);


#endif /* VLMathOpsP_H */



