#ifndef VLMiscP_H
#define VLMiscP_H
/* *******************************************************************
*
* Copyright (c) 1989 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* HEADER FILE: VLMiscP.h
*
* DESCRIPTION:  
*	RVCG run-time library miscellaneous functions (instantiation and
*	error reporting).
*
* CONSTANTS:
*	<constants>	<constants defined in this header file >
*
* TYPES:
*	<types>		<types defined in this header file >
*
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this header file >
*
* ROUTINES:
*	...
*
* HISTORY:
* 	14-SEP-90 GJB	Created from VCGRTL.h
*	  -APR-91 DSB	Applying VKI changes (new types, mainly)
*	25-JUL-91 DSB	Removed VL_InstantiateComponent
*
* SCCS ID: @(#)VLMiscP.h	35.3 1/13/92
*
******************************************************************* */

#include "VKI.h"		/* for simulator kernel interface */
#include "VLDataP.h"		/* for ?? */


/* *******************************************************************
*
* Library types for configuration
*
* HISTORY:
*	16-JUL-91 DSB	Defined VL_tStandardEntityIAR in terms of VK_tTopIAR
*	08-AUG-91 DSB	Removed VL_tStandardEntityIAR and VK_tTopIAR reference 
*
******************************************************************* */

typedef VK_tVoidPtr VL_tConfigFn(
#ifdef VK_ANSI_FN_PROTOS
	VK_tInteger id		/* ?? formalize beyond VK_tInteger ?? */
#endif
	);			/* returns VL_tConfigFnPtr or 
				   VK_tGenericElabFnPtr */

typedef VL_tConfigFn * VL_tConfigFnPtr;


/* *******************************************************************
*
* VL_ReportCodeError - 
*
******************************************************************* */

void VL_ReportCodeError(
#ifdef VK_ANSI_FN_PROTOS
	VK_tLARHeaderPtr current_region_data,
	VK_tVHDLErrorCode error_code,
	VK_tCString message_string,
	VK_tCString extra_string			
#endif /* VK_ANSI_FN_PROTOS */
	);


/* *******************************************************************
*
* These appear unused ??? MNP 911202
*
******************************************************************* */

#if 0000

void VL_MiscErrorOld(
#ifdef VK_ANSI_FN_PROTOS
	char * message_string
#endif /* ANSI_FN_PROTOS */
	);


void VL_MiscError(
#ifdef VK_ANSI_FN_PROTOS
	char * error_string,
	char * extra_string,
	int line_number,
	VK_tUnitSymbInfo * unit_data
#endif /* ANSI_FN_PROTOS */
	);

#endif

#endif /* VLMiscP_H */
