/*ident	"@(#)ctrans:incl-master/proto-headers/assert.h	1.6" */

/* This header file intentionally has no wrapper, since the user
*  may want to re-include it to turn off/on assertions for only
*  a portion of the source file.
*/


#ifndef __LIBC_H
#include <libc.h>
#endif

#include <iostream.h>

#ifdef assert
#undef assert
#endif
#ifdef _assert
#undef _assert
#endif

#ifdef NDEBUG
#define assert(e) ((void)0)
#else
#if defined(__STDC__) && __STDC__
#define assert(EX) (void)((EX) || ((cerr << "Assertion failed: " # EX ", file " << __FILE__ << ", line " << __LINE__ << endl), abort(), 0))
#else
#define assert(EX) (void)((EX) || ((cerr << "Assertion failed: EX, file " << __FILE__ << ", line " << __LINE__ << endl), abort(), 0))
#endif
#endif

#define _assert(e) assert(e)

#ifdef NDEBUG
#define trace(e) ((void)0)
#else
#if defined(__STDC__) && __STDC__
#define trace(EX) (void)((cerr << "Trace: " # EX " in file " << __FILE__ << " at line " << __LINE__ << " is " << EX <<  endl), 0)
#else
#define trace(EX) (void)((cerr << "Trace: EX in file " << __FILE__ << " at line " << __LINE__ << " is " << EX <<endl),0)
#endif
#endif

#define _trace(e) trace(e)

#ifdef NMSG
#define mesg(e) ((void)0)
#else
#if defined(__STDC__) && __STDC__
#define mesg(EX) (void)((cerr << "Mesg: " # EX " in file " << __FILE__ << " at line " << __LINE__ <<  endl), 0)
#else
#define mesg(EX) (void)((cerr << "Message: EX in file " << __FILE__ << " at line " << __LINE__ <<endl),0)
#endif
#endif

#define _mesg(e) mesg(e)



