# rtl.make - rtl make file
#
# SCCS ID: @(#)rtl.make	35.1 12/24/91 
#
# HISTORY:
#	08-SEP-91 AWH	Handcrafted to work with PaulG's Makefile
#			system.

src = $(cgl_src)/
obj = $(cgl_obj)/
ksrc = $(cgk_src)/

RTLlib = $(obj)libVCGRTL.a

CFLAGS = $(GLOBAL_CFLAGS) -I$(ksrc) -pg
LINKFLAGS = $(GLOBAL_LINKFLAGS)


OBJECTS = \
	$(obj)STANDARD-body$(objsfx) \
	$(obj)STANDARD$(objsfx) \
	$(obj)VLData$(objsfx) \
	$(obj)VLLogOps$(objsfx) \
	$(obj)VLMath$(objsfx) \
	$(obj)VLMathOps$(objsfx) \
	$(obj)VLMisc$(objsfx) \
	$(obj)VLCodeIntf$(objsfx) \
	$(obj)conversions$(objsfx) \
	$(obj)conversions-body$(objsfx) \
	$(obj)textio$(objsfx) \
	$(obj)textio-body$(objsfx) 


default:	$(RTLlib)

$(RTLlib): $(OBJECTS)
	$(AR) $@ $?
	$(RANLIB) $@

# For now, don't automatically generated conversions.c.  It is generated 
#	manually from conversions.vhdl and conversions.vhdlview.


# Don't automatically generate conversions-body.c 
# It is hand-editted so never regenerate it automatically 


# For now, don't automatically generated textio.c.  It is generated 
#	manually from textio.vhdl and textio.vhdlview.

# For now, don't automatically generated textio-body.c.  It is generated 
#	manually from textio-body.vhdl and textio-body.vhdlview.

# Current manual steps:
# * conversions.c
#	Analyze RTL's conversions.vhdl to get conversions.vhdlview
#	Use conversions.vhdlview to generate conversions-g.c
#	Rename conversions-g.c to conversions.c
#       HAND EDIT vhdl source file name
# * conversions-body.c
#	Analyze conversions-body.vhdl to get conversions-body.vhdlview
#	Generate conversions-body-g.c from conversions-body.vhdlview
#	HAND EDIT conversions-body-g.c as specified in comments in 
#		conversions-body.vhdl
#	Rename edited conversions-body-g.c to conversions-body.c
#       HAND EDIT vhdl source file name
#
# * textio.c
#	Use VTIP's textio.vhdlview to generate textio-g.c
#	Rename textio-g.c to textio.c
#       HAND EDIT vhdl source file name
#
# * textio-body.c
#	Analyze RTL's textio-body.vhdl to get textio-body.vhdl 
#           ( requires conversions to be analyzed )
#	Use textio-body.vhdlview to generate textio-body-g.c
#	Rename textio-body-g.c to textio-body.c
#       HAND EDIT vhdl source file name
#
# *** We need to put the manually-run stuff in some other place, so that
#	we can separate the source we ship in the source kit (and RVCG object
#	release) from the source we need for development.  (E.g., 
#	textio-body.vhdl is needed for our development, but not for the source
#	releases.)


#
# Special Targets
#
gendep : 
	$(dt_pmake)/UpdateMakefile.sh\
        rtl.make $(src) -I$(ksrc) -ignoreothers -action \
	"src=$(src)" "ksrc=$(ksrc)" 


clean :
	$(CLEAN) $(OBJECTS) \
	$(RTLlib)


# GenDependencies -- Beginning of Dependencies --

$(obj)STANDARD-body$(objsfx) : \
		$(ksrc)VKBasicTypes.h \
		$(ksrc)VKCodeIntf.h \
		$(ksrc)VKConfig.h \
		$(ksrc)VKFiles.h \
		$(ksrc)VKI.h \
		$(ksrc)VKMisc.h \
		$(ksrc)VKProcesses.h \
		$(ksrc)VKRegister.h \
		$(ksrc)VKSignals.h \
		$(ksrc)VKSymbTypes.h \
		$(ksrc)VKTrace.h \
		$(src)STANDARD-body.c \
		$(src)STANDARD.h \
		$(src)VLCodeIntfP.h \
		$(src)VLConfigP.h \
		$(src)VLDataP.h \
		$(src)VLI.h \
		$(src)VLLogOpsP.h \
		$(src)VLMathOpsP.h \
		$(src)VLMiscP.h 
	$(CC) $(src)STANDARD-body.c -o $@ $(CFLAGS)

$(obj)STANDARD$(objsfx) : \
		$(ksrc)VKBasicTypes.h \
		$(ksrc)VKCodeIntf.h \
		$(ksrc)VKConfig.h \
		$(ksrc)VKFiles.h \
		$(ksrc)VKI.h \
		$(ksrc)VKMisc.h \
		$(ksrc)VKProcesses.h \
		$(ksrc)VKRegister.h \
		$(ksrc)VKSignals.h \
		$(ksrc)VKSymbTypes.h \
		$(ksrc)VKTrace.h \
		$(src)STANDARD.c \
		$(src)STANDARD.h \
		$(src)VLCodeIntfP.h \
		$(src)VLConfigP.h \
		$(src)VLDataP.h \
		$(src)VLI.h \
		$(src)VLLogOpsP.h \
		$(src)VLMathOpsP.h \
		$(src)VLMiscP.h 
	$(CC) $(src)STANDARD.c -o $@ $(CFLAGS)

$(obj)VLCodeIntf$(objsfx) : \
		$(ksrc)VKBasicTypes.h \
		$(ksrc)VKCodeIntf.h \
		$(ksrc)VKConfig.h \
		$(ksrc)VKFiles.h \
		$(ksrc)VKI.h \
		$(ksrc)VKMisc.h \
		$(ksrc)VKProcesses.h \
		$(ksrc)VKRegister.h \
		$(ksrc)VKSignals.h \
		$(ksrc)VKSymbTypes.h \
		$(ksrc)VKTrace.h \
		$(src)VLCodeIntf.c \
		$(src)VLCodeIntf.h \
		$(src)VLCodeIntfP.h \
		$(src)VLConfigP.h \
		$(src)VLDataP.h \
		$(src)VLMiscP.h 
	$(CC) $(src)VLCodeIntf.c -o $@ $(CFLAGS)

$(obj)VLData$(objsfx) : \
		$(ksrc)VKBasicTypes.h \
		$(ksrc)VKCodeIntf.h \
		$(ksrc)VKConfig.h \
		$(ksrc)VKFiles.h \
		$(ksrc)VKI.h \
		$(ksrc)VKMisc.h \
		$(ksrc)VKProcesses.h \
		$(ksrc)VKRegister.h \
		$(ksrc)VKSignals.h \
		$(ksrc)VKSymbTypes.h \
		$(ksrc)VKTrace.h \
		$(src)VLConfigP.h \
		$(src)VLData.c \
		$(src)VLData.h \
		$(src)VLDataP.h \
		$(src)VLMathOps.h \
		$(src)VLMathOpsP.h 
	$(CC) $(src)VLData.c -o $@ $(CFLAGS)

$(obj)VLLogOps$(objsfx) : \
		$(ksrc)VKBasicTypes.h \
		$(ksrc)VKCodeIntf.h \
		$(ksrc)VKConfig.h \
		$(ksrc)VKFiles.h \
		$(ksrc)VKI.h \
		$(ksrc)VKMisc.h \
		$(ksrc)VKProcesses.h \
		$(ksrc)VKRegister.h \
		$(ksrc)VKSignals.h \
		$(ksrc)VKSymbTypes.h \
		$(ksrc)VKTrace.h \
		$(src)VLConfigP.h \
		$(src)VLDataP.h \
		$(src)VLLogOps.c \
		$(src)VLLogOps.h \
		$(src)VLLogOpsP.h 
	$(CC) $(src)VLLogOps.c -o $@ $(CFLAGS)

$(obj)VLMath$(objsfx) : \
		$(ksrc)VKBasicTypes.h \
		$(ksrc)VKCodeIntf.h \
		$(ksrc)VKConfig.h \
		$(ksrc)VKFiles.h \
		$(ksrc)VKI.h \
		$(ksrc)VKMisc.h \
		$(ksrc)VKProcesses.h \
		$(ksrc)VKRegister.h \
		$(ksrc)VKSignals.h \
		$(ksrc)VKSymbTypes.h \
		$(ksrc)VKTrace.h \
		$(src)VLMath.c \
		$(src)VLMath.h 
	$(CC) $(src)VLMath.c -o $@ $(CFLAGS)

$(obj)VLMathOps$(objsfx) : \
		$(ksrc)VKBasicTypes.h \
		$(ksrc)VKCodeIntf.h \
		$(ksrc)VKConfig.h \
		$(ksrc)VKFiles.h \
		$(ksrc)VKI.h \
		$(ksrc)VKMisc.h \
		$(ksrc)VKProcesses.h \
		$(ksrc)VKRegister.h \
		$(ksrc)VKSignals.h \
		$(ksrc)VKSymbTypes.h \
		$(ksrc)VKTrace.h \
		$(src)VLConfigP.h \
		$(src)VLDataP.h \
		$(src)VLMath.h \
		$(src)VLMathOps.c \
		$(src)VLMathOps.h \
		$(src)VLMathOpsP.h 
	$(CC) $(src)VLMathOps.c -o $@ $(CFLAGS)

$(obj)VLMisc$(objsfx) : \
		$(ksrc)VKBasicTypes.h \
		$(ksrc)VKCodeIntf.h \
		$(ksrc)VKConfig.h \
		$(ksrc)VKFiles.h \
		$(ksrc)VKI.h \
		$(ksrc)VKMisc.h \
		$(ksrc)VKProcesses.h \
		$(ksrc)VKRegister.h \
		$(ksrc)VKSignals.h \
		$(ksrc)VKSymbTypes.h \
		$(ksrc)VKTrace.h \
		$(src)VLConfigP.h \
		$(src)VLDataP.h \
		$(src)VLMisc.c \
		$(src)VLMisc.h \
		$(src)VLMiscP.h 
	$(CC) $(src)VLMisc.c -o $@ $(CFLAGS)

$(obj)conversions-body$(objsfx) : \
		$(ksrc)VKBasicTypes.h \
		$(ksrc)VKCodeIntf.h \
		$(ksrc)VKConfig.h \
		$(ksrc)VKFiles.h \
		$(ksrc)VKI.h \
		$(ksrc)VKMisc.h \
		$(ksrc)VKProcesses.h \
		$(ksrc)VKRegister.h \
		$(ksrc)VKSignals.h \
		$(ksrc)VKSymbTypes.h \
		$(ksrc)VKTrace.h \
		$(src)STANDARD.h \
		$(src)VLCodeIntfP.h \
		$(src)VLConfigP.h \
		$(src)VLDataP.h \
		$(src)VLI.h \
		$(src)VLLogOpsP.h \
		$(src)VLMathOpsP.h \
		$(src)VLMiscP.h \
		$(src)conversions-body.c 
	$(CC) $(src)conversions-body.c -o $@ $(CFLAGS)

$(obj)conversions$(objsfx) : \
		$(ksrc)VKBasicTypes.h \
		$(ksrc)VKCodeIntf.h \
		$(ksrc)VKConfig.h \
		$(ksrc)VKFiles.h \
		$(ksrc)VKI.h \
		$(ksrc)VKMisc.h \
		$(ksrc)VKProcesses.h \
		$(ksrc)VKRegister.h \
		$(ksrc)VKSignals.h \
		$(ksrc)VKSymbTypes.h \
		$(ksrc)VKTrace.h \
		$(src)STANDARD.h \
		$(src)VLCodeIntfP.h \
		$(src)VLConfigP.h \
		$(src)VLDataP.h \
		$(src)VLI.h \
		$(src)VLLogOpsP.h \
		$(src)VLMathOpsP.h \
		$(src)VLMiscP.h \
		$(src)conversions.c 
	$(CC) $(src)conversions.c -o $@ $(CFLAGS)

$(obj)textio-body$(objsfx) : \
		$(ksrc)VKBasicTypes.h \
		$(ksrc)VKCodeIntf.h \
		$(ksrc)VKConfig.h \
		$(ksrc)VKFiles.h \
		$(ksrc)VKI.h \
		$(ksrc)VKMisc.h \
		$(ksrc)VKProcesses.h \
		$(ksrc)VKRegister.h \
		$(ksrc)VKSignals.h \
		$(ksrc)VKSymbTypes.h \
		$(ksrc)VKTrace.h \
		$(src)STANDARD.h \
		$(src)VLCodeIntfP.h \
		$(src)VLConfigP.h \
		$(src)VLDataP.h \
		$(src)VLI.h \
		$(src)VLLogOpsP.h \
		$(src)VLMathOpsP.h \
		$(src)VLMiscP.h \
		$(src)textio-body.c 
	$(CC) $(src)textio-body.c -o $@ $(CFLAGS)

$(obj)textio$(objsfx) : \
		$(ksrc)VKBasicTypes.h \
		$(ksrc)VKCodeIntf.h \
		$(ksrc)VKConfig.h \
		$(ksrc)VKFiles.h \
		$(ksrc)VKI.h \
		$(ksrc)VKMisc.h \
		$(ksrc)VKProcesses.h \
		$(ksrc)VKRegister.h \
		$(ksrc)VKSignals.h \
		$(ksrc)VKSymbTypes.h \
		$(ksrc)VKTrace.h \
		$(src)STANDARD.h \
		$(src)VLCodeIntfP.h \
		$(src)VLConfigP.h \
		$(src)VLDataP.h \
		$(src)VLI.h \
		$(src)VLLogOpsP.h \
		$(src)VLMathOpsP.h \
		$(src)VLMiscP.h \
		$(src)textio.c 
	$(CC) $(src)textio.c -o $@ $(CFLAGS)



