// This header file was created in order to allow compilation with the C++ compiler.
// As it is updated incrementally, it is not necessarily (nor likely to be) complete.
// Declarations are copied from the user manual.

#ifndef LWP_FN_H
#define LWP_FN_H

typedef int funconearg(int);
typedef funconearg* function;

extern "C" int pod_setmaxpri(int maxprio);
extern "C" int lwp_setstkcache(int minstksz, int numstks);
extern "C" int lwp_create(thread_t* tid, function func, int prio, int flags, 
			  stkalign_t* stack, int nargs, ...);
extern "C" int lwp_destroy(thread_t tid);
extern "C" int lwp_self(thread_t*);
extern "C" int lwp_sleep(struct timeval* timeout);
extern "C" int lwp_resched(int prio);
extern "C" void lwp_perror(char*);
extern "C" int lwp_suspend(thread_t);
extern "C" int lwp_resume(thread_t);
extern "C" int msg_send(thread_t, caddr_t, int, caddr_t, int);
extern "C" int msg_recv(thread_t*, caddr_t*, int*, caddr_t*, int*, timeval*);
extern "C" msg_reply(thread_t);

extern "C" int mon_create(mon_t*);
extern "C" int mon_destroy(mon_t);
extern "C" int mon_enter(mon_t);
extern "C" int mon_exit(mon_t);

extern "C" int lwp_getstate(thread_t, statvec_t*);
extern "C" int pod_getmaxpri();
extern "C" int lwp_setpri(thread_t, int);

#endif;			  
