CC = cc ${VSIM_ENV_OPTS} -I${CG_VKI} -I${CG_RTLI} -c -g
CPLUSPLUS = CC
VSIMTOP = /users/projects/vsim


# generate with   echo RCS/*.{c,C,h},v | nawk '{gsub(/,v/,""); gsub(/RCS\//,"");print}'

SOURCES = VK_Assign.c VK_SensitizeSet.c DelayedSignal.C DependentSet.C DesignUnitInfo.C Driver.C EventQueue.C File.C ForLoopInfo.C GuardSensSet.C GuardSignal.C GuardedDriver.C GuardedSignal.C InputFile.C InterfaceObjectInfo.C LWProcess.C LargePhysUtils.C LocalObjectInfo.C Log.C MonitorSignal.C NewMain.C ObjectInfo.C OutputFile.C ProcessSensSet.C PsuedoDriver.C Real_VK_Assign.C RegionInfo.C RegionStatementInfo.C ResolvedDriver.C ResolvedSignal.C SensitivitySet.C Signal.C SignalRep.C SimpleSignal.C Simulation.C SubProgramInfo.C SymbolicInfo.C TransactionList.C Traverse.C TypeInfo.C VHDLProcess.C VK_CreateDriver.C VK_CreateSignal.C VK_Elaborate.C VK_Misc.C VK_Process.C VK_ReadSignal.C VK_Register.C VK_Trace.C str.C AssignmentInfo.h BooleanSignalRep.h BusSignal.h ComponentInfo.h ConstraintUtils.h CurrentTime.h DelayedSignal.h DesignUnitInfo.h Driver.h EventQueue.h File.h FloatingSignalRep.h ForLoopInfo.h GuardSensitivitySet.h GuardSignal.h GuardedDriver.h GuardedSignal.h InputFile.h InterfaceObjectInfo.h KernelLARHook.h LWProcess.h LargePhysicalUtils.h LargeSignalRep.h LocalObjectInfo.h Log.h MonitorSignal.h ObjectInfo.h OutputFile.h ProcessSensitivitySet.h PsuedoDriver.h QueueElement.h QuietSignal.h RegionInfo.h RegionStatementInfo.h RegisterSignal.h ResolvedDriver.h ResolvedSignal.h Resource.h ScalarSignalRep.h SensitivitySet.h Signal.h SignalDependent.h SignalDependentSet.h SignalRep.h SimpleSignal.h Simulation.h StableSignal.h Standard.h StringRep.h SubProgramInfo.h SubSignal.h SymbolicInfo.h Transaction.h TransactionList.h TransactionSignal.h TransactionSignalRep.h TransactionValue.h Traverse.h TypeInfo.h VHDLProcess.h priorities.h str.h

ARFLAGS = rv
AR = ar
RCSFILES = RCS/*.C,v RCS/*.h,v
CG_VKI_CC = ${VSIMTOP}/include/VKI-CPP
CG_RTLI_CC = ${VSIMTOP}/include/RTLI-CPP
CPLUSPLUSFLAGS = ${VSIM_ENV_OPTS} -I${CG_VKI_CC} -I${CG_RTLI_CC} -I. -c -g +w
CG_RTLO = ${VSIMTOP}/lib
.SUFFIXES:
.SUFFIXES: .C .sim ${SUFFIXES}
% : RCS/%,v
	test -f $@ || co $@
.C.o : 
	${CPLUSPLUS} ${CPLUSPLUSFLAGS} -c $<
step%.sim : step%--config.o step%-a-g.o step%-g.o libVsim.a
	CC -o step$*.sim -v step$*-*.o EventQueue.o  -L${CG_RTLO}  -L. -lVsim -lVCGRTL -llwp
all :
libVsim.a : \
	libVsim.a(NewMain.o) libVsim.a(Simulation.o) libVsim.a(EventQueue.o) \
	libVsim.a(VK_Register.o) libVsim.a(SymbolicInfo.o) libVsim.a(TypeInfo.o) libVsim.a(ForLoopInfo.o) libVsim.a(Traverse.o) \
	libVsim.a(DesignUnitInfo.o) libVsim.a(RegionStatementInfo.o) libVsim.a(SubProgramInfo.o) libVsim.a(RegionInfo.o) \
	libVsim.a(ObjectInfo.o) libVsim.a(LocalObjectInfo.o) libVsim.a(InterfaceObjectInfo.o) \
	libVsim.a(VK_Trace.o) libVsim.a(VK_Elaborate.o) \
	libVsim.a(VK_Misc.o) \
	libVsim.a(VK_CreateDriver.o) libVsim.a(VK_CreateSignal.o) libVsim.a(Signal.o) libVsim.a(Driver.o) \
	libVsim.a(VK_ReadSignal.o) libVsim.a(TransactionList.o) libVsim.a(VK_Assign.o) \
	libVsim.a(Real_VK_Assign.o) libVsim.a(SignalRep.o) libVsim.a(DependentSet.o) libVsim.a(ScalarArraySignalRep.o) \
	libVsim.a(SimpleSignal.o) libVsim.a(GuardSignal.o) libVsim.a(MonitorSignal.o) libVsim.a(DelayedSignal.o) \
	libVsim.a(PsuedoDriver.o) libVsim.a(ResolvedDriver.o) libVsim.a(ResolvedSignal.o) libVsim.a(GuardedSignal.o) \
	libVsim.a(GuardedDriver.o) \
	libVsim.a(VK_Process.o) libVsim.a(VHDLProcess.o) libVsim.a(LWProcess.o) libVsim.a(SensitivitySet.o) \
	libVsim.a(VK_SensitizeSet.o) libVsim.a(GuardSensSet.o) libVsim.a(ProcessSensSet.o) \
	libVsim.a(LargePhysUtils.o) \
	libVsim.a(Log.o)
	ranlib libVsim.a

depend : ${SOURCES}
	co -l Makefile
	makedepend -I. -I${CG_VKI_CC} -I${CG_RTLI_CC} -I/usr/local/include/CC *.c *.C
	ci Makefile < /users/projects/vsim/src/.comment
.INIT : ${SOURCES}
	testandset /tmp/.lock.vsim
.DONE : 
	rm /tmp/.lock.vsim
	@echo "Build successful"
.FAILED :
	rm /tmp/.lock.vsim
	@echo "Build unsuccessful"
.DEFAULT :
	co $@
