/* *******************************************************************
*
* Copyright (c) 1991-1991 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* HEADER FILE: FWMisc.h
*
* DESCRIPTION:  
*	Common stuff for waveform formatter.
*
* CONSTANTS:
*	<constants>	<constants defined in this .h file >
*
* TYPES:
*	<types>		<types defined in this .h file >
*
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this .h file >
*
* ROUTINES:
*   External:
*	...
*
* HISTORY:
*	15-MAY-91 DSB	Created.
*	02-JUL-91 JBR	Replaced SPI.h dependency with VKConfig.h dependency.
*	02-JUL-91 JBR	Replaced TKCommon.h with FWCommon.h.
*
* SCCS ID: @(#)FWMisc.h	42.2 1/13/92
*
******************************************************************* */

#include "FWCommon.h"		/* for OS/Compiler dependent stuff */
#include "TKCommon.h"		/* for Integer4 ...                */

#define VersionText RVCG_SYSTEM_VERSION_4

#ifdef VK_OS_SUNOS
# define GoodExit 0
# define BadExit 1
#else
#ifdef VK_OS_AEGIS
# define GoodExit 0
# define BadExit 1
#else
#ifdef VK_OS_AIX3
# define GoodExit 0
# define BadExit 1
#else
#ifdef VK_OS_VMS
# define GoodExit 0x10000001
# define BadExit  0x10000004
#else
  #error Need OS type
#endif
#endif
#endif
#endif

#define NO_WAVE_FILE 0
#define NO_PREVIEW -1
#define Fmt_SkipTraceLine "...\n"

/*****************************************************************************
*
* Globals
*
*****************************************************************************/

/* Do not print version in the banner when True. I'd prefer a fn param
   than a global, but changing WriteHeader's args will be a pain. MNP */ 

extern VK_tBoolean TestMode;	

/* Print simple signal names in wave file when True. TestMode True
   imples NamesMode True. */

extern VK_tBoolean NamesMode;

/* SkipColumns
 * Amount of space to skip between columns. If 0, you get this:
 * 
 *       1   2   3 
 *     --- --- --- 
 *     '0' '0' '0' 	
 *    *'1' '0'*'0' 		; transaction marks are between columns
 *    *'0' '0'*'0' ...
 *    
 * If 1 this:	(only 0 and 1 for now)
 *
 *       1    2    3 
 *    ---- ---- ---- 
 *     '0'  '0'  '0' 	
 *    *'1'  '0' *'0' 		; transaction marks are under headers, 
 *    *'0'  '0' *'0' ... 	; header underlines are one wider.
 *
 */ 
extern Integer4 SkipColumns;


/*****************************************************************************
*
* Prototypes
*
*****************************************************************************/

void Format(
#ifdef VK_ANSI_FN_PROTOS
	VK_tCString prefix,
	VK_tBoolean control,
	VK_tCString control_file,
	Integer4 preview
#endif
	);


void ControlGenerate(
#ifdef VK_ANSI_FN_PROTOS
	VK_tCString prefix,
	VK_tCString control_file
#endif
	);

void WriteTimeSlice(
#ifdef VK_ANSI_FN_PROTOS
#endif
	);

void DisplayTraceLinesSkipped(
#ifdef VK_ANSI_FN_PROTOS
#endif
	);


void DisplayError(
#ifdef VK_ANSI_FN_PROTOS
	VK_tCString message,
	VK_tCString extra,
	VK_tCString source_file,
	int line_number
#endif
	);


void DisplayAssertion(
#ifdef VK_ANSI_FN_PROTOS
	VK_tCString process_name,
	VK_tCString source_file,
	int line_number,
	VK_tCString message,
	VK_tCString severity
#endif
	);


#if 0
/* *******************************************************************
*
* RtnName - <description of function or procedure>
*
* HISTORY:
*	??-JUN-90 DSB	Created.
*
******************************************************************* */
<static> Fntype RtnName(parm)	/* return value desc. if not void */
tParmType parm;			/* mode: description */
{
    type local;				/* description */
    type local;				/* description */
/**/

} /* RtnName */
#endif

