static char SCCS_ID[] = "@(#)FWUtils.c	42.1 1/10/92";
/* ******************************************************************* 
* 
* Copyright (c) 1989-1990 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* CODE FILE: FWUtils.c
*
* DESCRIPTION:  
*	Module that manages data structures that represent trace file information
*	over time 
*	<then describe contents> 
* 
* CONSTANTS: 
*	<constants>	<constants defined in this header file > 
* 
* TYPES: 
*	<types>		<types defined in this header file > 
* 
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this header file >
*
* ROUTINES:
*   External:
*	...
*
*   Internal:
*	...
*
* HISTORY:
*	15-MAY-91 DSB	Created
*	02-JUL-91 JBR	Removed dependency on SPI.h.
*	02-JUL-91 JBR	Added iAllocateMemory and iFreeMemory from FWMain.c.
*
* SCCS ID: @(#)FWUtils.c	42.1 1/10/92
*
******************************************************************* */

#include "FWUtils.h"
#include <stdio.h>		/* for stderr */


/* *********************************************************************
*
* CopyPrivStr - allocate new space and copy string to it
*
* HISTORY:
*	26-FEB-90 RM	Created.
* 	24-Aug-90 RM	Modified for use with kernel routines.
*	02-APR-91 WAG	W0015.  Replaced malloc call with AllocateMemory.
*	19-APR-91 DSB	Kludged bug: handle null pointer as empty string.
*
********************************************************************* */
 
char * CopyPrivStr(str)
char * str;
{
    char * ptr;
    int len;
/**/
    if (str == (char *) NULL) {
	fprintf(stderr, "fmtwave error: null pointer in CopyPrivStr");
	AllocateMemory(ptr, char, strlen("") + 1);
        ptr = "";		/* for now, return empty string */
    }
    else {
	AllocateMemory(ptr, char, strlen(str) + 1);
        if (ptr == (char *) NULL) {
	    fprintf(stderr, "fmtwave error: out of memory in CopyPrivStr");
        }
        else {
            /* even if it is a null string */
            strcpy(ptr, str);
        }
    }
    return ptr;
}  /* CopyPrivStr */



/* *******************************************************************
*
* iAllocateMemory - allocate memory from the heap
*
* HISTORY:
*	01-APR-91 WAG	W0015. Created from the Kernel iAllocateMemory routine.
*	02-JUL-91 JBR	Changed parameter type from Integer4 to int.
*	09-JAN-92 DKC	Added zeroing option to match TKTemp implementation
*
******************************************************************* */

void * iAllocateMemory(size,zero)
int size,
    zero;
{
    void * pointer;				
/**/
    pointer = (void *) malloc(size);
    
    if (NULL == pointer) {
	fprintf(stderr, "fmtwave error: Out of memory.\n");
    }
    else if (zero) {
        bzero(pointer,size);
    }

    return pointer;
    
} /*iAllocateMemory */


/* *******************************************************************
*
* iFreeMemory - Free memory allocated from the heap
*
* HISTORY:
*	27-MAR-91 AWH	Created.
*
******************************************************************* */

void iFreeMemory(pointer)
void * pointer;
{
/**/
    free(pointer);
        
} /* iFreeMemory */


#if 0
/* *******************************************************************
*
* RtnName - <description of function or procedure>
*
* HISTORY:
*	??-JUN-90 DSB	Created.
*
******************************************************************* */

#define RtnName(parms) \
	iRtnName(parms)
<static> Fntype iRtnName(parms)		/* return value desc. if not void */
tParmType parm;				/* in: description */
tParmType parm;				/* &in: description */
tParmType parm;				/* &inout: description */
tParmType parm;				/* &out: description */
{
    type local;				/* description */
    type local;				/* description */
/**/
    /* section comments */
    <code>				/* other comments */	
    ...

} /* iRtnName */

#endif
