#ifndef FWUtils_H
#define FWUtils_H
/* *******************************************************************
*
* Copyright (c) 1989-1990 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* HEADER FILE: FWUtils.h
*
* DESCRIPTION:  
*	Private interface file for FWUtils.h  <then describe contents>
*
* CONSTANTS:
*	<constants>	<constants defined in this header file >
*
* TYPES:
*	<types>		<types defined in this header file >
*
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this header file >
*
* ROUTINES:
*   External:
*	...
*
* HISTORY:
*	15-MAY-91 DSB	Created
*	02-JUL-91 JBR	Changed parameter type of iAllocateMemory from Integer4
*			to int.
*
* SCCS ID: @(#)FWUtils.h	42.2 1/13/92
*
******************************************************************* */

/* *******************************************************************
*	Static Global Subroutines
******************************************************************* */
#ifndef AllocateMemory 
        /* also defined in TKTemp.h */
#define AllocateMemory(POINTER, TYPE, COUNT)\
	POINTER = (TYPE *) iAllocateMemory(sizeof(TYPE) * (COUNT),0)

void * iAllocateMemory(
#ifdef VK_ANSI_FN_PROTOS
	int  size,		/* in: size of request in bytes */
             zero               /* in: set memory to zero       */
#endif
	);
#endif

/* *******************************************************************
*
* FreeMemory -- Free Memory allocated with AllocateMemory or ReallocateMemory
*
* Note: implemented here for completeness
*
******************************************************************* */
#define FreeMemory(POINTER) iFreeMemory(POINTER)

void iFreeMemory(
#ifdef VK_ANSI_FN_PROTOS
	void * pointer			/* in: pointer to existing block */
#endif
	);

				
#endif /* FWUtils_H */
	
