#ifndef TKCommon_H
#define TKCommon_H
/* *******************************************************************
*
* Copyright (c) 1989-1990 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* HEADER FILE: TKCommon.h
*
* DESCRIPTION:  
*	Interface file for TKCommon.c. 
*
* CONSTANTS:
*	<constants>	<constants defined in this header file >
*
* TYPES:
*	<types>		<types defined in this header file >
*
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this header file >
*
* ROUTINES:
*   External:
*	...
*
* HISTORY:
*	04-OCT-89 DSB	Created
* 	07-Sep-90 RM	Moved extern variables to TKGlobals module.
*	25-APR-91 AWH	WOO21: Renamed to TK...
*	02-MAY-91 DSB	Cleaning up generally
*       29-OCT-91 DKC   Removed tTempDataType
*
* SCCS ID: @(#)TKCommon.h	42.1 1/10/92
*
******************************************************************* */

#include "VKI.h"			/* get all public definitions */
#include "TKConfig.h"

#include <stdio.h>
#include <string.h>
#include <sys/types.h>

#ifdef VK_ANSI_FN_PROTOS
	/* AWH: used only for the function prototypes, doesn't compile on SunOS 4.0 */
#include <sys/time.h>		/* for time_t... */
#include <time.h>		/* for time_t... */
#endif

#include <memory.h>		/* for memset() */

#ifdef TK_ANSI_VAR_ARGS
#  include <stdarg.h>
#else
#  include <varargs.h>
#endif

/* These are not declared in some system's headers. Declaring them 
   here supresses implicit declaration warnings for strict compliers.
   These may need to be turned off on machines which have proper
   header files. Defining a macro in VKConfig.h might be best. 
   MNP 910916 */ 

#ifdef VK_ANSI_FN_PROTOS
  extern char *malloc(unsigned);
  extern void free(void *);
  extern char *realloc(char *, unsigned);
  extern void exit(int);
  extern int usleep(unsigned);
  extern int atoi(char *);
  extern int printf(char *, ...);
  extern int fprintf(FILE *, char *, ...);
  extern int sscanf(char *, char *, ...);
  extern int scanf(char *, ...);
  extern int fscanf(FILE *, char *, ...);
  extern int fclose(FILE *);
  extern int fflush(FILE *);
  extern int fputc(char, FILE *);
  extern int fgetc(FILE *);
  extern void setbuf(FILE *, char *);
  extern int setlinebuf(FILE *);
  extern int ungetc(int, FILE *);
  extern int _filbuf(FILE *);		/* poss. machine dep? */
  extern int _flsbuf(unsigned, FILE *); /* poss. machine dep? */
  extern int fread(char *, int, int, FILE *);
  extern int fwrite(char *, int, int, FILE *);
  extern char *getenv(char *);   
  extern char *ctime(time_t *clock);
  extern time_t time(time_t *tloc);
#else
  extern char *malloc();
  extern void free();
  extern char *realloc();
  extern void exit();
  extern int usleep();
  extern int atoi();
  extern int printf();
  extern int fprintf();
  extern int setlinebuf();
  extern int sscanf();
  extern int scanf();
  extern void setbuf();
  extern int setlinebuf();
  extern int fscanf();
  extern int fclose();
  extern int fflush();
  extern int fputc();
  extern int fgetc();
  extern int ungetc();
  extern int fread();
  extern int fwrite();
  extern char *getenv();
  extern char *ctime();
  extern time_t time();
#endif


#ifndef TK_FAST_COMPILE
#  include "SPI.h"
#else
#  include "AuxAttrsPub.h"
#  include "NodeIntfPub.h"	/* for NewIntegerValue4, etc. */

#  include "DataFnsPub.h"	/* for IsNull */
#  include "TKListFns.h"	/* for NoList, ... */
#  include "LibFnsPub.h"	/* for OpenDLS */
#  include "ErrPkgPub.h"	/* for SetTraceBack */
#endif

#ifndef MAX	
#  define MAX(x,y)		((x)>=(y)?(x):(y))
#endif

#ifndef MIN
#  define MIN(a,b) 		((x)<=(y)?(x):(y))
#endif

#define BYTES(w)	((w)*sizeof(long))	/* nr. of bytes in w words */
#define WORDS(b)	((b)/sizeof(long))	/* nr. of words in b bytes */

typedef char tTempBuf20[20];
typedef char tTempBuf40[40];
typedef char tTempBuf80[80];
typedef char tTempBuf256[256];
typedef char tTempBuf1024[1024];

/* *******************************************************************
*
*
*
******************************************************************* */

#define KernelPrefix "K_"
#define UserPrefix "U_"

#define TempMaxSources 10

#endif /* TKCommon_H */


