#ifndef TKConfig_H
#define TKConfig_H
/* *******************************************************************
*
* Copyright (c) 1989-1991 by CAD Language Systems, Inc. All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* HEADER FILE: TKConfig.h
*
* DESCRIPTION:  
*	Host-dependent configuration file for VHDL Kernel Interface 
*	(uncustomized VKI).
*
* PREPROCESSOR CONSTANTS:
*	<constants>	<constants defined in this header file >
*
* CONSTANTS:
*	<constants>	<constants defined in this header file >
*
* TYPES:
*	<types>		<types defined in this header file >
*
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this header file >
*
* ROUTINES:
*	...
*
* HISTORY:
*	12-SEP-91 AWH	Added TK_CPP_NO_LARGE_STRINGS, apollo
*			portablility issue
*
* SCCS ID: @(#)TKConfig.h	42.1 1/10/92
*
******************************************************************* */

/* *******************************************************************
*
* Control macro TK_CPP_NO_LARGE_STRINGS
*
* DESCRIPTION:
*   TK_CPP_NO_LARGE_STRINGS selects code to work around CPP portablility
*   problem.
* 
*  C Preprocessor does not handle "stringization" of macro parameters
*  when actual value is broken over multiple lines:
*  (' #define X(y) "y"' with 'X(a + \n b)' ) 
*
* USAGE:  Defined here, used in Test Kernel Code
*
******************************************************************* */
#ifdef VK_OS_AEGIS
#  define TK_CPP_NO_LARGE_STRINGS
#endif /* VK_OS_AEGIS */

#endif /* TKConfig_H */




