static char SCCS_ID[] = "@(#)TKDebug.c	42.1 1/10/92";
/* *******************************************************************
*
* Copyright (c) 1989-1990 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* CODE FILE: TKDebug.c
*
* DESCRIPTION:  
*	<then describe contents>
*
* CONSTANTS:
*	<constants>	<constants defined in this header file >
*
* TYPES:
*	<types>		<types defined in this header file >
*
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this header file >
*
* ROUTINES:
*   External:
*	...
*
*   Internal:
*	...
*
* HISTORY:
*	04-OCT-89 DSB	Split from VKI.c
*	07-JAN-91 AWH   New commands for VHDL Learning Kit
*	18-MAR-91 HK	Added references to TIME macros
*	25-APR-91 AWH	WOO21: Renamed to TK...
*	02-MAY-91 DSB	Cleaning up generally
*	16-MAY-91 DSB	Pulled out DuplicateString
*	16-MAY-91 DSB	Converting to unsigned absolute time
*	17-MAY-91 JBR	W0046. Added VK_TraceBegin
*	17-MAY-91 DSB	Added VK_TraceEnd; moved VK_Trace..`VK_tUnitSymbInfo
*			to TKDebug.c`tUnitSymbInfo
*	21-MAY-91 DSB	Cleaned up old types; renamed to remove some VK_
*	11-OCT-91 MNP	Header cleanup
*	21-OCT-91 MNP	Added FormatBreakpoint()
*
* SCCS ID: @(#)TKDebug.c	42.1 1/10/92
*
******************************************************************* */

#include "TKDebug.h"
#include "TKCommon.h"
#include "TKStructs.h"
#include "TKGlobals.h"		/* for GF */
#include "TKSim.h"		/* for CurrentProcess */
#include "TKListFns.h"
#include "TKTemp.h"		/* for AllocateMemory, etc. */
#include "TKData.h"		/* for TIME macros */
#include "TKSymbUtils.h"	/* for su_GetUnitNames */
#include "TKIO.h"		/* for END_OF_LIST */
#include "TKRegions.h"		/* for Create<Region> */
#include "TKRecord.h"		/* for RD_WriteBreakPoint */
#include "TKFileUtils.h"	/* for ExpandPathName ... */

#include "VKCodeIntf.h"		/* for VK_tLARHeaderPtr, etc. */

#include <stdio.h>
#include <string.h>             /* for strok */


/* extern */ tDebugData DB = {
    	False,			/* next_step_flag */
	False,			/* movie_flag */
	False,			/* break_any_process */
	False, 			/* break_after_elab */
	False,			/* break_after_init */
	False,			/* is_after_elab */
	False,			/* is_after_init */
	False			/* is_after_sim */
    };

TempList BreakpointList = NULL;

typedef struct sLastBreakpointRecord {
    	VK_tCString file;
    	VK_tCString library;
    	VK_tCString primary;
    	VK_tCString secondary;
    	Integer4 line;
    } tLastBreakpointRecord;

tLastBreakpointRecord LastBreakpoint = {
    "",
    "",
    "",
    "",
    0
   };

typedef struct  {
	VK_tLARHeaderPtr region_data;
    } tLastTracepointRecord;

tLastTracepointRecord LastTracepoint = {NULL};


/* *******************************************************************
*
* tUnitSymbInfo - static debugging data per unit
*
* HISTORY:
*	26-DEC-90 DSB	Created first draft
*	21-JAN-91 DSB	Added library_name; moved file_name to end
*
******************************************************************* */

typedef struct {
	VK_tName library_name;		/* library name of design unit */
	VK_tName primary_name;		/* primary name of design unit */
	VK_tName secondary_name;	/* secondary name of design unit */
	VK_tName file_name;		/* source file name */
    } tUnitSymbInfo;		/* preliminary version */



/* *******************************************************************
*
* CancelLineBreakpoint -
*
* HISTORY:
*	21-JAN-91 AWH	Created
*	01-APR-91 WAG	W0015.  Changed VerifyFree to FreeMemory
*
******************************************************************* */
void CancelLineBreakpoint (handle)
tBP_Line * handle;
{
/**/

    if (NULL != qqLibrary(handle)) {
	FreeMemory(qqLibrary(handle));
    }

    if (NULL != qqPrimary(handle)) {
	FreeMemory(qqPrimary(handle));
    }

    if (NULL != qqSecondary(handle)) {
	FreeMemory(qqSecondary(handle));
    }

    FreeMemory(handle);

} /* CancelLineBreakpoint */


/* *******************************************************************
*
* CancelProcessBreakpoint -
*
* HISTORY:
*	21-JAN-91 AWH	Created
*	01-APR-91 WAG	W0015.  Changed VerifyFree to FreeMemory
*
******************************************************************* */
void CancelProcessBreakpoint (handle)
tBP_Process * handle;
{
VK_tProcessHandle process;
/**/
    process = qqProcess(handle);

    SetqqDebugBit(process, False);

    FreeMemory(handle);

} /* CancelProcessBreakpoint */



/* *******************************************************************
*
* CancelProcessAllBreakpoint -
*
* HISTORY:
*	21-JAN-91 AWH	Created
*	01-APR-91 WAG	W0015.  Changed VerifyFree to FreeMemory
*
******************************************************************* */
void CancelProcessAllBreakpoint (handle)
tBP_ProcessAll * handle;
{
/**/
    FreeMemory(handle);

    DB.break_any_process = False;
    
} /* CancelProcessAllBreakpoint */




/* *******************************************************************
*
* CancelBreakpointN - 
*
* HISTORY:
*	09-JAN-91 AWH	Created
*	01-APR-91 WAG	W0015.  Changed VerifyFree to FreeMemory
*
******************************************************************* */
VK_tBoolean CancelBreakpointN(number)
Integer4 number;
{
    TempItem scan;
    tBP_Cycle * handle;
    Integer4 count;
/**/
    count = 0;
   
    /* For each  break point in list */
    for (scan=TempFirstItem(BreakpointList);
    	! TempNullItem(scan); scan=TempNextItem(scan)) {

	count ++;
        if (count == number) {
	    TempRemoveItem(scan, handle);
	    
	    switch(qqRecordKind(handle)) {
	      case bp_Process:
		CancelProcessBreakpoint(handle);
		break;
	      case bp_ProcessAll:
		CancelProcessAllBreakpoint(handle);
		break;
	      case bp_Line:
		CancelLineBreakpoint(handle);
		break;

	      case bp_Time:
	      default:
		FreeMemory(handle);
		break;
		
	    } /* switch */
	    return True;
	}
   } /* for */
   return False;

} /* CancelBreakpointN */



/* *******************************************************************
*
* IsUserProcess - 
*
* HISTORY:
*	21-JAN-91 AWH	Split from Show Processes
*	20-MAR-91 WAG	Check by looking at qqKernelProcess instead of
*			the (now defunct) qqPriority field
*
******************************************************************* */
VK_tBoolean IsUserProcess(process)
VK_tProcessHandle process;
{
/**/
    if (process != NULL && 
        qqKernelProcess(process) == False) {

	return True;
    }
    else {
	return False;
    }
/* ?? Why not "return (..) && ...;", especialy since the condition is simple
	enough to fit nicely on one if statement. */
} /* IsUserProcess */
/* ?? move this to some utility module or to TKProcesses ?? */


/* *******************************************************************
*
* GetLastBreakpoint - 
*
* HISTORY:
*	21-JAN-91 AWH	Created
*
******************************************************************* */
void GetLastBreakpoint(library, primary, secondary, file, line)
VK_tCString * library;
VK_tCString * primary;
VK_tCString * secondary;
VK_tCString * file;
Integer4 * line;
{
/**/
    *library = LastBreakpoint.library;
    *primary = LastBreakpoint.primary;
    *secondary = LastBreakpoint.secondary;
    *file = LastBreakpoint.file;
    *line = LastBreakpoint.line;
    
} /* GetLastBreakpoint */



/* *******************************************************************
*
* GetLastTracepoint - 
*
* HISTORY:
*	17-MAY-91 DSB	Created
*
******************************************************************* */
void GetLastTracepoint(region_data)
VK_tLARHeaderPtr * region_data;		/* region LAR pointer address */
{
/**/
    *region_data = LastTracepoint.region_data;
} /* GetLastTracepoint */



/* *******************************************************************
*
* ShowProcesses - 
*
* HISTORY:
*	15-JUN-90 DSB	Created
*	18-JAN-91 AWH	Split from Debug Process
*	18-MAR-91 WAG	Changed the name of the accessed list from
*			"ProcessList" to "UserProcessList"
*	20-SEP-91 MNP	Paralleled output to look like show hier.
*
******************************************************************* */
void ShowProcesses()
{
    TempItem 		procscan;
    VK_tProcessHandle	process;
    tTempBuf256 	buf;
    int			used;
/**/
    DisplayText("Processes:");	
    for (procscan = TempFirstItem(UserProcessList); 
		! TempNullItem(procscan); procscan = TempNextItem(procscan)) {
	process = TempValue (procscan);

	sprintf(buf, " %d: ", qqNumber(process));
	used = strlen(buf);
	FormatHierarchicalName(&buf[used], sizeof(buf) - used, process);
	DisplayText(buf);
    
	sprintf(buf, "\t\t%s this cycle; %s",
		SimCycleCount == qqTriggerCycle(process) ? "  active"
                                                         : "inactive",
		qqDebugBit(process) ? "   breakpoint set"
                                    : "no breakpoint set"
		);
	DisplayText(buf);
    }
    DisplayText(END_OF_LIST);
} /* ShowProcesses */



/* *******************************************************************
*
* ShowSignals - 
*
* HISTORY:
*	29-MAY-91 AWH	Created
*
******************************************************************* */
void ShowSignals()
{
    TempItem scan;
    tTempBuf1024 hier_buf;
    tTempBuf1024 buffer;
    tSignalGroupRec * group;
/**/
    DisplayText("Signals:");
    for (scan = TempFirstItem(SignalGroupList); 
			! TempNullItem(scan); 
			scan = TempNextItem(scan)) {
	    group = (tSignalGroupRec *) TempValue(scan);
	    FormatHierarchicalName(hier_buf, sizeof(hier_buf),
				   group);
	   
	    if (gc_ScalarSignal == qqGroupClass(group)) {
	    	sprintf(buffer, "       %-3d : %s", 
		    	qqSignalStart(group),
		    	hier_buf);
	    }
	    else {
	    	sprintf(buffer, " %3d - %-3d : %s", 
		    	qqSignalStart(group),
			qqSignalStart(group) + qqSignalLength(group) - 1,
		    	hier_buf);
	    }
     	    DisplayText(buffer);
    } /* for */    
    DisplayText(END_OF_LIST);

} /* ShowSignals */




/* *******************************************************************
*
* SetProcessBreakpoint - 
*
* HISTORY:
*	15-JUN-90 DSB	Created
*	21-JAN-91 AWH	Renamed, added breakpoint list
*	18-MAR-91 WAG	Changed the name of the accessed list from
*			"ProcessList" to "UserProcessList"
*	01-APR-91 WAG	W0015.  Changed VerifyMalloc to AllocateMemory
*
******************************************************************* */
void SetProcessBreakpoint(process_name)
VK_tCString process_name;		/* in: process simple name */
{
    VK_tBoolean looping;
    TempItem procscan;
    VK_tBoolean any;
    tTempBuf256 buffer;
    tBP_Process * handle;
/**/
    any = False;
    looping = True;
    procscan = TempFirstItem(UserProcessList);
    while (looping) {
	if (TempNullItem(procscan)) {
	    looping = False;
	    if (! any) {
	    	 sprintf(buffer, "Error: Unrecognized process name '%s'", 
		    process_name);
           	 DisplayResponse(buffer);
	   	 if (! GF.slave) {
	   	    ShowProcesses();
	   	 }
	     }
	}
#if 000
	else if (StringMatch(process_name, qqName(ProcValue(procscan)))) {
#else
	    /* We think this was not updated to do regions.  MNP 910920 */

	else if (StringMatch(process_name, qqName(qqParentRegion(ProcValue(procscan)))))
	{
#endif
	    /* set process breakpoint */
	    if (qqDebugBit(ProcValue(procscan))) {
		sprintf(buffer, "Warning: Break on process %s already set.",
			process_name);
		DisplayResponse(buffer);
	     }
	    else {
		SetqqDebugBit(ProcValue(procscan), True);
		AllocateMemory(handle, tBP_Process, 1);
		SetqqRecordKind(handle, bp_Process);
		SetqqProcess(handle, ProcValue(procscan));
		TempAddLast(BreakpointList, handle);
		
      		sprintf(buffer, "Done: Set break on process %s.", process_name);	      DisplayResponse(buffer);
	    }
/*	    looping = False; */		
	/* sensitize all processes with this name because for now we don't
	   disambigate names */
	    any = True;
	    procscan = TempNextItem(procscan);
	}
	else {
	    procscan = TempNextItem(procscan);
	}
    }
	
} /* SetProcessBreakpoint */






/* *******************************************************************
*
* SetCycleBreakpoint - Set cycle Breakpoint
*
* HISTORY:
*	08-JAN-91 AWH	Created
*	01-APR-91 WAG	W0015.  Changed VerifyMalloc to AllocateMemory
*
******************************************************************* */
void SetCycleBreakpoint ()
{
    tBP_Cycle * cycle;
/**/
    AllocateMemory(cycle, tBP_Cycle, 1);
    AddqqRecordKind(cycle, bp_Cycle);

    TempAddLast(BreakpointList, cycle);
    
} /* SetCycleBreakpoint */



/* *******************************************************************
*
* SetElabBreakpoint - Set after elaboration breakpoint
*
* HISTORY:
*	09-JAN-91 AWH	Created
*	01-APR-91 WAG	W0015.  Changed VerifyMalloc to AllocateMemory
*
******************************************************************* */
void SetElabBreakpoint ()
{
    tBP_AfterElaboration * handle;
/**/
    AllocateMemory(handle, tBP_AfterElaboration, 1);
    AddqqRecordKind(handle, bp_AfterElaboration);

    TempAddLast(BreakpointList, handle);
    
} /* SetElabBreakpoint */



/* *******************************************************************
*
* SetInitBreakpoint - Set after initialization breakpoint
*
* HISTORY:
*	09-JAN-91 AWH	Created
*	01-APR-91 WAG	W0015.  Changed VerifyMalloc to AllocateMemory
*
******************************************************************* */
void SetInitBreakpoint ()
{
    tBP_AfterInitialization * handle;
/**/
    AllocateMemory(handle, tBP_AfterInitialization, 1);
    AddqqRecordKind(handle, bp_AfterInitialization);

    TempAddLast(BreakpointList, handle);
    
} /* SetElabBreakpoint */


/* *******************************************************************
*
* SetLineBreakpoint -
*
* HISTORY:
*	21-JAN-91 AWH	Created
*	01-APR-91 WAG	W0015.  Changed VerifyMalloc to AllocateMemory
*	21-OCT-91 MNP	Added sourcefile parameter
*	21-OCT-91 MNP	Prints the 'Done' message here now
*
******************************************************************* */
void SetLineBreakpoint(process, library, primary, secondary, line,
		       sourcefile)
VK_tProcessHandle process;
VK_tCString library;
VK_tCString primary;
VK_tCString secondary;
Integer4 line;
VK_tCString sourcefile;
{
    tBP_Line * handle;
    tTempBuf1024 buffer;
/**/
    AllocateMemory(handle, tBP_Line, 1);
    AddqqRecordKind(handle, bp_Line);
    AddqqProcess(handle, process);
    AddqqLibrary(handle, DuplicateString(library));
    AddqqPrimary(handle, DuplicateString(primary));
    AddqqSecondary(handle, DuplicateString(secondary));
    AddqqLine(handle, line);
    AddqqSourcefile(handle, DuplicateString(sourcefile));

    TempAddLast(BreakpointList, handle);

    strcpy(buffer, "Done: break set ");
    FormatBreakpoint(buffer, sizeof(buffer), handle);
    DisplayResponse(buffer);

} /* SetLineBreakpoint */



/* *******************************************************************
*
* SetProcessAllBreakpoint -
*
* HISTORY:
*	21-JAN-91 AWH	Created
*	01-APR-91 WAG	W0015.  Changed VerifyMalloc to AllocateMemory
*
******************************************************************* */
void SetProcessAllBreakpoint ()
{
    tBP_ProcessAll * handle;
/**/
    AllocateMemory(handle, tBP_ProcessAll, 1);
    AddqqRecordKind(handle, bp_ProcessAll);

    TempAddLast(BreakpointList, handle);

    DB.break_any_process = True;
    
} /* SetProcessAllBreakpoint */



/* *******************************************************************
*
* SetStepBreakpoint - Set step Breakpoint
*
* HISTORY:
*	08-JAN-91 AWH	Created
*	01-APR-91 WAG	W0015.  Changed VerifyMalloc to AllocateMemory
*
******************************************************************* */
void SetStepBreakpoint (process)
VK_tProcessHandle process;		/* current process */
{
    tBP_Step * step;
/**/
    AllocateMemory(step, tBP_Step, 1);
    AddqqRecordKind(step, bp_Step);
    AddqqProcess(step, IsUserProcess(process) ? process : NULL );

    TempAddLast(BreakpointList, step);
    
} /* SetStepBreakpoint */



/* *******************************************************************
*
* SetStepOverBreakpoint - Set step over Breakpoint
*
* HISTORY:
*	09-JAN-91 AWH	Created
*	01-APR-91 WAG	W0015.  Changed VerifyMalloc to AllocateMemory
*
******************************************************************* */
void SetStepOverBreakpoint (process)
VK_tProcessHandle process;		/* current process */
{
    tBP_StepOver * step_over;
/**/
    AllocateMemory(step_over, tBP_StepOver, 1);
    AddqqRecordKind(step_over, bp_StepOver);
    AddqqProcess(step_over, IsUserProcess(process) ? process : NULL);
    AddqqDepth(step_over, 0);
    
    TempAddLast(BreakpointList, step_over);
} /* SetStepOverBreakpoint */



/* *******************************************************************
*
* SetSuspendBreakpoint - Set suspend Breakpoint
*
* HISTORY:
*	08-JAN-91 AWH	Created
*	01-APR-91 WAG	W0015.  Changed VerifyMalloc to AllocateMemory
*
******************************************************************* */
void SetSuspendBreakpoint ()
{
    tBP_Suspend * suspend;
/**/
    AllocateMemory(suspend, tBP_Suspend, 1);
    AddqqRecordKind(suspend, bp_Suspend);

    TempAddLast(BreakpointList, suspend);
    
} /* SetSuspendBreakpoint */



/* *******************************************************************
*
* SetTimeBreakpoint - 
*
* HISTORY:
*	23-JAN-91 AWH	Created
*	01-APR-91 WAG	W0015.  Changed VerifyMalloc to AllocateMemory
*
******************************************************************* */
void SetTimeBreakpoint (time)
tAbsTimePtr time;
{
    tBP_Time * handle;
/**/
    AllocateMemory(handle, tBP_Time, 1);
    AddqqRecordKind(handle, bp_Time);
    AddqqTime(handle, *time);

    TempAddLast(BreakpointList, handle);
    
} /* SetTimeBreakpoint */



/*****************************************************************************
*
* FormatBreakpoint -
*
* DESCRIPTION:
*	 give breakpoint and buffer, fills in buffer, like
*
*		at line lib`prim`sec`line
*		in file /a/b/foo.vhdl
*
* HISTORY:
*	21-OCT-91 MNP	Created
*
*****************************************************************************/

void FormatBreakpoint(buffer, buf_size, handle)
char * buffer;			/* in/out: buffer */
int buf_size;			/* in: buffer size */
VK_tVoidPtr handle;		/* in: generalized handle to break rec */
{
    tTempBuf80 time;
    VK_tCString bps, bps2;
    tTempBuf256 other_buffer;
    VK_tCString source;
/**/
    bps = "";
    bps2 = "";
    source = "";
    
    switch (qqRecordKind((tBP_Step *) handle)) {
      case bp_Interrupt:  		bps = "- user interrupt (^C)";  break;
      case bp_AfterInitialization:  bps = "after initialization";  break;
      case bp_AfterElaboration:	bps = "after elaboration";  break;
      case bp_Step:	 	        bps = "before next statement";  break;
      case bp_ProcessAll:		bps = "in any process"; break;
      case bp_Process:
	FormatHierarchicalName(other_buffer, sizeof(other_buffer),
			       qqProcess((tBP_Process *) handle));
	bps = "in process: ";
	bps2 = other_buffer;
	break;
	
      case bp_Time:
	UTIME_FORMAT(time, qqTime((tBP_Time *) handle));
	sprintf(other_buffer, "%s %s", time, BaseUnit);
	bps = "at time ";
	bps2 = other_buffer;
	break;
	
      case bp_Line:
	sprintf(other_buffer, "at line %s`%s`%s`%d",
		qqLibrary((tBP_Line *) handle),
		qqPrimary((tBP_Line *) handle),
		qqSecondary((tBP_Line *) handle),
		qqLine((tBP_Line *) handle));
	source = qqSourcefile((tBP_Line *) handle);
	bps = other_buffer;
	break;
	
      default:	
	bps = "unknown";  
	break;

    } /* switch */

    /* Append the formatted breakpoint strings to the return buffer. */

    TempStrCat(buffer, buf_size, bps);
    TempStrCat(buffer, buf_size, bps2);
    
    /*  If the source file was used in the record, show it, too, on a 
     	second line (bp_Line type only). */

    if (NULL != source && '\0' != *source) {
	sprintf(other_buffer, "\n     in file %s", source);
	TempStrCat(buffer, buf_size, other_buffer);
    }

} /* FormatBreakpoint */


/* *******************************************************************
*
* ShowBreakpoints - List all breakpoints
*
* HISTORY:
*	09-JAN-91 AWH	Created
*
******************************************************************* */
void ShowBreakpoints()
{
    TempItem scan;
    void * handle;
    Integer4 count;
    tTempBuf1024 buffer;
/**/
    count = 0;
   
    DisplayText("Breakpoints: ");
    
    /* For each  break point in list */
    for (scan=TempFirstItem(BreakpointList);
    	! TempNullItem(scan); scan=TempNextItem(scan)) {

        handle = TempValue(scan);
	count ++;
	
	sprintf(buffer, "%3d: break ", count);
	FormatBreakpoint(buffer, sizeof(buffer), handle);
    	DisplayText(buffer);
   } /* for */

    DisplayText(END_OF_LIST);
} /* ShowBreakpoints */



/* *******************************************************************
*
* BreakpointExists - Returns True if the breakpoint is already set
*
* HISTORY:
*	02-OCT-91 MNP	Created
*
******************************************************************* */
VK_tBoolean BreakpointExists(process, library, primary, secondary, line)
VK_tProcessHandle process;
VK_tCString library;
VK_tCString primary;
VK_tCString secondary;
Integer4 line;
{
    return False;
} /* BreakpointExists */


/* *******************************************************************
*
* RecordCallOrReturn - Record subprogram call or return in current process
*
* HISTORY:
*	09-JAN-91 AWH	Created
*	21-MAY-91 DSB	Added VK_Begin, VK_End cases
*
******************************************************************* */
static void RecordCallOrReturn(process, call_type)
VK_tProcessHandle process; 		/* Current Process */
VK_tExecPosKind call_type;
{
    TempItem scan;
    tBP_StepOver * step_over;
/**/
    if (IsUserProcess(process)) {
/* ?? why not handle kernel processes too?; they can execute VHDL code (e.g, 
	resolution functions, type conversion functions, functions called from
	guard expression or wait expression) ?? */
    
	/* For each StepOver break point in list */
    	for (scan=TempFirstItem(BreakpointList);
		! TempNullItem(scan); scan=TempNextItem(scan)) {

 	    step_over = (tBP_StepOver *) TempValue(scan);
   
	    if (bp_StepOver == qqRecordKind(step_over)) {
	        if (process == qqProcess(step_over)) {
/* ?? might stored something with process to avoid search */

		    if (VK_Return == call_type || VK_End == call_type)  {
			step_over->depth ++;
		    }
		    else {
			step_over->depth --;
		    }
		}
	    }
    	} /* for */
    } /* if (NULL != process) */
} /* RecordCallOrReturn */



/* *******************************************************************
*
* IsBreakTime - Search BreakpointList and determine if time to break
*
* HISTORY:
*	07-JAN-91 AWH	Created
*	01-APR-91 WAG	W0015.  Changed VerifyFree to FreeMemory
*
******************************************************************* */
static VK_tBoolean IsBreakTime (breakpoint_class, process, library,
				primary, secondary, line, time)
tBreakPointClass breakpoint_class;
VK_tProcessHandle process;
VK_tCString library;
VK_tCString primary;
VK_tCString secondary;
Integer4 line;
tAbsTimePtr time;
{
    TempItem    scan; 
    VK_tBoolean do_break;
    void        *handle;
    tBP_Line    *bp_line;
/**/
    do_break = False;

    /* for each breakpoint in list */
    scan = TempFirstItem(BreakpointList);
    while (! TempNullItem(scan)) {

 	handle = (tBP_Interrupt *) TempValue(scan);

	switch (qqRecordKind((tBP_Interrupt *) handle)) {
	    case bp_Interrupt:
	        do_break = True;
		TempRemoveItem(scan, handle);
		FreeMemory(handle);
	        break;
	    case bp_Step:
		if (NULL == qqProcess((tBP_Step *) handle) ||
		    process == qqProcess((tBP_Step *) handle)) {

		    do_break = True;
 		    /* Clear Step Breakpoint */
		    TempRemoveItem(scan, handle);
		    FreeMemory(handle);
		}
		else {
		    scan = TempNextItem(scan);
		}    
		break;
	    case bp_StepOver:
		if (bp_Step == breakpoint_class && 
		    (NULL == qqProcess((tBP_Step *) handle) ||
		    process == qqProcess((tBP_StepOver *) handle)) &&
		    qqDepth((tBP_StepOver *) handle) >= 0) {

		    do_break = True;
 		    /* Clear Step Breakpoint */
		    TempRemoveItem(scan, handle);
		    FreeMemory(handle);
		}
		else {
		    scan = TempNextItem(scan);
		}    
		break;
	    case bp_Cycle:
		/* at end of cycle */
		if (bp_Cycle == breakpoint_class) {
		    do_break = True;
		    TempRemoveItem(scan, handle);
		    FreeMemory(handle);
		}
		else {
		    scan = TempNextItem(scan);
		}
		break;

	    case bp_Time:
		/* At beginning of cycle with new time */
		if (bp_Time == breakpoint_class &&
		    NULL    != time             &&
		    UTIME_LESSTHAN(qqTime((tBP_Time *) handle), *time)) {

		    do_break = True;
		    TempRemoveItem(scan, handle);
		    FreeMemory(handle);
		}
		else {
		    scan = TempNextItem(scan);
		}
		break;
	   
	    case bp_Line:
                bp_line = (tBP_Line *) handle;
		if (bp_Step == breakpoint_class             &&
		    line    == qqLine(bp_line)              &&
 		    (NULL    == qqProcess(bp_line) || 
                     process == qqProcess(bp_line))         &&
		   StringMatch(library, qqLibrary(bp_line)) &&
		   StringMatch(primary, qqPrimary(bp_line)) &&
                   (NULL == qqSecondary(bp_line) ||
		    StringMatch(secondary, qqSecondary(bp_line)))) {

		       do_break = True;
		}
		scan = TempNextItem(scan);
		break;
	     
	    case bp_Suspend:
		if (bp_Suspend == breakpoint_class) {
		    do_break = True;
		    TempRemoveItem(scan, handle);
		    FreeMemory(handle);
		}
		else {
		    scan = TempNextItem(scan);
		}
		break;
	    case bp_AfterElaboration:
		if (bp_AfterElaboration == breakpoint_class) {
		    do_break = True;
		    TempRemoveItem(scan, handle);
		    FreeMemory(handle);
		}
		else {
		    scan = TempNextItem(scan);
		}
		break;
	    case bp_AfterInitialization:
		if (bp_AfterInitialization == breakpoint_class) {
		    do_break = True;
		    TempRemoveItem(scan, handle);
		    FreeMemory(handle);
		}
		else {
		    scan = TempNextItem(scan);
		}
		break;
	    default:
		scan = TempNextItem(scan);		
	        break;
	 } /* switch */

    } /* while */
    return do_break;
} /* IsBreakTime */



/* *******************************************************************
*
* DebugInterrupt - 
*
* HISTORY:
*	07-JAN-91 AWH	Created
*	01-APR-91 WAG	W0015.  Changed VerifyMalloc to AllocateMemory
*
******************************************************************* */
void DebugInterrupt ()
{
    TempItem scan; 
    tBP_Interrupt * record;

/**/
    /* Check if list initialized */
    if (NULL == BreakpointList) {
	ReportInternalError("Interrupt before initialization completed",
		"", NULL, 0);
    }

    /* Check if Currently Interrupted, report internal error */
    for (scan=TempFirstItem(BreakpointList);
	! TempNullItem(scan); scan=TempNextItem(scan)) {

 	record = (tBP_Interrupt *) TempValue(scan);
   
	if (bp_Interrupt ==  qqRecordKind(record)) {
	    ReportInternalError("Simulation interrupted by user", "", NULL, 0);
	    }

    } /* for */


    /* Set Interrupt Breakpoint */
    AllocateMemory(record, tBP_Interrupt, 1);
    AddqqRecordKind(record, bp_Interrupt);
    TempAddLast(BreakpointList, record);

} /* DebugInterrupt */





/* *******************************************************************
*
* InitializeDebug - 
*
* HISTORY:
*	07-JAN-91 AWH	Created
*
******************************************************************* */
void InitializeDebug ()
{
/**/
   BreakpointList = TempNewList();
} /* InitializeDebug */


 
/* *******************************************************************
*
* BreakpointDirect - break point in Direct Mode (nonslave)
*
* HISTORY:
*	08-JAN-91 AWH	Created
*
******************************************************************* */
static void BreakpointDirect(source_file_name, source_line_number, call_type,
	breakpoint_class)
VK_tCString source_file_name;
VK_tLineNumber source_line_number;
VK_tExecPosKind call_type;
tBreakPointClass breakpoint_class;
{
static FILE * CurrentFP = NULL;
static tTempBuf256 CurrentFile = "";
static int CurrentLineNumber = 0;
static tTempBuf256 CurrentLine;
static tTempBuf256 buffer2;
static tTempBuf256 buffer;
char *type_str, *badvar;
tFileUtilStatus fstat;
/**/

    /* : current debug call types to current strings */

    switch (call_type) {
    	case VK_ElabDecl:	type_str = "Elaborating";	break;
	case VK_ExecStmt:	type_str = "Executing";		break;
	case VK_Call:	type_str = "Called";		break;
	case VK_Return:	type_str = "Returning";		break;
	default:	type_str = "BAD VALUE";		break;
    } /* switch */

    switch (breakpoint_class) {
      case bp_AfterInitialization:
	  DisplayText("Break: after initialization");
	  break;
      case bp_AfterElaboration:
	  DisplayText("Break: after elaboration");
	  break;
      case bp_Cycle:
	  DisplayText("Break: at end of simulation cycle");
	  break;  
      case bp_Time:
	  DisplayText("Break: at time advance");
	  break;
      case bp_Suspend:
	  FormatHierarchicalName(buffer2, sizeof(buffer2), CurrentProcess);
	  sprintf(buffer, "Break: at process %s suspension",
		  buffer2);
	  DisplayText(buffer);
	  break;  
	  
      default:
    	  /* ?? probably add unit names now ?? */
   	  sprintf(buffer, "Break: line = %d of file = %s (%s)",
		source_line_number, source_file_name, type_str);
   	  DisplayText(buffer);
   	  if (! (StringMatch(source_file_name, CurrentFile) && 
	      CurrentLineNumber <= source_line_number)) {
       	      if (CurrentFP != NULL) {
	      	  fclose(CurrentFP);
       	      }

#if 000 
      	      strcpy(CurrentFile, source_file_name);
       	      CurrentFP = fopen(source_file_name, "r");
       	      CurrentLineNumber = 0;
#else
	      fstat = ExpandPathName(source_file_name, CurrentFile, &badvar);
	      switch (fstat) {

		case UnknownVarInPath:
		case BadTildeInPath:
		  sprintf(buffer, "Error: Bad environment expansion :%s", 
			  badvar);
		  DisplayResponse(buffer);
		  break;

		case FileSuccess:
		  CurrentFP = fopen(source_file_name, "r");
		  CurrentLineNumber = 0;
		  break;

		case IntError:
		default:
		  DisplayResponse("Internal error in BreakPointDirect");
	      }	/* switch */
#endif
	  }

   	  if (CurrentFP == NULL) {
       	      sprintf(buffer, "Error: Can't open %s", source_file_name);
       	      DisplayResponse(buffer);
   	  }
   	  else {
       	      while (CurrentLineNumber < source_line_number && ! feof(CurrentFP)) {
       	        fgets(CurrentLine, sizeof(CurrentLine), CurrentFP);
	        CurrentLineNumber = CurrentLineNumber + 1;
	      }
	
	      sprintf(buffer, "\t%s", CurrentLine);
	      DisplayResponse(buffer);
          }
	  break;
    } /* switch */
} /* BreakpointDirect */


 
/* *******************************************************************
*
* BreakpointSlave - break point in slave mode
*
* HISTORY:
*	08-JAN-91 AWH	Created
*
******************************************************************* */
static void BreakpointSlave(library, primary, secondary, source_file_name, 
	source_line_number, call_type, breakpoint_class)
VK_tCString source_file_name;
VK_tLineNumber source_line_number;
VK_tExecPosKind call_type;
tBreakPointClass breakpoint_class;
VK_tCString library;
VK_tCString primary;
VK_tCString secondary;
{
    VK_tCString sfn;
    VK_tCString cpn;
    /* tTempBuf256 buffer; */
/**/
    /* get current process */
    if (IsUserProcess(CurrentProcess)) {
/*
        FormatHierarchicalName(buffer, sizeof(buffer), CurrentProcess);
*/
#if 000
        cpn = qqName(CurrentProcess);
#else
        cpn = qqName(qqParentRegion(CurrentProcess));  /* MNP 910920 */
#endif

    }
    else {
        cpn = "<kernel_process>";
    }
    if (source_file_name[0] == '\0') {
	sfn = "<NULL>";
    }
    else {
	sfn = source_file_name;
    }

    RD_WriteBreakPoint(breakpoint_class, library, primary, secondary,
		cpn, sfn, source_line_number);

} /* BreakpointSlave */

 
/* *******************************************************************
*
* InternalDebug - Debug from within the kernel
*
* HISTORY:
*	08-JAN-91 AWH	Created
*
******************************************************************* */

void InternalDebug(breakpoint_class, time)
tBreakPointClass breakpoint_class;
tAbsTimePtr time;
{
    VK_tBoolean break_now;
/**/
    break_now =	IsBreakTime(breakpoint_class,
			    CurrentProcess,
			    LastBreakpoint.library,
			    LastBreakpoint.primary,
			    LastBreakpoint.secondary,
			    LastBreakpoint.line,
			    time);
    if (DB.next_step_flag || DB.movie_flag || break_now) {
	if (GF.slave) {
	    BreakpointSlave(LastBreakpoint.library,
			    LastBreakpoint.primary,
			    LastBreakpoint.secondary,
			    LastBreakpoint.file,
			    LastBreakpoint.line,
			    VK_BadExecPosKind,
			    breakpoint_class);
	}
	else {
	    BreakpointDirect(LastBreakpoint.file, LastBreakpoint.line,
			     VK_BadExecPosKind, breakpoint_class);
	}    

	if (break_now || DB.next_step_flag)  {
	    /* other then movie_flag */
	    GetCommands();
        }
	if (DB.next_step_flag) {
            DB.next_step_flag = False;	/* reset single-shot stepping */
        }
    }
}  /* InternalDebug */


 
/* *******************************************************************
*
* BreakpointCheck - Determine if a break has been requested.  If so,
*	report location and break
*
* HISTORY:
*	10-MAY-91 JBR	Created from old VK_Debug
*	17-MAY-91 DSB	Added temporary TryTraceback
*
******************************************************************* */
void BreakpointCheck(current_LARP, unit_record, source_line_number,
	call_type, breakpoint_class)
VK_tLARHeaderPtr current_LARP;
tUnitSymbInfo * unit_record;
VK_tLineNumber source_line_number;
VK_tExecPosKind call_type;
tBreakPointClass breakpoint_class;
{
    VK_tBoolean break_now;
#define SetNull(S) ((S != NULL) && (*(S) != NULL)) ? S : "<NULL>"
/**/
    /* support of the pace command */
    WaitToPaceTime();

    /* save last line information for suspend breakpoints */
    LastBreakpoint.library = SetNull(unit_record->library_name);
    LastBreakpoint.primary = SetNull(unit_record->primary_name);
    LastBreakpoint.secondary = SetNull(unit_record->secondary_name);
    LastBreakpoint.file = SetNull(unit_record->file_name);
    LastBreakpoint.line = source_line_number; 

    break_now = IsBreakTime(breakpoint_class,
			CurrentProcess,
			LastBreakpoint.library,
			LastBreakpoint.primary,
			LastBreakpoint.secondary,
			LastBreakpoint.line,
			NULL);

    if ( DB.next_step_flag || DB.movie_flag || break_now) {

	/* Report the breakpoint's location */
	if (GF.slave) {
	    BreakpointSlave(
		LastBreakpoint.library,
		LastBreakpoint.primary,
		LastBreakpoint.secondary,
		LastBreakpoint.file,
		LastBreakpoint.line,
		call_type,
		breakpoint_class);
	}
	else {
	    BreakpointDirect(
		 LastBreakpoint.file, 
		 LastBreakpoint.line, 
		 call_type,
	     	 breakpoint_class);
	}    

	if (break_now || DB.next_step_flag)  {
	    if (GF.dump) {
		TryTraceback(current_LARP);
	    }

	    /* other than movie_flag */
	    GetCommands();		/* do the break */
        }
	if (DB.next_step_flag) {
            DB.next_step_flag = False;	/* reset single-shot stepping */
        }
    }
} /* BreakpointCheck */



/* *******************************************************************
*
* VK_TraceBegin -
*
* HISTORY:
*	17-MAY-91 JBR	Created
*	17-MAY-91 DSB	Uncommented SetqqRegionData line; added error reports
*			for unused cases
*	17-MAY-91 DSB	Added LastTracepoint, etc.
*	21-MAY-91 DSB	Added RecordCallOrReturn
*	22-MAY-91 DSB	Added temporary null check for region_info
*	17-JUL-91 DSB	Added parameter value access for for generate stmts.
*
******************************************************************* */
void VK_TraceBegin(region_data, unit_info, exec_pos, region_info)
VK_tLARHeaderPtr region_data;
VK_tSymbInfoHandle unit_info;
VK_tExecPosIndex exec_pos;
VK_tSymbInfoHandle region_info;
/* ?? where are parameter comments? copy them from VKI file ?? */
{
    TK_tRegionHandle region_handle;
    VK_tLARHeaderPtr caller_LARP;
    TempList children;
    VK_tSymbInfoHandle child;
    VK_tSymbInfoHandle index_type;
    VK_tInteger index_value;
/**/
    TK_SetRegionInfo(region_data, region_info);
    TK_SetUnitInfo(region_data, unit_info);
    TK_SetExecPos(region_data, exec_pos);
					/* update position info. in LAR */
    LastTracepoint.region_data = region_data;
					/* remember last VK_TraceXx call */

    if (NULL == region_info) {
	return;				/* ?? temporary: just quit if NULL
					   (component instantiation) ?? */
    }

    /* Create the region handle depending on what type of region it is */
    switch (qqSymbInfoKind(region_info)) {
	case PackageDeclInfo:
	    region_handle = CreatePackage(NULL, qqName(region_info));
	    SetqqRegionData(region_info, region_data);
					/* save package decl. LAR so it's
					   accessible for certain operations 
					   and debugging*/
	    break;

	case PackageBodyInfo:
	    region_handle = CreatePackageBody(NULL, qqName(region_info));
	    SetqqRegionData(region_info, region_data);
					/* save package body LAR so it's
					   accessible for debugging */
	    break;

	case ArchitectureBodyInfo:
	    caller_LARP = VK_GetCallerLARP(VK_GetIARP(region_data));
	    if (NULL == caller_LARP) {
					/* top level design entity, no context
					   */
		region_handle = CreateDesignEntity(
			NULL,
			qqName(qqExtReg(region_info)), qqName(region_info));
	    }
	    else {
		region_handle = CreateDesignEntity(
			TK_GetRegionHandle(caller_LARP),
			qqName(qqExtReg(region_info)),
			qqName(region_info));
	    }
	    break;

	case ConfigurationDeclInfo:
	    region_handle = NULL;	/* ?? not implemented in cg ??*/
	    break;

	case BlockStmtInfo:
	    region_handle = CreateBlock(
		TK_GetRegionHandle(VK_GetCallerLARP(VK_GetIARP(region_data))),
		qqName(region_info));
	    break;

	case IfGenerateStmtInfo:
	    region_handle = CreateIfGenerate(
		TK_GetRegionHandle(VK_GetCallerLARP(VK_GetIARP(region_data))),
		qqName(region_info), 1 /* dummy */);
	    break;

	case ForGenerateStmtInfo:
	    region_handle = CreateRegion(
		TK_GetRegionHandle(VK_GetCallerLARP(VK_GetIARP(region_data))),
		ForGenerateRegion, qqName(region_info));


	    children = qqChildren(region_info);
	    if (! TempIsEmpty(children)) {
		child = SymbInfoValue(TempFirstItem(children));
		if (InterfaceConstantDeclInfo == qqSymbInfoKind(child)) {
		    index_type = qqBaseTypeInfo(child);
		    index_value = * (VK_tIntegerData *)
			(qqValueOffset(child) + 
			(char *) VK_GetIARP(region_data));
					/* get for generate parameter value
					   from IARP */
		}
		else {
		    index_type = NULL;
		    index_value = MinInt4;	/* dummy value */
		}
	    }
	    else {
		index_type = NULL;
		index_value = MinInt4;	/* dummy value */
	    }
	    SetqqForIndexValue(region_handle, index_value);
	    SetqqForTypeSymbInfo(region_handle, index_type);
	    SetqqForTypeClass(region_handle, su_GetTypeInfoTypeClass(index_type));
	    SetqqForGroupData(region_handle, NULL);
	    break;

	case ProcessStmtInfo:
	    region_handle = CreateRegion(
		TK_GetRegionHandle(VK_GetCallerLARP(VK_GetIARP(region_data))),
		ProcessRegion, qqName(region_info));
	    break;		/* troublemaker? */

	case InstantiationStmtInfo:
	    region_handle = CreateComponentInstantiation(
		TK_GetRegionHandle(VK_GetCallerLARP(VK_GetIARP(region_data))),
		qqName(region_info));
	    break;


	case EntityDeclInfo:
	case ProcedureDeclInfo:
	case ProcedureBodyInfo:
	case FunctionDeclInfo:
	case FunctionBodyInfo:
	case RecordTypeDeclInfo: 
	    ReportInternalError("VK_TraceBegin: Unexpected region type", "", 
		__FILE__, __LINE__);
	    region_handle = NULL;
	    break;

	default:
	    ReportInternalError("VK_TraceBegin: Unknown region type", "", 
		__FILE__, __LINE__);
	    region_handle = NULL;
	    break;
    } /* switch */

    /* Record the handle in the LAR */
    TK_SetRegionHandle(region_data, region_handle);
    RecordCallOrReturn(CurrentProcess, VK_Begin);
} /* VK_TraceBegin */


/* *******************************************************************
*
* VK_TraceEnd -
*
* HISTORY:
*	17-MAY-91 DSB	Created
*	21-MAY-91 DSB	Added line_number
*	21-MAY-91 DSB	Added RecordCallOrReturn
*	05-JUN-91 DSB	Added dump-mode test of DoExamineObjects
*
******************************************************************* */
void VK_TraceEnd(region_data, unit_info, exec_pos, region_info)
VK_tLARHeaderPtr region_data;
VK_tSymbInfoHandle unit_info;
VK_tExecPosIndex exec_pos;
VK_tSymbInfoHandle region_info;
				/* ?? I need parameter comments ?? */
{
    tUnitSymbInfo unit_symb_info;
    VK_tLineNumber line_number;
/**/
    TK_SetUnitInfo(region_data, unit_info);
    TK_SetExecPos(region_data, exec_pos);
					/* update position info. in LAR */
    LastTracepoint.region_data = region_data;
					/* remember last VK_TraceXx call */

    RecordCallOrReturn(CurrentProcess, VK_End);

    su_GetUnitNames(unit_info, &unit_symb_info.library_name,
	&unit_symb_info.primary_name, &unit_symb_info.secondary_name,
	&unit_symb_info.file_name);

#if 0	/* DSB - put this in when the trace table is created */
    /* check for valid exec_pos */
    if (0 > exec_pos || exec_pos >= qqExecTableSize(unit_info)) {
	ReportInternalError("Invalid execution position for VK_TraceElab",
		"", __FILE__, __LINE__);
    }
    else {
	BreakpointCheck(region_data, &unit_symb_info,
		qqTraceTable(unit_info)[exec_pos].line_number,
		VK_ElabDecl, bp_Step);
    }
#else
    if (exec_pos < 0) {	/* ?? RVCG 0.6.0.0 supplied negated line number */
	line_number = -exec_pos;
    }
    else {
	line_number = qqTraceTable(unit_info)[exec_pos].line_number;
    }
    BreakpointCheck(region_data, &unit_symb_info, line_number, VK_ElabDecl, 
	bp_Step);
#endif
    if (GF.dump) {
	DoExamineObjects("*");
    }
} /* VK_TraceEnd */



/* *******************************************************************
*
* VK_TraceCall -
*
* HISTORY:
*	10-MAY-91 JBR	Created
*	13-MAY-91 JBR	Corrected routine name
*	17-MAY-91 DSB	Added LastTracepoint, etc.
*
******************************************************************* */
void VK_TraceCall(subprogram_data, unit_info, exec_pos, subprogram_info)
VK_tLARHeaderPtr subprogram_data;
VK_tSymbInfoHandle unit_info;
VK_tExecPosIndex exec_pos;
VK_tSymbInfoHandle subprogram_info;
{
/**/
    TK_SetRegionInfo(subprogram_data, subprogram_info);
    TK_SetUnitInfo(subprogram_data, unit_info);
    TK_SetExecPos(subprogram_data, exec_pos);
					/* update position info. in LAR */
    LastTracepoint.region_data = subprogram_data;
					/* remember last VK_TraceXx call */

    RecordCallOrReturn(CurrentProcess, VK_Call);
} /* VK_TraceCall */


/* *******************************************************************
*
* VK_TraceReturn -
*
* HISTORY:
*	10-MAY-91 JBR	Created
*	13-MAY-91 JBR	Corrected routine name
*	17-MAY-91 DSB	Added LastTracepoint, etc.
*	21-MAY-91 DSB	Added line_number
*	05-JUN-91 DSB	Added dump-mode test of DoExamineObjects
*
******************************************************************* */
void VK_TraceReturn(subprogram_data, unit_info, exec_pos, subprogram_info)
VK_tLARHeaderPtr subprogram_data;
VK_tSymbInfoHandle unit_info;
VK_tExecPosIndex exec_pos;
VK_tSymbInfoHandle subprogram_info;
{
    tUnitSymbInfo unit_symb_info;
    VK_tLineNumber line_number;
/**/
    TK_SetUnitInfo(subprogram_data, unit_info);
    TK_SetExecPos(subprogram_data, exec_pos);
					/* update position info. in LAR */
    LastTracepoint.region_data = subprogram_data;
					/* remember last VK_TraceXx call */

    RecordCallOrReturn(CurrentProcess, VK_Return);

    su_GetUnitNames(unit_info, &unit_symb_info.library_name,
	&unit_symb_info.primary_name, &unit_symb_info.secondary_name,
	&unit_symb_info.file_name);

#if 0	/* JBR - put this in when the trace table is created */
    /* check for valid exec_pos */
    if (0 > exec_pos || exec_pos >= qqExecTableSize(unit_info)) {
	ReportInternalError("Invalid execution position for VK_TraceReturn",
		"", __FILE__, __LINE__);
    }
    else {
	BreakpointCheck(subprogram_data, &unit_symb_info,
		qqTraceTable(unit_info)[exec_pos].line_number,
		VK_Return, bp_Return);
    }
#else
    if (exec_pos < 0) {	/* ?? RVCG 0.6.0.0 supplied negated line number */
	line_number = -exec_pos;
    }
    else {
	line_number = qqTraceTable(unit_info)[exec_pos].line_number;
    }
    BreakpointCheck(subprogram_data, &unit_symb_info, line_number, VK_Return, 
	bp_Return);
#endif
    if (GF.dump) {
	DoExamineObjects("*");
    }
} /* VK_TraceReturn */


/* *******************************************************************
*
* VK_TraceElab
*
* HISTORY:
*	10-MAY-91 JBR	Created
*	17-MAY-91 DSB	Added LastTracepoint, etc.
*	21-MAY-91 DSB	Added line_number
*
******************************************************************* */
void VK_TraceElab(encl_region_data, unit_info, exec_pos)
VK_tLARHeaderPtr encl_region_data;
VK_tSymbInfoHandle unit_info;
VK_tExecPosIndex exec_pos;
{
    tUnitSymbInfo unit_symb_info;
    VK_tLineNumber line_number;
/**/
    TK_SetUnitInfo(encl_region_data, unit_info);
    TK_SetExecPos(encl_region_data, exec_pos);
					/* update position info. in LAR */
    LastTracepoint.region_data = encl_region_data;
					/* remember last VK_TraceXx call */

    su_GetUnitNames(unit_info, &unit_symb_info.library_name,
	&unit_symb_info.primary_name, &unit_symb_info.secondary_name,
	&unit_symb_info.file_name);

#if 0	/* JBR - put this in when the trace table is created */
    /* check for valid exec_pos */
    if (0 > exec_pos || exec_pos >= qqExecTableSize(unit_info)) {
	ReportInternalError("Invalid execution position for VK_TraceElab",
		"", __FILE__, __LINE__);
    }
    else {
	BreakpointCheck(encl_region_data, &unit_symb_info,
		qqTraceTable(unit_info)[exec_pos].line_number,
		VK_ElabDecl, bp_Step);
    }
#else
    if (exec_pos < 0) {	/* ?? RVCG 0.6.0.0 supplied negated line number */
	line_number = -exec_pos;
    }
    else {
	line_number = qqTraceTable(unit_info)[exec_pos].line_number;
    }
    BreakpointCheck(encl_region_data, &unit_symb_info, line_number, 
	VK_ElabDecl, bp_Step);
#endif
} /* VK_TraceElab */


/* ?? routine name and parameters should have comments; go ahead and copy
	them from VKTrace.h ?? */
/* *******************************************************************
*
* VK_TraceExec
*
* HISTORY:
*	10-MAY-91 JBR	Created
*	17-MAY-91 DSB	Added LastTracepoint, etc.
*	21-MAY-91 DSB	Added line_number
*
******************************************************************* */
void VK_TraceExec(encl_region_data, unit_info, exec_pos)
VK_tLARHeaderPtr encl_region_data;
VK_tSymbInfoHandle unit_info;
VK_tExecPosIndex exec_pos;
{
    tUnitSymbInfo unit_symb_info;
    VK_tLineNumber line_number;
/**/
    TK_SetUnitInfo(encl_region_data, unit_info);
    TK_SetExecPos(encl_region_data, exec_pos);
					/* update position info. in LAR */
    LastTracepoint.region_data = encl_region_data;
					/* remember last VK_TraceXx call */

    su_GetUnitNames(unit_info, &unit_symb_info.library_name,
	&unit_symb_info.primary_name, &unit_symb_info.secondary_name,
	&unit_symb_info.file_name);

#if 0	/* JBR - put this in when the trace table is created */
    /* check for valid exec_pos */
    if (0 > exec_pos || exec_pos >= qqExecTableSize(unit_info)) {
	ReportInternalError("Invalid execution position for VK_TraceExec",
		"", __FILE__, __LINE__);
    }
    else {
	BreakpointCheck(encl_region_data, &unit_symb_info,
		qqTraceTable(unit_info)[exec_pos].line_number,
		VK_ExecStmt, bp_Step);
    }
#else
    if (exec_pos < 0) {	/* ?? RVCG 0.6.0.0 supplied negated line number */
	line_number = -exec_pos;
    }
    else {
	line_number = qqTraceTable(unit_info)[exec_pos].line_number;
    }
    BreakpointCheck(encl_region_data, &unit_symb_info, line_number, 
	VK_ExecStmt, bp_Step);
#endif
} /* VK_TraceExec */


#if 0
/* *******************************************************************
*
* RtnName - <description of function or procedure>
*
* HISTORY:
*	??-MAY-91 JBR	Created
*
******************************************************************* */


<static> Fntype RtnName(parm)				/* return value desc. if not void */
tParmType parm;			/* mode: description */
{
    type local;				/* description */
    type local;				/* description */
/**/

} /* RtnName */


#endif
