#ifndef TKDebugUtils_H
#define TKDebugUtils_H
/*****************************************************************************
*
* Copyright (c) 1991 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* FILE: TKDebugUtils.h - secondary support functions for TKDebug
*
* DESCRIPTION:
*
* TYPES:
*
* CONSTANTS:
*
* FUNCTIONS:
*
* HISTORY:
*	16-OCT-91 MNP	Created
*
* SCCS ID: @(#)TKDebugUtils.h	42.1 1/10/92
*
*****************************************************************************/

#include "TKCommon.h"
#include "TKData.h"		/* for TIME macros */
#include "TKStructs.h"		/* for symbolic information types */
#include "TKSymbUtils.h"	/* for TK_GetRegionInfo, etc. */


/*****************************************************************************
*
* Types
*
*****************************************************************************/

/* Return status from VerifyLineNum() and friends. From rphaned
   TKUnitInfo.[ch]. 04-OCT-91 MNP */

typedef enum {		
        L_NoValue,
        L_InvParam,
	L_InvLine,
	L_NoLibrary,
	L_NoUnit,
	L_InRange,
	L_OutOfRange,
	L_InvSrcFile,
	L_Same
} tLineNumCode;


/*****************************************************************************
*
* Prototypes
*
*****************************************************************************/

tLineNumCode ScanTraceTable(
#ifdef ANSI_FN_PROTOS
	VK_tSymbInfoHandle syminfo,	
	VK_tLineNumber wanted_line,
	VK_tLineNumber *previous,
	VK_tLineNumber *following,
	VK_tLineNumber *smallest,
	VK_tLineNumber *largest
#endif
	);

tLineNumCode VerifyUnitLine(
#ifdef ANSI_FN_PROTOS
	VK_tCString lib_name,   	
	VK_tCString entity_name,	
	VK_tCString arch_name,  	
	Integer4 line_num,     		
	Integer4 *prev,     
	Integer4 *next,
	VK_tCString *lib_name
#endif
);

tLineNumCode VerifyFileLine(
#ifdef ANSI_FN_PROTOS
	VK_tCString source_file,	
	VK_tLineNumber line_number,	
	VK_tLineNumber *previous_line,	
	VK_tLineNumber *following_line, 
	VK_tLineNumber *smallest,	
	VK_tLineNumber *largest,	
	VK_tSymbInfoHandle *unit_info,	
#endif
	);


#endif 
