#ifndef TKFileUtils_H
#define TKFileUtils_H
/*****************************************************************************
*
* Copyright (c) 1991 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* FILE: TKFileUtils.c - Utilities dealing with filenames and
*	environment variables.
*
* DESCRIPTION:
*	Based upon work from STSrcDisplay in the VLK, by GJB.
*
* DESCRIPTION:
*
* TYPES:
*
* CONSTANTS:
*
* FUNCTIONS:
*
* HISTORY:
*	22-OCT-91 MNP	Created
*
* SCCS ID: @(#)TKFileUtils.h	42.1 1/10/92
*
*****************************************************************************/

/* TODO
 *  - This should be OS independant. Much of this is Unix only. 
 *  - File access routines like FileExists(). Anything stdio can 
 *    work portably, even on MSDOS.
 *  - Low level file things like read(2), pipe(2), etc. should go
 *    someplace.
 */


#include "VKBasicTypes.h"	/* for VK_tCString ... */


/*****************************************************************************
*
* Types
*
*****************************************************************************/

/* Status returned by most file util functions. */

typedef enum {
    NonexistantFile,		/* can't find or access it */
    UnknownVarInPath,		/* variable not expandable */
    BadTildeInPath,		/* tilde not where it belongs */
    IntError,			/* internal error */
    FileSuccess			/* okeedoke */
} tFileUtilStatus;


/*****************************************************************************
*
* Prototypes
*
*****************************************************************************/

tFileUtilStatus ExpandPathName(
#ifdef ANSI_FN_PROTOS
	char * old_file_name,		/* in: filename to look at */
	char ** new_file_name,		/* out: the expanded name */
	char ** bad_var_or_tilde	/* out: if error, talk about this */
#endif
	);

VK_tCString FilenameBase(
#ifdef ANSI_FN_PROTOS
	VK_tCString *fname
#endif
	);

VK_tBoolean FilenamesEqual(
#ifdef ANSI_FN_PROTOS
	VK_tCString a,
	VK_tCString b,
#endif
	);

#endif /* TKFileUtils_H */
