static char SCCS_ID[] = "@(#)TKGlobals.c	42.1 1/10/92";
/* *******************************************************************
*
* Copyright (c) 1989-1990 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* CODE FILE: TKGlobals.c
*
* DESCRIPTION:  
*	<then describe contents>
*
* CONSTANTS:
*	<constants>	<constants defined in this header file >
*
* TYPES:
*	<types>		<types defined in this header file >
*
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this header file >
*
* ROUTINES:
*   External:
*	...
*
*   Internal:
*	...
*
* HISTORY:
* 	07-Sep-90 RM	Created from TKCommon module.
*	27-MAR-91 WAG	Split the ProcessList into two lists: KernelProcessList
*			and UserProcessList.
*	25-APR-91 AWH	WOO21: Renamed to TK...
*	02-MAY-91 DSB	Cleaning up generally
*	06-MAY-91 DSB	Cleaning up signal changes, etc.
*	14-MAY-91 DSB	W0053+: Split out DelayedProcessList
*	15-MAY-91 DSB	Moved EventTimeQueue to TKSim.c (trying to break 
*			FmtWave dependencies to call VK_ResolveSolve from 
*			kernel)
*	16-MAY-91 DSB	Converting to unsigned absolute time
*	08-JAN-92 DKC	Removed Driver count/Table stuff
*
* SCCS ID: @(#)TKGlobals.c	42.1 1/10/92
*
******************************************************************* */

#include "VKBasicTypes.h"
#include "TKData.h"		/* for tSimCycleCount, etc. */
#include "TKGlobals.h"
#include "TKListFns.h"
#include "TKStructs.h"
#include "TKSim.h"


/* extern */ tGlobalFlags GF = {
	False,			/* interactive */
	False,			/* slave */
	False,			/* dump */
        False, 			/* verbose */
        False,			/* error_occurred */
    	False			/* warning_occured */
	};


/* extern */ TempList SymbInfoList = TempNoList();
/* extern */ TempList LibraryInfoList = TempNoList();

/* extern */ TempList RegionList = TempNoList();
/* extern */ TempList TypeList = TempNoList();
/* extern */ TempList AssocList = TempNoList();
/* extern */ TempList SensitivitySetList = TempNoList();
/* extern */ TempList KernelProcessList = TempNoList();
/* extern */ TempList DelayedProcessList = TempNoList();
/* extern */ TempList UserProcessList = TempNoList();

/* extern */ tSignalNumber	ScalarSignalCount = 0;
/* extern */ tSignalNumberTable	SignalNumberTable = NULL;
/* extern */ TempList	        SignalGroupList = TempNoList();

/* extern */ TempList	        DriverGroupList = TempNoList();

/* extern */ tAbsTimeBuf SimTime;
/* extern */ tSimCycleCount SimCycleCount;
/* extern */ int DeltaCount;
/* extern */ int EventCount;
/* extern */ int TotalAssertionCount;
/* extern */ int LocalAssertionCount;
/* extern */ int TotalErrorCount;
/* extern */ int LocalErrorCount;
/* extern */ int TotalWarningCount;
/* extern */ int LocalWarningCount;


/* *******************************************************************
*
* InitGlobals - initialize global lists.
*
* HISTORY:
* 	07-Sep-90 RM	Created from TKMain module.
*	27-MAR-91 WAG	Added initialization for split process lists: 
*			KernelProcessList and UserProcessList.
*
******************************************************************* */

void InitGlobals()
{
/**/
    SymbInfoList = TempNewList();
    LibraryInfoList = TempNewList();

    RegionList = TempNewList();
    TypeList = TempNewList();		/* ?? remove this when cleaning up */
    AssocList = TempNewList();

    KernelProcessList = TempNewList();
    DelayedProcessList = TempNewList();
    UserProcessList = TempNewList();

    SensitivitySetList = TempNewList();

    SignalGroupList = TempNewList();
    DriverGroupList = TempNewList();
} /* InitGlobals */

