static char SCCS_ID[] = "@(#)TKIO.c	42.2 1/13/92";
/* *******************************************************************
*
* Copyright (c) 1989-1990 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* CODE FILE: TKIO.c
*
* DESCRIPTION:  
*	<then describe contents>
*
* CONSTANTS:
*	<constants>	<constants defined in this header file >
*
* TYPES:
*	<types>		<types defined in this header file >
*
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this header file >
*
* ROUTINES:
*   External:
*	...
*
*   Internal:
*	...
*
* HISTORY:
*	04-OCT-89 DSB	Split from VKI.c
*	24-APR-90 DSB	Converting to combined map/trace file
*	12-OCT-90 AWH	Added formatting of vector signals.
*	18-MAR-91 HK	Added references to TIME macros.
*	25-APR-91 AWH	WOO21: Renamed to TK...
*	02-MAY-91 DSB	Cleaning up generally
*	06-MAY-91 DSB	Cleaning up signal changes
*	16-MAY-91 DSB	Removed FileNamePart
*	16-MAY-91 DSB	Cleaning up tSymbInfoKind enumerators
*	16-MAY-91 DSB	Converting to unsigned absolute time
*	21-MAY-91 DSB	Cleaned up old types; renamed to remove some VK_
*	24-OCT-91 MNP	New param to RD_WriteSignalDeclaration: simple name.
*	14-NOV-91 DKC	Removed WriteXDeclarations
*	08-JAN-92 DKC	Removed use of qqNumber(element)
*
* SCCS ID: @(#)TKIO.c	42.2 1/13/92
*
******************************************************************* */

/* ?? It look like TKIO should be split into two modules, one that
	formats data and one that writes (mostly) and reads data;
	maybe TKFormat (sort of) and TK? ... ?? */

				/* ?? now how did the following comments get
					moved to the wrong column? ?? */
#include "TKCommon.h"
#include "TKIO.h"
#include "TKSim.h"		 /* for EventTimeQueue, CurrentProcess */
#include "TKStructs.h"		 /* for Signal Record etc ... */
#include "TKTemp.h"		 /* for VERIFY, TempStrCat */
#include "TKData.h"		 /* for TIME macros */
#include "TKSymbUtils.h" 	 /* for su_GetTypeInfoTypeClass */
#include "TKRegister.h" 	 /* for SymbInfoList, SIH_* */
#include "TKRecord.h"		/* for RD_WriteXxx, etc. */


#include "TKListFns.h"
#include "TKGlobals.h"
 
#ifndef TK_FAST_COMPILE
#  include "SPI.h"

#else
#  include "DataFnsPub.h"	/* for ... */
#  include "ListFnsPub.h"	/* for ... */
#  include "TimeFnsPub.h"	/* for TimeStampToStrN */
#  include "HostMiscPub.h"	/* for SysDateTime*/
#endif

#include <stdio.h>		/* for fflush, etc. */

/* extern */ FILE * TraceFile = NULL; 
#define GET_TraceFile (NULL == TraceFile ? stderr : TraceFile)
				/* initialize to stderr to report errors
				   until StartTraceFile is called. */
	/* ?? why isn't (something like) this used anymore? if it's really
	not needed, let's remove it ?? */

/* ?? rename, e.g., to TransactionString ?? */
#define TRANSACTION	"Transaction"
#define QUIET		"Quiet"
#define STABLE		"Stable"
#define DELAYED		"Delayed"
#define GUARD		"GUARD"	


	/* separators for "lexical" names */
#define LexicalSeparator "."		/* VHDL selected name separator */
#define ExtendedSeparator1 "("		/* for E(A), P(body) */
#define ExtendedSeparator2 ")"		/* for E(A), P(body) */

	/* separators for "hierarchical" names */
#define NormalSeparator "."		/* follow VHDL selected name */
#define SpecialSeparator "/"		/* show instantiation points */
#define RootSeparator "/"		/* currently, start with "/" */
#define TickSeparator "'"		/* as in S'Stable */


static void FormatHierarchicalNameSub(
#ifdef ANSI_FN_PROTOS
	char * buffer,
	int buf_size,
	VK_tVoidPtr handle
#endif /* ANSI_FN_PROTOS */
	);


/* *******************************************************************
*
* GetRegionKindStr - get string for region type
*
* HISTORY:
*	16-APR-90 DSB	Created
*	19-JUN-90 DSB	Fixed bug: added return statement
*	17-MAY-91 DSB	Added PackageBodyRegion
*
******************************************************************* */
VK_tCString GetRegionKindStr(region_kind)
tRegionKind region_kind;
{
    VK_tCString result = NULL;
/**/
    switch (region_kind) {
	case KernelRegion:		result = "Kernel";		break;

	case PackageRegion:		result = "Package";		break;
	case PackageBodyRegion:		result = "PackageBody";		break;
	case DesignEntityRegion:	result = "DesignEntity";	break;
	case BlockRegion:		result = "Block";		break;
	case IfGenerateRegion:		result = "IfGenerate";		break;
	case ForGenerateGroupRegion:	result = "ForGenerateGroup";	break;
	case ForGenerateRegion:		result = "ForGenerate";		break;
	case ComponentInstantiationRegion:	
				result = "ComponentInstantiation";	break;
	case ProcessRegion:		result = "Process";		break;
	case ProcedureRegion:		result = "Procedure";		break;
	case FunctionRegion:		result = "Function";		break;
	default:			result = "UNKNOWN REGION";	break;
    } /* switch */
    return result;
} /* GetRegionKindStr */


/* *******************************************************************
*
* GetSymbInfoKindStr - get string for symbolic information record type
*
* HISTORY:
*	25-FEB-91 DSB	Created
*	05-JUN-91 DSB	Fixed typo.
*	11-JUN-91 DSB	Added LargePhysicalTypeDeclInfo case
*	23-JUL-91 DSB	Added component and configuration cases
*
******************************************************************* */
VK_tCString GetSymbInfoKindStr(symb_info_kind)
tSymbInfoKind symb_info_kind;
{
    VK_tCString result = NULL;
/**/
    switch (symb_info_kind) {
    	case LibraryRegionInfo:		result = "Library";		break;
    	case PackageDeclInfo:		result = "Package Declaration"; break;
	case PackageBodyInfo:		result = "Package Body";	break;
	case EntityDeclInfo:		result = "Entity Declaration";	break;
	case ArchitectureBodyInfo:	result = "Architecture Body";	break;
	case ConfigurationDeclInfo:
				result = "Configuration Declaration";	break;

	case BlockStmtInfo:		result = "Block Statement";	break;
	case IfGenerateStmtInfo:	
				result = "If Generate Statement";	break;
	case ForGenerateStmtInfo:
				result = "For Generate Statement";	break;
	case ProcessStmtInfo:		result = "Process Statement";	break;

	case ProcedureDeclInfo:	result = "Procedure Declaration";	break;
	case ProcedureBodyInfo:		result = "Procedure Body";	break;
	case FunctionDeclInfo:	result = "Function Declaration";	break;
	case FunctionBodyInfo:		result = "Function Body";	break;

	case EnumerationTypeDeclInfo:	result = "Enumeration Type";	break;
	case IntegerTypeDeclInfo:	result = "Integer Type";	break;
	case FloatingTypeDeclInfo:	result = "Floating Type";	break;
	case PhysicalTypeDeclInfo:	result = "Physical Type";	break;
	case LargePhysicalTypeDeclInfo:	result = "Large Physical Type";	break;
	case ArrayTypeDeclInfo:		result = "Array Type";		break;
	case IndexSubtypeInfo:		result = "Index Subtype";	break;
	case RecordTypeDeclInfo:		result = "Record Type";	break;
	case RecordElementDeclInfo:	result = "Record Element";	break;
	case FileTypeDeclInfo:		result = "File Type";		break;
	case AccessTypeDeclInfo:		result = "Access Type";	break;
	case SubtypeDeclInfo:		result = "Subtype Declaration";	break;

	case InterfaceConstantDeclInfo:	result = "Interface Constant";	break;
	case LocalConstantDeclInfo:	result = "Local Constant";	break;
	case InterfaceVariableDeclInfo:	result = "Interface Variable";	break;
	case LocalVariableDeclInfo:	result = "Local Variable";	break;
	case LocalFileDeclInfo:		result = "Local File Variable";	break;
	case InterfaceSignalDeclInfo:	result = "Interface Signal";	break;
	case LocalSignalDeclInfo:	result = "Local Signal";	break;

	case ComponentDeclInfo:	result = "Component Declaration";	break;
	case InstantiationStmtInfo:
				result = "Component Instantiation";	break;
	case ConfigurationSpecInfo:
				result = "Configuration Specification";	break;
	case ComponentConfigurationInfo:
				result = "Component Configuration";	break;
	case LibrarySymbolInfo:		result = "Library Symbol";	break;

	default:			result = "UNKNOWN SYMB. INFO.";	break;
    } /* switch */
    return result;
} /* GetSymbInfoKindStr */


/* *******************************************************************
*
* FormatScalarValue - format scalar VHDL value
*
* NOTE: If the style of the values stored in buffer is modified
*	(for example changing the spacing between the number and
*	units in a physical type's value), ComputeFieldWidth
*	(below in this file) should be modified to match.
*
* HISTORY:
*	25-APR-90 DSB	Created
* 	03-OCT-90 AWH	Reduced from FormatSignalValue
*	05-MAR-91 DSB	Cleaning up a little; adding comments
*	27-MAR-91 JBR	W0003.  Added support for integer and floating type
*			symbolic information.
*	03-APR-91 JBR	W0013.  Added support for physical type symbolic info.
*	05-APR-91 JBR	W0013 bug fix.  Changed qqPositionValue to qqLiterals.
*	05-APR-91 JBR	W0022.  Added cross reference comments to
*			ComputeFieldWidth.
*	08-APR-91 AWH	Fix problem with format of Physical Types
*	15-MAY-91 DSB	Changed %f to %g (eliminate ~38-char. columns)
*	30-MAY-91 DSB	Assume integer for element of non-vector composite
*	05-JUN-91 DSB	Applied TempStrCat
*	11-JUN-91 DSB	Added tc_LargePhysical case
*
******************************************************************* */
void FormatScalarValue(buffer, buf_size, type_class, type_symb_info, 
	value_addr)
char * buffer;				/* &out: buffer in which to format
					   value */
int buf_size;				/* in: size of buffer */
tTypeClass type_class;		/* in: type class of value */
					/* ?? remove this when type_symb_info
					   is  provided for all calls ?? */
VK_tSymbInfoHandle type_symb_info;	/* in: type information */
VK_tScalarAddr value_addr;		/* &in: address of value */
{
#define TC_PHYSICAL_BASE_UNIT(TSI) \
	((TSI == SIH_Std__Standard__Time) ? BaseUnit : qqLiterals(TSI)[0])
		    			/* if type Time use system BaseUnit;
					   otherwise use first element in 
					   literals array */
    VK_tIntegerData enum_value;
    VK_tIntegerData int_value;
    VK_tLargeAddr large_value_addr;
    VK_tFloatingData float_value;
    VK_tIntegerData phys_value;
/**/
    if (NULL != type_symb_info) {
	    VERIFY_ERROR(type_class == su_GetTypeInfoTypeClass(type_symb_info));
    }
/* ?? CLEANUP: remove type_class parameter ?? */
    switch (type_class) {
	case tc_BadTypeClass:		/* intended for partial display of
					   non-vector composites; display as
					   integers */
	    int_value = * (VK_tIntegerData *) value_addr;

	    sprintf(buffer, "?%d", int_value);
	    break;
	case tc_Enumeration:
	    enum_value = * (VK_tIntegerData *) value_addr;

	    if (NULL == type_symb_info) {
					/* there is no type information */
		sprintf(buffer, "?%d",  enum_value);
	    }
	    else if ((enum_value < 0) ||
		    (qqCardinality(type_symb_info) < enum_value)) {
					/* value is out of range */
		sprintf(buffer, "E%d", enum_value);
	    }
	    else {			/* type and value are fine */
		sprintf(buffer, "%s", 
			(qqLiterals(type_symb_info))[enum_value]);
					/* get literals array from type; then 
					   index array with position value */
	    }
	    break;
	case tc_Integer:
	    int_value = * (VK_tIntegerData *) value_addr;

	    if (NULL == type_symb_info) {
					/* there is no type information */
		sprintf(buffer, "?%d", int_value);
	    }
	    else if ((VK_Ascending == qqDirection(type_symb_info)) &&
		    ((qqIntegerLeftBound(type_symb_info) > int_value) ||
		    (qqIntegerRightBound(type_symb_info) < int_value))) {
					/* value is out of range */
		sprintf(buffer, "E%d", int_value);
	    }
	    else if ((VK_Descending == qqDirection(type_symb_info)) &&
		    ((qqIntegerLeftBound(type_symb_info) < int_value) ||
		    (qqIntegerRightBound(type_symb_info) > int_value))) {
					/* value is out of range */
		sprintf(buffer, "E%d", int_value);
	    }
	    else {			/* type and value are fine */
		sprintf(buffer, "%d", int_value);
	    }
	    break;
	case tc_Physical:
	    phys_value = * (VK_tIntegerData *) value_addr;
					/* If a space is added between the
					   number and the unit name, modify
					   ComputeFieldWidth to match */
	    if (NULL == type_symb_info) {
					/* there is no type information */
		sprintf(buffer, "?%d<UNITS>", phys_value);
	    }
	    else if ((VK_Ascending == qqDirection(type_symb_info)) &&
		    ((qqIntegerLeftBound(type_symb_info) > phys_value) ||
		    (qqIntegerRightBound(type_symb_info) < phys_value))) {
					/* value is out of range */
		if (NULL == qqLiterals(type_symb_info)) {
			sprintf(buffer, "E%d<UNITS>", phys_value);
		}
		else {
			sprintf(buffer, "E%d%s", phys_value,
				TC_PHYSICAL_BASE_UNIT(type_symb_info));
		}
	    }
	    else if ((VK_Descending == qqDirection(type_symb_info)) &&
		    ((qqIntegerLeftBound(type_symb_info) < phys_value) ||
		    (qqIntegerRightBound(type_symb_info) > phys_value))) {
					/* value is out of range */
		if (NULL == qqLiterals(type_symb_info)) {
			sprintf(buffer, "E%d<UNITS>", phys_value);
		}
		else {
			sprintf(buffer, "E%d%s", phys_value,
				TC_PHYSICAL_BASE_UNIT(type_symb_info));
		}
	    }
	    else {			/* type and value are fine */
		if (NULL == qqLiterals(type_symb_info)) {
			sprintf(buffer, "%d<UNITS>", phys_value);
		}
		else {
			sprintf(buffer, "%d%s", phys_value,
				TC_PHYSICAL_BASE_UNIT(type_symb_info));
		}
	    }
	    break;
	case tc_LargePhysical:
	    large_value_addr = (VK_tLargeAddr) value_addr;
					/* If a space is added between the
					   number and the unit name, modify
					   ComputeFieldWidth to match */
	    if (NULL == type_symb_info) {
					/* there is no type information */
		strcpy(buffer, "?");
		STIME_FORMAT(&buffer[1], *large_value_addr);
		strcat(buffer, "<UNITS>");
	    }
#if 0
	    else if ((VK_Ascending == qqDirection(type_symb_info)) &&
		    ((qqIntegerLeftBound(type_symb_info) > phys_value) ||
		    (qqIntegerRightBound(type_symb_info) < phys_value))) {
					/* value is out of range */
		if (NULL == qqLiterals(type_symb_info)) {
			sprintf(buffer, "E%d<UNITS>", phys_value);
		}
		else {
			sprintf(buffer, "E%d%s", phys_value,
				TC_PHYSICAL_BASE_UNIT(type_symb_info));
		}
	    }
	    else if ((VK_Descending == qqDirection(type_symb_info)) &&
		    ((qqIntegerLeftBound(type_symb_info) < phys_value) ||
		    (qqIntegerRightBound(type_symb_info) > phys_value))) {
					/* value is out of range */
		if (NULL == qqLiterals(type_symb_info)) {
			sprintf(buffer, "E%d<UNITS>", phys_value);
		}
		else {
			sprintf(buffer, "E%d%s", phys_value,
				TC_PHYSICAL_BASE_UNIT(type_symb_info));
		}
	    }
#endif
	    else {			/* type and value are fine */
		if (NULL == qqLiterals(type_symb_info)) {
		    STIME_FORMAT(buffer, *large_value_addr);
		    strcat(buffer, "<UNITS>");
		}
		else {
		    STIME_FORMAT(buffer, *large_value_addr);
		    strcat(buffer, TC_PHYSICAL_BASE_UNIT(type_symb_info));
		}
	    }
	    break;
	case tc_Floating:
	    float_value = *(VK_tFloatingData *) value_addr;

	    if (NULL == type_symb_info) {
					/* there is no type information */
		sprintf(buffer, "?%13.7g", float_value);
	    }
	    else if ((VK_Ascending == qqDirection(type_symb_info)) &&
		    ((qqFloatLeftBound(type_symb_info) > float_value) ||
		    (qqFloatRightBound(type_symb_info) < float_value))) {
					/* value is out of range */
		sprintf(buffer, "E%13.7g", float_value);
	    }
	    else if ((VK_Descending == qqDirection(type_symb_info)) &&
		    ((qqFloatLeftBound(type_symb_info) < float_value) ||
		    (qqFloatRightBound(type_symb_info) > float_value))) {
					/* value is out of range */
		sprintf(buffer, "E%13.7g", float_value);
	    }
	    else {			/* type and value are fine */
		sprintf(buffer, "%13.7g", float_value);
	    }
	    break;
	default:
	    TempStrCpy(buffer, buf_size, "<UNEXPECTED SCALAR TYPE>");
	    break;
    } /* switch */
} /* FormatScalarValue */


/* *******************************************************************
*
* FormatSignalGroupName - Formats simple signal name or name of a signal
*			  valued attribute.
*
* DESCRIPTION:
*	Gets the name of the signal either from the Symbolic Information
*	Record if the signal is an explicit one or construct it if the
*	signal is an implicit one, and puts the name in the buffer.
*
* HISTORY:
*	01-MAR-91 HK	Created
*	05-JUN-91 DSB	Applied TempStrCat
*
******************************************************************* */
static void FormatSignalGroupName(buffer, buf_size, group)
char * buffer;
int buf_size;
VK_tSignalHandle group;
{
    tTempBuf80 time_buf;
    tSignalElementHandle element;
    tSignalNumber signal_number;
/**/
    if (NULL == qqSymbInfo(group)) {
	VERIFY_ERROR((sc_Explicit != qqSignalClass(group)) &&
	       (sc_BadSignalClass != qqSignalClass(group)));
					/* implicit signal */
	switch (qqSignalClass(group)) {
	    case sc_Transaction:
		TempStrCpy(buffer, buf_size, TRANSACTION);
		break;
	    case sc_Quiet:
		signal_number = qqSignalStart(group);
		element = SignalElementHandle(signal_number);
		UTIME_FORMAT(time_buf, ImplicitTime(element));
		sprintf(buffer, "%s(%s %s)", QUIET, time_buf, BaseUnit);
/* ?? now, we should probably use FormatScalarValue for the physical
	literal part (the part inside the parentheses) [DSB, 910410]?? */
		break;
	    case sc_Stable:
		signal_number = qqSignalStart(group);
		element = SignalElementHandle(signal_number);
		UTIME_FORMAT(time_buf, ImplicitTime(element));
		sprintf(buffer, "%s(%s %s)", STABLE, time_buf, BaseUnit);
/* ?? see above ?? */
		break;
	    case sc_Delayed:
		signal_number = qqSignalStart(group);
		element = SignalElementHandle(signal_number);
		UTIME_FORMAT(time_buf, ImplicitTime(element));
		sprintf(buffer, "%s(%s %s)", DELAYED, time_buf, BaseUnit);
/* ?? see above ?? */
		break;
	    case sc_Guard:
		TempStrCpy(buffer, buf_size, GUARD);
		break;
	    default:
		break;
	} /* switch */
    }
    else {
	TempStrCpy(buffer, buf_size, qqName(qqSymbInfo(group)));
    }
} /* FormatSignalGroupName */


/* *******************************************************************
*
* FormatSignalNameSub - format signal name 
*
* HISTORY:
*	23-OCT-90 AWH	Created
*	02-MAR-91 HK	Changed step 2, since signal group records do not
*			have a Name field any more.
*	04-APR-91 WAG	W0023.  Modified to conform to coding style standards.
*	30-MAY-91 DSB	Fixed bug: index values were wrong (usually zero)
*	30-MAY-91 DSB	Reworked to handle non-vector composites
*	05-JUN-91 DSB	Applied TempStrCat
*	 6-NOV-91 DKC	Fixed for arrays of large physical type
*	21-NOV-91 DKC	Removed index stuff (may not yield expected result)
*
******************************************************************* */
static void FormatSignalNameSub(buffer, buf_size, signal_handle, start, 
	length, expand)
char * buffer;
int buf_size;
VK_tSignalHandle signal_handle;
tSignalNumber start;
VK_tSignalLength length;
VK_tBoolean expand;
{
    VK_tSignalHandle group;
    tSignalElementHandle element;
    VK_tSignalLength prefix_length;
    VK_tScalarData left_index, right_index, index;
    tTempBuf80 value_buf;
    int len;
    tPrefixDataHandle imp_data;
/**/

	/* 1: Format Hierarchy */
    element = SignalElementHandle(start);
    if (NULL != signal_handle) {
	group = signal_handle;		/* ?? starting change to handle ?? */
	VERIFY_ERROR(group == qqRootSignal(qqGroup(element)));
    }
    else {
	group = qqGroup(element);	/* get group from first element */
    }
 
    VERIFY_ERROR(sc_BadSignalClass != qqSignalClass(group));
    if (sc_Explicit == qqSignalClass(group) ||
	sc_Guard == qqSignalClass(group)) {
					/* explicit or GUARD signal */
	FormatHierarchicalNameSub(buffer, buf_size, 
                                  TK_GetRegionHandle(qqRegionData(group)));
	TempStrCat(buffer, buf_size, NormalSeparator);
    } 
    else {				/* implicit signal other than guard */
        imp_data = qqImplicitData(group);
	if (sc_Delayed == qqSignalClass(group)) {
					/* for 'Delayed signals, format the 
					   name of the base signal for all the
					   elements of `Delayed */
	    prefix_length = qqSignalLength(group);
	}
	else {
	    prefix_length = qqPrefixSignalLength(imp_data);
	}
	FormatSignalNameSub(buffer, buf_size, PrefixSignalHandle(imp_data),
		          qqPrefixSignalStart(imp_data), prefix_length, False);
					/* False: don't expand inner signal 
					   name components */
	TempStrCat(buffer, buf_size, TickSeparator);
    }

	/* 2: Base Name */
    len = strlen(buffer);
    FormatSignalGroupName(&buffer[len], buf_size-len, group);

	/* 3: Range - if vector */

    if (expand || length < qqSignalLength(group)) {
					/* if forced expansion, or if not
					   whole signal */
	if (gc_VectorSignal == qqGroupClass(group)) {
					/* group is vector signal */
            tStaticStrBuf  str_buff;
                
            DESC_STR_APPEND(buffer,buf_size,&str_buff);

	    if (expand || length > 1) {	/* format a slice name */
                FormatSignalPortionName(&str_buff,start,length,FALSE,FALSE);
	    }
	    else {			/* format an indexed name */
                FormatSignalPortionName(&str_buff,start,0,FALSE,FALSE);
	    }
	}
	else if (gc_CompositeSignal == qqGroupClass(group)) {
					/* group is non-vector composite 
					   signal */
	    if (sc_Delayed != qqSignalClass(group)) { 
					/* not to repeat <...> after 
					   "S<...>'Delayed" */
		TempStrCat(buffer, buf_size, "<...>");
	    }
	}
    }
} /* FormatSignalNameSub */


/* *******************************************************************
*
* FormatHierarchicalNameSub - format hierarchical name 
*
* DESCRIPTION:
*	Notes:
*
* HISTORY:
*	05-FEB-90 DSB	Created
*	15-JUN-90 DSB	Added Type case
*	04-OCT-90 AWH	Added vector signals.
*	02-JAN-90 DSB	Changed Comp.Inst. to Design Entity for '/' vs. '.'
*	02-JAN-90 DSB	Split FormatHierarchicalName and ...Sub
*	04-APR-91 WAG	W0023.  Now reference TK_tRegionHandle fields with
*			the appropriate qqX macro instead of directly.
*	17-MAY-91 DSB	Change process case: use process statement region
*	05-JUN-91 DSB	Applied TempStrCat
*	17-JUL-91 DSB	Restored for generate parameter value in label name
*
******************************************************************* */
static void FormatHierarchicalNameSub(buffer, buf_size, handle)
char * buffer;
int buf_size;
VK_tVoidPtr handle;		/* generalized handle */
{
    tRecordKind type;
    VK_tProcessHandle process_handle;
    tSignalElementHandle element_handle;
    VK_tSignalHandle group_handle;
    TK_tRegionHandle region_handle;
    tTempBuf80 value_buf;
/**/
/* Note: This routine does not handle signals correctly. It should
 	work on a signal_number, signal_length pair instead of the group
	handle.  ??*/

    if (NULL == handle) {
	TempStrCat(buffer, buf_size, "<NULL>");		/* ERROR */
    }
    else {
    	type = qqRecordKind((tSignalElementHandle) handle);
	switch (type) {
	    case ProcessRecord:		/* for process, get name from process 
					   statement region */
		process_handle = (VK_tProcessHandle) handle;
		FormatHierarchicalNameSub(buffer, buf_size, 
			qqParentRegion(process_handle));
		break;

	    case SignalGroupRecord:
		group_handle = (VK_tSignalHandle) handle;
		FormatSignalNameSub(buffer, buf_size, 
			group_handle,
			qqSignalStart(group_handle), 
			qqSignalLength(group_handle), True);
					/* expand the outermost signal name */
		break;
 
	    case SignalElementRecord:
		element_handle = (tSignalElementHandle) handle;
		FormatSignalNameSub(buffer, buf_size, 
			qqGroup(element_handle),
			ElementFormatId(element_handle), 1, True);
					/* expand the outermost signal name */
 		break;

	    case RegionRecord:
		region_handle = (TK_tRegionHandle) handle;
		if (NULL != qqParentRegion(region_handle)) {
		    FormatHierarchicalNameSub(buffer, buf_size, 
				qqParentRegion(region_handle));
		    if (qqRegionKind(region_handle) == DesignEntityRegion) {
		        TempStrCat(buffer, buf_size, SpecialSeparator);
		    }
		    else {
		    	TempStrCat(buffer, buf_size, NormalSeparator);
		    }
		}
		TempStrCat(buffer, buf_size, qqName(region_handle));
					/* each region has primary name */
		if (qqRegionKind(region_handle) == DesignEntityRegion) {
					/* design entity also has arch. name */
		    TempStrCat(buffer, buf_size, "(");	/* architecture separator */
		    TempStrCat(buffer, buf_size, qqSecName(region_handle));
		    TempStrCat(buffer, buf_size, ")");
		}
		else if (qqRegionKind(region_handle) == ForGenerateRegion) {
					/* for generate equivalent block has
					   parameter value */
		    TempStrCat(buffer, buf_size, "(");
					/* gen. ~indexed name separator */

					/* format index according to type */
		    FormatScalarValue(value_buf, sizeof(value_buf),
			qqForTypeClass(region_handle),
			qqForTypeSymbInfo(region_handle),
			&qqForIndexValue(region_handle));

		    TempStrCat(buffer, buf_size, value_buf);

		    TempStrCat(buffer, buf_size, ")");
		}
		break;
	    default:
		TempStrCat(buffer, buf_size, "<unhandled case in FormatHierarchicalNameSub>");
		break;
	} /* switch */
    }
} /* FormatHierarchicalNameSub */



/* *******************************************************************
*
* FormatHierarchicalName - format hierarchical name 
*
* HISTORY:
*	02-JAN-90 DSB	Split
*	05-JUN-91 DSB	Applied TempStrCat
*
******************************************************************* */
void FormatHierarchicalName(buffer, buf_size, handle)
char * buffer;
int buf_size;
VK_tVoidPtr handle;		/* generalized handle */
{
    int len;
/**/
    TempStrCpy(buffer, buf_size, RootSeparator);
    len = strlen(buffer);
    FormatHierarchicalNameSub(&buffer[len], buf_size-len, handle);
} /* FormatHierarchicalName */



/* *******************************************************************
*
* FormatLexicalNameSub - format lexical name 
*
* DESCRIPTION:
*	A "lexical" name is a locally static name reflecting the lexical
*	hierarchy of a VHDL unit, but not the globally static model hierarchy.
*
* HISTORY:
*	17-MAY-91 DSB	Created
*	05-JUN-91 DSB	Changed E-A to E(A) to be a little closer to VHDL
*	05-JUN-91 DSB	Applied TempStrCat
*	14-AUG-91 DSB	Follow change to separate library regions
*
******************************************************************* */
static void FormatLexicalNameSub(buffer, buf_size, handle)
char * buffer;
int buf_size;
VK_tSymbInfoHandle handle;
{
    tSymbInfoKind kind;
/**/
/* Note: This routine does not handle signals correctly. It should
 	work on a signal_number, signal_length pair instead of the group
	handle.  ??*/

    if (NULL == handle) {
	TempStrCat(buffer, buf_size, "<NULL>");		/* ERROR */
    }
    else {
	VERIFY_ERROR(SymbInfoRecord == qqRecordKind(handle));

    	kind = qqSymbInfoKind(handle);
	switch (kind) {
	    case LibraryRegionInfo:
		TempStrCat(buffer, buf_size, qqName(handle));
		break;
	    case PackageDeclInfo:
	    case EntityDeclInfo:
	    case ConfigurationDeclInfo:
		if (NULL != qqEnclReg(handle)) {
		    FormatLexicalNameSub(buffer, buf_size, qqEnclReg(handle));
		    TempStrCat(buffer, buf_size, LexicalSeparator);
		}
		TempStrCat(buffer, buf_size, qqName(handle));
		break;
	    default:
		if (NULL != qqEnclReg(handle)) {
		    if (ArchitectureBodyInfo != qqSymbInfoKind(handle)) {
					/* ?? kludge until data structures are
					   fixed:  avoid L. L.E (A) for 
					   architecture ?? */
			FormatLexicalNameSub(buffer, buf_size, 
				qqEnclReg(handle));
			TempStrCat(buffer, buf_size, LexicalSeparator);
		    }
		}
		if (NULL != qqExtReg(handle)) {
		    FormatLexicalNameSub(buffer, buf_size, qqExtReg(handle));
		    TempStrCat(buffer, buf_size, ExtendedSeparator1);
		}
		TempStrCat(buffer, buf_size, qqName(handle));
					/* most items have simple name */
		if (NULL != qqExtReg(handle)) {
		    TempStrCat(buffer, buf_size, ExtendedSeparator2);
		}

		break;
	} /* switch */
    }
} /* FormatLexicalNameSub */


/* *******************************************************************
*
* FormatLexicalName - format lexical name 
*
* HISTORY:
*	17-MAY-91 DSB	Created
*	05-JUN-91 DSB	Applied TempStrCat
*
******************************************************************* */
void FormatLexicalName(buffer, buf_size, handle)
char * buffer;
int buf_size;
VK_tSymbInfoHandle handle;		/* symb. info. record */
{
    int len;
/**/
    TempStrCpy(buffer, buf_size, "");
    len = strlen(buffer);
    FormatLexicalNameSub(&buffer[len], buf_size-len, handle);
} /* FormatLexicalName */



/* *******************************************************************
*
* DisplayInfo - Display Information Message 
*
* NOTE:
*	Evenutally want to use SPI error message stuff for this
*
* HISTORY:
*	19-DEC-90 AWH	Created
*
******************************************************************* */
void DisplayInfo(message)
VK_tCString message;
{
    if (! GF.slave) {
	fprintf(stdout, "%s\n", message);
    }
} /* DisplayInfo */



/*****************************************************************************
*
* PrintfResponse - DisplayResponse with printf calling style.
*
* DESCRIPTION:
*	PrintfResponse(format  [ , arg... ] )
*
* NOTE: 
*	Unchecked 1k char size limit! A trailing \n is always added.
*
* HISTORY:
*	 7-NOV-91 MNP	Created
*
*****************************************************************************/
void PrintfResponse(format VA_ALIST)
VK_tCString format;
VA_DCL
{
    va_list p;
    char buf[1024];
/**/
    VA_START(p,format);
    vsprintf(buf, format, p);
    DisplayResponse((VK_tCString)buf);
    va_end(p);

} /* PrintfResponse */


/* *******************************************************************
*
* DisplayResponse - Display Text Message  To User
*
* HISTORY:
*	18-JAN-91 AWH	Created
*
******************************************************************* */
void DisplayResponse(text_line)
VK_tCString text_line;
{
    if (GF.slave) {
	RD_WriteCommandResponse(text_line);
    }
    else {
	fprintf(stdout, "%s\n", text_line);
    }
} /* DisplayResponse */



/* *******************************************************************
*
* DisplayText - Display Text Message  To User
*
* HISTORY:
*	19-DEC-90 AWH	Created
*
******************************************************************* */
void DisplayText(text_line)
VK_tCString text_line;
{
    if (GF.slave) {
	RD_WriteTextLine(text_line);
    }
    else {
	fprintf(stdout, "%s\n", text_line);
    }
} /* DisplayText */



/* *******************************************************************
*
* DisplayPrompt - Display Prompt  To User
*
* HISTORY:
*	19-DEC-90 AWH	Created
*
******************************************************************* */
void DisplayPrompt(prompt)
VK_tCString prompt;
{
    if (GF.slave) {
	RD_WriteUserPrompt(prompt);
    }
    else {
	fprintf(stdout, prompt);
	fflush(stdout);
    }
} /* DisplayPrompt */




/* *******************************************************************
*
* ComputeFieldWidth - determine number of characters in type's values
*
* NOTE: The function calls used in this routine to determine the
*	maximum field width correspond to the function calls used
*	in FormatScalarValue above.
*
* HISTORY:
*	04-APR-91 JBR	Created for W0022.
*	15-MAY-91 DSB	Used fixed width for reals
*	11-JUN-91 DSB	Implemented large physical types
*
******************************************************************* */
int ComputeFieldWidth(type_symb_info)
VK_tSymbInfoHandle type_symb_info;
{
    int i;
    int len;
    int rec_width;
    tTempBuf80 buffer;
/**/
    if (NULL == type_symb_info) {
	rec_width = 3;
    }
    else {
	switch (qqSymbInfoKind(type_symb_info)) {
	    case IntegerTypeDeclInfo:
		sprintf(buffer, "%d", qqIntegerLeftBound(type_symb_info));
		rec_width = strlen(buffer);
		sprintf(buffer, "%d", qqIntegerRightBound(type_symb_info));
		len = strlen(buffer);
		if (len > rec_width) {
		    rec_width = len;
		}
		break;
	    case FloatingTypeDeclInfo:
#if 0
		sprintf(buffer, "%f", qqFloatLeftBound(type_symb_info));
		rec_width = strlen(buffer);
		sprintf(buffer, "%f", qqFloatRightBound(type_symb_info));
		len = strlen(buffer);
		if (len > rec_width) {
		    rec_width = len;
		}
#endif
		rec_width = 14;		/* +1.234567e+12 */
		break;
	    case PhysicalTypeDeclInfo:
		sprintf(buffer, "%d", qqIntegerLeftBound(type_symb_info));
		rec_width = strlen(buffer);
		sprintf(buffer, "%d", qqIntegerRightBound(type_symb_info));
		len = strlen(buffer);
		if (len > rec_width) {
		    rec_width = len;
		}
		if (NULL == qqLiterals(type_symb_info)) {
		    rec_width = rec_width + strlen("<UNITS>");
		}
		else {
		    rec_width = rec_width +
			strlen(qqLiterals(type_symb_info)[0]);
		}
		break;
	    case LargePhysicalTypeDeclInfo:
/* ?? I need to rename the time macros (probably name with LARGE and have
	TIME aliases) ?? */
		STIME_FORMAT(buffer, qqLargeLeftBound(type_symb_info));
		rec_width = strlen(buffer);
		STIME_FORMAT(buffer, qqLargeRightBound(type_symb_info));
		len = strlen(buffer);
		if (len > rec_width) {
		    rec_width = len;
		}
		if (NULL == qqLiterals(type_symb_info)) {
		    rec_width = rec_width + strlen("<UNITS>");
		}
		else {
		    rec_width = rec_width +
			strlen(qqLiterals(type_symb_info)[0]);
		}
		break;
	    case EnumerationTypeDeclInfo:
		rec_width = 1;
	    	for (i=qqCardinality(type_symb_info)-1; i>=0; i--) {
		    len = strlen(qqLiterals(type_symb_info)[i]);
		    if (len > rec_width) {
			rec_width = len;
		    }
		}   /* for */
		break;
	    default:
		rec_width = 3;
		break;
	}   /* switch (qqSymbInfoKind(type_symb_info)) */
    }	/* if */
    return rec_width;
}  /* ComputeFieldWidth */


/* *******************************************************************
*
* TraceTimeAdvance - write trace file record for time advancement
*
* HISTORY:
*	15-NOV-89 DSB	Created
*	28-DEC-90 AWH	Moved file IO to TKRecord.c
*
******************************************************************* */
void TraceTimeAdvance(time)
tAbsTimePtr time;
{
/**/
    RD_WriteTimeAdvance(time);
} /* TraceTimeAdvance */


/* *******************************************************************
*
* TraceSimCycle - write trace file record for simulation cycle
*
* HISTORY:
*	15-NOV-89 DSB	Created
*	28-DEC-90 AWH	Moved file IO to TKRecord.c
*
******************************************************************* */
void TraceSimCycle()
{
/**/
    RD_WriteSimulationCycle();
} /* TraceSimCycle */



/* *******************************************************************
*
* TraceSignalInitial - write trace file record for signal initial value
*
* HISTORY:
*	25-APR-90 DSB	ReCreated
*	28-DEC-90 AWH	Moved file IO to TKRecord.c
*	22-MAR-91 HK	Changed type symbolic information retrieval
*
******************************************************************* */
void TraceSignalInitial(element)
tSignalElementHandle element;
{
    tTempBuf80 value_buf;
    VK_tSymbInfoHandle type_symb_info;
/**/
    type_symb_info = GetElementTypeInfo(element);
    FormatScalarValue(value_buf, sizeof(value_buf), 
		qqElementClass(element), type_symb_info,
		(VK_tScalarAddr)qqEffectiveValuePtr(element));
    RD_WriteSignalInitialization(ElementFormatId(element), value_buf);
} /* TraceSignalInitial */


/* *******************************************************************
*
* TraceTransaction - write trace file record for transaction on signal
*
* HISTORY:
*	15-NOV-89 DSB	Created
*	28-DEC-90 AWH	Moved file IO to TKRecord.c
*
******************************************************************* */
void TraceTransaction(element)
tSignalElementHandle element;
{
/**/
    RD_WriteSignalTransaction(ElementFormatId(element));
} /* TraceTransaction */


/* *******************************************************************
*
* TraceEvent - write trace file record for event on signal
*
* HISTORY:
*	15-NOV-89 DSB	Created
*	28-DEC-90 AWH	Moved file IO to TKRecord.c
*	22-MAR-91 HK	Changed type symbolic information retrieval
*       29-OCT-91 DKC   Changed tTempDataType* to tScalarUnionPtr on value
*
******************************************************************* */
void TraceEvent(element, value)
tSignalElementHandle element;
tScalarUnionPtr value;
{
    VK_tSymbInfoHandle type_symb_info;
    tTempBuf20 value_buf;
/**/
    type_symb_info = GetElementTypeInfo(element);
    FormatScalarValue(value_buf, sizeof(value_buf), 
		qqElementClass(element),
		type_symb_info,
		(VK_tScalarAddr)qqEffectiveValuePtr(element));

    RD_WriteSignalEvent(ElementFormatId(element), value_buf);
} /* TraceEvent */


/* *******************************************************************
*
* TraceAssertion - write trace file record for assertion violation
*
* HISTORY:
*	16-NOV-89 DSB	Created
*	11-MAY-90 DSB	Added process pathname
*	28-DEC-90 AWH	Moved file IO to TKRecord.c
*
******************************************************************* */
void TraceAssertion(severity, message, source_file, line_number, proc_name)
VK_tSeverity severity;
char * message;
char * source_file;
int line_number;
char * proc_name;
{
/**/
    RD_WriteAssertion(severity, message, source_file, line_number, proc_name);
} /* TraceAssertion */


/* *******************************************************************
*
* TraceError - write trace file record for simulation error
*
* HISTORY:
*	11-APR-90 DSB	Created
*	28-DEC-90 AWH	Moved file IO to TKRecord.c
*	04-APR-91 WAG	W0023.  Modified to conform to coding style standards.
*	14-MAY-91 AWH	WOO54: Added error_code parameter
*	16-MAY-91 DSB	Fixed bug: error_code hit %s, not %d
*
******************************************************************* */
void TraceError(message, extra, source_file, line_number, error_code)
VK_tCString message;
VK_tCString extra;
VK_tCString source_file;
Integer4 line_number;
VK_tVHDLErrorCode error_code;
{
    tTempBuf256 buffer;
/**/
/* ?? indentation is off one char. ?? */

/* ?? *extra (a character) should not be compared to NULL; use '\0' to follow 
	type formalism ?? */

   if ((extra != NULL) && (*extra != NULL)) {

	sprintf(buffer, "%d:%s (%s)", error_code, message, extra);
   }
   else {
	sprintf(buffer, "%d:%s",  error_code, message);
   }

    RD_WriteError(buffer, source_file, line_number);
} /* TraceError */


/* *******************************************************************
*
* OpenTraceFile - Open trace file
*
* HISTORY:
*	15-NOV-89 DSB	Created
*	24-APR-90 DSB	Converting to combined map/trace file
*	19-DEC-90 AWH	Copied from StartTraceFile
*	16-MAY-91 DSB	Used new TK_ModelName instead of old FileNamePart
*	16-DEC-91 HWK	added error checking for fopen
*
******************************************************************* */
void OpenTraceFile()
{
    tTempBuf1024 tempbuf;
	extern char *sys_errlist[];
	extern int errno;
/**/
 
    if (GF.slave) {
	TraceFile = stdout;
    }
    else {
    	sprintf(tempbuf, "%s%s", TK_ModelName, TraceFileExtension);
    	TraceFile = fopen(tempbuf, "w");
		if (TraceFile == NULL) {
		  ReportKernelError("Failed to open trace file",sys_errlist[errno],
							"TKIO.c",1255);
		}
    }

    RD_SetOutput(TraceFile);
} /* OpenTraceFile */



/* *******************************************************************
*
* StartTraceFile - start trace file
*
* HISTORY:
*	15-NOV-89 DSB	Created
*	24-APR-90 DSB	Converting to combined map/trace file
*	14-NOV-91 DKC	Changed to mark as Signal Declarations are now 
*                       done during eleaboration
*
******************************************************************* */
void StartTraceFile()
{
/**/
    RD_WriteEndOfSignalMap();
} /* StartTraceFile */



/* *******************************************************************
*
* FinishTraceFile - terminate trace file
*
* HISTORY:
*	15-NOV-89 DSB	Created
*	24-APR-90 DSB	Converting to combined map/trace file
*	...
*
******************************************************************* */
void FinishTraceFile()
{
/**/
    if (GF.slave) {
	fflush(TraceFile);
    }
    else {
        fclose(TraceFile);
    }
} /* FinishTraceFile */



/* *******************************************************************
*
* IndentLevel - 
*
* HISTORY:
*	26-APR-90 DSB	Created
*
******************************************************************* */
static void IndentLevel(level)
int level;			/* how many spaces */
{
    int i;
/**/
    for (i=1; i<=level; i++) {
	fprintf(stdout, " ");
    }
} /* IndentLevel */


/*****************************************************************************
*
* VK_DH_DriverTable - dump driver list
*
* DESCRIPTION:
*
* HISTORY:
*	30-DEC-91 DKC	Created
*
*****************************************************************************/

VK_DH_DriverTable(level,driver_table,driver_count)
int          level;
tDriverTable driver_table;
VK_tInteger  driver_count;
{
    TempList             waveform_values,
                         waveform_times;
    tRelTimeBuf          time;
    tScalarUnion         temp;
    TempItem             scant, scanv;
    tTempBuf80           buf1, buf2, buf3;
    tDriverElementHandle driver;
/**/
    if (0 == driver_count) {
        return;
    }

    IndentLevel(level);
    fprintf(stdout, "DriverList:\n");
    /* for each driver */
    for (; driver_count-- ;  driver_table++) {
	driver = *driver_table;
        if (NULL == driver) {
            continue;
        }
	fprintf(stdout, "    Driver: ");
	FormatSignalGroupName(buf1, sizeof(buf1),
			qqGroup(SignalElementHandle(qqParentElement(driver))));
	fprintf(stdout, "ParentSignal = %s; ", buf1);
	fprintf(stdout, "LastActiveCycle = %d;\n", qqLastActiveCycle(driver));
	fprintf(stdout, "        ");
        GetCurrentValue(driver,&temp);
	fprintf(stdout, "CurrentValue = %d; ", temp.t_int);
	waveform_values = qqWaveformValues(driver);
        waveform_times = qqWaveformTimes(driver);
	fprintf(stdout, "        Waveform = ");
	for (scanv=TempFirstItem(waveform_values),
	     scant=TempFirstItem(waveform_times); ! TempNullItem(scanv); 
	     scanv=TempNextItem(scanv), scant=TempNextItem(scant)) {
	    UTIME_FORMAT(buf1, *(tAbsTimeBuf *) TempValue(scanv));
			/* shouldn't buf1 be FormatScalarValue? */
	    TIME_SUB(time, *(tAbsTimeBuf *) TempValue(scant), SimTime);
	    STIME_FORMAT(buf2, time);
	    UTIME_FORMAT(buf3, *(tAbsTimeBuf *) TempValue(scant));
	    fprintf(stdout, "%s after %s (at %s)", buf1, buf2, buf3);
	    if (! TempNullItem(TempNextItem(scanv))) {
		fprintf(stdout, ", ");
	    }
	}
    }
    fprintf(stdout, "\n");
} /* VK_DH_DriverTable */


/* *******************************************************************
*
* VK_DH_Process - 
*
* HISTORY:
*	06-FEB-90 DSB	Created
*       06-Sep-90 RM	Cleaned up unused variables.
* 	28-Sep-90 GJB	Modified TriggerCycle to be TimeoutTriggerCycle
*			and SignalTriggerCycle
*	02-Mar-91 HK	Added a call to FormatSignalGroupName, since Name
*			field of signal group records does not exist any more.
*	27-MAR-91 WAG	Replaced output of priority field with output of
*			kernel_process field.
*
******************************************************************* */
void VK_DH_Process(level, process)
int level;
VK_tProcessHandle process;
{
    TempItem sigscan;
    tTempBuf80 buffer;
/**/
    IndentLevel(level);
    level = level + 4;
    FormatHierarchicalName(buffer, sizeof(buffer), process);
    fprintf(stdout, "%s:", buffer);
    fprintf(stdout, " (Process)");

    fprintf(stdout, "    ParentRegion = %s", qqName(qqParentRegion(process)));
    fprintf(stdout, "\n");
    IndentLevel(level);
    fprintf(stdout, "    ProcessKind = (%d)", qqProcessKind(process));
    fprintf(stdout, "    KernelProcess = %d", qqKernelProcess(process));
    fprintf(stdout, "    ProcessData = <%d>", qqProcessData(process));
    fprintf(stdout, "\n");
    IndentLevel(level);
    fprintf(stdout, "    SensitivityList = ");
    for (sigscan=TempFirstItem(qqSensitivityList(process));
		! TempNullItem(sigscan); sigscan=TempNextItem(sigscan)) {
	FormatSignalGroupName(buffer, sizeof(buffer),
				qqGroup(SigElemValue(sigscan)));
	fprintf(stdout, "%s; ", buffer);
    }
    fprintf(stdout, "\n");
    IndentLevel(level);
    fprintf(stdout, "    CurrentSensSet = %d", qqCurrentSensSet(process));
    if (NULL != qqScheduled(process)) {
        UTIME_FORMAT(buffer, 
                     qqTime(EventValue(qqScheduled(process))));
    }
    fprintf(stdout, "    WakeUpTime = %s", buffer);
    fprintf(stdout, "    TriggerCycle = <%d>", qqTriggerCycle(process));
    fprintf(stdout, "\n");
    VK_DH_DriverTable(level,qqDriverTable(process),qqDriverCount(process));
} /* VK_DH_Process */



/* *******************************************************************
*
* SH_Process - 
*
* HISTORY:
*	15-JUN-90 DSB	Created from VK_DH_Process
*	06-Sep-90 RM	Cleaned up unused variables.
* 	28-Sep-90 GJB	Replace qqTriggerCycle with qqTimeoutTriggerCycle
*			and qqSignalTriggerCycle.
*	21-JAN-91 AWH	Conform output for slave mode
*
******************************************************************* */
void SH_Process(level, process)
int level;
VK_tProcessHandle process;
{
    tTempBuf80 hier_buf;
    tTempBuf256 output_line;
/**/
/*
    IndentLevel(level);
*/
    level = level + 4;
    FormatHierarchicalName(hier_buf, sizeof(hier_buf), process);
    sprintf(output_line, "%s: (Process)", hier_buf);
    DisplayText(output_line);
    
    sprintf(output_line, "\t\t%s this cycle; %s",
	    SimCycleCount == qqTriggerCycle(process) ? "  active"
                                                     : "inactive",
    	    qqDebugBit(process)                      ? "   breakpoint set" 
			                             : "no breakpoint set"
	    );
    DisplayText(output_line);
    

#if 0
    fprintf(stdout, "    SensitivityList = ");
    for (sigscan=TempFirstItem(qqSensitivityList(process));
		! TempNullItem(sigscan); sigscan=TempNextItem(sigscan)) {
	fprintf(stdout, "%s; ", qqName(SigValue(sigscan)));
    }
    fprintf(stdout, "\n");
#endif
} /* SH_Process */



/* *******************************************************************
*
* VK_DH_Signal - 
*
* HISTORY:
*	06-FEB-90 DSB	Created
*	02-Mar-91 HK	Added a call to FormatSignalGroupName, since Name
*			field of signal group records does not exist any more
*	15-MAY-91 DSB	Changed qqResCallerFn to qqResEvalFn
*
******************************************************************* */
void VK_DH_Signal(level, element)
int                  level;
tSignalElementHandle element;
{
    TempItem             sigscan;
    TempItem             drvrscan;
    TempItem             scant, scanv;
    tTempBuf80           buf1, buf2, buf3;
    tAbsTimeBuf          time;
    VK_tProcessHandle    tempproc;
    TempItem             procscan;
    tDriverElementHandle driver;
    TempList             waveform_values;
    TempList             waveform_times;
    tScalarUnion         temp;
/**/
    IndentLevel(level);
    level = level + 4;
    FormatHierarchicalName(buf1, sizeof(buf1), element);
    fprintf(stdout, "%s:", buf1);
    fprintf(stdout, " (Signal)");
    fprintf(stdout, " #%d\n", ElementFormatId(element));

    IndentLevel(level);
    fprintf(stdout, "Missing qqSignalKind, qqSignalClass, qqPrefixSignalStart, etc\n");
    IndentLevel(level);
    fprintf(stdout, " ParentRegion = ");
    if (qqRegionData(qqGroup(element)) == NULL) {
	fprintf(stdout, "NONE; ");
    }
    else if (NULL != TK_GetRegionHandle(qqRegionData(qqGroup(element)))) {
    	fprintf(stdout, "%s; ", 
                qqName(TK_GetRegionHandle(qqRegionData(qqGroup(element)))));
    }
    else {
    	fprintf(stdout, "%s; ", 
                qqName(TK_GetRegionInfo(qqRegionData(qqGroup(element)))));
    }
    IndentLevel(level);
/*   FormatSignalGroupName(buf1, sizeof(buf1),
 *      		qqGroup(SignalElementHandle(qqRootNet(element))));
 *  fprintf(stdout, "RootNet = %s; ", buf1);
 *  need to update this (DKC) */
    tempproc = qqEvalProcess(element);
    fprintf(stdout,"    EvalProcess = %s;\n",
                   tempproc == NULL ? "<none>" 
                                    : qqName(tempproc));
    if (qqResolved(element)) {
        fprintf(stdout,"    ResEvalFn = <%d>, ResolutionContext = <%d>\n",
	               qqResEvalFn(qqResolutionData(qqGroup(element))), 
                       qqResolutionContext(qqResolutionData(qqGroup(element))));
    }
    IndentLevel(level);
    fprintf(stdout, "    TriggerActive list = ");
    for (procscan=TempFirstItem(qqTriggerActive(element)); 
		! TempNullItem(procscan); procscan = TempNextItem(procscan)) {
	fprintf(stdout, "%s; ", qqName(ProcValue(procscan)));
    }
    fprintf(stdout, "\n");
    IndentLevel(level);
    fprintf(stdout, "    TriggerEvent list = ");
    for (procscan=TempFirstItem(qqTriggerEvent(element)); 
		! TempNullItem(procscan); procscan = TempNextItem(procscan)) {
	fprintf(stdout, "%s; ", qqName(ProcValue(procscan)));
    }
    fprintf(stdout, "\n");
    IndentLevel(level);
    fprintf(stdout, "    TriggerEventSets list = ");
    for (procscan=TempFirstItem(qqTriggerEventSets(element)); 
		! TempNullItem(procscan); procscan = TempNextItem(procscan)) {
	fprintf(stdout, "??; " /* , qqName(ProcValue(procscan)) */);
				/* ?? how to print this? ?? */
    }
    fprintf(stdout, "\n");
    IndentLevel(level);
    fprintf(stdout, "    SourceList:\n");
    for (drvrscan=TempFirstItem(qqSourceList(element)); 
	    ! TempNullItem(drvrscan); drvrscan = TempNextItem(drvrscan)) {
	driver = DrvElemValue(drvrscan);
        if (qqRecordKind(driver) != DriverElementRecord) {
            continue;
        }     
    IndentLevel(level);
	fprintf(stdout, "        Driver: ");
	fprintf(stdout, "OwnerProcess = %s; ", qqName(qqOwnerProcess(driver)));
	fprintf(stdout, "LastActiveCycle = %d\n", qqLastActiveCycle(driver));
    IndentLevel(level);
	fprintf(stdout, "            ");
        GetCurrentValue(driver,&temp);
	fprintf(stdout, "CurrentValue = %d; ", temp.t_int); /* ??? (DKC) */
	waveform_values = qqWaveformValues(driver);
	waveform_times = qqWaveformTimes(driver);
	fprintf(stdout, "Waveform = ");
	for (scanv=TempFirstItem(waveform_values),
	     scant=TempFirstItem(waveform_times); ! TempNullItem(scanv); 
	     scanv=TempNextItem(scanv), scant=TempNextItem(scant)) {
	    UTIME_FORMAT(buf1, *(tAbsTimeBuf *) TempValue(scanv));
			/* ?? shouldn't buf1 be FormatScalarValue? ?? */
	    TIME_SUB(time, *(tAbsTimeBuf *) TempValue(scant), SimTime);
	    STIME_FORMAT(buf2, time);
	    UTIME_FORMAT(buf3, *(tAbsTimeBuf *) TempValue(scant));
	    fprintf(stdout, "%s after %s (at %s)", buf1, buf2, buf3);
	    if (! TempNullItem(TempNextItem(scanv))) {
		fprintf(stdout, ", ");
	    }
	}
	fprintf(stdout, "\n");
    }
    IndentLevel(level);
    GetDefaultValue(element,&temp);
    fprintf(stdout, "    Values: Default=%3d,",temp.t_int);
    GetPreviousValue(element,&temp);
    fprintf(stdout, "Previous=%3d,", temp.t_int);
    GetDrivingValue(element,&temp);
    fprintf(stdout, "Driving=%3d,",  temp.t_int);
    GetEffectiveValue(element,&temp);
    fprintf(stdout, "Effective=%3d,",temp.t_int);
    IndentLevel(level);
    UTIME_FORMAT(buf1, qqLastActiveTime(element));
    UTIME_FORMAT(buf2, qqLastEventTime(element));
    fprintf(stdout,
	"    Last: Active: Time=%3s, Cycle=%3d, Event: Time=%3s Cycle=%3d \n",
	buf1, qqLastActiveCycle(element), buf2, qqLastEventCycle(element));

    fprintf(stdout, "\n");

    IndentLevel(level);
    fprintf(stdout, "ImplicitSignals list:");
    fprintf(stdout, "\n");
    for (sigscan=TempFirstItem(qqImplicitSignals(qqGroup(element))); 
		! TempNullItem(sigscan); sigscan = TempNextItem(sigscan)) {
        VK_DH_Signal(level, 
                     SignalElementHandle(qqSignalStart(SigGrpValue(sigscan))));
    }
} /* VK_DH_Signal */



/* *******************************************************************
*
* VK_DH_Region - 
*
* HISTORY:
*	06-FEB-90 DSB	Created
*	02-Mar-91 HK	Added a call to FormatSignalGroupName, since Name
*			field of signal group records does not exist any more
*
******************************************************************* */
void VK_DH_Region(level, region)
int level;
TK_tRegionHandle region;
{
    TempItem childscan;
    TK_tRegionHandle child;
    tTempBuf80 buffer;
/**/
    IndentLevel(level);
    level = level + 4;
    FormatHierarchicalName(buffer, sizeof(buffer), region);
    fprintf(stdout, "%s: (", buffer);
    fprintf(stdout, GetRegionKindStr(qqRegionKind(region)));
    fprintf(stdout, ")");
    fprintf(stdout, " ParentRegion = ");
    if (qqParentRegion(region) == NULL) {
	fprintf(stdout, "NONE; ");
    }
    else {
    	fprintf(stdout, "%s; ", qqName(qqParentRegion(region)));
    }
    fprintf(stdout, "\n");
#if 0
    IndentLevel(level);
    fprintf(stdout, "    Children = ");
    for (childscan=TempFirstItem(qqChildren(region)); 
		! TempNullItem(childscan); childscan=TempNextItem(childscan)) {
	child = RegValue(childscan);
	if (child == NULL) {
	    fprintf(stdout, "** NULL CHILD FROM NON-NULL CHILDSCAN **");
	}
	else {
	    switch (qqRecordKind(child)) {
	    	case RegionRecord:
	    	    fprintf(stdout, "%s; ", qqName(RegValue(childscan)));
		    break;
	    	case TypeRecord:
	    	    fprintf(stdout, "%s; ", qqName(TypeValue(childscan)));
		    break;
	    	case ProcessRecord:
	    	    fprintf(stdout, "%s; ", qqName(ProcValue(childscan)));
		    break;
		case SignalElementRecord:
		    FormatSignalGroupName(buffer, sizeof(buffer),
					qqGroup(SigElemValue(childscan)));
		    fprintf(stdout, "%s; ", buffer);
		    break;
	    	case SignalGroupRecord:
		    FormatSignalGroupName(buffer, sizeof(buffer),
					SigGrpValue(childscan));
	    	    fprintf(stdout, "%s; ", buffer);
		    break;
	    	default:
	    	    fprintf(stdout, "<unknown record type>; ");
		    break;
	    } /* switch */
	}
    }
    fprintf(stdout, "\n");
#endif

    for (childscan=TempFirstItem(qqChildren(region)); 
		! TempNullItem(childscan); childscan=TempNextItem(childscan)) {
	child = RegValue(childscan);
	if (child == NULL) {
	    fprintf(stdout, "** NULL CHILD FROM NON-NULL CHILDSCAN **");
	}
	else {
	    switch (qqRecordKind(child)) {
	    	case RegionRecord:
		    VK_DH_Region(level, child);
		    break;
	    	case TypeRecord:
/*
		    VK_DH_Type(level, child);
*/
		    break;
	    	case ProcessRecord:
		    VK_DH_Process(level, child);
		    break;
	    	case SignalElementRecord:
		    VK_DH_Signal(level, child);
		    break;
	    	default:
	    	    fprintf(stdout, "<unknown record type>; ");
		    break;
	    } /* switch */
	}
    }
    fprintf(stdout, "\n");
} /* VK_DH_Region */


/* *******************************************************************
*
* SH_Region - 
*
* HISTORY:
*	15-JUN-90 DSB	Created from VK_DH_Region
*	05-JUN-91 DSB	Fixed bug: missing parameter to ReportInternalError
*
******************************************************************* */
void SH_Region(level, region)
int level;
TK_tRegionHandle region;
{
    TempItem childscan;
    TK_tRegionHandle child;
    tTempBuf80 hier_buf;
    tTempBuf256 output_line;
/**/
/*
    IndentLevel(level);
*/
    level = level + 4;
    FormatHierarchicalName(hier_buf, sizeof(hier_buf), region);
    sprintf(output_line, "%s: (%s)",
	    hier_buf,
	    GetRegionKindStr(qqRegionKind(region))
	    );
    DisplayText(output_line);
    
    for (childscan=TempFirstItem(qqChildren(region)); 
		! TempNullItem(childscan); childscan=TempNextItem(childscan)) {
	child = RegValue(childscan);
	if (child == NULL) {
	    ReportInternalError("** NULL CHILD FROM NON-NULL CHILDSCAN **", "",
			 __FILE__, __LINE__);
	}
	else {
	    switch (qqRecordKind(child)) {
	    	case RegionRecord:
		    SH_Region(level, child);
		    break;
	    	case TypeRecord:
/*		    VK_DH_Type(level, child); */
		    break;
	    	case ProcessRecord:
		    SH_Process(level, child);
		    break;
	    	case SignalElementRecord:
/*		    VK_DH_Signal(level, child); */
		    break;
	    	case SignalGroupRecord:
/*		    VK_DH_Signal(level, child); */
		    break;
	    	default:
	    	    ReportInternalError("<unknown record type>", "",
			       	   __FILE__, __LINE__);
		    break;
	    } /* switch */
	}
    }
} /* SH_Region */


/* *******************************************************************
*
* VK_DumpHier - 
*
* HISTORY:
*	06-FEB-90 DSB	Created
*	02-MAR-91 HK	Added a call to FormatSignalGroupName, since signal
*			group records do not have a Name field any more
*	08-JAN-92 DKC	Broke out dumping of driver data
*
******************************************************************* */
void VK_DumpHier()
{
    TempItem   regscan;
    TempItem   scan;
    tTempBuf80 buf1;
/**/
    fprintf(stdout, "----------\n");
    UTIME_FORMAT(buf1, SimTime);
    fprintf(stdout, "SimTime = %s %s, ", buf1, BaseUnit);
    fprintf(stdout, "SimCycleCount = %d, ", SimCycleCount);
    fprintf(stdout, "DeltaCount = %d", DeltaCount);
    fprintf(stdout, "\n");

    fprintf(stdout, "EventTimeQueue = <");
    for (scan=TempFirstItem(EventTimeQueue); 
		! TempNullItem(scan); scan=TempNextItem(scan)) {
	UTIME_FORMAT(buf1, *(tAbsTimePtr) TempValue(scan));
	fprintf(stdout, " %s", buf1);
    }
    fprintf(stdout, ">\n");


    fprintf(stdout, "Top-Level Regions:\n");
	for (regscan=TempFirstItem(RegionList); 
		! TempNullItem(regscan); regscan = TempNextItem(regscan)) {
	    if (qqParentRegion(RegValue(regscan)) == NULL) {
					/* only dump root regions, because
					   they will dump non-root regions too
					*/
	        VK_DH_Region(0, RegValue(regscan));
	    }
	}
    fprintf(stdout, "\n");

} /* VK_DumpHier */


/* *******************************************************************
*
* ShowHierarchy - 
*
* HISTORY:
*	15-JUN-90 DSB	Created from VK_DumpHier
*	21-JAN-91 AWH	Conform output for salve mode
*
******************************************************************* */
void ShowHierarchy()
{
    TempItem regscan;
    TK_tRegionHandle region;
/**/
    DisplayText("Simulation Model Hierarchy:");

	/* : Display package regions (flat) plus top-level design entity
		region with it descendents */

    for (regscan=TempFirstItem(RegionList); 
		! TempNullItem(regscan); regscan = TempNextItem(regscan)) {
	region = RegValue(regscan);
	    if (qqParentRegion(region) == NULL &&
		KernelRegion != qqRegionKind(region) ){
					/* skip kernel region */
	        SH_Region(0, region);
	    }
    }
    DisplayText(END_OF_LIST);
} /* ShowHierarchy */


/* *******************************************************************
*
* DSI_Any - dump symbolic information for any item
*
* HISTORY:
*	25-FEB-91 DSB	Created
*	04-MAR-91 DSB	Added children processing
*	02-APR-91 JBR	Added case for PhysicalTypeDeclInfo
*	19-APR-91 WAG	W0025, W0026, and W0027.  Added cases for
*			AccessTypeDeclInfo, InstantiationStmtInfo, 
*			InterfaceConstantDeclInfo, InterfaceSignalDeclInfo,
*			InterfaceVariableDeclInfo, LocalConstantDeclInfo,
*			LocalFileDeclInfo, LocalSignalDeclInfo,
*			LocalVariableDeclInfo, RecordElementDeclInfo,
*			RecordTypeDeclInfo, and SubtypeDeclInfo.
*	30-APR-91 DSB	Removed duplicate XInfo and XDeclInfo enumerators
*	05-JUN-91 DSB	Added comp. decl. and config. spec. cases
*	05-JUN-91 DSB	Fixed bug: missing parameter to ReportInternalError
*	11-JUN-91 DSB	Added case for LargePhysicalTypeDeclInfo
*
******************************************************************* */
void DSI_Any(level, region_symb_info)
int level;
VK_tSymbInfoHandle region_symb_info;
{
    TempItem childscan;
    VK_tSymbInfoHandle child;
    tTempBuf256 output_line;
/**/
    IndentLevel(level);
    level = level + 4;

    sprintf(output_line, "* %s: (%s)",
	    qqName(region_symb_info),
	    GetSymbInfoKindStr(qqSymbInfoKind(region_symb_info))
	    );
    DisplayText(output_line);


    switch (qqSymbInfoKind(region_symb_info)) {
    	case LibraryRegionInfo:
	    /* nothing else to do */
	    break;

	case LibrarySymbolInfo:
	    IndentLevel(level);
	    sprintf(output_line, "library = %s", 
		qqName(qqLibraryInfo(region_symb_info)));
	    DisplayText(output_line);
	
	    /* ... */
	    break;

    	case PackageDeclInfo:
	case PackageBodyInfo:
	case EntityDeclInfo:
	case ArchitectureBodyInfo:
	case ConfigurationDeclInfo:

	case BlockStmtInfo:
	case IfGenerateStmtInfo:
	case ForGenerateStmtInfo:
	case ProcessStmtInfo:

	case ProcedureDeclInfo:
	case ProcedureBodyInfo:
	case FunctionDeclInfo:
	case FunctionBodyInfo:

	case EnumerationTypeDeclInfo:
	case IntegerTypeDeclInfo:
	case FloatingTypeDeclInfo:
	case PhysicalTypeDeclInfo:
	case LargePhysicalTypeDeclInfo:
	case ArrayTypeDeclInfo:
	case IndexSubtypeInfo:
	case RecordTypeDeclInfo:
	case RecordElementDeclInfo:
	case AccessTypeDeclInfo:
	case FileTypeDeclInfo:
	case SubtypeDeclInfo:


	case InterfaceConstantDeclInfo:
	case LocalConstantDeclInfo:
	case InterfaceVariableDeclInfo:
	case LocalVariableDeclInfo:
	case LocalFileDeclInfo:
	case InterfaceSignalDeclInfo:
	case LocalSignalDeclInfo:

	case ComponentDeclInfo:
	case InstantiationStmtInfo:
	case ConfigurationSpecInfo:
	case ComponentConfigurationInfo:
	    /* kind-specific code not implemented yet */
	    break;
    	default:
    	    ReportInternalError("<unknown symbolic information record type>",
		"", __FILE__, __LINE__);
	    break;
    } /* switch */

/* * *
    IndentLevel(level);
    sprintf(output_line, "");
    DisplayText(output_line);
* * */


    for (childscan=TempFirstItem(qqChildren(region_symb_info)); 
		! TempNullItem(childscan); childscan=TempNextItem(childscan)) {
	child = SymbInfoValue(childscan);
	if (child == NULL) {
	    ReportInternalError("** NULL CHILD FROM NON-NULL CHILDSCAN **", "",
			 __FILE__, __LINE__);
	}
	else {
	    VERIFY_ERROR(SymbInfoRecord == qqRecordKind(child));
	    DSI_Any(level, child);
	}
    }
} /* DSI_Any */


/* *******************************************************************
*
* DumpSymbInfo - dump symbolic information record
*
* NOTE:
*	This is for kernel debugging.  Let's not use it for VLK stuff:
*	write a new version if VLK needs data.
*
* HISTORY:
*	25-DSB-91 DSB	Created
*	04-MAR-91 DSB	Process only root records (children are done above)
*
******************************************************************* */
void DumpSymbInfo()
{
    TempItem scan;
    VK_tSymbInfoHandle symb_info;
/**/
    DisplayText("Registered symbolic information:");

    for (scan=TempFirstItem(SymbInfoList); 
		! TempNullItem(scan); scan=TempNextItem(scan)) {
	symb_info = SymbInfoValue(scan);
	if (NULL == qqEnclReg(symb_info) /* ?? && 
		NULL == qqExtReg(symb_info) ?? */) {
					/* dump roots */
	    DSI_Any(0, symb_info);
	}
    }

    DisplayText("End of registered symbolic information");
} /* DumpSymbInfo */


#if 0
/* *******************************************************************
*
* RtnName - <description of function or procedure>
*
* HISTORY:
*	??-JUN-90 DSB	Created
*
******************************************************************* */
<static> Fntype RtnName(parm)				/* return value desc. if not void */
tParmType parm;			/* mode: description */
{
    type local;				/* description */
    type local;				/* description */
/**/

} /* RtnName */


#endif
