#ifndef TKIO_H
#define TKIO_H
/* *******************************************************************
*
* Copyright (c) 1989-1990 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* HEADER FILE: TKIO.h
*
* DESCRIPTION:  
*	Interface file for TKIO.c.
*
* CONSTANTS:
*	<constants>	<constants defined in this header file >
*
* TYPES:
*	<types>		<types defined in this header file >
*
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this header file >
*
* ROUTINES:
*   External:
*	...
*
* HISTORY:
*	04-OCT-89 DSB	Created
*	25-APR-91 AWH	WOO21: Renamed to TK...
*	02-MAY-91 DSB	Cleaning up generally
*	06-MAY-91 DSB	Cleaning up signal changes
*	16-MAY-91 DSB	Removed FileNamePar
*	02-JUL-91 JBR	Replaced #include of TKCommon.h with stdio.h.
*	11-OCT-91 MNP	Header fixup.
*
* SCCS ID: @(#)TKIO.h	42.3 1/13/92
*
******************************************************************* */

#include "TKStructs.h"		/* for tSignalElementHandle */

#include <stdio.h>		/* for FILE */


#define TraceFileExtension ".trace"	/* simulation output file */

#define WaveFileExtension ".wave"	/* formatter output file */
#define ControlFileExtension ".control" /* formatter control file */

#define END_OF_LIST "-- end of list --"            /* End of list string */

extern FILE * TraceFile;

void TraceSignalInitial(
#ifdef VK_ANSI_FN_PROTOS
	tSignalElementHandle element
#endif
	);

void TraceAssertion(
#ifdef VK_ANSI_FN_PROTOS
	VK_tSeverity severity,
	char         *message,
	char         *source_file,
	int          line_number,
	char         *proc_name
#endif
	);

void TraceError(
#ifdef VK_ANSI_FN_PROTOS
	VK_tCString       message,
	VK_tCString       extra,
	VK_tCString       source_file,
	Integer4          line_number,
        VK_tVHDLErrorCode error_code
#endif
	);

void TraceEvent(
#ifdef VK_ANSI_FN_PROTOS
	tSignalElementHandle element,
	tScalarUnionPtr value
#endif
	);

void TraceTransaction(
#ifdef VK_ANSI_FN_PROTOS
	tSignalElementHandle element
#endif
	);

void StartTraceFile(
#ifdef VK_ANSI_FN_PROTOS
#endif
	);

void FinishTraceFile(
#ifdef VK_ANSI_FN_PROTOS
#endif
	);

void TraceSimCycle(
#ifdef VK_ANSI_FN_PROTOS
#endif
	);

void TraceTimeAdvance(
#ifdef VK_ANSI_FN_PROTOS
 	tAbsTimePtr time
#endif
	);

void FormatHierarchicalName(
#ifdef VK_ANSI_FN_PROTOS
	char * buffer,
	int buf_size,
	VK_tVoidPtr handle		/* generalized handle */
#endif
	 );

VK_tCString GetRegionKindStr(
#ifdef VK_ANSI_FN_PROTOS
	tRegionKind region_kind
#endif
	 );

VK_tCString GetSymbInfoKindStr(
#ifdef VK_ANSI_FN_PROTOS
	tSymbInfoKind symb_info_kind
#endif
	 );

void PrintfResponse(
#ifdef VK_ANSI_FN_PROTOS
        VK_tCString format,
        ...
#endif
       );

void DisplayText(
#ifdef VK_ANSI_FN_PROTOS
	VK_tCString text_line
#endif
	 );

void FormatScalarValue(
#ifdef VK_ANSI_FN_PROTOS
	char * buffer,			/* &out: buffer in which to format
					   value */
	int buf_size,			/* in: size of buffer */
	tTypeClass type_class,		/* in: type class of value */
					/* ?? remove this when type_symb_info
					   is  provided for all calls ?? */
	VK_tSymbInfoHandle type_symb_info,
					/* in: type information */
	VK_tScalarAddr value_addr	/* &in: address of value */
#endif
	 );

void FormatLexicalName(
#ifdef VK_ANSI_FN_PROTOS
	char * buffer,
	int buf_size,
	VK_tSymbInfoHandle handle
#endif
	);

void FormatHierarchicalName(
#ifdef VK_ANSI_FN_PROTOS
	char * buffer,
	int buf_size,
	VK_tVoidPtr handle
#endif
	);

void LogTimeSlice();

void WriteWaveHeader();

void DisplayResponse(
#ifdef VK_ANSI_FN_PROTOS
	VK_tCString text_line
#endif
	);

void DisplayText(
#ifdef VK_ANSI_FN_PROTOS
	VK_tCString text_line
#endif
	);

void DisplayPrompt(
#ifdef VK_ANSI_FN_PROTOS
	VK_tCString prompt
#endif
	);

void ShowHierarchy(
#ifdef VK_ANSI_FN_PROTOS
#endif
	);

void DumpSymbInfo(
#ifdef VK_ANSI_FN_PROTOS
#endif
	);

void OpenTraceFile(
#ifdef VK_ANSI_FN_PROTOS
#endif
	);


#endif /* TKIO_H */
