static char SCCS_ID[] = "@(#)TKParams.c	42.1 1/10/92";
/* *******************************************************************
*
* Copyright (c) 1989-1990 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* CODE FILE: TKParams.c
*
* DESCRIPTION:  
*	<then describe contents>
*
* CONSTANTS:
*	<constants>	<constants defined in this header file >
*
* TYPES:
*	<types>		<types defined in this header file >
*
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this header file >
*
* ROUTINES:
*   External:
*	...
*
*   Internal:
*	...
*
* HISTORY:
*	14-JUN-90 DSB	Created
*	25-APR-91 AWH	WOO21: Renamed to TK...
*	02-MAY-91 DSB	Cleaning up generally
*
* SCCS ID: @(#)TKParams.c	42.1 1/10/92
*
******************************************************************* */

#include "TKParams.h"
#include "ParseCommand.h"

#define K_UNIX_STYLE 1

#ifdef K_UNIX_STYLE

#define VK_SLAVE_QUALIFIER "SLAVE"
#define VK_INTERACTIVE_QUALIFIER "INTERACTIVE"
#define VK_DUMP_QUALIFIER "DUMP"	/* ?? temporary ?? */
#define VK_VERBOSE_QUALIFIER "VERBOSE"	

static PCL_tParameterTable KernelParams =
{

/*    {"P1", 	0, 	"Unit", 	NULL},	*/	/* ?? remove this ?? */
    {NULL, 	0, 	NULL, 		NULL}
};

static PCL_tQualifierTable KernelQuals =
{
    {VK_INTERACTIVE_QUALIFIER,	PCL_Negatable, 	0},	/* interactive mode */
    {VK_SLAVE_QUALIFIER,	PCL_Negatable,  0},	/* slave mode */
    {VK_DUMP_QUALIFIER,		PCL_Negatable,  0},	/* dump mode */
    {VK_VERBOSE_QUALIFIER,	PCL_Negatable,  0},	/* verbose mode */
    {NULL, 			0, 	0}
};

#endif


/* *******************************************************************
*
* GetParams - 
*
* HISTORY:
*	14-JUN-90 DSB	Created
*
******************************************************************* */

VK_tBoolean GetParams(argc, argv, interactive, slave, dump, verbose)
int argc;
char *argv[];
VK_tBoolean *interactive;
VK_tBoolean *slave;
VK_tBoolean *dump;
VK_tBoolean *verbose;
{
    Integer4 status;
    tTempBuf256 error_buf;
/**/

#ifdef K_UNIX_STYLE
    if (PCL_SetTable(KernelParams, KernelQuals) != PCL_Normal) {
	sprintf(error_buf, "%s (%s)\n", PCL_ErrorMessage(), PCL_ErrorString());
	fprintf(stderr, error_buf);
/*	SetErrorStatus(GE_CmdErr, error_buf); */
	return False;
    }
#endif
    if (PCL_ParseArgs(argc, argv) != PCL_Normal) {
	sprintf(error_buf, "%s (%s)\n", PCL_ErrorMessage(), PCL_ErrorString());
	fprintf(stderr, error_buf);
/*	SetErrorStatus(GE_CmdErr, error_buf); */
	return False;
    }

    status = (int) PCL_IsPresent(VK_INTERACTIVE_QUALIFIER);
    switch (status) {
	case PCL_Present:
	    *interactive = True;
	    break;
	
	case PCL_Absent:
	case PCL_Negated:
	    *interactive = False;
	    break;

   	default:
	    sprintf(error_buf, "%s (%s)\n", PCL_ErrorMessage(), 
		    PCL_ErrorString());
	    fprintf(stderr, error_buf);
/* 	    SetErrorStatus(GE_CmdErr, error_buf); */
	    return False;
	    break;
    }

    status = (int) PCL_IsPresent(VK_SLAVE_QUALIFIER);
    switch (status) {
	case PCL_Present:
	    *slave = True;
	    break;
	
	case PCL_Absent:
	case PCL_Negated:
	    *slave = False;
	    break;

   	default:
	    sprintf(error_buf, "%s (%s)\n", PCL_ErrorMessage(), 
		    PCL_ErrorString());
	    fprintf(stderr, error_buf);
/* 	    SetErrorStatus(GE_CmdErr, error_buf); */
	    return False;
	    break;
    }

    status = (int) PCL_IsPresent(VK_DUMP_QUALIFIER);
    switch (status) {
	case PCL_Present:
	    *dump = True;
	    break;
	
	case PCL_Absent:
	case PCL_Negated:
	    *dump = False;
	    break;

   	default:
	    sprintf(error_buf, "%s (%s)\n", PCL_ErrorMessage(), 
		    PCL_ErrorString());
	    fprintf(stderr, error_buf);
/* 	    SetErrorStatus(GE_CmdErr, error_buf); */
	    return False;
	    break;
    }

    status = (int) PCL_IsPresent(VK_VERBOSE_QUALIFIER);
    switch (status) {
	case PCL_Present:
	    *verbose = True;
	    break;
	
	case PCL_Absent:
#ifdef VCG_VLK
	    *verbose = False;
#else
	    *verbose = True;
#endif
	    break;
	case PCL_Negated:
	    *verbose = False;
	    break;

   	default:
	    sprintf(error_buf, "%s (%s)\n", PCL_ErrorMessage(), 
		    PCL_ErrorString());
	    fprintf(stderr, error_buf);
/* 	    SetErrorStatus(GE_CmdErr, error_buf); */
	    return False;
	    break;
    }

    return True;
} /* GetParams */


#if 0
/* *******************************************************************
*
* RtnName - <description of function or procedure>
*
* HISTORY:
*	??-JUN-90 DSB	Created
*
******************************************************************* */


<static> Fntype RtnName(parm)				/* return value desc. if not void */
tParmType parm;			/* mode: description */
{
    type local;				/* description */
    type local;				/* description */
/**/

} /* RtnName */


#endif
