#ifndef TKProcesses_H
#define TKProcesses_H
/* *******************************************************************
*
* Copyright (c) 1989-1990 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* HEADER FILE: TKProcesses.h
*
* DESCRIPTION:  
*	Private interface file for TKProcesses.c.
*
* CONSTANTS:
*	<constants>	<constants defined in this header file >
*
* TYPES:
*	<types>		<types defined in this header file >
*
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this header file >
*
* ROUTINES:
*   External:
*	...
*
* HISTORY:
*	15-DEC-89 DSB	Created
*	18-MAR-91 WAG	Renamed declaration of CreateProcess to
*			CreateUserProcess; added declaration of
*			CreateKernelProcess.
*	20-MAR-91 WAG	Removed priority field for both CreateKernelProcess
*			and CreateUserProcess. 	Removed type definition of
*			tProcessPriority and #defines for priority values.
*	25-APR-91 AWH	WOO21: Renamed to TK...
*	02-MAY-91 DSB	Cleaning up generally
*	06-MAY-91 DSB	Cleaning up signal changes
*	14-MAY-91 DSB	W0053+: Split out 'Delayed processes; removed 
*			obsolete Create*Process parameters
*	21-MAY-91 DSB	Cleaned up old types; renamed to remove some VK_
*
* SCCS ID: @(#)TKProcesses.h	42.1 1/10/92
*
******************************************************************* */
#include "VKProcesses.h"


VK_tProcessHandle CreateKernelProcess(
#ifdef ANSI_FN_PROTOS
	TK_tRegionHandle parent_region,	/* parent region handle */
	tProcessKind process_kind,
	VK_tVoidPtr execution_context
#endif
	);				/* create internal kernel process */


VK_tProcessHandle CreateDelayedProcess(
#ifdef ANSI_FN_PROTOS
	TK_tRegionHandle parent_region,	/* parent region handle */
	tProcData_Delayed_Ptr execution_context
#endif
	);				/* create internal user process */
			/* ?? remove excess parameters when cleaning up ?? */



#endif /* TKProcesses_H */
