static char SCCS_ID[] = "@(#)TKRegister.c	42.1 1/10/92";
/* *******************************************************************
*
* Copyright (c) 1989-1990 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* CODE FILE: TKRegister.c
*
* DESCRIPTION:  
*	??
*
* CONSTANTS:
*	<constants>	<constants defined in this header file >
*
* TYPES:
*	<types>		<types defined in this header file >
*
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this header file >
*
* ROUTINES:
*   External:
*	...
*
*   Internal:
*	...
*
* HISTORY:
*	21-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003.  Added VK_RegisterIntegerType and
*			VK_RegisterFloatingType
*	02-APR-91 JBR	W0013.  Added VK_RegisterPhysicalType,
*			VK_RegisterArrayTypeDecl, and VK_RegisterIndexSubtype
*	16-APR-91 WAG	W0033.  Added NewCreateSymbInfoRecord, modified
*			CreateSymbInfoRecord to call it.  NewCreate... routine
*			will become the Create... routine eventually
*	18-APR-91 WAG	W0027.  Added routines VK_RegisterInterfaceSignalDecl
*			and VK_RegisterLocalSignalDecl
*	18-APR-91 WAG	W0025.  Added routines VK_RegisterRecordTypeDecl,
*			VK_RegisterRecordElementDecl, VK_RegisterFileTypeDecl,
*			VK_RegisterAccessTypeDecl, and VK_RegisterSubtypeDecl
*	18-APR-91 WAG	W0026.  Added for routines
*			VK_RegisterInstantiationStmt,
*			VK_RegisterInterfaceConstantDecl,
*			VK_RegisterLocalConstantDecl,
*			VK_RegisterInterfaceVariableDecl,
*			VK_RegisterLocalVariableDecl, and
*			VK_RegisterLocalFileDecl
*	25-APR-91 AWH	WOO21: Renamed to TK...
*	02-MAY-91 DSB	Cleaning up generally
*	04-MAY-91 DSB	Changed to signal handle / signal offset protocol
*	10-MAY-91 JBR	W0041. Added su_GetUnitNames
*	16-MAY-91 DSB	Cleaning up tSymbInfoKind enumerators; added new ones
*			to remove BadInfo uses; fixed bug: IntegerTypeDecl
*			had EnumerationTypeDeclInfo value
*	16-MAY-91 DSB	Fixing bug: fixed "0.0" that were "0"
*	30-MAY-91 DSB	Moved su_GetTypeInfoTypeClass to here from TKSignals.c
*	05-JUN-91 DSB	Moved su_TraverseToData from TKSignals to TKSymbInfo
*	06-JUN-91 DSB	Added SIH_Std__TextIO__Text
*	12-JUN-91 DSB	Added SIH_Std__Standard, SIH_Std__Standard__String, 
*			SIH_Std__TextIO
*	17-JUN-91 JBR	Corrected types of some dummy parameters to
*			CreateSymbInfoRecord_Decls
*	23-AUG-91 DSB	Split TKSymbInfo into TKSymbUtils and TKRegister
*
* SCCS ID: @(#)TKRegister.c	42.1 1/10/92
*
******************************************************************* */

#include "TKRegister.h"

#include "VKI.h"
#include "TKStructs.h"
#include "TKGlobals.h"		/* for SymbInfoList */
#include "TKTemp.h"		/* for AllocateMemory */
#include "TKRecord.h"		/* for RD_WriteEnumerationType... */
#include "TKSymbUtils.h"	/* for su_FindLibrary */


/* static int TemporarySymbInfoNumber = 0; */

/* extern */ VK_tSymbInfoHandle SIH_std = NULL;

/* extern */ VK_tSymbInfoHandle SIH_Std__Standard = NULL;

/* extern */ VK_tSymbInfoHandle SIH_Std__Standard__Boolean = NULL;
/* extern */ VK_tSymbInfoHandle SIH_Std__Standard__Bit = NULL;
/* extern */ VK_tSymbInfoHandle SIH_Std__Standard__Time = NULL;
/* extern */ VK_tSymbInfoHandle SIH_Std__Standard__String = NULL;

/* extern */ VK_tSymbInfoHandle SIH_Std__TextIO = NULL;
/* extern */ VK_tSymbInfoHandle SIH_Std__TextIO__Text = NULL;
				/* file type (STD.)TEXTIO.TEXT */
/* ?? yes, the capitalization is inconsistent; someday I'll get to clean up 
?? */

typedef enum {CheckValue = -57005} tCheck;	/* for sync. check only */

static VK_tSymbInfoHandle NewCreateSymbInfoRecord();
/* ?? Why doesn't this have an ANSI C function prototype? ?? */



/* *******************************************************************
*
* CreateSymbInfoRecord - create and initialize common symbolic information 
*	record
*
* HISTORY:
*	22-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003.  Added parameters left_bound, direction,
*			and right_bound
*	01-APR-91 WAG	W0015.  Changed VerifyMalloc to AllocateMemory
*	03-APR-91 JBR	W0013.  Added parameters positions, base_type,
*			subtype_reg, subtype_off, res_func, dimensions
*	16-APR-91 WAG	W0033.  Modified to act as a shell for
*			NewCreateSymbInfoRecord
*	28-MAY-91 JBR	Added tCheck parameter to NewCreateSymbInfoRecord call
*
******************************************************************* */
static VK_tSymbInfoHandle CreateSymbInfoRecord(
	symb_info_record_type, encl_region, item_number,
	extended_region, item_name, remove_this, int_left_bound,
	float_left_bound, direction, int_right_bound, float_right_bound,
	cardinality, literals, positions, value_offset, base_type, subtype_reg,
	subtype_off, res_func, dimensions)
tSymbInfoKind symb_info_record_type;
VK_tSymbInfoHandle encl_region;
VK_tEnclItemNumber item_number;
VK_tSymbInfoHandle extended_region;
VK_tName item_name;
VK_tSymbInfoHandle remove_this;
VK_tScalarData int_left_bound;	/* integer left bound */
VK_tFloatingData float_left_bound;	/* floating left bound */
VK_tDirection direction;	/* numeric direction */
VK_tScalarData int_right_bound;	/* integer right bound */
VK_tFloatingData float_right_bound;	/* floating right bound */
VK_tArraySize cardinality;	/* number of literals */
VK_tStringArray literals;	/* literals string table */
VK_tIntegerArray positions;	/* unit position values table */
VK_tFieldOffset value_offset;
VK_tSymbInfoHandle base_type;	/* element base type */
VK_tSymbInfoHandle subtype_reg;	/* elem. constr. path indication */
VK_tFieldOffset subtype_off;	/* elem. const. LAR field offset */
VK_tSymbInfoHandle res_func;	/* resolution function (arrays) */
VK_tInteger dimensions;		/* number of dimensions */
{
    VK_tSymbInfoHandle symb_info;
/**/

    symb_info = NewCreateSymbInfoRecord(symb_info_record_type, 
	extended_region, encl_region, item_number, item_name, 
	"", NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, base_type, subtype_reg, subtype_off, res_func, value_offset,
	NULL, NULL, VK_BadMode, VK_BadMode, VK_BadSignalKind, 
	int_left_bound, NULL, float_left_bound, direction, 
	int_right_bound, NULL, float_right_bound, 
	cardinality, literals, positions, 
	dimensions, 0, 
	False, False, 
	0, 0, NULL, NULL, NULL, NULL, NULL, "",
	CheckValue);

    return symb_info;
} /* CreateSymbInfoRecord */


/* *******************************************************************
*
* NewCreateSymbInfoRecord - create and initialize common symbolic 
*		information record
*
* HISTORY:
*	22-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003.  Added parameters left_bound, direction,
*			and right_bound
*	01-APR-91 WAG	W0015.  Changed VerifyMalloc to AllocateMemory
*	03-APR-91 JBR	W0013.  Added parameters positions, base_type,
*			subtype_reg, subtype_off, res_func, dimensions
*	16-APR-91 WAG	W0033. Created from CreateSymbInfoRecord.  This
*			routine will be come CreateSymbInfoRecord eventually
*	26-APR-91 DSB	Kludged or fixed bug: map null children value to
*			empty list
*	16-MAY-91 DSB	Added VERIFYs to catch invalid null values being
*			passed around
*	16-MAY-91 DSB	Added check tCheck for robustness
*	24-MAY-91 DSB	Adding some more VERIFYs
*	06-JUN-91 JBR	W0019.  Added AddqqTracenum call
*	11-JUN-91 DSB	Added large_{left,right}_bounds
*	15-AUG-91 DSB	Added library_info for VK_RegisterLibraryClause
*	08-JAN-92 DKC	Data for type bounds is now overlayed
*
******************************************************************* */
static VK_tSymbInfoHandle NewCreateSymbInfoRecord(symb_info_kind, 
	extended_region, encl_region, item_number, item_name, 
	source_file_name, 
	exec_table_size, trace_table, break_table, 
	elab_pos, begin_pos, end_pos, encl_item_count, children,
	base_type_info, constraint_region_info, constraint_offset,
	res_func_info, 
	value_offset, handle_offset, offset_offset, 
	intf_mode, file_mode, signal_kind, 
	integer_left_bound, large_left_bound, float_left_bound,
	direction, 
	integer_right_bound, large_right_bound, float_right_bound, 
	cardinality, literals, position_values, dimensions, record_elem_count, 
	has_sensitivity_list, contains_wait_stmt, 
	intf_data_offset, intf_data_size, 
	elaboration_function, binding_function, evaluation_function,
	analysis_time, comp_decl_info, library_info, check)
tSymbInfoKind symb_info_kind;
VK_tSymbInfoHandle extended_region;
VK_tSymbInfoHandle encl_region;
VK_tEnclItemNumber item_number;
VK_tName item_name;
VK_tCString source_file_name;
VK_tExecPosIndex exec_table_size;
VK_tTraceTable trace_table;
VK_tBreakTable break_table;
VK_tExecPosIndex elab_pos;
VK_tExecPosIndex begin_pos;
VK_tExecPosIndex end_pos;
VK_tEnclItemNumber encl_item_count;
TempList children;
VK_tSymbInfoHandle base_type_info;
VK_tSymbInfoHandle constraint_region_info;
VK_tFieldOffset constraint_offset;
VK_tSymbInfoHandle res_func_info;
VK_tFieldOffset value_offset;
VK_tFieldOffset handle_offset;
VK_tFieldOffset offset_offset;
VK_tMode intf_mode;
VK_tMode file_mode;
VK_tSignalKind signal_kind;
VK_tScalarData integer_left_bound;	/* integer left bound */
VK_tLargeAddr large_left_bound;		/* large integer left bound */
VK_tFloatingData float_left_bound;	/* floating left bound */
VK_tDirection direction;		/* numeric direction */
VK_tScalarData integer_right_bound;	/* integer right bound */
VK_tLargeAddr large_right_bound;	/* large integer right bound */
VK_tFloatingData float_right_bound;	/* floating right bound */
VK_tArraySize cardinality;		/* number of literals */
VK_tStringArrayAddr literals;		/* literals string table */
VK_tIntegerArrayAddr position_values;	/* unit position values table */
VK_tInteger dimensions;			/* number of dimensions */
VK_tEnclItemNumber record_elem_count;
VK_tBoolean has_sensitivity_list;
VK_tBoolean contains_wait_stmt;
VK_tFieldOffset intf_data_offset;
VK_tByteSize intf_data_size;	/* byte size of interface activation
				   record */
VK_tGenericElabFnPtr elaboration_function;
VK_tBindFnPtr binding_function;
VK_tGenericEvalFnPtr evaluation_function;
VK_tTimeStampPtr analysis_time;
VK_tSymbInfoHandle comp_decl_info;
VK_tSymbInfoHandle library_info;
tCheck check;
{
    VK_tFloatingData   temp_float; /* passed float is actually double */
    VK_tSymbInfoHandle symb_info;
/**/
    VERIFY_WARN(check == CheckValue);
#define CHECK_PARAMS 1

				/* create the record */
    AllocateMemory(symb_info, tSymbInfoRec, 1);

    AddqqRecordKind(symb_info, SymbInfoRecord);

    TempAddLast(SymbInfoList, (TempNode) symb_info);

				/* fill the record */
    AddqqSymbInfoKind(symb_info, symb_info_kind);

    AddqqExtReg(symb_info, extended_region);
#if CHECK_PARAMS
    VERIFY_WARN(NULL == extended_region || 
	SymbInfoRecord == qqRecordKind(extended_region));
#endif
    if (NULL != extended_region) {
	TempAddLast(qqExtensions(extended_region), (TempNode) symb_info);
    }

    AddqqEnclReg(symb_info, encl_region);
#if CHECK_PARAMS
    VERIFY_WARN(NULL == encl_region || 
	SymbInfoRecord == qqRecordKind(encl_region));
#endif
    if (! (NULL == encl_region) ) {
	TempAddLast(qqChildren(encl_region), (TempNode) symb_info);
    }

    AddqqItemNum(symb_info, item_number);

    AddqqName(symb_info, item_name);
    AddqqSourceFileName(symb_info, source_file_name);

    AddqqTraceNum(symb_info, -1);

				/* elaboration/execution: */
    AddqqExecTableSize(symb_info, exec_table_size);
    AddqqTraceTable(symb_info, trace_table);
    AddqqBreakTable(symb_info, break_table);

				/* debug information: */
    AddqqElabPos(symb_info, elab_pos);
    AddqqBeginPos(symb_info, begin_pos);
    AddqqEndPos(symb_info, end_pos);

				/* region information: */
    AddqqEnclItemCount(symb_info, encl_item_count);

				/* for regions: for record/array types: */
    if (TempNullList(children)) {
	children = TempNewList();
    }
    AddqqChildren(symb_info, children);

    AddqqExtensions(symb_info, TempNewList());

/* ?? Why isn't this stuff in a logical order?  See note in VKRegister.h. ?? */

				/* for array types: */
    AddqqBaseTypeInfo(symb_info, base_type_info);
#if CHECK_PARAMS
    VERIFY_WARN(NULL == base_type_info || 
	SymbInfoRecord == qqRecordKind(base_type_info));
#endif
    AddqqConstraintRegionInfo(symb_info, constraint_region_info);
    AddqqConstraintOffset(symb_info, constraint_offset);
    AddqqResFuncInfo(symb_info, res_func_info);
#if CHECK_PARAMS
    VERIFY_WARN(NULL == res_func_info || 
	SymbInfoRecord == qqRecordKind(res_func_info));
#endif
    AddqqValueOffset(symb_info, value_offset);

				/* signal-specific information: */
    AddqqHandleOffset(symb_info, handle_offset);
    AddqqOffsetOffset(symb_info, offset_offset);

				/* other: */
    AddqqIntfMode(symb_info, intf_mode);
#if CHECK_PARAMS
    VERIFY_WARN(intf_mode == VK_BadMode ||
		intf_mode == VK_InternalMode ||
		intf_mode == VK_InMode ||
		intf_mode == VK_InoutMode ||
		intf_mode == VK_OutMode ||
		intf_mode == VK_BufferMode ||
		intf_mode == VK_LinkageMode);
#endif
    AddqqFileMode(symb_info, file_mode);
#if CHECK_PARAMS
    VERIFY_WARN(file_mode == VK_BadMode ||
		file_mode == VK_InMode ||
		file_mode == VK_OutMode);
#endif

/* ?? file_mode and intf_mode were meant to be folded ?? */

    AddqqSignalKind(symb_info, signal_kind);
#if CHECK_PARAMS
    VERIFY_WARN(signal_kind == VK_BadSignalKind ||
		signal_kind == VK_UnguardedKind ||
		signal_kind == VK_BusKind ||
		signal_kind == VK_RegisterKind);
#endif

				/* for numeric types: */
    if (NULL != large_left_bound) {
	AddqqLargeLeftBound  (symb_info, *large_left_bound);
    }
    else {
        temp_float = float_left_bound; 
        AddqqFloatLeftBound  (symb_info, temp_float);
        AddqqIntegerLeftBound(symb_info, integer_left_bound);
    }

    AddqqDirection(symb_info, direction);
#if CHECK_PARAMS
    VERIFY_WARN(direction == VK_Ascending || direction == VK_Descending ||
	direction == VK_BadDirection);
#endif

    if (NULL != large_left_bound) {
	AddqqLargeRightBound(symb_info, *large_right_bound);
    }
    else {
        temp_float = float_right_bound;
        AddqqFloatRightBound  (symb_info, temp_float);
        AddqqIntegerRightBound(symb_info, integer_right_bound);
    }
				/* for enumeration and physical types: */
    AddqqCardinality(symb_info, cardinality);
#if CHECK_PARAMS
    VERIFY_WARN(cardinality >= 0);
#endif

    AddqqLiterals(symb_info, literals);
    AddqqPositionValues(symb_info, position_values);

    AddqqDimensions(symb_info, dimensions);
#if CHECK_PARAMS
    VERIFY_WARN(dimensions >= 0);
#endif

/* ?? note: dimensions, record_element_count, and probably encl_item_count
	were meant to be folded ?? */

    AddqqRecordElemCount(symb_info, record_elem_count);
#if CHECK_PARAMS
    VERIFY_WARN(record_elem_count >= 0);
#endif

				/* process-specific information: */
    AddqqHasSensitivityList(symb_info, has_sensitivity_list);
#if CHECK_PARAMS
    VERIFY_WARN(has_sensitivity_list == TRUE || has_sensitivity_list == FALSE);
#endif

				/* procedure-specific information: */
    AddqqContainsWaitStmt(symb_info, contains_wait_stmt);
#if CHECK_PARAMS
    VERIFY_WARN(contains_wait_stmt == TRUE || contains_wait_stmt == FALSE);
#endif

    AddqqIntfDataOffset(symb_info, intf_data_offset);
    AddqqIntfDataSize(symb_info, intf_data_size);

    AddqqElaborationFunction(symb_info, elaboration_function);
    AddqqBindingFunction(symb_info, binding_function);
    AddqqEvaluationFunction(symb_info, evaluation_function);

    AddqqAnalysisTime(symb_info, analysis_time);

    AddqqCompDeclInfo(symb_info, comp_decl_info);

    AddqqLibraryInfo(symb_info, library_info);

#if CHECK_PARAMS
    VERIFY_WARN(NULL == comp_decl_info || 
	SymbInfoRecord == qqRecordKind(comp_decl_info));
#endif

    return symb_info;
} /* NewCreateSymbInfoRecord */


/* *******************************************************************
*
* CreateSymbInfoRecord_Units - create and initialize symbolic 
*		information record for design units
*
* HISTORY:
*	17-APR-91 WAG	W0033. Created from NewCreateSymbInfoRecord
*	22-APR-91 AHW	W0033. Changed to call NewCreateSymbInfoRecord
*	11-JUN-91 DSB	Added large_{left,right}_bounds
*
******************************************************************* */
static VK_tSymbInfoHandle CreateSymbInfoRecord_Units(symb_info_kind, 
	extended_region, enclosing_region, item_name,
	source_file_name, exec_table_size, trace_table,	break_table,
        encl_item_count, elaboration_function, binding_function, 
	intf_data_size, analysis_time, check)
tSymbInfoKind symb_info_kind;
VK_tSymbInfoHandle extended_region;
VK_tSymbInfoHandle enclosing_region;	/* library region */
VK_tName item_name;
VK_tCString source_file_name;
VK_tExecPosIndex exec_table_size;
VK_tTraceTable trace_table;
VK_tBreakTable break_table;
VK_tEnclItemNumber encl_item_count;
VK_tGenericElabFnPtr elaboration_function;
VK_tBindFnPtr binding_function;
VK_tByteSize intf_data_size;	/* byte size of interface activation
				   record */
VK_tTimeStampPtr analysis_time;
tCheck check;
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = NewCreateSymbInfoRecord(
	symb_info_kind,	  	/* tSymbInfoKind symb_info_kind; */
	extended_region,  	/* VK_tSymbInfoHandle extended_region; */
	enclosing_region,	/* VK_tSymbInfoHandle encl_region; */
	0,			/* VK_tEnclItemNumber item_number; */
	item_name,		/* VK_tName item_name; */

	source_file_name,	/* VK_tCString source_file_name; */
	exec_table_size,	/* VK_tExecPosIndex exec_table_size; */
	trace_table,		/* int *trace_table; */
	NULL,			/* int *break_table; */
	0,			/* VK_tExecPosIndex elab_pos; */
	0,			/* VK_tExecPosIndex begin_pos; */
	0,			/* VK_tExecPosIndex end_pos; */
	encl_item_count,	/* VK_tEnclItemNumber encl_item_count; */
	NULL,			/* TempList children; */
	NULL,			/* VK_tSymbInfoHandle base_type_info; */
	NULL,			/* VK_tSymbInfoHandle constraint_region_info; */
	0,			/* VK_tFieldOffset constraint_offset; */
	NULL,			/* VK_tSymbInfoHandle res_func_info; */
	0,			/* VK_tFieldOffset value_offset; */
	0, 			/* VK_tFieldOffset handle_offset; */
	0, 			/* VK_tFieldOffset offset_offset; */
	VK_BadMode,		/* VK_tMode intf_mode; */
	VK_BadMode,		/* VK_tMode file_mode; */
	VK_BadSignalKind,	/* VK_tSignalKind signal_kind; */
	0,			/* VK_tScalarData integer_left_bound;	*/
	NULL,			/* VK_tLargeAddr large_left_bound;	*/
	0.0,			/* VK_tFloatingData float_left_bound; */
	VK_BadDirection,	/* VK_tDirection direction;	*/
	0,			/* VK_tScalarData integer_right_bound; */
	NULL,			/* VK_tLargeAddr large_right_bound;	*/
	0.0, 			/* VK_tFloatingData float_right_bound; */
	0,			/* VK_tArraySize cardinality;	*/
	NULL,			/* VK_tStringArrayAddr literals;	*/
	NULL,			/* VK_tIntegerArrayAddr position_values; */
	0,			/* VK_tInteger dimensions; */
	0,			/* VK_tEnclItemNumber record_elem_count; */
	False,			/* VK_tBoolean has_sensitivity_list; */
	False,			/* VK_tBoolean contains_wait_stmt; */
	0,			/* VK_tFieldOffset intf_data_offset; */
	intf_data_size,		/* VK_tByteSize intf_data_size; */
	elaboration_function,	/* VK_tGenericElabFnPtr elaboration_function; */
	binding_function,	/* VK_tBindFnPtr binding_function; */
	NULL,			/* VK_tGenericEvalFnPtr evaluation_function; */
	analysis_time,		/* VK_tTimeStampPtr analysis_time; */
	NULL,			/* VK_tSymbInfoHandle comp_decl_info; */
	"",			/* VK_tSymbInfoHandle library_info; */
	CheckValue);
    return symb_info;
} /* CreateSymbInfoRecord_Units */


/* *******************************************************************
*
* CreateSymbInfoRecord_Regions - create and initialize symbolic 
*		information record for regions
*
* HISTORY:
*	17-APR-91 WAG	W0033. Created from NewCreateSymbInfoRecord
*	22-APR-91 AHW	W0033. Changed to call NewCreateSymbInfoRecord
*	11-JUN-91 DSB	Added large_{left,right}_bounds
*	17-JUL-91 DSB	Implemented intf_data_offset
*
******************************************************************* */
static VK_tSymbInfoHandle CreateSymbInfoRecord_Regions(
	symb_info_kind, extended_region, encl_region, item_number,
	item_name, elab_pos, begin_pos, end_pos, encl_item_count,
	has_sensitivity_list, contains_wait_stmt, evaluation_function, 
	intf_data_offset, reserved, check)
tSymbInfoKind symb_info_kind;
VK_tSymbInfoHandle extended_region;
VK_tSymbInfoHandle encl_region;
VK_tEnclItemNumber item_number;
VK_tName item_name;
VK_tExecPosIndex elab_pos;
VK_tExecPosIndex begin_pos;
VK_tExecPosIndex end_pos;
VK_tEnclItemNumber encl_item_count;
VK_tBoolean has_sensitivity_list;
VK_tBoolean contains_wait_stmt;
VK_tGenericEvalFnPtr evaluation_function;
VK_tFieldOffset intf_data_offset;
int reserved;
tCheck check;
{
    VK_tSymbInfoHandle symb_info;
/**/
    VERIFY_WARN(check == CheckValue);
    symb_info = NewCreateSymbInfoRecord(
	symb_info_kind,	  	/* tSymbInfoKind symb_info_kind; */
	extended_region,  	/* VK_tSymbInfoHandle extended_region; */
	encl_region,	/* VK_tSymbInfoHandle encl_region; */
	item_number,		/* VK_tEnclItemNumber item_number; */
	item_name,		/* VK_tName item_name; */

	"",			/* VK_tCString source_file_name; */
	0,			/* VK_tExecPosIndex exec_table_size; */
	NULL,			/* int *trace_table; */
	NULL,			/* int *break_table; */
	elab_pos,      		/* VK_tExecPosIndex elab_pos; */
	begin_pos,     		/* VK_tExecPosIndex begin_pos; */
	end_pos,       		/* VK_tExecPosIndex end_pos; */
	encl_item_count,	/* VK_tEnclItemNumber encl_item_count; */
	NULL,			/* TempList children; */
	NULL,			/* VK_tSymbInfoHandle base_type_info; */
	NULL,			/* VK_tSymbInfoHandle constraint_region_info; */
	0,			/* VK_tFieldOffset constraint_offset; */
	NULL,			/* VK_tSymbInfoHandle res_func_info; */
	0,			/* VK_tFieldOffset value_offset; */
	0, 			/* VK_tFieldOffset handle_offset; */
	0, 			/* VK_tFieldOffset offset_offset; */
	VK_BadMode,		/* VK_tMode intf_mode; */
	VK_BadMode,		/* VK_tMode file_mode; */
	VK_BadSignalKind,	/* VK_tSignalKind signal_kind; */
	0,			/* VK_tScalarData integer_left_bound;	*/
	NULL,			/* VK_tLargeAddr large_left_bound;	*/
	0.0,			/* VK_tFloatingData float_left_bound; */
	VK_BadDirection,	/* VK_tDirection direction;	*/
	0,			/* VK_tScalarData integer_right_bound; */
	NULL,			/* VK_tLargeAddr large_right_bound;	*/
	0.0, 			/* VK_tFloatingData float_right_bound; */
	0,			/* VK_tArraySize cardinality;	*/
	NULL,			/* VK_tStringArrayAddr literals;	*/
	NULL,			/* VK_tIntegerArrayAddr position_values; */
	0,			/* VK_tInteger dimensions; */
	0,			/* VK_tEnclItemNumber record_elem_count; */
	has_sensitivity_list,	/* VK_tBoolean has_sensitivity_list; */
	contains_wait_stmt,	/* VK_tBoolean contains_wait_stmt; */
	intf_data_offset,	/* VK_tFieldOffset intf_data_offset; */
	0,			/* VK_tByteSize intf_data_size; */
	NULL,			/* VK_tGenericElabFnPtr elaboration_function; */
	NULL,			/* VK_tBindFnPtr binding_function; */
	evaluation_function,	/* VK_tGenericEvalFnPtr evaluation_function; */
	NULL,			/* VK_tTimeStampPtr analysis_time; */
	NULL,			/* VK_tSymbInfoHandle comp_decl_info; */
	"",			/* VK_tSymbInfoHandle library_info; */
	CheckValue);

    return symb_info;
} /* CreateSymbInfoRecord_Regions */


/* *******************************************************************
*
* CreateSymbInfoRecord_HighLevelMisc - create and initialize symbolic 
*		information record for low level miscellaneous objects
*
* HISTORY:
*	17-APR-91 WAG	W0033. Created from NewCreateSymbInfoRecord
*	22-APR-91 AHW	W0033. Changed to call NewCreateSymbInfoRecord
*	23-MAY-91 DSB	Added return type inf. for function decl
*	11-JUN-91 DSB	Added large_{left,right}_bounds
*	16-DEC-91 DKC	Added intf_data_size parameter for functions
*
******************************************************************* */
static VK_tSymbInfoHandle CreateSymbInfoRecord_HighLevelMisc(
	symb_info_kind, encl_region, item_number,
	item_name, elab_pos, encl_item_count, 
	base_type, constraint_region, constraint_offset,
	comp_decl_info,intf_data_size)
tSymbInfoKind symb_info_kind;
VK_tSymbInfoHandle encl_region;
VK_tEnclItemNumber item_number;
VK_tName item_name;
VK_tExecPosIndex elab_pos;
VK_tEnclItemNumber encl_item_count;
VK_tSymbInfoHandle base_type;		
VK_tSymbInfoHandle constraint_region;
VK_tFieldOffset constraint_offset;
 				/* Added type specification for above three;
				   I guessed from usage below. MNP 910917 */
VK_tSymbInfoHandle comp_decl_info;
VK_tByteSize intf_data_size;	/* byte size of interface activation
				   record */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = NewCreateSymbInfoRecord(
	symb_info_kind,	  	/* tSymbInfoKind symb_info_kind; */
	NULL,  			/* VK_tSymbInfoHandle extended_region; */
	encl_region,	/* VK_tSymbInfoHandle encl_region; */
	item_number,		/* VK_tEnclItemNumber item_number; */
	item_name,		/* VK_tName item_name; */

	"",			/* VK_tCString source_file_name; */
	0,			/* VK_tExecPosIndex exec_table_size; */
	NULL,			/* int *trace_table; */
	NULL,			/* int *break_table; */
	elab_pos,      		/* VK_tExecPosIndex elab_pos; */
	0, 	    		/* VK_tExecPosIndex begin_pos; */
	0,       		/* VK_tExecPosIndex end_pos; */
	encl_item_count,	/* VK_tEnclItemNumber encl_item_count; */
	NULL,			/* TempList children; */
	base_type,		/* VK_tSymbInfoHandle base_type_info; */
	constraint_region,
			/* VK_tSymbInfoHandle constraint_region_info; */
	constraint_offset,	/* VK_tFieldOffset constraint_offset; */
	NULL,			/* VK_tSymbInfoHandle res_func_info; */
	0,			/* VK_tFieldOffset value_offset; */
	0, 			/* VK_tFieldOffset handle_offset; */
	0, 			/* VK_tFieldOffset offset_offset; */
	VK_BadMode,		/* VK_tMode intf_mode; */
	VK_BadMode,		/* VK_tMode file_mode; */
	VK_BadSignalKind,	/* VK_tSignalKind signal_kind; */
	0,			/* VK_tScalarData integer_left_bound;	*/
	NULL,			/* VK_tLargeAddr large_left_bound;	*/
	0.0,			/* VK_tFloatingData float_left_bound; */
	VK_BadDirection,	/* VK_tDirection direction;	*/
	0,			/* VK_tScalarData integer_right_bound; */
	NULL,			/* VK_tLargeAddr large_right_bound;	*/
	0.0, 			/* VK_tFloatingData float_right_bound; */
	0,			/* VK_tArraySize cardinality;	*/
	NULL,			/* VK_tStringArrayAddr literals;	*/
	NULL,			/* VK_tIntegerArrayAddr position_values; */
	0,			/* VK_tInteger dimensions; */
	0,			/* VK_tEnclItemNumber record_elem_count; */
	False,			/* VK_tBoolean has_sensitivity_list; */
	False,			/* VK_tBoolean contains_wait_stmt; */
	0,			/* VK_tFieldOffset intf_data_offset; */
	intf_data_size,		/* VK_tByteSize intf_data_size; */
	NULL,			/* VK_tGenericElabFnPtr elaboration_function; */
	NULL,			/* VK_tBindFnPtr binding_function; */
	NULL,			/* VK_tGenericEvalFnPtr evaluation_function; */
	NULL,			/* VK_tTimeStampPtr analysis_time; */
	comp_decl_info,		/* VK_tSymbInfoHandle comp_decl_info; */
	"",			/* VK_tSymbInfoHandle library_info; */
	CheckValue);

    return symb_info;
} /* CreateSymbInfoRecord_HighLevelMisc */


/* *******************************************************************
*
* CreateSymbInfoRecord_Decls - create and initialize symbolic 
*		information record for declarations
*
* HISTORY:
*	17-APR-91 WAG	W0033. Created from NewCreateSymbInfoRecord
*	22-APR-91 AHW	W0033. Changed to call NewCreateSymbInfoRecord
*	11-JUN-91 DSB	Added large_{left,right}_bounds
*	14-NOV-91 DKC	Passed on large left/right bound
*
******************************************************************* */
static VK_tSymbInfoHandle CreateSymbInfoRecord_Decls(
	symb_info_kind, encl_region, item_number,
	item_name, elab_pos, encl_item_count, base_type_info,
	constraint_region_info, constraint_offset, res_func_info, 
	integer_left_bound, large_left_bound, float_left_bound,
	direction, integer_right_bound, large_right_bound, float_right_bound, 
	cardinality, literals, position_values, dimensions, record_elem_count)
tSymbInfoKind symb_info_kind;
VK_tSymbInfoHandle encl_region;
VK_tEnclItemNumber item_number;
VK_tName item_name;
VK_tExecPosIndex elab_pos;
VK_tEnclItemNumber encl_item_count;
VK_tSymbInfoHandle base_type_info;
VK_tSymbInfoHandle constraint_region_info;
VK_tFieldOffset constraint_offset;
VK_tSymbInfoHandle res_func_info;
VK_tScalarData integer_left_bound;	/* integer left bound */
VK_tLargeAddr large_left_bound;		/* large physical type left bound */
VK_tFloatingData float_left_bound;	/* floating left bound */
VK_tDirection direction;		/* numeric direction */
VK_tScalarData integer_right_bound;	/* integer right bound */
VK_tLargeAddr large_right_bound;	/* large physical type right bound */
VK_tFloatingData float_right_bound;	/* floating right bound */
VK_tArraySize cardinality;		/* number of literals */
/* ?? this should be VK_tArraySize, not VK_tArraySize; see VKBasicTypes.h,
	and VK_RegisterEnumerationTypeDecl.cardinality ?? */
VK_tStringArrayAddr literals;		/* literals string table */
VK_tIntegerArrayAddr position_values;	/* unit position values table */
VK_tInteger dimensions;			/* number of dimensions */
VK_tEnclItemNumber record_elem_count;
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = NewCreateSymbInfoRecord(
	symb_info_kind,	  	/* tSymbInfoKind symb_info_kind; */
	NULL,  			/* VK_tSymbInfoHandle extended_region; */
	encl_region,	/* VK_tSymbInfoHandle encl_region; */
	item_number,		/* VK_tEnclItemNumber item_number; */
	item_name,		/* VK_tName item_name; */

	"",			/* VK_tCString source_file_name; */
	0,			/* VK_tExecPosIndex exec_table_size; */
	NULL,			/* int *trace_table; */
	NULL,			/* int *break_table; */
	elab_pos,      		/* VK_tExecPosIndex elab_pos; */
	0, 	    		/* VK_tExecPosIndex begin_pos; */
	0,       		/* VK_tExecPosIndex end_pos; */
	encl_item_count,	/* VK_tEnclItemNumber encl_item_count; */
	NULL,			/* TempList children; */
	base_type_info,		/* VK_tSymbInfoHandle base_type_info; */
	constraint_region_info,	/* VK_tSymbInfoHandle constraint_region_info; */
	constraint_offset,	/* VK_tFieldOffset constraint_offset; */
	res_func_info,		/* VK_tSymbInfoHandle res_func_info; */
	0,			/* VK_tFieldOffset value_offset; */
	0, 			/* VK_tFieldOffset handle_offset; */
	0, 			/* VK_tFieldOffset offset_offset; */
	VK_BadMode,		/* VK_tMode intf_mode; */
	VK_BadMode,		/* VK_tMode file_mode; */
	VK_BadSignalKind,	/* VK_tSignalKind signal_kind; */
	integer_left_bound,	/* VK_tScalarData integer_left_bound;	*/
	large_left_bound,	/* VK_tLargeAddr large_left_bound;	*/
	float_left_bound,	/* VK_tFloatingData float_left_bound; */
	direction,		/* VK_tDirection direction;	*/
	integer_right_bound,	/* VK_tScalarData integer_right_bound; */
	large_right_bound,	/* VK_tLargeAddr large_right_bound;	*/
	float_right_bound, 	/* VK_tFloatingData float_right_bound; */
	cardinality,	       	/* VK_tArraySize cardinality;	*/
	literals,     		/* VK_tStringArrayAddr literals;	*/
	position_values,       	/* VK_tIntegerArrayAddr position_values; */
	dimensions,    		/* VK_tInteger dimensions; */
	record_elem_count,     	/* VK_tEnclItemNumber record_elem_count; */
        0,			/* VK_tBoolean has_sensitivity_list; */
	0,			/* VK_tBoolean contains_wait_stmt; */
	0,			/* VK_tFieldOffset intf_data_offset; */
	0,			/* VK_tByteSize intf_data_size; */
	NULL,			/* VK_tGenericElabFnPtr elaboration_function; */
	NULL,			/* VK_tBindFnPtr binding_function; */
        NULL,			/* VK_tGenericEvalFnPtr evaluation_function; */
	NULL,			/* VK_tTimeStampPtr analysis_time; */
	NULL,			/* VK_tSymbInfoHandle comp_decl_info; */
	"",			/* VK_tSymbInfoHandle library_info; */
	CheckValue);

    return symb_info;
} /* CreateSymbInfoRecord_Decls */


/* *******************************************************************
*
* CreateSymbInfoRecord_Objects - create and initialize symbolic 
*		information record for objects
*
* HISTORY:
*	17-APR-91 WAG	W0033. Created from NewCreateSymbInfoRecord
*	22-APR-91 AHW	W0033. Changed to call NewCreateSymbInfoRecord
*	11-JUN-91 DSB	Added large_{left,right}_bounds
*
******************************************************************* */
static VK_tSymbInfoHandle CreateSymbInfoRecord_Objects(
	symb_info_kind, encl_region, item_number,
	item_name, elab_pos, base_type_info, constraint_region_info,
	constraint_offset, res_func_info, value_offset, handle_offset,
	offset_offset, intf_mode, file_mode, signal_kind)
tSymbInfoKind symb_info_kind;
VK_tSymbInfoHandle encl_region;
VK_tEnclItemNumber item_number;
VK_tName item_name;
VK_tExecPosIndex elab_pos;
VK_tSymbInfoHandle base_type_info;
VK_tSymbInfoHandle constraint_region_info;
VK_tFieldOffset constraint_offset;
VK_tSymbInfoHandle res_func_info;
VK_tFieldOffset value_offset;
VK_tFieldOffset handle_offset;
VK_tFieldOffset offset_offset;
VK_tMode intf_mode;
VK_tMode file_mode;
VK_tSignalKind signal_kind;
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = NewCreateSymbInfoRecord(
	symb_info_kind,	  	/* tSymbInfoKind symb_info_kind; */
	NULL,  			/* VK_tSymbInfoHandle extended_region; */
	encl_region,	/* VK_tSymbInfoHandle encl_region; */
	item_number,		/* VK_tEnclItemNumber item_number; */
	item_name,		/* VK_tName item_name; */

	"",			/* VK_tCString source_file_name; */
	0,			/* VK_tExecPosIndex exec_table_size; */
	NULL,			/* int *trace_table; */
	NULL,			/* int *break_table; */
	elab_pos,      		/* VK_tExecPosIndex elab_pos; */
	0,	     		/* VK_tExecPosIndex begin_pos; */
	0,            		/* VK_tExecPosIndex end_pos; */
	0,			/* VK_tEnclItemNumber encl_item_count; */
	NULL,			/* TempList children; */
	base_type_info,		/* VK_tSymbInfoHandle base_type_info; */
	constraint_region_info,	/* VK_tSymbInfoHandle constraint_region_info; */
	constraint_offset,	/* VK_tFieldOffset constraint_offset; */
	res_func_info,	      	/* VK_tSymbInfoHandle res_func_info; */
	value_offset,		/* VK_tFieldOffset value_offset; */
	handle_offset, 		/* VK_tFieldOffset handle_offset; */
	offset_offset, 		/* VK_tFieldOffset offset_offset; */
	intf_mode,	       	/* VK_tMode intf_mode; */
	file_mode,     		/* VK_tMode file_mode; */
	signal_kind,	       	/* VK_tSignalKind signal_kind; */
	0,			/* VK_tScalarData integer_left_bound;	*/
	NULL,			/* VK_tLargeAddr large_left_bound;	*/
	0.0,			/* VK_tFloatingData float_left_bound; */
	VK_BadDirection,	/* VK_tDirection direction;	*/
	0,			/* VK_tScalarData integer_right_bound; */
	NULL,			/* VK_tLargeAddr large_right_bound;	*/
	0.0, 			/* VK_tFloatingData float_right_bound; */
	0,			/* VK_tArraySize cardinality;	*/
	NULL,			/* VK_tStringArrayAddr literals;	*/
	NULL,			/* VK_tIntegerArrayAddr position_values; */
	0,			/* VK_tInteger dimensions; */
	0,			/* VK_tEnclItemNumber record_elem_count; */
	0,			/* VK_tBoolean has_sensitivity_list; */
	0,			/* VK_tBoolean contains_wait_stmt; */
	0,			/* VK_tFieldOffset intf_data_offset; */
	0,			/* VK_tByteSize intf_data_size; */
	NULL,			/* VK_tGenericElabFnPtr elaboration_function; */
	NULL,			/* VK_tBindFnPtr binding_function; */
	NULL,			/* VK_tGenericEvalFnPtr evaluation_function; */
	NULL,			/* VK_tTimeStampPtr analysis_time; */
	NULL,			/* VK_tSymbInfoHandle comp_decl_info; */
	"",			/* VK_tSymbInfoHandle library_info; */
	CheckValue);

    return symb_info;
} /* CreateSymbInfoRecord_Objects */


/* *******************************************************************
*
* CreateSymbInfoRecord_LowLevelMisc - create and initialize symbolic 
*		information record for low-level objects
*
* HISTORY:
*	17-APR-91 WAG	W0033. Created from NewCreateSymbInfoRecord
*	22-APR-91 AHW	W0033. Changed to call NewCreateSymbInfoRecord
*	11-JUN-91 DSB	Added large_{left,right}_bounds
*
******************************************************************* */

#ifdef THIS_LOOKS_UNUSED__DOESNT_IT

static VK_tSymbInfoHandle CreateSymbInfoRecord_LowLevelMisc(
	symb_info_kind, encl_region, elab_pos, base_type_info,
	constraint_region_info, constraint_offset, handle_offset, offset_offset)
tSymbInfoKind symb_info_kind;
VK_tSymbInfoHandle encl_region;
VK_tExecPosIndex elab_pos;
VK_tSymbInfoHandle base_type_info;
VK_tSymbInfoHandle constraint_region_info;
VK_tFieldOffset constraint_offset;
VK_tFieldOffset handle_offset;
VK_tFieldOffset offset_offset;
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = NewCreateSymbInfoRecord(
	symb_info_kind,	  	/* tSymbInfoKind symb_info_kind; */
	NULL,  			/* VK_tSymbInfoHandle extended_region; */
	encl_region,	/* VK_tSymbInfoHandle encl_region; */
	0,			/* VK_tEnclItemNumber item_number; */
	"",			/* VK_tName item_name; */
	"",			/* VK_tCString source_file_name; */

	0,			/* VK_tExecPosIndex exec_table_size; */
	NULL,			/* int *trace_table; */
	NULL,			/* int *break_table; */
	elab_pos,      		/* VK_tExecPosIndex elab_pos; */
	0, 	    		/* VK_tExecPosIndex begin_pos; */
	0,       		/* VK_tExecPosIndex end_pos; */
	0,			/* VK_tEnclItemNumber encl_item_count; */
	NULL,			/* TempList children; */
	base_type_info,		/* VK_tSymbInfoHandle base_type_info; */
	constraint_region_info,	/* VK_tSymbInfoHandle constraint_region_info; */
	0,			/* VK_tFieldOffset constraint_offset; */
	NULL,			/* VK_tSymbInfoHandle res_func_info; */
	0,			/* VK_tFieldOffset value_offset; */
	handle_offset, 		/* VK_tFieldOffset handle_offset; */
	offset_offset, 		/* VK_tFieldOffset offset_offset; */
	VK_BadMode,		/* VK_tMode intf_mode; */
	VK_BadMode,		/* VK_tMode file_mode; */
	VK_BadSignalKind,	/* VK_tSignalKind signal_kind; */
	0,			/* VK_tScalarData integer_left_bound;	*/
	NULL,			/* VK_tLargeAddr large_left_bound;	*/
	0.0,			/* VK_tFloatingData float_left_bound; */
	VK_BadDirection,	/* VK_tDirection direction;	*/
	0,			/* VK_tScalarData integer_right_bound; */
	NULL,			/* VK_tLargeAddr large_right_bound;	*/
	0.0, 			/* VK_tFloatingData float_right_bound; */
	0,			/* VK_tArraySize cardinality;	*/
	NULL,			/* VK_tStringArrayAddr literals;	*/
	NULL,			/* VK_tIntegerArrayAddr position_values; */
	0,			/* VK_tInteger dimensions; */
	0,			/* VK_tEnclItemNumber record_elem_count; */
	0,		       	/* VK_tBoolean has_sensitivity_list; */
	0,			/* VK_tBoolean contains_wait_stmt; */
	0,			/* VK_tFieldOffset intf_data_offset; */
	0,			/* VK_tByteSize intf_data_size; */
	NULL,			/* VK_tGenericElabFnPtr elaboration_function; */
	NULL,			/* VK_tBindFnPtr binding_function; */
	NULL,			/* VK_tGenericEvalFnPtr evaluation_function; */
	NULL,			/* VK_tTimeStampPtr analysis_time; */
	NULL,			/* VK_tSymbInfoHandle comp_decl_info; */
	"",			/* VK_tSymbInfoHandle library_info; */
	CheckValue);

    return symb_info;
} /* CreateSymbInfoRecord_LowLevelMisc */

#endif /* UNUSED */

/* *******************************************************************
*
* RegisterLibraryRegion - register library
*
* HISTORY:
*	14-AUG-91 DSB	Created
*
******************************************************************* */

VK_tSymbInfoHandle RegisterLibraryRegion(library_name)
				/* returns handle to registered data */
VK_tName library_name;		/* VHDL library name (dls_xx) */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord_Units(LibraryRegionInfo,
        NULL, NULL, library_name, 
	"", 0, NULL, NULL, 
	0, NULL, NULL, 0, NULL, 
	CheckValue);
    
    if (SIH_std == NULL) {
	if (StringMatch(library_name, "dls_std")) {
	    SIH_std = symb_info;
	}
    }
    return symb_info;
} /* RegisterLibraryRegion */


/* *******************************************************************
*
* VK_RegisterLibraryClause - register library symbol from library clauses
*
* HISTORY:
*	15-AUG-91 DSB	Created
*
******************************************************************* */
void VK_RegisterLibraryClause(encl_region, symbol_name, library_name)
VK_tSymbInfoHandle encl_region;	/* enclosing unit identification */
VK_tName symbol_name;		/* library symbol simple name */
VK_tName library_name;		/* VHDL library name */
{
    VK_tSymbInfoHandle library_info;
    VK_tSymbInfoHandle symb_info;
/**/
    library_info = su_FindLibrary(library_name);
    if (NULL == library_info) {
	library_info = RegisterLibraryRegion(library_name);
    }

    symb_info = NewCreateSymbInfoRecord(LibrarySymbolInfo,
	NULL, encl_region, 0, symbol_name, 
	"", 
	0, NULL, NULL, 
	0, 0, 0, 0, NULL, 
	NULL, NULL, 0, 
	NULL, 
	0, 0, 0, 
	VK_BadMode, VK_BadMode, VK_BadSignalKind, 
	0, NULL, 0.0, VK_BadDirection, 0, NULL, 0.0,  
	0, NULL, NULL, 0, 0, 
	False, False, 
	0, 0, 
	NULL, NULL, NULL, 
	NULL, NULL, library_info, CheckValue);
} /* VK_RegisterLibraryClause */


/* *******************************************************************
*
* VK_RegisterPackageDecl - register package declaration
*
* HISTORY:
*	21-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003: Added parameters to CreateSymbInfoRecord
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*	14-MAY-91 AWH	W0032: New protocol
*	12-JUN-91 DSB	Added SIH_Std__Standard, SIH_Std__TextIO
*	14-AUG-91 DSB	Represent libraries as separate regions
*
******************************************************************* */

VK_tSymbInfoHandle VK_RegisterPackageDecl(library_name, package_name,
	source_file_name, exec_pos_count, trace_table, break_table,
        encl_item_count)	/* returns handle to registered data */
VK_tName library_name;		/* VHDL library name */
VK_tName package_name;		/* package declaration simple name */
VK_tName source_file_name;	/* VHDL source file name */
VK_tExecPosIndex exec_pos_count;
				/* execution tables sizes */
VK_tTraceTable trace_table;	/* elaboration/execution pos. table */
VK_tBreakTable break_table;	/* execution control table */
VK_tEnclItemNumber encl_item_count;
				/* number of enclosed items */
{
    VK_tSymbInfoHandle library_info;
    VK_tSymbInfoHandle symb_info;
/**/
    library_info = su_FindLibrary(library_name);
    if (NULL == library_info) {
	library_info = RegisterLibraryRegion(library_name);
    }

    symb_info = CreateSymbInfoRecord_Units(PackageDeclInfo,
        NULL, library_info, package_name, 
	source_file_name, exec_pos_count, trace_table, break_table, 
	encl_item_count, NULL, NULL, 0, NULL, 
	CheckValue);
    
    if (SIH_Std__Standard == NULL) {
	if (SIH_std == library_info && StringMatch(package_name, "STANDARD")) {
	    SIH_Std__Standard = symb_info;
	}
    }
    if (SIH_Std__TextIO == NULL) {
	if (SIH_std == library_info && StringMatch(package_name, "TextIO")) {
	    SIH_Std__TextIO = symb_info;
	}
    }
    return symb_info;
} /* VK_RegisterPackageDecl */

/* ?? Probably want to have list of libraries, and for each have list of
	contained units.  Then when package declaration or entity declaration
	is registered, create library if it doesn't exist and create unit
	under library.  This should help for library searching for default
	entity selection, and for lexical name searching.  ?? */

/* *******************************************************************
*
* VK_RegisterPackageBody - register package body
*
* HISTORY:
*	21-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003: Added parameters to CreateSymbInfoRecord
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*	14-MAY-91 AWH	W0032: New protocol
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterPackageBody(extended_package, 
	source_file_name, exec_pos_count, trace_table, break_table,
        encl_item_count)
				/* returns handle to registered data */
VK_tSymbInfoHandle extended_package;	/* extended entity's handle */
VK_tName source_file_name;	/* VHDL source file name */
VK_tExecPosIndex exec_pos_count;
			       	/* execution tables sizes */
VK_tTraceTable trace_table;	/* elaboration/execution pos. table */
VK_tBreakTable break_table;	/* execution control table */
VK_tEnclItemNumber encl_item_count;
       				/* number of enclosed items */
{
    VK_tSymbInfoHandle library_info;
    VK_tSymbInfoHandle symb_info;
/**/
    library_info = qqEnclReg(extended_package);
    symb_info = CreateSymbInfoRecord_Units(PackageBodyInfo,
        extended_package, library_info, "", 
	source_file_name, exec_pos_count, trace_table, break_table, 
	encl_item_count, NULL, NULL, 0, NULL, 
	CheckValue);
/* ?? we consider package body region to extend package declaration region;
	but is package body a child of a library? */

    return symb_info;
} /* VK_RegisterPackageBody */


/* *******************************************************************
*
* VK_RegisterEntityDecl - register entity declaration
*
* HISTORY:
*	21-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003: Added parameters to CreateSymbInfoRecord
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*	14-MAY-91 AWH	W0032: New protocol
*	22-JUL-91 DSB	Added intf_data_size
*	14-AUG-91 DSB	Represent libraries as separate regions
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterEntityDecl(library_name, entity_name,
	source_file_name, exec_pos_count, trace_table, break_table,
        encl_item_count, intf_data_size, binding_function)
				/* returns handle to registered data */
VK_tName library_name;		/* VHDL library name */
VK_tName entity_name;		/* entity declaration simple name */
VK_tName source_file_name;	/* VHDL source file name */
VK_tExecPosIndex exec_pos_count;
				/* execution tables sizes */
VK_tTraceTable trace_table;	/* elaboration/execution pos. table */
VK_tBreakTable break_table;	/* execution control table */
VK_tEnclItemNumber encl_item_count;
				/* number of enclosed items */
VK_tByteSize intf_data_size;	/* byte size of interface activation
				   record */
VK_tBindFnPtr binding_function;	/* special function for default binding 
				   indication */
{
    VK_tSymbInfoHandle library_info;
    VK_tSymbInfoHandle symb_info;
/**/
    library_info = su_FindLibrary(library_name);
    if (NULL == library_info) {
	library_info = RegisterLibraryRegion(library_name);
    }

    symb_info = CreateSymbInfoRecord_Units(EntityDeclInfo,
        NULL, library_info, entity_name, 
	source_file_name, exec_pos_count, trace_table, break_table, 
	encl_item_count, NULL, binding_function, intf_data_size, NULL, 
	CheckValue);

    return symb_info;
} /* VK_RegisterEntityDecl */


/* *******************************************************************
*
* VK_RegisterArchitectureBody - register architecture body
*
* HISTORY:
*	21-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003: Added parameters to CreateSymbInfoRecord
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*	14-MAY-91 AWH	W0032: New Protocol
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterArchitectureBody(extended_entity, 
	architecture_name, source_file_name, exec_pos_count, trace_table,
        break_table, encl_item_count, elaboration_function, analysis_time)
				/* returns handle to registered data */
VK_tSymbInfoHandle extended_entity;	/* extended entity's handle */
VK_tName architecture_name;	/* architecture body simple name */
VK_tName source_file_name;	/* VHDL source file name */
VK_tExecPosIndex exec_pos_count;
				/* execution tables sizes */
VK_tTraceTable trace_table;	/* elaboration/execution pos. table */
VK_tBreakTable break_table;	/* execution control table */
VK_tEnclItemNumber encl_item_count;
				/* number of enclosed items */
VK_tGenericElabFnPtr elaboration_function;
	       			/* design entity elaboration fn. */
VK_tTimeStampPtr analysis_time;	/* time and date unit was analyzed */
{
    VK_tSymbInfoHandle library_info;
    VK_tSymbInfoHandle symb_info;
/**/
    library_info = qqEnclReg(extended_entity);
    symb_info = CreateSymbInfoRecord_Units(ArchitectureBodyInfo,
        extended_entity, library_info, architecture_name, 
	source_file_name, exec_pos_count, trace_table, break_table, 
	encl_item_count, elaboration_function, NULL, 0, analysis_time, 
	CheckValue);
/* ?? we consider architecture region to extend entity region (not 
	architecture secondary unit as child of entity primary unit); but is 
	architecture a child of a library? */

    return symb_info;
} /* VK_RegisterArchitectureBody */


/* *******************************************************************
*
* VK_RegisterConfigurationDecl - register configuration declaration
*
* HISTORY:
*	21-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003: Added parameters to CreateSymbInfoRecord
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*	14-MAY-91 AWH	W0032: New protocol
*	11-JUL-91 DSB	Added elaboration function
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterConfigurationDecl(extended_architecture, 
	configuration_name, source_file_name, exec_pos_count,
        trace_table, break_table, encl_item_count, elaboration_function)
				/* returns handle to registered data */
VK_tSymbInfoHandle extended_architecture;
				/* extended architecture's handle */
VK_tName configuration_name;	/* configuration declaration simple name */
VK_tName source_file_name;	/* VHDL source file name */
VK_tExecPosIndex exec_pos_count;
			       	/* execution tables sizes */
VK_tTraceTable trace_table;	/* elaboration/execution pos. table */
VK_tBreakTable break_table;	/* execution control table */
VK_tEnclItemNumber encl_item_count;
	       			/* number of enclosed items */
VK_tGenericElabFnPtr elaboration_function;
 				/* Added type specification; guessed */
 				/* from call. MNP 910917 */
{
    VK_tSymbInfoHandle library_info;
    VK_tSymbInfoHandle symb_info;
/**/
    library_info = qqEnclReg(qqExtReg(extended_architecture));
    symb_info = CreateSymbInfoRecord_Units(ConfigurationDeclInfo,
        extended_architecture, library_info, configuration_name, 
	source_file_name, exec_pos_count, trace_table, break_table, 
	encl_item_count, elaboration_function, NULL, 0, NULL, 
	CheckValue);
/* ?? we consider configuration region to extend architecture region; but is 
	architecture a child of a library? */

    return symb_info;
} /* VK_RegisterConfigurationDecl */




/* *******************************************************************
*
* VK_RegisterBlockStmt - register block statement
*
* HISTORY:
*	21-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003: Added parameters to CreateSymbInfoRecord
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*	15-MAY-91 AWH	W0032: New protocol
*
******************************************************************* */

VK_tSymbInfoHandle VK_RegisterBlockStmt(encl_region, item_number,
	label_name, elab_pos, begin_pos, end_pos, encl_item_count,
        intf_data_offset, has_guard_expression)	
				/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* parent region or unit */
VK_tEnclItemNumber item_number;	/* which item in region */
VK_tName label_name;		/* simple name of region */
VK_tExecPosIndex elab_pos;	/* statement elaboration position */
VK_tExecPosIndex begin_pos;	/* region begin position */
VK_tExecPosIndex end_pos;	/* region end position */
VK_tEnclItemNumber encl_item_count;
				/* number of enclosed items */
VK_tFieldOffset intf_data_offset;	
				/* offset of IAR field in encl. LAR */
VK_tBoolean has_guard_expression;
				/* block has guard expression */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord_Regions(BlockStmtInfo, 
        NULL, encl_region, item_number, 
        label_name, elab_pos, begin_pos, end_pos, 
 	encl_item_count, 0, 0, NULL, intf_data_offset, 0, CheckValue);

    /* ?? W0032: not recorded has_guard_expression */

    return symb_info;
} /* VK_RegisterBlockStmt */


/* *******************************************************************
*
* VK_RegisterIfGenerateStmt - register "if generate" statement
*
* HISTORY:
*	21-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003: Added parameters to CreateSymbInfoRecord
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*	15-MAY-91 AWH	W0032: New protocol
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterIfGenerateStmt(encl_region, 
	item_number, label_name, elab_pos, begin_pos, end_pos,
        encl_item_count, intf_data_offset)
				/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* parent region or unit */
VK_tEnclItemNumber item_number;	/* which item in region */
VK_tName label_name;		/* simple name of region */
VK_tExecPosIndex elab_pos;	/* statement elaboration position */
VK_tExecPosIndex begin_pos;	/* region begin position */
VK_tExecPosIndex end_pos;	/* region end position */
VK_tEnclItemNumber encl_item_count;
				/* number of enclosed items */
VK_tFieldOffset intf_data_offset;
				/* offset of IAR field in encl. LAR */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord_Regions(IfGenerateStmtInfo, 
        NULL, encl_region, item_number, 
        label_name, elab_pos, begin_pos, end_pos, 
 	encl_item_count, 0, 0, NULL, intf_data_offset, 0, CheckValue);

    return symb_info;
} /* VK_RegisterIfGenerateStmt */


/* *******************************************************************
*
* VK_RegisterForGenerateStmt - register "for generate" statement
*
* HISTORY:
*	21-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003: Added parameters to CreateSymbInfoRecord
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*	15-MAY-91 AWH	W0032: New Protocol
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterForGenerateStmt(encl_region, 
	item_number, label_name, elab_pos, begin_pos, end_pos,
        encl_item_count, intf_data_offset)
				/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* parent region or unit */
VK_tEnclItemNumber item_number;	/* which item in region */
VK_tName label_name;		/* simple name of region */
VK_tExecPosIndex elab_pos;	/* statement elaboration position */
VK_tExecPosIndex begin_pos;	/* region begin position */
VK_tExecPosIndex end_pos;	/* region end position */
VK_tEnclItemNumber encl_item_count;
				/* number of enclosed items */
VK_tFieldOffset intf_data_offset;
				/* offset of IAR field in encl. LAR */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord_Regions(ForGenerateStmtInfo, 
        NULL, encl_region, item_number, 
        label_name, elab_pos, begin_pos, end_pos, 
 	encl_item_count, 0, 0, NULL, intf_data_offset, 0, CheckValue);

    return symb_info;
} /* VK_RegisterForGenerateStmt */


/* *******************************************************************
*
* VK_RegisterProcessStmt - register process statement
*
* HISTORY:
*	21-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003: Added parameters to CreateSymbInfoRecord
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*	15-MAY-91 AWH	W0032: New protocol
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterProcessStmt(encl_region, 
	item_number, label_name, elab_pos, begin_pos, end_pos,
        encl_item_count, has_sensitivity_list)
				/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* parent region or unit */
VK_tEnclItemNumber item_number;	/* which item in region */
VK_tName label_name;		/* simple name of region */
VK_tExecPosIndex elab_pos;	/* statement elaboration position */
VK_tExecPosIndex begin_pos;	/* region begin position */
VK_tExecPosIndex end_pos;	/* region end position */
VK_tEnclItemNumber encl_item_count;
				/* number of enclosed items */
VK_tBoolean has_sensitivity_list;
				/* process had sensitivity list */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord_Regions(ProcessStmtInfo, 
        NULL, encl_region, item_number, 
        label_name, elab_pos, begin_pos, end_pos, 
 	encl_item_count, has_sensitivity_list, 0, NULL, 0, 0, 
		CheckValue);

    return symb_info;
} /* VK_RegisterProcessStmt */


/* *******************************************************************
*
* VK_RegisterProcedureDecl - register procedure declaration
*
* HISTORY:
*	21-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003: Added parameters to CreateSymbInfoRecord
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*	19-APR-91 AWH	W0032: Added parameters elab_pos, encl_item_count
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterProcedureDecl(encl_region, 
	item_number, procedure_name, elab_pos, encl_item_count)
				/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* parent region or unit */
VK_tEnclItemNumber item_number;	/* which item in region */
VK_tName procedure_name;	/* simple name of region */
VK_tExecPosIndex elab_pos;      /* declaration elaboration position */
VK_tEnclItemNumber encl_item_count;
                                /* number of enclosed items */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord_HighLevelMisc(ProcedureDeclInfo,
        encl_region, item_number, procedure_name, elab_pos, 
        encl_item_count, NULL, NULL, 0, NULL, 0);
    
    return symb_info;
} /* VK_RegisterProcedureDecl */


/* *******************************************************************
*
* VK_RegisterProcedureBody - register procedure body
*
* HISTORY:
*	21-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003: Added parameters to CreateSymbInfoRecord
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*	22-APR-91 AWH	W0032: Added new parameters to match target
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterProcedureBody(extended_declaration, 
        encl_region, item_number, begin_pos, end_pos,
        encl_item_count, contains_wait_stmt)
				/* returns handle to registered data */
VK_tSymbInfoHandle extended_declaration;
				/* parent region or unit */
VK_tSymbInfoHandle encl_region;	/* parent region or unit */
VK_tEnclItemNumber item_number;	/* which item in region */
VK_tExecPosIndex begin_pos;	/* region begin position */
VK_tExecPosIndex end_pos;	/* region end position */
VK_tEnclItemNumber encl_item_count;
                               /* number of enclosed items */
VK_tBoolean contains_wait_stmt; /* procedure contains wait statement */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord_Regions(ProcedureBodyInfo, 
	extended_declaration, encl_region, item_number,
	"", 0, begin_pos, end_pos, encl_item_count, 0,
        contains_wait_stmt, NULL, 0, 0, CheckValue);


    return symb_info;
} /* VK_RegisterProcedureBody */


/* *******************************************************************
*
* VK_RegisterFunctionDecl - register function declaration
*
* HISTORY:
*	21-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003: Added parameters to CreateSymbInfoRecord
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*	22-APR-91 AWH	W0032: Added new parameters to match target
*	15-MAY-91 AWH	W0032: Complete change to new protocol
*	23-MAY-91 DSB	Added return subtype information
*	03-JAN-92 MNP	Added is_unconstrained parameter
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterFunctionDecl(encl_region, 
	item_number, function_name, elab_pos, encl_item_count,
	base_type, constraint_region, constraint_offset, 
	is_unconstrained, intf_data_size)
				/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* parent region or unit */
VK_tEnclItemNumber item_number;	/* which item in region */
VK_tName function_name;		/* simple name of region */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */
VK_tEnclItemNumber encl_item_count;
    				/* number of enclosed items */
VK_tSymbInfoHandle base_type;	/* base type identification */
VK_tSymbInfoHandle constraint_region;
				/* constraint path indication */
VK_tFieldOffset constraint_offset;
				/* constraint LAR field offset */
VK_tBoolean is_unconstrained; 	/* whether declared as unconstrained */
VK_tByteSize intf_data_size;	/* byte size of interface activation
					   record */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord_HighLevelMisc(FunctionDeclInfo, 
	encl_region, item_number, function_name, elab_pos, 
        encl_item_count, base_type, constraint_region, constraint_offset, 
	NULL,intf_data_size);

    AddqqIsUnconstrained(symb_info,is_unconstrained);

    return symb_info;
} /* VK_RegisterFunctionDecl */


/* *******************************************************************
*
* VK_RegisterFunctionBody - register function body
*
* HISTORY:
*	21-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003: Added parameters to CreateSymbInfoRecord
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*       22-APR-91 AWH   W0032: Added parameters to match target
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterFunctionBody(extended_declaration, 
        encl_region, item_number, begin_pos, end_pos, encl_item_count,
        evaluation_function)
				/* returns handle to registered data */
VK_tSymbInfoHandle extended_declaration;
				/* parent region or unit */
VK_tSymbInfoHandle encl_region;	/* parent region or unit */
VK_tEnclItemNumber item_number;	/* which item in region */
VK_tExecPosIndex begin_pos;	/* region begin position */
VK_tExecPosIndex end_pos;	/* region end position */

VK_tEnclItemNumber encl_item_count;
                                /* number of enclosed items */
VK_tGenericEvalFnPtr evaluation_function;
				/* evaluation function pointer */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord_Regions(FunctionBodyInfo, 
	extended_declaration, encl_region, item_number, "", 0, 
        begin_pos, end_pos, encl_item_count, 0, 0, evaluation_function, 0, 0,
	CheckValue);
/* ?? "0" is not a Boolean value; use False (unless we define a BadBoolean)
	to follow the type formalism ?? */

    return symb_info;
} /* VK_RegisterFunctionBody */


/* *******************************************************************
*
* VK_RegisterComponentDecl - register component declaration
*
* HISTORY:
*	15-MAY-91 AWH	Created
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterComponentDecl(encl_region, item_number,
	component_name, elab_pos, encl_item_count)
VK_tSymbInfoHandle encl_region;	/* enclosing region identification */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tName component_name;	/* component simple name */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */
VK_tEnclItemNumber encl_item_count;
				/* number of enclosed items */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord_Regions(ComponentDeclInfo, 
	NULL, encl_region, item_number, component_name, elab_pos, 
        0, 0, encl_item_count, 0, 0, NULL, 0, 0, CheckValue);
    return symb_info;
} /* VK_RegisterComponentDecl */


/* *******************************************************************
*
* VK_RegisterInstantiationStmt - register instantiation statement
*
* HISTORY:
*	18-APR-91 WAG	W0026.  Created
*	15-MAY-91 AWH	W0032:  New protocol
*	22-MAY-91 DSB	New protocol: removed configuration_spec
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterInstantiationStmt(encl_region, item_number, 
	label_name, elab_pos, intf_data_offset, component_decl)
VK_tSymbInfoHandle encl_region;	/* enclosing region identification */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tName label_name;		/* comp. inst. label simple name */
VK_tExecPosIndex elab_pos;	/* statement elaboration position */
VK_tFieldOffset intf_data_offset;	
				/* offset of IAR field in encl. LAR */
VK_tSymbInfoHandle component_decl;
				/* component declaration ident. */

{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord_HighLevelMisc(InstantiationStmtInfo,
	encl_region, item_number, label_name, NULL, NULL, 
	NULL, NULL, 0, component_decl, 0);
/* ?? W0032: intf_data_offset not saved */

    return symb_info;
} /* VK_RegisterInstantiationStmt */


/* *******************************************************************
*
* VK_RegisterConfigurationSpec - register configuration specification
*
* HISTORY:
*	15-MAY-91 AWH	Created
*	22-MAY-91 DSB	New protocol: removed extended_component, added
*			configured_instantiation
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterConfigurationSpec(configured_instantiation,
	item_number, elab_pos, intf_data_offset, instantiated_unit)
VK_tSymbInfoHandle configured_instantiation;
				/* "parent" comp. instantiation */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tExecPosIndex elab_pos;	/* specification elaboration pos. */
VK_tFieldOffset intf_data_offset;	
				/* offset of IAR field in encl. LAR */
VK_tSymbInfoHandle instantiated_unit;
				/* instantiated unit ident. */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord_Regions(ConfigurationSpecInfo, 
	NULL, configured_instantiation, item_number, "", elab_pos, 
        0, 0, 0, 0, 0, NULL, intf_data_offset, 0, CheckValue);
   /* ?? W0032: instantiated_unit stored */

    return symb_info;
} /* VK_RegisterConfigurationSpec */



/* *******************************************************************
*
* VK_RegisterComponentConfiguration - register component configuration
*
* HISTORY:
*	15-JUL-91 DSB	Created from VK_RegisterConfigurationSpecification
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterComponentConfiguration(configured_instantiation,
	encl_region, item_number, elab_pos, intf_data_offset, 
	instantiated_unit)
VK_tSymbInfoHandle configured_instantiation;
				/* "parent" comp. instantiation */
VK_tSymbInfoHandle encl_region;	/* enclosing region (not used yet) */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tExecPosIndex elab_pos;	/* specification elaboration pos. */
VK_tFieldOffset intf_data_offset;	
				/* offset of IAR field in encl. LAR */
VK_tSymbInfoHandle instantiated_unit;
				/* instantiated unit ident. */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord_Regions(ComponentConfigurationInfo, 
	NULL, configured_instantiation, item_number, "", elab_pos, 
        0, 0, 0, 0, 0, NULL, intf_data_offset, 0, CheckValue);
   /* ?? W0032: instantiated_unit is stored yet */

    return symb_info;
} /* VK_RegisterComponentConfiguration */



/* *******************************************************************
*
* VK_RegisterEnumerationTypeDecl - register enumeration type declaration
*
* HISTORY:
*	22-FEB-91 DSB	Created
*	26-MAR-91 JBR	W0003: Added parameters to CreateSymbInfoRecord
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*	15-MAY-91 AWH	W0032: New protocol
*	04-JUN-91 JBR	W0019: Added call to RD_WriteEnumerationType
*	12-JUN-91 DSB	Added SIH_Std__Standard
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterEnumerationTypeDecl(encl_region, 
	item_number, type_name, elab_pos, cardinality, literals)
				/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* parent region or unit */
VK_tEnclItemNumber item_number;	/* which item in region */
VK_tName type_name;		/* simple name of type */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */

VK_tArraySize cardinality;	/* number of literals */
VK_tStringArray literals;	/* literals string table */
{
    VK_tSymbInfoHandle symb_info;
    int trace_num;
/**/
    symb_info = CreateSymbInfoRecord_Decls(EnumerationTypeDeclInfo, 
	encl_region, item_number,
        type_name, elab_pos, 0, NULL,
	NULL, 0,
        NULL, 
	0, NULL, 0.0, VK_BadDirection, 0, NULL, 0.0, 
	cardinality, literals, 0, 0, 0);

    RD_WriteEnumerationType(type_name, cardinality, literals, &trace_num);
    SetqqTraceNum(symb_info, trace_num);
    
    if (SIH_Std__Standard__Boolean == NULL) {
	if (encl_region == SIH_Std__Standard &&
					StringMatch(type_name, "BOOLEAN")) {
	    SIH_Std__Standard__Boolean = symb_info;
	}
    }
    if (SIH_Std__Standard__Bit == NULL) {
	if (encl_region == SIH_Std__Standard && 
					StringMatch(type_name, "BIT")) {
	    SIH_Std__Standard__Bit = symb_info;
	}
    }

    return symb_info;
} /* VK_RegisterEnumerationTypeDecl */



/* *******************************************************************
*
* VK_RegisterIntegerTypeDecl - register integer type declaration
*
* HISTORY:
*	26-MAR-91 JBR	Created
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*	15-MAY-91 AWH	W0032: New protocol
*	04-JUN-91 JBR	W0019: Added call to RD_WriteIntegerType
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterIntegerTypeDecl(encl_region, 
	item_number, type_name, elab_pos, left_bound, direction, 
        right_bound)		/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* parent region or unit */
VK_tEnclItemNumber item_number;	/* which item in region */
VK_tName type_name;		/* simple name of type */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */
VK_tIntegerData left_bound;	/* left bound of integer range */
VK_tDirection direction;	/* direction of integer range */
VK_tIntegerData right_bound;	/* right bound of integer range */
{
    VK_tSymbInfoHandle symb_info;
    int trace_num;
/**/
    symb_info = CreateSymbInfoRecord_Decls(IntegerTypeDeclInfo, 
	encl_region, item_number,
        type_name, elab_pos, 0, NULL,
	NULL, 0,
        NULL, left_bound, NULL, 0.0, direction, right_bound, NULL, 0.0, 0,
	NULL, 0, 0, 0);

    RD_WriteIntegerType(type_name, left_bound, direction, right_bound,
	&trace_num);

    SetqqTraceNum(symb_info, trace_num);

    return symb_info;
} /* VK_RegisterIntegerTypeDecl */



/* *******************************************************************
*
* VK_RegisterPhysicalTypeDecl - register physical type declaration
*
* HISTORY:
*	02-APR-91 JBR	Created
*	15-MAY-91 AWH	New protocol
*	06-JUN-91 JBR	W0019: Added call to RD_WritePhysicalType
*	12-JUN-91 DSB	Added SIH_Std__Standard
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterPhysicalTypeDecl(encl_region, 
	item_number, type_name, elab_pos, left_bound, direction, right_bound,
	unit_count, units, position_values)
				/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* parent region or unit */
VK_tEnclItemNumber item_number;	/* which item in region */
VK_tName type_name;		/* simple name of type */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */
VK_tScalarData left_bound;	/* left bound of integer range */
VK_tDirection direction;	/* direction of integer range */
VK_tScalarData right_bound;	/* right bound of integer range */
VK_tArraySize unit_count;	/* number of physical units */
VK_tStringArrayAddr units;	/* physical units string table */
VK_tIntegerArray position_values;
				/* unit position values table */
{
    VK_tSymbInfoHandle symb_info;
    int trace_num;
/**/
    symb_info = CreateSymbInfoRecord_Decls(PhysicalTypeDeclInfo, 
	encl_region, item_number,
        type_name, elab_pos, 0, NULL,
	NULL, 0,
        NULL, left_bound, NULL, 0.0, direction, right_bound, NULL, 0.0, 
	unit_count, units, position_values, 0, 0);

    RD_WritePhysicalType(type_name, left_bound, direction, right_bound,
	unit_count, units, position_values, &trace_num);
    SetqqTraceNum(symb_info, trace_num);

    /* used in FormatScalarValue to control unit description */
    if (SIH_Std__Standard__Time == NULL) {
	if (encl_region == SIH_Std__Standard && 
					StringMatch(type_name, "TIME")) {
	    SIH_Std__Standard__Time = symb_info;
	}
    }

    return symb_info;
} /* VK_RegisterPhysicalTypeDecl */



/* *******************************************************************
*
* VK_RegisterLargePhysicalTypeDecl - register large physical type declaration
*
* HISTORY:
*	11-JUN-91 DSB	Created from VK_RegisterPhysicalTypeDecl
*	12-JUN-91 DSB	Added SIH_Std__Standard
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterLargePhysicalTypeDecl(encl_region, 
	item_number, type_name, elab_pos, left_bound, direction, right_bound,
	unit_count, units, position_values)
				/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* parent region or unit */
VK_tEnclItemNumber item_number;	/* which item in region */
VK_tName type_name;		/* simple name of type */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */
VK_tLargeAddr left_bound;	/* left bound of integer range */
VK_tDirection direction;	/* direction of integer range */
VK_tLargeAddr right_bound;	/* right bound of integer range */
VK_tArraySize unit_count;	/* number of physical units */
VK_tStringArrayAddr units;	/* physical units string table */
VK_tLargeArray position_values;
				/* unit position values table */
{
    VK_tSymbInfoHandle symb_info;
    int trace_num;
/**/
    symb_info = CreateSymbInfoRecord_Decls(LargePhysicalTypeDeclInfo, 
	encl_region, item_number,
        type_name, elab_pos, 0, NULL,
	NULL, 0,
        NULL, 0, left_bound, 0.0, direction, 0, right_bound, 0.0, 
	unit_count, units, position_values, 0, 0);

    RD_WriteLargePhysicalType(type_name, left_bound, direction, right_bound,
	unit_count, units, position_values, &trace_num);
    SetqqTraceNum(symb_info, trace_num);

    /* used in FormatScalarValue to control unit description */
    if (SIH_Std__Standard__Time == NULL) {
	if (encl_region == SIH_Std__Standard && 
					StringMatch(type_name, "TIME")) {
	    SIH_Std__Standard__Time = symb_info;
	}
    }

    return symb_info;
} /* VK_RegisterLargePhysicalTypeDecl */



/* *******************************************************************
*
* VK_RegisterFloatingTypeDecl - register floating type declaration
*
* HISTORY:
*	26-MAR-91 JBR	Created
*	03-APR-91 JBR	W0013: Added parameters to CreateSymbInfoRecord
*	15-MAY-91 AWH	W0032: New protocol
*	04-JUN-91 JBR	W0019: Added call to RD_WriteFloatingType
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterFloatingTypeDecl(encl_region, item_number, 
	type_name, elab_pos, left_bound, direction, right_bound)
				/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* parent region or unit */
VK_tEnclItemNumber item_number;	/* which item in region */
VK_tName type_name;		/* simple name of type */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */
VK_tFloatingData left_bound;	/* left bound of floating range */
VK_tDirection direction;	/* direction of floating range */
VK_tFloatingData right_bound;	/* right bound of floating range */
{
    VK_tSymbInfoHandle symb_info;
    int trace_num;
/**/
    symb_info = CreateSymbInfoRecord_Decls(FloatingTypeDeclInfo, 
	encl_region, item_number,
        type_name, elab_pos, 0, NULL,
	NULL, 0,
        NULL, 
	0, NULL, left_bound, direction, 0, NULL, right_bound, 
	0, NULL, 0, 0, 0);

    RD_WriteFloatingType(type_name, left_bound, direction, right_bound,
	&trace_num);

    SetqqTraceNum(symb_info, trace_num);

    return symb_info;
} /* VK_RegisterFloatingTypeDecl */



/* *******************************************************************
*
* VK_RegisterArrayTypeDecl - register array type declaration
*
* HISTORY:
*	02-APR-91 JBR	Created
*	15-MAY-91 AWH	New protocol
*	12-JUN-91 DSB	Added SIH_Std__Standard, SIH_Std__Standard__String
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterArrayTypeDecl(encl_region, 
	item_number, type_name, elab_pos, base_type, constraint_region, 
	constraint_offset, res_func_info, dimensions)
				/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* parent region or unit */
VK_tEnclItemNumber item_number;	/* which item in region */
VK_tName type_name;		/* simple name of type */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */
VK_tSymbInfoHandle base_type;	/* element base type */
VK_tSymbInfoHandle constraint_region;
				/* element constraint path indication */
VK_tFieldOffset constraint_offset; /* element constr. LAR field offset */
VK_tSymbInfoHandle res_func_info;
				/* resolution function lexical indent. */
VK_tInteger dimensions;		/* number of dimensions */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord_Decls(ArrayTypeDeclInfo, 
	encl_region, item_number,
        type_name, elab_pos, 0, base_type,
	constraint_region, constraint_offset,
        res_func_info, 0, NULL, 0.0, VK_BadDirection, 0, NULL, 0.0, 0,
	NULL, 0, dimensions, 0);

    if (SIH_Std__Standard__String == NULL) {
	if (encl_region == SIH_Std__Standard && 
					StringMatch(type_name, "STRING")) {
	    SIH_Std__Standard__String = symb_info;
	}
    }
    return symb_info;
} /* VK_RegisterArrayTypeDecl */



/* *******************************************************************
*
* VK_RegisterIndexSubtype - register index subtypeinformation
*
* HISTORY:
*	02-APR-91 JBR	Created
*	15-MAY-91 AWH	New protocol
*
******************************************************************* */
void VK_RegisterIndexSubtype(parent_type, dimension, base_type, 
	constraint_region, constraint_offset)
				/* returns handle to registered data */
VK_tSymbInfoHandle parent_type;	/* containing array type */
VK_tEnclItemNumber dimension;	/* which dimension's index subtype */
VK_tSymbInfoHandle base_type;	/* base type identification */
VK_tSymbInfoHandle constraint_region;
				/* range path indication */
VK_tFieldOffset constraint_offset;	/* range LAR field offset */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord(IndexSubtypeInfo, 
	parent_type, 0, NULL, "", 
	NULL, 
	0, 0.0, VK_BadDirection, 0, 0.0,
	0, NULL, NULL, 0,
	base_type, constraint_region, constraint_offset, NULL, 0);

} /* VK_RegisterIndexSubtype */


/* *******************************************************************
*
* VK_RegisterRecordTypeDecl - register record type declaration
*
* HISTORY:
*	18-APR-91 WAG	Created
*	15-MAY-91 AWH	New protocol
*	17-JUN-91 JBR	Corrected types of dummy parameters to
*			CreateSymbInfoRecord_Decls
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterRecordTypeDecl(encl_region,
	item_number, type_name, elab_pos, record_element_count)
				/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* enclosing region */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tName type_name;		/* type simple name */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */
VK_tEnclItemNumber record_element_count;
				/* number of record elements */
{
    VK_tSymbInfoHandle symb_info = (VK_tSymbInfoHandle) NULL;
/**/
    symb_info = CreateSymbInfoRecord_Decls(RecordTypeDeclInfo,
	encl_region, item_number, type_name, elab_pos, record_element_count,
	NULL, NULL, NULL, NULL,
	0, NULL, 0.0, VK_BadDirection, 0, NULL, 0.0,
	0, NULL, 0, 0, 0);
	
    return symb_info;
} /* VK_RegisterRecordTypeDecl */


/* *******************************************************************
*
* VK_RegisterRecordElementDecl - register record element declaration
*
* HISTORY:
*	18-APR-91 WAG	Created
*	15-MAY-91 AWH	New Protocol
*	17-JUN-91 JBR	Corrected types of dummy parameters to
*			CreateSymbInfoRecord_Decls
*
******************************************************************* */
void VK_RegisterRecordElementDecl(parent_type,
	record_element_number, element_name, base_type, constraint_region,
	constraint_offset, res_func_info)
				/* returns handle to registered data */
VK_tSymbInfoHandle parent_type;	/* containing record type */
VK_tEnclItemNumber record_element_number;
				/* which record element */
VK_tName element_name;		/* record element name */
VK_tSymbInfoHandle base_type;	/* element base type */
VK_tSymbInfoHandle constraint_region;
				/* constraint path indication */
VK_tFieldOffset constraint_offset;
				/* constraint LAR field offset */
VK_tSymbInfoHandle res_func_info;
				/* resolution function */
{
    VK_tSymbInfoHandle symb_info = (VK_tSymbInfoHandle) NULL;
/**/
    symb_info = CreateSymbInfoRecord_Decls(RecordElementDeclInfo,
	parent_type, record_element_number, element_name, NULL, NULL,
	base_type, constraint_region, constraint_offset, res_func_info,
	0, NULL, 0.0, VK_BadDirection, 0, NULL, 0.0,
	0, NULL, 0, 0, 0);

} /* VK_RegisterRecordElementDecl */


/* *******************************************************************
*
* VK_RegisterFileTypeDecl - register file type declaration
*
* HISTORY:
*	18-APR-91 WAG	Created
*	15-MAY-91 AWH	New protocol
*	06-JUN-91 DSB	Recognize type (STD.)TEXTIO.TEXT for text files
*	12-JUN-91 DSB	Added SIH_Std__Standard, SIH_Std__TextIO
*	17-JUN-91 JBR	Corrected types of dummy parameters to
*			CreateSymbInfoRecord_Decls
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterFileTypeDecl(encl_region, 
	item_number, type_name, elab_pos, base_type, constraint_region,
	constraint_offset)	/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* enclosing region */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tName type_name;		/* type simple name */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */
VK_tSymbInfoHandle base_type;	/* base type identification */
VK_tSymbInfoHandle constraint_region;
				/* constraint path indication */
VK_tFieldOffset constraint_offset;
				/* constraint LAR field offset */

{
    VK_tSymbInfoHandle symb_info = (VK_tSymbInfoHandle) NULL;
/**/
    symb_info = CreateSymbInfoRecord_Decls(FileTypeDeclInfo,
	encl_region, item_number, type_name, elab_pos, NULL,
	base_type, constraint_region, constraint_offset, NULL,
	0, NULL, 0.0, VK_BadDirection, 0, NULL, 0.0,
	0, NULL, 0, 0, 0);

    if (SIH_Std__TextIO__Text == NULL) {
	if (encl_region == SIH_Std__TextIO && StringMatch(type_name, "TEXT") 
		&& qqBaseTypeInfo(symb_info) == SIH_Std__Standard__String) {
	    SIH_Std__TextIO__Text = symb_info;
	}
    }
    return symb_info;
} /* VK_RegisterFileTypeDecl */


/* *******************************************************************
*
* VK_RegisterAccessTypeDecl - register access type declaration
*
* HISTORY:
*	18-APR-91 WAG	Created
*	15-MAY-91 AWH	New protocol
*	17-JUN-91 JBR	Corrected types of dummy parameters to
*			CreateSymbInfoRecord_Decls
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterAccessTypeDecl(encl_region, 
	item_number, type_name, elab_pos, base_type, constraint_region,
	constraint_offset)	/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* enclosing region */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tName type_name;		/* type simple name */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */
VK_tSymbInfoHandle base_type;	/* base type identification */
VK_tSymbInfoHandle constraint_region;
				/* constraint path indication */
VK_tFieldOffset constraint_offset;
				/* constraint LAR field offset */


{
    VK_tSymbInfoHandle symb_info = (VK_tSymbInfoHandle) NULL;
/**/
    symb_info = CreateSymbInfoRecord_Decls(AccessTypeDeclInfo,
	encl_region, item_number, type_name, elab_pos, NULL,
	base_type, constraint_region, constraint_offset, NULL,
	0, NULL, 0.0, VK_BadDirection, 0, NULL, 0.0,
	0, NULL, 0, 0, 0);

    return symb_info;
} /* VK_RegisterAccessTypeDecl */


/* *******************************************************************
*
* VK_RegisterSubtypeDecl - register subtype declaration
*
* HISTORY:
*	18-APR-91 WAG	Created
*	15-MAY-91 AWH 	New protocol
*	12-JUN-91 DSB	Still correcting incorrect null values
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterSubtypeDecl(encl_region, 
	item_number, constraint_name, elab_pos, base_type, constraint_region,
	constraint_offset, res_func_info)
				/* returns handle to registered data */
VK_tSymbInfoHandle encl_region;	/* enclosing region */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tName constraint_name;	/* subtype simple name */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */
VK_tSymbInfoHandle base_type;	/* base type identification */
VK_tSymbInfoHandle constraint_region;
				/* constraint path indication */
VK_tFieldOffset constraint_offset;
				/* constraint LAR field offset */
VK_tSymbInfoHandle res_func_info;
				/* resolution func. lexical ident. */
{
    VK_tSymbInfoHandle symb_info = (VK_tSymbInfoHandle) NULL;
/**/
    symb_info = CreateSymbInfoRecord_Decls(SubtypeDeclInfo,
	encl_region, item_number, constraint_name, elab_pos, NULL,
	base_type, constraint_region, constraint_offset, res_func_info,
	0, NULL, 0.0, VK_BadDirection, 0, NULL, 0.0, 
	0, NULL, NULL, 0, 0);
    return symb_info;
} /* VK_RegisterSubtypeDecl */



/* *******************************************************************
*
* VK_RegisterInterfaceSignalDecl - register interface signal
*
* HISTORY:
*	18-APR-91 WAG	W0027.  Created
*	15-MAY-91 AWH	W0032: New Protocol
*	03-JAN-92 MNP	Added is_unconstrained parameter
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterInterfaceSignalDecl(
	encl_region, item_number, signal_name, elab_pos, base_type, 
	constraint_region, constraint_offset, res_func_info, is_unconstrained,
	handle_offset, offset_offset, intf_mode, signal_kind)
VK_tSymbInfoHandle encl_region;	/* enclosing region identification */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tName signal_name;		/* signal simple name */

				/* debug information: */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */

				/* object type and subtype information: */
VK_tSymbInfoHandle base_type;	/* base type identification */
VK_tSymbInfoHandle constraint_region;
				/* constraint path indication */
VK_tFieldOffset constraint_offset;
				/* constraint field offset */
VK_tSymbInfoHandle res_func_info;
				/* resolution func. lexical ident. */

VK_tBoolean is_unconstrained;	/* whether declared as unconstrained */

				/* signal-specific information: */
				    /* object value information: */
VK_tFieldOffset handle_offset;	/* offset of signal handle field */
VK_tFieldOffset offset_offset;	/* offset of signal offset field */
				    /* other */
VK_tMode intf_mode;		/* interface mode */
VK_tSignalKind signal_kind;	/* signal kind */

{
    VK_tSymbInfoHandle symb_info = (VK_tSymbInfoHandle) NULL;
/**/
    symb_info = CreateSymbInfoRecord_Objects(InterfaceSignalDeclInfo,
	encl_region, item_number, signal_name, elab_pos, base_type,
	constraint_region, constraint_offset, res_func_info, NULL,
	handle_offset, offset_offset, intf_mode, VK_BadMode, signal_kind);

    AddqqIsUnconstrained(symb_info,is_unconstrained);

    return symb_info;
} /* VK_RegisterInterfaceSignalDecl */


/* *******************************************************************
*
* VK_RegisterLocalSignalDecl - register local signal declaration
*
* HISTORY:
*	18-APR-91 WAG	W0027.  Created
*	15-MAY-91 AWH	W0032: New protocol
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterLocalSignalDecl(
	encl_region, item_number, signal_name, elab_pos, base_type, 
	constraint_region, constraint_offset, res_func_info, handle_offset,
	offset_offset, signal_kind)
VK_tSymbInfoHandle encl_region;	/* enclosing region identification */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tName signal_name;		/* signal simple name */

				/* debug information: */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */

				/* object type and subtype information: */
VK_tSymbInfoHandle base_type;	/* base type identification */
VK_tSymbInfoHandle constraint_region;
				/* constraint path indication */
VK_tFieldOffset constraint_offset;
				/* constraint field offset */
VK_tSymbInfoHandle res_func_info;
				/* resolution func. lexical ident. */

				/* signal-specific information: */
				    /* object value information: */
VK_tFieldOffset handle_offset;	/* offset of signal handle field */
VK_tFieldOffset offset_offset;	/* offset of signal offset field */
				    /* other */
VK_tSignalKind signal_kind;	/* signal kind */

{
    VK_tSymbInfoHandle symb_info = (VK_tSymbInfoHandle) NULL;
/**/
    symb_info = CreateSymbInfoRecord_Objects(LocalSignalDeclInfo,
	encl_region, item_number, signal_name, elab_pos, base_type,
	constraint_region, constraint_offset, res_func_info, NULL,
	handle_offset, offset_offset, VK_InternalMode, VK_BadMode, 
	signal_kind);

    return symb_info;
} /* VK_RegisterLocalSignalDecl */


/* *******************************************************************
*
* VK_RegisterInterfaceConstantDecl - register interface constant declaration
*
* HISTORY:
*	18-APR-91 WAG	W0026.  Created
*	15-MAY-91 AWH	W0032: New protocol
*	03-JAN-92 MNP	Added is_unconstrained parameter
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterInterfaceConstantDecl(
	encl_region, item_number, constant_name, elab_pos, base_type, 
	constraint_region, constraint_offset, is_unconstrained, 
	value_offset, intf_mode)
VK_tSymbInfoHandle encl_region;	/* enclosing region identification */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tName constant_name;		/* constant simple name */

				/* debug information: */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */

				/* object type and subtype information: */
VK_tSymbInfoHandle base_type;	/* base type identification */
VK_tSymbInfoHandle constraint_region;
				/* constraint path indication */
VK_tFieldOffset constraint_offset;
				/* constraint field offset */
VK_tBoolean is_unconstrained;	/* whether declared as unconstrained */
VK_tFieldOffset value_offset;	/* IAR offset of value field */
VK_tMode intf_mode;		/* interface mode */

{
    VK_tSymbInfoHandle symb_info = (VK_tSymbInfoHandle) NULL;
/**/
    symb_info = CreateSymbInfoRecord_Objects(InterfaceConstantDeclInfo,
	encl_region, item_number, constant_name, elab_pos, base_type,
	constraint_region, constraint_offset, NULL, value_offset, NULL, NULL,
	intf_mode, VK_BadMode, VK_BadSignalKind);

    AddqqIsUnconstrained(symb_info,is_unconstrained);

    return symb_info;
} /* VK_RegisterInterfaceConstantDecl */


/* *******************************************************************
*
* VK_RegisterLocalConstantDecl - register local constant declaration
*
* HISTORY:
*	18-APR-91 WAG	W0026.  Created
*	15-MAY-91 AWH	W0032: New protocol
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterLocalConstantDecl(
	encl_region, item_number, constant_name, elab_pos, base_type, 
	constraint_region, constraint_offset, value_offset)
VK_tSymbInfoHandle encl_region;	/* enclosing region identification */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tName constant_name;		/* constant simple name */

				/* debug information: */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */

				/* object type and subtype information: */
VK_tSymbInfoHandle base_type;	/* base type identification */
VK_tSymbInfoHandle constraint_region;
				/* constraint path indication */
VK_tFieldOffset constraint_offset;
				/* constraint field offset */
VK_tFieldOffset value_offset;	/* IAR offset of value field */


{
    VK_tSymbInfoHandle symb_info = (VK_tSymbInfoHandle) NULL;
/**/
    symb_info = CreateSymbInfoRecord_Objects(LocalConstantDeclInfo,
	encl_region, item_number, constant_name, elab_pos, base_type,
	constraint_region, constraint_offset, NULL, value_offset, NULL, NULL,
	VK_BadMode, VK_BadMode, VK_BadSignalKind);

    return symb_info;
} /* VK_RegisterLocalConstantDecl */


/* *******************************************************************
*
* VK_RegisterInterfaceVariableDecl - register interface variable declaration
*
* HISTORY:
*	18-APR-91 WAG	W0026.  Created
*	15-MAY-91 AWH	W0032: New protocol
*	03-JAN-92 MNP	Added is_unconstrained parameter
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterInterfaceVariableDecl(
	encl_region, item_number, variable_name, elab_pos, base_type, 
	constraint_region, constraint_offset, is_unconstrained,
	value_offset, intf_mode)
VK_tSymbInfoHandle encl_region;	/* enclosing region identification */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tName variable_name;		/* variable simple name */

				/* debug information: */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */

				/* object type and subtype information: */
VK_tSymbInfoHandle base_type;	/* base type identification */
VK_tSymbInfoHandle constraint_region;
				/* constraint path indication */
VK_tFieldOffset constraint_offset;
				/* constraint field offset */
VK_tBoolean is_unconstrained;	/* whether declared as unconstrained */
VK_tFieldOffset value_offset;	/* IAR offset of value field */
VK_tMode intf_mode;		/* interface mode */
{
    VK_tSymbInfoHandle symb_info = (VK_tSymbInfoHandle) NULL;
/**/
    symb_info = CreateSymbInfoRecord_Objects(InterfaceVariableDeclInfo,
	encl_region, item_number, variable_name, elab_pos, base_type,
	constraint_region, constraint_offset, NULL, value_offset, NULL, NULL,
	intf_mode, VK_BadMode, VK_BadSignalKind);

    AddqqIsUnconstrained(symb_info,is_unconstrained);

    return symb_info;
} /* VK_RegisterInterfaceVariableDecl */


/* *******************************************************************
*
* VK_RegisterLocalVariableDecl - register local variable declaration
*
* HISTORY:
*	18-APR-91 WAG	W0026.  Created
*	15-MAY-91 AWH	W0032: New protocol
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterLocalVariableDecl(
	encl_region, item_number, variable_name, elab_pos, base_type, 
	constraint_region, constraint_offset, value_offset)
VK_tSymbInfoHandle encl_region;	/* enclosing region identification */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tName variable_name;		/* variable simple name */

				/* debug information: */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */

				/* object type and subtype information: */
VK_tSymbInfoHandle base_type;	/* base type identification */
VK_tSymbInfoHandle constraint_region;
				/* constraint path indication */
VK_tFieldOffset constraint_offset;
				/* constraint field offset */
VK_tFieldOffset value_offset;	/* IAR offset of value field */
{
    VK_tSymbInfoHandle symb_info = (VK_tSymbInfoHandle) NULL;
/**/
    symb_info = CreateSymbInfoRecord_Objects(LocalVariableDeclInfo,
	encl_region, item_number, variable_name, elab_pos, base_type,
	constraint_region, constraint_offset, NULL, value_offset, NULL, NULL,
	VK_BadMode, VK_BadMode, VK_BadSignalKind);

    return symb_info;
} /* VK_RegisterLocalVariableDecl */


/* *******************************************************************
*
* VK_RegisterLocalFileDecl - register local file declaration
*
* HISTORY:
*	18-APR-91 WAG	W0026.  Created
*	15-MAY-91 AWH	W0032: New protocol
*
******************************************************************* */
VK_tSymbInfoHandle VK_RegisterLocalFileDecl(
	encl_region, item_number, file_name, elab_pos, base_type, 
	constraint_region, constraint_offset, value_offset, file_mode)
VK_tSymbInfoHandle encl_region;	/* enclosing region identification */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tName file_name;		/* file simple name */

				/* debug information: */
VK_tExecPosIndex elab_pos;	/* declaration elaboration position */

				/* object type and subtype information: */
VK_tSymbInfoHandle base_type;	/* base type identification */
VK_tSymbInfoHandle constraint_region;
				/* constraint path indication */
VK_tFieldOffset constraint_offset;
				/* constraint field offset */
VK_tFieldOffset value_offset;	/* IAR offset of value field */
VK_tMode file_mode;		/* VHDL mode of file */

{
    VK_tSymbInfoHandle symb_info = (VK_tSymbInfoHandle) NULL;
/**/
    symb_info = CreateSymbInfoRecord_Objects(LocalFileDeclInfo,
	encl_region, item_number, file_name, elab_pos, base_type,
	constraint_region, constraint_offset, NULL, value_offset,
	NULL, NULL, VK_BadMode, file_mode, VK_BadSignalKind);

    return symb_info;
} /* VK_RegisterLocalFileDecl */


/*****************************************************************************
*
* VK_RegisterLoopStmt - register loop statement and label 
*
* DESCRIPTION:
*
* HISTORY:
*	18-NOV-91 MNP	Created
*	17-DEC-91 DKC	Filled in
*
*****************************************************************************/

VK_tSymbInfoHandle VK_RegisterLoopStmt(
	encl_loop_etc, item_number, label_name, loop_exec_pos,
	begin_pos, end_pos)
VK_tSymbInfoHandle encl_loop_etc; /* enclosing loop or major region */
VK_tEnclItemNumber item_number;	/* which item in enclosing region */
VK_tName label_name;		/* loop label simple name */
VK_tExecPosIndex loop_exec_pos;	/* loop statement execution position */
VK_tExecPosIndex begin_pos;	/* region begin position */
VK_tExecPosIndex end_pos;	/* positions of first and last */
				/*   statements enclosed by for loop */
{
    VK_tSymbInfoHandle symb_info;
/**/
    symb_info = CreateSymbInfoRecord_Regions(LoopStmtInfo, 
        NULL, encl_loop_etc, item_number, 
        label_name, loop_exec_pos, begin_pos, end_pos, 
 	0, 0, 0, NULL, 0, 0, CheckValue);

    return symb_info;
} /* VK_RegisterLoopStmt */


/*****************************************************************************
*
* VK_RegisterLoopParameter - register loop parameter effective declaration 
*
* DESCRIPTION:
*
* HISTORY:
*	18-NOV-91 MNP	Created
*	17-DEC-91 DKC	Filled in
*
*****************************************************************************/

VK_tSymbInfoHandle VK_RegisterLoopParameter(
	encl_loop, item_number, parameter_name, base_type,
	constraint_region, constraint_offset, value_offset)
VK_tSymbInfoHandle encl_loop;		/* enclosing for loop identification */
VK_tEnclItemNumber item_number;		/* which item in enclosing region */
VK_tName parameter_name;		/* loop parameter simple name */
VK_tSymbInfoHandle base_type;		/* base type identification */
VK_tSymbInfoHandle constraint_region;	/* constraint path indication */
VK_tFieldOffset constraint_offset;	/* constraint LAR field offset */
VK_tFieldOffset value_offset;		/* LAR offset of value field */
{

    VK_tSymbInfoHandle symb_info = (VK_tSymbInfoHandle) NULL;
/**/
    symb_info = CreateSymbInfoRecord_Objects(LoopParameterInfo,
	encl_loop, item_number, parameter_name, NULL, base_type,
	constraint_region, constraint_offset, NULL, value_offset, NULL, NULL,
	VK_BadMode, VK_BadMode, VK_BadSignalKind);

    return symb_info;
} /* VK_RegisterLoopParameter */


#if 0
/* *******************************************************************
*
* RtnName - <description of function or procedure>
*
* HISTORY:
*	??-FEB-91 DSB	Created
*
******************************************************************* */
<static> Fntype RtnName(parm)	/* return value desc. if not void */
tParmType parm;			/* mode: description */
{
    type local;				/* description */
    type local;				/* description */
/**/

} /* RtnName */


#endif


