#ifndef TKSignals_H
#define TKSignals_H
/* *******************************************************************
*
* Copyright (c) 1989-1990 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* HEADER FILE: TKSignals.h
*
* DESCRIPTION:  
*	Private interface file for TKSignals.c.
*
* CONSTANTS:
*	<constants>	<constants defined in this header file >
*
* TYPES:
*	<types>		<types defined in this header file >
*
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this header file >
*
* ROUTINES:
*   External:
*	...
*
* HISTORY:
*	04-OCT-89 DSB	Created
*	21-SEP-90 AWH	Change to Signal Handles and support Vector Signals
*	26-MAR-90 HK	Added routines GetElementTypeInfo and
*			GetIndexByElementNumber
*	25-APR-91 AWH	WOO21: Renamed to TK...
*	02-APR-91 DSB	Cleaning up generally
*	04-MAY-91 DSB	Changed to signal handle / signal offset protocol
*	21-MAY-91 DSB	Cleaned up old types; renamed to remove some VK_
*       29-OCT-91 DKC   Removed FIXEDDATASIZE and FixedDataOffset
*
* SCCS ID: @(#)TKSignals.h	42.1 1/10/92
*
******************************************************************* */

#include "VKSignals.h"
#include "TKStructs.h"		/* for tSignalElementHandle, etc. */

/* *******************************************************************
*
* ElementHandle - given scalar signal number return handle (MACRO)
*
******************************************************************* */

#define SignalElementHandle(NUMBER) SignalNumberTable[NUMBER]

/* *******************************************************************
*
* GetElementTypeInfo - get type information for a signal element
*
******************************************************************* */

VK_tSymbInfoHandle GetElementTypeInfo(
#ifdef ANSI_FN_PROTOS
	tSignalElementHandle element		/* signal element */
#endif
	);


/* *******************************************************************
*
* GetIndexByElementNumber - get index number for a given signal element
*		number if the signal element is part of a vector signal.
*
******************************************************************* */

VK_tScalarData GetIndexByElementNumber(
#ifdef ANSI_FN_PROTOS
	tSignalNumber element_number		/* signal element number */
#endif
	);


#endif /* TKSignals_H */



