static char SCCS_ID[] = "@(#)TKSim.c	42.3 1/13/92";
/* *******************************************************************
*
* Copyright (c) 1989-1990 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* CODE FILE: TKSim.c
*
* DESCRIPTION:  
*	<then describe contents>
*
* CONSTANTS:
*	<constants>	<constants defined in this header file >
*
* TYPES:
*	<types>		<types defined in this header file >
*
* GLOBAL VARIABLES:
*	<globals>	<global variables defined in this header file >
*
* ROUTINES:
*   External:
*	...
*
*   Internal:
*	...
*
* HISTORY:
*	04-OCT-89 DSB	Split from VKI.c
*	18-MAR-91 HK	Added references to TIME macros.
*	18-MAR-91 WAG	Removed the SortProcesses routine and calls to it.
*	03-APR-91 WAG	W0023. Renamed all _Eval_* routines to Evaluate*;
*			renamed	_Eval_Explicit to EvaluateExplicit.
*	03-APR-91 WAG	W0023. Cleaned up code per Daniel's comments.
*	25-APR-91 AWH	WOO21: Renamed to TK...
*	02-MAY-91 DSB	Cleaning up generally
*	04-MAY-91 DSB	Changed to signal handle / signal offset protocol
*	06-MAY-91 DSB	Cleaning up signal changes
*	14-MAY-91 DSB	W0053+: Split DelayedProcessList from UserProcessList;
*			renamed tLAR_*_{Rec,Ptr} to tProcData..., ARP to
*			proc_data, etc.; called VK_RunProcess vice qqExecFn;
*			made Evaluate* static (private to module)
*	16-MAY-91 DSB	Converting to unsigned absolute time
*	21-MAY-91 DSB	Cleaned up old types; renamed to remove some VK_
*	26-SEP-91 MNP	Converted PaceTime feature to take integer instead
*			of tAbsTimBuf.
*       29-OCT-91 DKC   Changes for large physical types.
*	14-NOV-91 DKC	Moved StartTraceFile from Simulate_Initialize  
*                       to SimulateModel
*
* SCCS ID: @(#)TKSim.c	42.3 1/13/92
*
******************************************************************* */
#include "SPI.h"
#include "TKCommon.h"
#include "TKSim.h"
#include "TKIO.h"		/* for ... */
#include "TKSignals.h"		/* for VK_tFnPtr */
#include "TKStructs.h"		/* for Lists, ... */
#include "TKDebug.h"		/* for DB */
#include "TKData.h"		/* for TIME macros */

#include "TKListFns.h"		/* for TempAddLast, etc. */
#include "TKGlobals.h"
#include "TKErrors.h"		/* for KE_<...> */
#include "TKTemp.h"		/* for VERIFY */
#include "TKRecord.h"		/* for RD_WriteStatus()... */

#include <stdio.h>		/* for NULL */
#include <assert.h>		/* for assert */

#include "VKCodeIntf.h" 	/* experimenting */

/* extern */ TempList EventTimeQueue;
				
/* extern */ tAbsTimeBuf       NeverTime;     /* initialized in InitSim */
/* extern */ tRelTimeBuf       EarlyTime;     /* initialized in InitSim */

/* extern */ VK_tProcessHandle CurrentProcess = NULL;

/* extern */ VK_tInteger       MaxSourceCount  = 0,
                               MaxResolvedData = 0;

#ifdef VCG_VLK
static tSimCycleCount MaxCycles = MaxInt4 - 1;	
#else
static tSimCycleCount MaxCycles = 10000;  /* to limit endless simulation */
#endif

static VK_tInteger  PaceTime;      /* initialized in InitSim */

static VK_tBoolean TrueVar = True;
static VK_tBoolean FalseVar = False;

static TempList    ActiveDriverList,
                   EvalProcessList,
                   ImplicitProcessList,
                   ActiveProcessList;

static tScalarUnionPtr DrivingValues = NULL;

void Simulate_Initialize();
void Simulate_TerminAte();

static tStaticStrBuf SimError = STATIC_STR_INITIAL;

void SetDriverActive(
#ifdef ANSI_FN_PROTOS
	tDriverElementHandle driver
#endif
	);
void SetSignalActive(
#ifdef ANSI_FN_PROTOS
	tSignalElementHandle signal
#endif
	);
void SetSignalEvent(
#ifdef ANSI_FN_PROTOS
	tSignalElementHandle signal
#endif
	);


/* *******************************************************************
*
* Execution functions for internal kernel processes maintaining signal values
*
******************************************************************* */


static void EvaluateExplicit(
#ifdef ANSI_FN_PROTOS
      VK_tProcessHandle    process
#endif
	);
static void EvaluateStable(
#ifdef ANSI_FN_PROTOS
      VK_tProcessHandle    process,
      VK_tBoolean          timed_out
#endif
	);
static void EvaluateQuiet(
#ifdef ANSI_FN_PROTOS
      VK_tProcessHandle    process,
      VK_tBoolean          timed_out
#endif
	);
static void EvaluateTransaction(
#ifdef ANSI_FN_PROTOS
      VK_tProcessHandle    process
#endif
	);
static void EvaluateDelayed(
#ifdef ANSI_FN_PROTOS
      VK_tProcessHandle    process
#endif
	);
static void EvaluateGuard(
#ifdef ANSI_FN_PROTOS
      VK_tProcessHandle    process
#endif
	);


/* *******************************************************************
*
* InitSim - 
*
* HISTORY:
*	14-MAR-91 HK	Created
*
******************************************************************* */

void InitSim()
{
/**/
    InitData();
    STIME_LOW(NeverTime);		/* signed or unsigned */
    STIME_LOW(EarlyTime);		/* unsigned */

    PaceTime = 0;			/* pacetime is inactive */

    EventTimeQueue      = TempNewList();
    ActiveDriverList    = TempNewList();
    EvalProcessList     = TempNewList();
    ImplicitProcessList = TempNewList();
    ActiveProcessList   = TempNewList();

} /* InitSim */



/* *******************************************************************
*
* SetPaceTime - 
*
* HISTORY:
*	25-JAN-91 AWH	Created
*	26-SEP-91 MNP	Converted from tAbsTimeBuf to VK_tInteger.
*
******************************************************************* */

void SetPaceTime(time)
VK_tInteger time;
{
/**/
    PaceTime = time;
} /* SetPaceTime */



/* *******************************************************************
*
* WaitToPaceTime - 
*
* HISTORY:
*	25-JAN-91 AWH	Created
*	26-SEP-91 MNP	Converted from tAbsTimeBuf to VK_tInteger.
*
******************************************************************* */

void WaitToPaceTime()
{
    unsigned int wait_us;
#define US_TO_10TH_SECOND 100000
/**/
    
    if (0 <= PaceTime) {
    	wait_us = PaceTime * US_TO_10TH_SECOND;
	usleep(wait_us);
    }
}


/* *******************************************************************
*
* QueueEvent - on time queue, note that event occurs at time
*
* HISTORY:
*	30-SEP-89 DSB	Created
*	10-JUN-91 DSB	Applied AllocateTimeBuffer, etc.
*	14-JUN-91 JBR	The parameter to AllocateTimeBuffer must be
*			tAbsTimePtr NOT tAbsTimeBuf.
*	12-JAN-92 DKC	Returns NULL if time is at/beyond time'high - i.e.
*                       no drivers or process will be activated then.
*
******************************************************************* */

TempItem QueueEvent(abs_time_addr,event_class,event_data)
tAbsTimePtr abs_time_addr;
tEventClass event_class;
void        *event_data;
{
    TempItem     scan,
                 scheduled;
    tEventHandle event;
/**/
    if (UTIME_LESSTHAN(MaxTime,*abs_time_addr)) {
        return (NULL);
    }

    event = (tEventHandle)AllocTempSpace(sizeof(tEventRec));

    SetqqTime      (event, *abs_time_addr);
    SetqqEventClass(event, event_class);
    SetqqData      (event, event_data);

    for (scan = TempLastItem(EventTimeQueue);;) {

	if (TempNullItem(scan)) {
	    scheduled = TempAddFirst(EventTimeQueue, event);
            break;
	}
	else {
	    if (UTIME_LESSTHAN(*abs_time_addr,
			       qqTime(EventValue(scan)))) {
		scan = TempPrevItem(scan);
	    }
	    else {
	    	scheduled = TempAddNext(scan, event);
                break;
	    }
	}
    }

    return (scheduled);

} /* QueueEvent */


/*****************************************************************************
*
* DequeueEvent - remove event
*
* DESCRIPTION:
*
* HISTORY:
*	02-JAN-92 DKC	Created
*
*****************************************************************************/

DequeueEvent(event)
TempItem event;
{
    TempNode old_event_data;
/**/
    TempRemoveItem(event,old_event_data);
    DeAllocTempSpace(old_event_data);

} /* DequeueEvent */


/* *******************************************************************
*
* ReadDriverActive - tell if driver is active now
*
* HISTORY:
*	02-OCT-89 DSB	Created from VK_ReadActiveOld
*
******************************************************************* */

VK_tBoolean ReadDriverActive(driver) 
tDriverElementHandle driver;
{
/**/
    return SimCycleCount == qqLastActiveCycle(driver);
} /* VK_ReadDriverActive */


/* *******************************************************************
*
* TriggerProcess - trigger a process to run during this simulation
*			 cycle due to a signal event.
*
* NOTE: qqSignalTriggerCycle triggers check of wait conditions; process
*	does not necessarily run
*
* HISTORY:
*	03-OCT-89 DSB	Created
* 	28-Sep-90 GJB	Renamed to TriggerProcess
*
******************************************************************* */

static void TriggerProcess(process)
VK_tProcessHandle process;
{
    tSignalElementHandle   element;
    tProcData_Implicit_Ptr proc_data;
/**/
    if (SimCycleCount != qqTriggerCycle(process)) {
        SetqqTriggerCycle(process, SimCycleCount);
        SetqqActivated   (process, FALSE);
        switch (qqProcessKind(process)) {
	    case pc_Delayed:
	    case pc_Explicit:
                TempAddFirst(EvalProcessList,process);
                break;
            case pc_Transaction:
            case pc_Quiet:
            case pc_Stable:
	    case pc_Guard:
                proc_data = (tProcData_Implicit_Ptr)qqProcessData(process);
                element   = SignalElementHandle(
                             qqSignalStart(qqImplicitSignalHandle(proc_data)));
                SetqqEvaluating(element,TRUE);
                TempAddLast(EvalProcessList,process);
                break;
            case pc_ProcessStatement:
                TempAddLast(ActiveProcessList,process);
                break;
	    default:
		ReportInternalError("Unexpected process kind in trigger list",
				    "", __FILE__, __LINE__);
		break;
	}
    }
} /* TriggerProcess */


/* *******************************************************************
*
* TriggerProcesses - trigger each process in a list
*
* HISTORY:
*	03-OCT-89 DSB	Created
* 	28-Sep-90 GJB	Renamed TriggerProcess to TriggerProcessSignal
*
******************************************************************* */

static void TriggerProcesses(process_list)
TempList process_list;
{
    TempItem scan;
/**/
    for (scan=TempFirstItem(process_list); ! TempNullItem(scan); 
		scan=TempNextItem(scan)) {
	TriggerProcess(ProcValue(scan));
    }
} /* TriggerProcesses */


/* *******************************************************************
*
* TriggerSensSets - triggers processes indicated by list of sensitivity sets
*
* HISTORY:
*	20-DEC-89 DSB	Created
* 	28-Sep-90 GJB	Rename TriggerProcess to TriggerProcessSignal
*
******************************************************************* */

static void TriggerSensSets(sens_set_list)
TempList sens_set_list;
{
    TempItem scan;
    VK_tSensitivitySetHandle sens_set;
/**/
    for (scan=TempFirstItem(sens_set_list); ! TempNullItem(scan); 
		scan=TempNextItem(scan)) {
	sens_set = SensValue(scan);
	if (qqEnabled(sens_set)) {
	    TriggerProcess(qqSensitiveProcess(sens_set));
					/* trigger process only if sensitivity
					   set is enabled */
	}
    }
} /* TriggerSensSets */


/* *******************************************************************
*
* SetSignalEvent - note event on scalar signal subelement
*
* HISTORY:
*	03-OCT-89 DSB	Created
*
******************************************************************* */

static void SetSignalEvent(element)
tSignalElementHandle element;
{
/**/
    SetqqLastEventTime(element, SimTime);
					/* update time of last event */
    SetqqLastEventCycle(element, SimCycleCount);
					/* update cycle of last event */
    TriggerProcesses(qqTriggerEvent(element));
					/* trigger processes directly sensi-
					   tive to events on this signal */
    TriggerSensSets(qqTriggerEventSets(element));
					/* triggers processes sensitive to
					   (enabled) sensitivity sets involving
					   this signal */

    TraceEvent(element, qqEffectiveValuePtr(element));		
                                       /* log event in trace file */
} /* SetSignalEvent */


/* *******************************************************************
*
* SetSignalActive - note activity on scalar signal subelement
*
* HISTORY:
*	03-OCT-89 DSB	Created
*
******************************************************************* */

static void SetSignalActive(element)
tSignalElementHandle element;
{
/**/
    SetqqLastActiveTime(element, SimTime);
					/* update time of last activity */
    SetqqLastActiveCycle(element, SimCycleCount);
					/* update cycle of last activity */
                                        /* also set in SetEvalSig        */
    TriggerProcesses(qqTriggerActive(element));
					/* trigger processes sensitive to
					   activity on this signal */

    TraceTransaction(element);		/* log activity in trace file */
} /* SetSignalActive */


/*****************************************************************************
*
* SetEvalSignal - called by SetDriverActive
*
* DESCRIPTION: Calls self recursively if elements are in a port map
*
* HISTORY:
*	26-NOV-91 DKC	Created
*
*****************************************************************************/

static void SetEvalSignal(signal_start,signal_length)
tSignalNumber    signal_start;
VK_tSignalLength signal_length;
{    
    VK_tSignalHandle     group;
    tSignalElementHandle element;
    tPortMap             port_map;
    tPortAssocHandle     port;
    int                  offset;
    VK_tSignalLength     data_length;
/**/
    while (signal_length > 0) {
        element   = SignalElementHandle(signal_start);
        if (!qqEvaluating(element)) {
            SetqqEvaluating     (element,TRUE);
            SetqqLastActiveCycle(element,SimCycleCount);
            group = qqGroup(element);
            if (qqMapped(element)) {
                port_map  = qqPortMap(qqRootSignal(group));
                offset    = qqNumber(element) - qqSignalStart(group);
                port      = port_map[offset];
                if (qqSimplePort(port)) {
                    SetqqLastActiveCycle(port,SimCycleCount);
                    SetEvalSignal(SignalOut(element,port), 1);
                } 
                else if (qqLastActiveCycle(port) != SimCycleCount) {
                    VERIFY_ERROR(NeverCycle == qqLastActiveCycle(port));
                    SetqqLastActiveCycle(port,SimCycleCount);
                    SetqqComputed       (port,FALSE);
                    SetqqActiveCount    (port,qqSignalUpLength(port));
                    SetEvalSignal       (qqSignalUpStart(port),
                                         qqSignalUpLength(port));
                }
            }
            else {
                TriggerProcess(qqEvalProcess(element));
					/* trigger (kernel) process for
					   root signal */
                if (!qqComplexNet(element)) {
                    SetqqActiveCount(group,qqActiveCount(group) 
                                           + qqDataLength(element));
                }
            }
        }
        else {
            VERIFY_ERROR(qqLastActiveCycle(element) == SimCycleCount);
        }
        data_length = qqDataLength(element);
        signal_length -= data_length;
        signal_start  += data_length;
    }
    
} /* SetEvalSignal */


/* *******************************************************************
*
* SetDriverActive - process activity on driver
*
* HISTORY:
*	03-OCT-89 DSB	Created
*
******************************************************************* */

static void SetDriverActive(driver)
tDriverElementHandle driver;
{
/**/
    TempAddLast(ActiveDriverList,(driver));

    SetqqLastActiveCycle(driver, SimCycleCount);

    SetEvalSignal (qqParentElement(driver), 1);

} /* SetDriverActive */


/*****************************************************************************
*
* GetPortValue - 
*
* DESCRIPTION:
*
* HISTORY:
*	 5-DEC-91 DKC	Created
*
*****************************************************************************/

int GetPortValue(element,port)
tSignalElementHandle element;
tPortAssocHandle     port;
{
    tSignalElementHandle child_el;
    int                  skipregister,
                         length,
                         index;
    VK_tDataAddr         current_value;
/**/
    if (qqSimplePort(port)) {
        child_el     = SignalElementHandle(SignalIn(element,port));
        skipregister = ComputeNetDrivingValue(child_el);
        SetqqSkipRegister(port,skipregister);
        if (!skipregister) {
            current_value  = qqCurrentValuePtr(port);
            current_value += qqNumber(element) - qqSignalUpStart(port);

            GetDrivingValue(child_el,current_value);
        }
    }
    else if (qqLastActiveCycle(port) == SimCycleCount && !qqComputed(port)) {
        /* need to re-evaluate */
        skipregister = TRUE;
        length       = qqSignalDownLength(port);
        for (index = 0; index < length ; index += qqDataLength(child_el)) {
            child_el = SignalElementHandle(qqSignalDownStart(port) +index);
            if (!ComputeNetDrivingValue(child_el)) {
                skipregister = FALSE;
            }
        }
        SetqqSkipRegister(port,skipregister);
        if (!skipregister) {
            ConvertSignalOut(port);
        }
        SetqqComputed(port,TRUE);
    }
    else {
        skipregister = qqSkipRegister(port);
    }

    return skipregister;

} /* GetPortValue */


/* *******************************************************************
*
* ComputeNetDrivingValue - compute driving value of a signal
*
* HISTORY:
*	04-OCT-89 DSB	Split out from _Eval_Explicit
*	12-APR-90 DSB	Added support for register signals
*	15-MAY-91 DSB	Converted to VC_ResolveSignal; from qqResCallerFn to
*			qqResEvalFn
*	16-MAY-91 DSB	Fixed new bugs: wrong sense of qqDriverNull; forgot
*			tc_Physical and tc_Enumeration
*	11-JUN-91 DSB	Recognize large physical type for resolution
*       29-OCT-91 DKC   Modified to handle large physical types
*	 6-DEC-91 DKC	Added Port Handling
*	08-JAN-92 DKC	Modified to handle composite resolution
*                       Value is computed directly into driving value buffer
*                       of element.
*                       Skip-register (no drivers active) is now the return.
*
******************************************************************* */

int ComputeNetDrivingValue(element)
tSignalElementHandle element;
{
    TempItem             srcscan;
    tDriverElementHandle source_d;
    tPortAssocHandle     source_p,
                         probe_d;
    tResolutionDataPtr   resolution_data;
    tSignalElementHandle port_el;
    int                  skipregister;
/**/
/* LRM 12.6.1p10:
    "For a scalar signal S, the driving value of S is determined as follows:"
*/

/* LRM 12.6.1p11:
    "If S has no source, then the driving value of S is given by the
	default value associated with S (see Section 4.3.1.2)." */

    if (qqGroupResolved(element)) {
        element = qqElements(qqGroup(element)); /* sources are attached
                                                   to first element only */
    }   

    if (TempIsEmpty(qqSourceList(element))) {
	GetDefaultValue(element,qqDrivingValuePtr(element));
        return FALSE;  
    }

/* LRM 12.6.1p12:
    "If S has one source that is a driver, and S is not a resolved signal (see
	Section 4.3.1.2), then the driving value of S is the value of that
	driver." */

    if (!qqResolved(element)) {  /* not resolved */

        source_d = NULL;
        source_p = NULL;
        
	for (srcscan=TempFirstItem(qqSourceList(element)); 
		    ! TempNullItem(srcscan); srcscan = TempNextItem(srcscan)) {

	    probe_d = PortAssocValue(srcscan);

	    if (qqRecordKind(probe_d) == DriverElementRecord) {
                VERIFY_ERROR(NULL == source_d);
                source_d = (tDriverElementHandle)probe_d;
	    }
	    else if (qqRecordKind(probe_d) == PortAssocRecord
                     && qqDrivingPorts(element)) {
                port_el = SignalElementHandle(SignalIn(element,probe_d));
                if (qqDriven(port_el)) {
                   VERIFY_ERROR(NULL == source_p);
                   source_p = probe_d;
	        }
	    }
	} /* for each source */

        if (NULL == source_d) {
	    if (NULL != source_p) {
                GetPortValue(element,source_p);
	    }
            else {
	        GetDefaultValue(element,qqDrivingValuePtr(element));  
            }
	}

        return FALSE;
    }

/* resolved signal */

/* Note: LRM 12.6.1p13 deals with ports formally; test kernel doesn't do that 
	yet */
/* LRM 12.6.1p14:
    "If S is a resolved signal, then the driving value of S is the same as the
	resolved value of S obtained by executing the resolution function 
	associated with S, where that function is called with an input
	parameter consisting of the concatenation of the driving values of
	the sources of S, with the exception of the value of any driver of S
	whose current value is determined by a null transaction (see Section 
	8.3.1)." */
/* Note: A register with zero active drivers is not updated. */

/* Note: The test kernel currently implements only scalar resolution. */

    resolution_data = qqResolutionData(qqGroup(element));

    if (qqGroupResolved(element)) {

        VK_tElementCount   active_count = 0;
        VK_tCompositeAddr  next_value;
        VK_tSignalLength   data_length;
        VK_tInteger        data_bytes;
        VK_tSignalHandle   group;

        group       = qqGroup(element);
        data_length = qqSignalLength(group);
        data_bytes  = BYTES(data_length);
        next_value  = (VK_tCompositeAddr)DrivingValues;

        if (qqDrivingPorts(element)) {
	    for (srcscan=TempFirstItem(qqSourceList(element)); 
		    ! TempNullItem(srcscan); srcscan = TempNextItem(srcscan)) {

	        source_p = PortAssocValue(srcscan);

	        if (qqRecordKind(source_p) == PortAssocRecord) {
                    source_p = (tPortAssocHandle)source_d;
                    if (qqPortDriven(source_p)) {
                        GetPortValue(element,source_p);
                    }
	        }
            } /* for each source */
        }

	for (srcscan=TempFirstItem(qqSourceList(element)); 
		    ! TempNullItem(srcscan); srcscan = TempNextItem(srcscan)) {

	    source_d = DrvElemValue(srcscan);	/* either driver or port */

            VERIFY_ERROR(active_count < MaxSourceCount);

	    if (qqRecordKind(source_d) == DriverElementRecord) {
		if (qqDriverNull(source_d)) {
					/* null driver (for guarded signal 
					   does not contribute to resolution 
					   function input vector */
		}
		else {
		    active_count++;	/* count active elements */
                    bcopy(qqCurrentValue(source_d),next_value,data_bytes);
					/* add driver current value to 
					   resolution function input vector */
                    next_value += data_length;
		}
	    }
	    else if (qqRecordKind(source_d) == PortAssocRecord) {
                source_p = (tPortAssocHandle)source_d;
                if (qqPortDriven(source_p) && !qqSkipRegister(source_p)) {
		    active_count++;	/* count active elements */
                    bcopy(qqCurrentValue(source_p),next_value,data_bytes);
                    next_value += data_length;
                }
	    }
	    else {
		/* shouldn't be anything else */
	    }
	} /* for each source */

	if (0 == active_count &&
            qqSignalKind(qqGroup(element)) == VK_RegisterKind) {	
                                        /* if register signal and no active 
					   drivers, then don't update */
	    skipregister = TRUE;	/* inform caller not to change signal
					   effective value; don't compute
					   resolved driving value */
            bcopy(qqEffectiveValuePtr(element),
                  qqDefaultValuePtr  (element),data_bytes);
	}
	else {				/* otherwise, resolve values */
            skipregister = FALSE;

	    VC_ResolveSignal(qqResEvalFn(resolution_data), 
		qqResolutionContext(resolution_data),
 	        (VK_tLARHeaderPtr)NULL, 	/* caller data */
                qqLeftBound(resolution_data),
                qqDirection(resolution_data),
		active_count,
		(VK_tCompositeAddr)DrivingValues, 
		qqGroupType(resolution_data),
		data_length,
		(VK_tDataAddr)qqDrivingValuePtr(element));
					/* resolve vectors of collected
					   driving values into buffer */
	}
    }
    else {
        VK_tElementCount   active_count = 0;
        VK_tCompositeAddr  next_value;
        VK_tSignalLength   data_length;
        VK_tDataAddr       port_value;

        data_length = qqDataLength(element);
        next_value  = (VK_tCompositeAddr)DrivingValues;

        if (qqDrivingPorts(element)) {
	    for (srcscan=TempFirstItem(qqSourceList(element)); 
		    ! TempNullItem(srcscan); srcscan = TempNextItem(srcscan)) {

	        source_p = PortAssocValue(srcscan);

	        if (qqRecordKind(source_p) == PortAssocRecord) {
                    port_el = SignalElementHandle(SignalIn(element,source_p));
                    if (qqDriven(port_el)) {
                        GetPortValue(element,source_p);
                    }
	        }
            } /* for each source */
        }

	for (srcscan=TempFirstItem(qqSourceList(element)); 
		    ! TempNullItem(srcscan); srcscan = TempNextItem(srcscan)) {

	    source_d = DrvElemValue(srcscan);	/* HOLE: only drivers now */

            VERIFY_ERROR(active_count < MaxSourceCount);

	    if (qqRecordKind(source_d) == DriverElementRecord) {
		if (qqDriverNull(source_d)) {
					/* null driver (for guarded signal 
					   does not contribute to resolution 
					   function input vector */
		}
		else {
		    active_count++;	/* count active elements */

                    GetCurrentValue(source_d,next_value);
					/* add driver current value to 
					   resolution function input vector */
                    next_value += data_length;
		}
	    }
	    else if (qqRecordKind(source_d) == PortAssocRecord) {
                source_p = (tPortAssocHandle)source_d;
                port_el  = SignalElementHandle(SignalIn(element,source_p));
                if (qqDriven(port_el)) {
		    active_count++;	/* count active elements */
                    port_value  = qqCurrentValue(source_p);
                    port_value += qqNumber(element) 
                                  - qqSignalUpStart(source_p);
                    COPY_ELEM_DATA(data_length,port_value,next_value)
                    next_value += data_length;
                }
	    }
	    else {
		/* shouldn't be anything else */
	    }
	} /* for each source */

	if (0 == active_count &&
            qqSignalKind(qqGroup(element)) == VK_RegisterKind) {
                                  	/* if register signal and no active 
					   drivers, then don't update */
	    skipregister = TRUE;	/* inform caller not to change signal
					   effective value; don't compute
					   resolved driving value */
            SetDrivingValue(element,qqEffectiveValuePtr(element))
	}
	else {				/* otherwise, resolve values */
            skipregister = FALSE;

	    VC_ResolveSignal(qqResEvalFn(resolution_data), 
		qqResolutionContext(resolution_data),
 	        (VK_tLARHeaderPtr)NULL, 	/* caller data */
                qqLeftBound(resolution_data),
                qqDirection(resolution_data),
		active_count,
		(VK_tCompositeAddr)DrivingValues, 
		qqGroupType(resolution_data),
		data_length, /* value_size */
		(VK_tDataAddr)qqDrivingValuePtr(element));
					/* resolve vectors of collected
					   driving values into buffer */
	}
    } 

    return (skipregister);

} /* ComputeNetDrivingValue */


/*****************************************************************************
*
* EvaluatingPrefix - of implicit
*
* DESCRIPTION:
*
* HISTORY:
*	03-JAN-92 DKC	Created
*
*****************************************************************************/

EvaluatingPrefix(implicit_data)
tPrefixDataHandle implicit_data;
{
    tSignalElementHandle element;
    VK_tSignalLength     prefix_length;
/**/
    element       = SignalElementHandle(qqPrefixSignalStart(implicit_data));
    prefix_length = qqPrefixSignalLength(implicit_data);

    while (0 < prefix_length) {
        if (qqEvaluating(element)) {
            return (TRUE);
        }
        element += qqDataLength(element);       
    }

    return (FALSE);
   
} /* EvaluatingPrefix */


/*****************************************************************************
*
* EvaluatingImplicit - is implicit being evealuated 
*
* DESCRIPTION:
*
* HISTORY:
*	02-JAN-92 DKC	Created
*
*****************************************************************************/

int EvaluatingImplicit(group)
VK_tSignalHandle group;
{
   tPrefixDataHandle  implicit_data;
/**/
   switch(qqSignalClass(group)) {

       sc_Delayed: 
           return Evaluating(qqElements(group)); /* if any are active all
                                                    will be */

       sc_Transaction:
           return EvaluatingPrefix(qqImplicitData(group));

       sc_Quiet:
       sc_Stable:
           return (qqEvaluating(qqElements(group)) ||
                   EvaluatingPrefix(qqImplicitData(group)));

       default:
           ReportKernelError("Unexpected Signal Class in EvaluatingImplicit",
                             "","", 0);
           break;
   }

   return FALSE; /* not reached */

} /* EvaluatingImplicit */


/*****************************************************************************
*
* EvaluatingGuard - is guard being evaluated
*
* DESCRIPTION:
*
* HISTORY:
*	02-JAN-92 DKC	Created
*
*****************************************************************************/

int EvaluatingGuard(group)
VK_tSignalHandle group;
{
/**/
    ReportKernelError("Impl. Limitation: EvaluatingGuard (NIY)","","", 0);
} /* EvaluatingGuard */


/*****************************************************************************
*
* Evaluating - finds out if element is still to be evaluated
*
* DESCRIPTION:
*
* HISTORY:
*	26-DEC-91 DKC	Created
*
*****************************************************************************/

int Evaluating(element)
tSignalElementHandle element;
{
    tSignalElementHandle assoc_el,
                         outer_el;
    VK_tSignalHandle     group;
    int                  evaluating = FALSE;
    VK_tSignalLength     length,
                         data_length,
                         port_length,
                         port_elmnt_lngth;
    tPortAssocHandle     port,
                         last_port = NULL;
/**/
    if (qqEvaluating(element)) {
        return (TRUE);
    }

    group = qqGroup(element);

    if (qqGroupResolved(element)) {
        assoc_el = SignalElementHandle(qqSignalStart(group));
        length   = qqSignalLength(group);
    }
    else {
        assoc_el = element;
        length   = 1;
    }

    group = qqRootSignal(group);

    for (;;) {
        if (qqEvaluating(assoc_el)) {
            evaluating = TRUE;
            break;
        }
        else if (qqMapped(assoc_el)) {
            port = qqPortMap(group)[qqNumber(assoc_el)
                                        - qqSignalStart(group)];
            if (qqSimplePort(port)) {
                outer_el = SignalElementHandle(SignalOut(assoc_el,port));
                if (Evaluating(outer_el)) {
                    evaluating = TRUE;
                    break;
                }
            }
            else if (port != last_port) {
                last_port   = port;
                outer_el    = SignalElementHandle(qqSignalUpStart(port));
                port_length = qqSignalUpLength(port);
                while (0 < port_length) {
                    if (Evaluating(outer_el)) {
                        evaluating = TRUE;
                        break;
                    }
                    port_elmnt_lngth = qqDataLength(outer_el);
                    port_length     -= port_elmnt_lngth;
                    outer_el        += port_elmnt_lngth;
                }
            }
        }
        else if (qqIsImplicit(assoc_el)) {
            evaluating = EvaluatingImplicit(group);
        }
        else if (qqIsGuard(assoc_el)) {
            evaluating = EvaluatingGuard(group);
        }

        if (evaluating) break;

        data_length = qqDataLength(assoc_el);
        length     -= data_length;

        if (0 >= length) break;

            assoc_el += data_length;
    }

    if (evaluating) {
       SetqqEvaluating(element,evaluating);
       return (TRUE);
    }

    return (FALSE);

} /* Evaluating */


/* *******************************************************************
*
* SetNetEffectiveValue - set effective value(s) of network of signals
*
* HISTORY:
*	04-OCT-89 DSB	Split out from _Eval_Explicit
*	07-MAY-90 DSB	Fixed 'Last_Value bug
*
******************************************************************* */

void SetNetEffectiveValue(element)
tSignalElementHandle element;
{
    TempItem             srcscan;
    tDriverElementHandle source_d;
    VK_tBoolean          changed;
    tPortAssocHandle     drive_child;
    tSignalElementHandle child_el,
                         port_el;
    int                  index,
                         length,
                         active;
    tScalarUnionPtr      driving; 
/**/
    driving = qqDrivingValuePtr(element);

    if (0 == SimCycleCount) { /* initialising */
        SetEffectiveValue(element,driving);
        SetPreviousValue (element,driving);
    }

    VERIFY_ERROR(qqLastEventCycle(element) != SimCycleCount);

    changed = (driving->t_int != qqEffectiveValuePtr(element)->t_int);

    if (!changed && 1 < qqDataLength(element)) {
        VERIFY_ERROR(2 == qqDataLength(element));
        changed = driving->t_array[1] 
                  != qqEffectiveValuePtr(element)->t_array[1];
    }

    if (changed) {  /* detect event on signal */
 	SetPreviousValue (element, qqEffectiveValuePtr(element));
        SetEffectiveValue(element, driving);     
	SetSignalEvent   (element);
    }

    SetqqEvaluating(element,FALSE);

    if (NULL == qqSourceList(element)) {
        return;
    }

    for (srcscan=TempFirstItem(qqSourceList(element)); 
	    ! TempNullItem(srcscan); srcscan = TempNextItem(srcscan)) {
	drive_child = PortAssocValue(srcscan);  /* ?? NOT QUITE ?? */
	if (PortAssocRecord == qqRecordKind(drive_child)) {
            if (qqSimplePort(drive_child)) {
                child_el = SignalElementHandle(SignalIn(element,drive_child));
                SetDrivingValue     (child_el,qqEffectiveValuePtr(element));
                SetNetEffectiveValue(child_el);
            }
            else {
                active = qqActiveCount(drive_child);

                if (0 < active) {
                    VERIFY_ERROR(qqLastActiveCycle(drive_child) 
                                       == SimCycleCount);
                    active -= qqDataLength(element);
	        } 
                else {
                    VERIFY_ERROR(qqLastActiveCycle(drive_child) 
                                       != SimCycleCount);

                    SetqqLastActiveCycle(drive_child,SimCycleCount);

                    length  = qqSignalUpLength(drive_child);
                    for (index = 0; index < length ;
                                    index += qqDataLength(port_el)) {

                        port_el = SignalElementHandle(
                                     qqSignalUpStart(drive_child) + index);

                        if (port_el != element && Evaluating(port_el)) {
                            active += qqDataLength(port_el);
                        }
                    }
	        }

                SetqqActiveCount(drive_child,active);
               
                if (0 == active) {
                    VERIFY_SET(SetqqLastActiveCycle(drive_child,NeverCycle));
                    ConvertSignalIn(drive_child);
                    length = qqSignalDownLength(drive_child);
                    for (index = 0; index < length ;
                                    index += qqDataLength(child_el)) {
                        child_el = SignalElementHandle(
                                     qqSignalDownStart(drive_child) + index);
                        SetNetEffectiveValue(child_el);
                    }
	        }
            }
        }
	else {
	    /* ignored for now */
	}
    } /* for each source */
} /* SetNetEffectiveValue */


/*****************************************************************************
*
* SetNetEffectiveValues - calls SetNetEffectiveValue for members of group
*
* DESCRIPTION:
*
* HISTORY:
*	27-DEC-91 DKC	Created
*
*****************************************************************************/

void SetNetEffectiveValues(group)
VK_tSignalHandle group;
{
    tSignalElementHandle element;
    VK_tSignalLength     length;
    VK_tDataLength       data_length;
/**/
    element = qqElements(group);
    for (length = qqSignalLength(group); 0 < length;) {
        SetNetEffectiveValue(element);
        data_length = qqDataLength(element);
        length  -= data_length;
        element += data_length;
    }
} /* SetNetEffectiveValues */


/* *******************************************************************
*
* RunProcess - run process for process statement
*
* NOTE: This is a separate function to make it easier to set breakpoints
*	for RVCG debugging.
*
* HISTORY:
*	14-MAY-91 DSB	Created
*
******************************************************************* */

static void RunProcess(proc_data)
VK_tPCBP proc_data;
{
/**/
#if ! VK_DEBUG_RP /* disable for debugging */
    VC_RunProcess(proc_data);		/* run process using VKI macro */
#else
    VC_RunProcess_Function(proc_data);	/* run process using VKI-defined 
					   function (for easier debugging) */

    /* VC_RunProcess_Function is declared, but commented out, in both:
       RTL - VLCodeIntfP.h: "VKI contains interface definition" 
       VKI - VKCodeIntf.h: "use real function version in RTL"  
       Someone please fix this ?? MNP 91 0917 */

#endif
} /* RunProcess */


/* *******************************************************************
*
* EvaluateExplicit - kernel process evaluation function for explicit signals
*
* HISTORY:
*	03-OCT-89 DSB	Created
*       29-OCT-91 DKC   Fixed for large physical types and tidied.
*
******************************************************************* */

static void EvaluateExplicit(process)
VK_tProcessHandle process;
{
    tSignalElementHandle   element;
    VK_tSignalHandle       group;
    VK_tInteger            active;
/**/
/* LRM 12.6.1p17:
	"If S is a signal declared by a signal declaration or ..., then the
	effective value of S is the same as the driving value of S."
   This is the only case we handle accurately now.
*/
/* LRM 12.6.1p26:
	"For any signal other than one declared with the signal kind register,
	the driving and effective values of the signal are determined and the
	current value of that signal is updated as descrived above in every
	simulation cycle.  A signal declared with the signal kind register is
	updated in the same fashion during every simulation cycle except those
	in which all of its sources have current values that are determined by
	null transactions."
*/
    element = SignalElementHandle((tSignalNumber)qqProcessData(process));
    group   = qqGroup(element);
    active  = qqActiveCount(group) - qqDataLength(element);

    VERIFY_ERROR(0 <= qqActiveCount(group))

    SetqqActiveCount(group,active);

    SetSignalActive(element);

    if (qqGroupResolved(element)) {
        if (0 == active) {
            ComputeNetDrivingValue(element); 
            SetNetEffectiveValues (group);
        }
    }
    else {
        ComputeNetDrivingValue(element); 
        /*CHECK W.R.T. LRM */
        SetNetEffectiveValue(element);
    }
} /* EvaluateExplicit */


/* *******************************************************************
*
* EvaluateGuard - kernel process evaluation function for implicit guard signals
*
* HISTORY:
*	03-OCT-89 DSB	Created
*
******************************************************************* */

static void EvaluateGuard(process)
VK_tProcessHandle process;
{
    tSignalElementHandle guard;
    tProcData_Guard_Ptr  proc_data;
/**/
    proc_data = (tProcData_Guard_Ptr)qqProcessData(process);
    guard     = SignalElementHandle(
                       qqSignalStart(qqImplicitSignalHandle(proc_data)));
    qqDrivingValuePtr(guard)->t_int = 
	(*proc_data->evaluation_function)(proc_data->evaluation_context);
					/* call guard evaluation function with
					   its context data (both are 
					   registered from the generated code)
					 */
    SetSignalActive(guard);
    SetNetEffectiveValue(guard);

} /* EvaluateGuard */


/* *******************************************************************
*
* EvaluateStable - kernel process evaluation function for all S'Stable(T)
*
* HISTORY:
*	02-OCT-89 DSB	Created
*	 6-DEC-91 DKC	Changed to use new PrefixData structure
*
******************************************************************* */

static void EvaluateStable(process,timed_out)
VK_tProcessHandle process;
VK_tBoolean       timed_out;
{
    tSignalElementHandle   element;
    VK_tBoolean            has_event;
    VK_tSignalHandle       stable_signal,
                           prefix_handle;
    VK_tSignalOffset       prefix_offset;
    tPrefixDataHandle      imp_data;
    tProcData_Implicit_Ptr proc_data;
    tAbsTimeBuf            stable_time;
/**/
/* LRM 12.6.2p?
	For any implicit signal S'Stable(T), the current value of the signal
	(and likewise the current state of the corresponding driver) is 
	modified if and only if one of the following statements is true:
	
	o	An event has occurred on S in this simulation cycle.
	o	The driver of S'Stable(T) is active.

	If an event has occurred on signal S, then S'Stable(T) is updated by
	assigning the value FALSE to the variable representing the current 
	value of S'Stable(T), and the driver of S'Stable(T) is assigned the
	waveform TRUE after T.  Otherwise, if the driver of S'Stable(T) is 
	active, then S'Stable(T) is updated by assigning the current value of
	the driver to the variable representing the current value of 
	S'Stable(T).  Otherwise, neither the variable nor the driver is
	modified.

*/
    proc_data      = (tProcData_Implicit_Ptr)qqProcessData(process);
    stable_signal  = qqImplicitSignalHandle(proc_data);
    imp_data       = qqImplicitData(stable_signal);
    element        = SignalElementHandle(qqSignalStart(stable_signal));
    prefix_handle  = PrefixSignalHandle(imp_data);
    prefix_offset  = qqPrefixSignalStart(imp_data) 
                         - qqSignalStart(prefix_handle);

    VK_ReadEvent(&has_event, prefix_handle, 
	                     prefix_offset, qqPrefixSignalLength(imp_data));
    if (has_event) {

        if (NULL != qqScheduled(process)) {
            DequeueEvent(qqScheduled(process));
        }

        UTIME_ADD(stable_time, qqTime(imp_data), SimTime);
        SetqqScheduled(process,
                       QueueEvent(&stable_time, ev_EvalImplicit, process));

        qqDrivingValuePtr(element)->t_int = FALSE;
	SetSignalActive(element);
	SetNetEffectiveValue(element);
    }
    else {
        VERIFY_ERROR(timed_out);

        qqDrivingValuePtr(element)->t_int = TRUE;
	SetSignalActive(element);
        SetNetEffectiveValue(element);
    }

} /* EvaluateStable */


/* *******************************************************************
*
* EvaluateQuiet - kernel process evaluation function for all S'Quiet(T)
*
* HISTORY:
*	03-OCT-89 DSB	Created
*	 6-DEC-91 DKC	Changed to handle new PrefixData structure
*
******************************************************************* */

static void EvaluateQuiet(process,timed_out)
VK_tProcessHandle process;
VK_tBoolean       timed_out;
{
    tSignalElementHandle   element;
    VK_tBoolean            is_active;
    VK_tSignalHandle       quiet_signal,
                           prefix_handle;
    VK_tSignalOffset       prefix_offset;
    tPrefixDataHandle      imp_data;
    tProcData_Implicit_Ptr proc_data;
    tAbsTimeBuf            quiet_time;
/**/
    proc_data     = (tProcData_Implicit_Ptr)qqProcessData(process);
    quiet_signal  = qqImplicitSignalHandle(proc_data);
    imp_data      = qqImplicitData(quiet_signal);
    element       = SignalElementHandle(qqSignalStart(quiet_signal));
    prefix_handle = PrefixSignalHandle(imp_data);
    prefix_offset = qqPrefixSignalStart(imp_data) 
                        - qqSignalStart(prefix_handle);

/* the ReadActive checks can be eliminated when EvaluateQuiet is called only
	when triggered appropriately */

    VK_ReadActive(&is_active, prefix_handle,
		              prefix_offset, qqPrefixSignalLength(imp_data));
    if (is_active) {

        if (NULL != qqScheduled(process)) {
            DequeueEvent(qqScheduled(process));
        }

        UTIME_ADD(quiet_time, qqTime(imp_data), SimTime);
        SetqqScheduled(process,
                       QueueEvent(&quiet_time, ev_EvalImplicit, process));

        qqDrivingValuePtr(element)->t_int = FALSE;
	SetSignalActive(element);
	SetNetEffectiveValue(element);
    }
    else {
        VERIFY_ERROR(timed_out);

        qqDrivingValuePtr(element)->t_int = TRUE;
	SetSignalActive(element);
	SetNetEffectiveValue(element);
    }

} /* EvaluateQuiet */


/* *******************************************************************
*
* EvaluateTransaction - kernel process evaluation function for all 
*                       S'Transaction(T)
*
* HISTORY:
*	13-OCT-89 DSB	Created from EvaluateQuiet
*	 6-DEC-91 DKC	Changed to handle new PrefixData structure
*
******************************************************************* */

static void EvaluateTransaction(process)
VK_tProcessHandle process;
{
    VK_tIntegerData        temp;
    tSignalElementHandle   element;
    VK_tBoolean            is_active;
    VK_tSignalHandle       transaction_signal,
                           prefix_handle;
    VK_tSignalOffset       prefix_offset;
    tPrefixDataHandle      imp_data;
    tProcData_Implicit_Ptr proc_data;
/**/
    proc_data          = (tProcData_Implicit_Ptr)qqProcessData(process);
    transaction_signal = qqImplicitSignalHandle(proc_data);
    imp_data           = qqImplicitData(transaction_signal);
    prefix_handle      = PrefixSignalHandle(imp_data);
    prefix_offset      = qqPrefixSignalStart(imp_data)
                         - qqSignalStart(prefix_handle);

    VK_ReadActive(&is_active, prefix_handle,
		              prefix_offset, qqPrefixSignalLength(imp_data));
    if (is_active) {
        element = SignalElementHandle(qqSignalStart(transaction_signal));
	SetSignalActive(element);
        GetEffectiveValue(element,&temp);

	temp = !temp;		/* alternates between True and False */

        qqDrivingValuePtr(element)->t_int = temp;
	SetNetEffectiveValue(element);
    }
    else {
	/* do nothing (should not even be triggered) */
    }
} /* EvaluateTransaction */


/* *******************************************************************
*
* EvaluateDelayed - kernel process evaluation function for all S'Delayed(T)
*
* NOTE:  For scalar subelement only
*
* HISTORY:
*	13-OCT-89 DSB	Created from EvaluateQuiet
*	 6-DEC-91 DKC	Changed to handle new PrefixData structure
*                       Removed unnecessary prefix check
*
******************************************************************* */

static void EvaluateDelayed(process)
VK_tProcessHandle process;
{
    tSignalElementHandle  prefix_element;
    VK_tBoolean           has_event;
    VK_tSignalHandle      delayed_signal,
                          prefix_handle;
    VK_tSignalOffset      prefix_offset;
    tScalarUnion          value;
    tPrefixDataHandle     imp_data;
    tProcData_Delayed_Ptr proc_data;
/**/
    proc_data      = (tProcData_Delayed_Ptr)qqProcessData(process);
    delayed_signal = qqImplicitSignalHandle(proc_data);
    imp_data       = qqImplicitData(delayed_signal);
    prefix_handle  = PrefixSignalHandle(imp_data);
    prefix_offset  = qqPrefixSignalStart(imp_data) 
                         - qqSignalStart(prefix_handle);

/*  LRM 14.1: This process is activated at time 0 and on events of the prefix
    element. */

    prefix_offset += qqImplicitSignalOffset(proc_data);
    GetElementHandle (prefix_element,prefix_handle,prefix_offset,1);
    VK_AssignWaveform(proc_data->delayed_driver, 
		      proc_data->delayed_driver_offset, 1, 
		      delayed_signal, 
		      qqImplicitSignalOffset(proc_data), CurrentProcess, 
		      VK_TransportDelay,1,
                      (VK_tCompositeAddr)
                           qqEffectiveValuePtr(prefix_element), 
                      &imp_data->fTime, NULL, NULL);

} /* EvaluateDelayed */


/*****************************************************************************
*
* TidyElementNet - Removes Copy-Up functions from association records
*                  for undriven sections of net - so ComputeNetDrivingValue
*                  can go down the driven branch.
*
* DESCRIPTION:     Performs recursive descent of net returning TRUE if net is
*                  driven.
*
* HISTORY:
*	26-NOV-91 DKC	Created
*	16-DEC-91 DKC	Added checks for conversion functions
*                 ***   - require checks for resolved types above driving
*                         down (requires port to have inward conversion)
*
*****************************************************************************/

static int TidyElementNet(element,complex)
tSignalElementHandle element;
int                  complex; /* resolved as group or port converted */
{
    TempItem             srcscan;
    tPortAssocHandle     source_d;
    int                  driven = 0,
                         driven_below;
    VK_tSignalLength     data_length;
    tSignalNumber        signal_start;
    int                  index;
    tSignalElementHandle child_el;
/**/
    if (qqTidied(element)) {
       return (qqDriven(element));
    }

    AddqqComplexNet(element,complex);

    complex |= qqResolved(element);

    if (NULL != qqSourceList(element)) {
        srcscan = TempFirstItem(qqSourceList(element));
    }
    else {
        srcscan = NULL;
    }

    for (; !TempNullItem(srcscan); srcscan = TempNextItem(srcscan)) {

	source_d = PortAssocValue(srcscan);

	if (qqRecordKind(source_d) == DriverElementRecord) {
            driven++;
        }
	else if (qqRecordKind(source_d) == PortAssocRecord) {
            if (qqSimplePort(source_d)) {
                child_el = SignalElementHandle(SignalIn(element,source_d));
                if (TidyElementNet(child_el,complex)) {
                    driven++;
                    SetqqPortDriven  (source_d,TRUE);
                    SetqqDrivingPorts(element, TRUE);
                }
            }
            else if (qqTidied(source_d)) { 
                if (qqPortDriven(source_d)) {
                    driven++;
                    SetqqDrivingPorts(element, TRUE);
                }
            }
            else {
                SetqqTidied(source_d,TRUE);
                driven_below = FALSE;
                signal_start = qqSignalDownStart(source_d);
                for (index = 0;
                     index < qqSignalDownLength(source_d); 
                     index += data_length) {

                     child_el      = SignalElementHandle(signal_start + index);
                     driven_below |= TidyElementNet(child_el,TRUE);
                     data_length   = qqDataLength(child_el);
	        }
                if (driven_below) {
                    driven++;
                    SetqqPortDriven  (source_d,TRUE);
                    SetqqDrivingPorts(element, TRUE);
                    if (!qqConvOutData(source_d)) {
                        ReportKernelError(
                            "Driving Port requires an outward conversion function",
                            FormatSignalPortionName(&SimError,
                                                  qqSignalDownStart(source_d),
                                                  qqSignalDownLength(source_d),
                                                  TRUE,TRUE),
                              "", 0);
                    }
                }
                else {
                    if (!qqConvInData(source_d)) {
                        ReportKernelError(
                            "Non-Driving Port requires an inward conversion function",
                            FormatSignalPortionName(&SimError,
                                                  qqSignalDownStart(source_d),
                                                  qqSignalDownLength(source_d),
                                                  TRUE,TRUE),
                                "", 0);
                    }
                }
	    }
        }
    } /* for each source */

    /* should remove extraneous type conversions and collapse net here */

    AddqqTidied(element,TRUE);

    if (0 < driven) {
        if (1 < driven && !qqResolved(element)) {
	    ReportKernelError("multiple sources for non-resolved signal", 
                              FormatSignalPortionName(&SimError,
                                                      qqNumber(element),
                                                      0,TRUE,TRUE),
		              "", 0);
        }

        AddqqDriven(element,TRUE);
    }
    
    return (driven ? TRUE : FALSE);

} /* TidyElementNet */


/* *******************************************************************
*
* Simulate_Initialize - initialize simulation, including VHDL initialization
*
* HISTORY:
*	02-OCT-89 DSB	Split from Simulate
*	12-APR-90 DSB	Replaced duplicated code the ComputeNetDrivingValue
*	15-JUN-90 DSB	Added process debug biy
*	18-MAR-91 WAG	Removed the call to the SortProcesses routine. Only
*			initialize processes on UserProcessList.
*	14-MAY-91 DSB	W0053+: split out DelayedProcessList; call 
*			VC_RunProcess; etc.
*	21-MAY-91 DSB	Added cast on qqProcessData
*       29-OCT-91 DKC   Modified for large physical types.
*	 9-DEC-91 DKC	Changed explicit signal evaluation for ports
*
******************************************************************* */

void Simulate_Initialize()
{
    TempItem             proc_scan;
    tSignalNumber        index;
    tSignalElementHandle element;
    VK_tProcessHandle    process;
    tScalarUnionPtr      driving;
    tScalarUnion         effective;
    tTempBuf80           sim_time_buf;
    tTempBuf256          buffer;
    tPortMap             port_map;
    VK_tSignalHandle     group;
    VK_tInteger          active;
/**/

    EarlyTerminate(FALSE); /* check global flags */

/* LRM 12.6.3: The Simulation Cycle, initialization part */

/* LRM 12.6.1 p2: 
	"This initialization phase consists of the following steps:" */

    TIME_ZERO(SimTime);

/* ?? Trace BEGINNING of time = zero */

    SimCycleCount = 0;
    EventCount = 0;
    DeltaCount = 0;
    TotalAssertionCount = 0;
    LocalAssertionCount = 0;
    TotalErrorCount = 0;
    LocalErrorCount = 0;

        /* initialization is SimTime 0, Delta 0 */

    if (GF.verbose) {
    	UTIME_FORMAT(sim_time_buf, SimTime);
    	sprintf(buffer, "cycle =%4d; time =%7s %s + %2d delta; events = %4d",
	    SimCycleCount, sim_time_buf, BaseUnit, DeltaCount, EventCount);
        SetErrorStatus(KE_Cycle, buffer);
    }

	/* : Initialize */

    /* allocate buffer for resolving signals */
    AllocateBlock(DrivingValues,tScalarUnion,BYTES(MaxResolvedData));

    /* for each signal */
    index = 1;
    while (index <= ScalarSignalCount) {
    	tProcData_Guard_Ptr proc_data_guard;

	element = SignalElementHandle(index);

        if (!TidyElementNet(element,FALSE) && !qqResolved(element)) {
/* ??
	    ReportKernelError("no source for non-resolved signal", 
                              FormatSignalPortionName(&SimError,
                                                      qqNumber(element),
                                                      0,TRUE,TRUE),
		              "", 0);
*/
        }

/* LRM 12.6.3 p3:
   "1.  The driving value and the effective value of each explicitly declared
	signal is computed, and the current value of the signal is set to the
	effective value.  This value is assumed to have been the value of the
	signal for an infinite length of time prior to the start of 
	simulation."
*/
        if (sc_Explicit == qqSignalClass(qqGroup(element))) {
					/* check if explicitly declared */

		/* ?? handle breakpoints/stepping in any resolution fn.
			evaluation ?? */

            /* If the element is part of a complex net then it is evaluated
               when the top element of the net is evaluated */

            if (!qqMapped(element)) {
                group  = qqGroup(element);
                active = qqActiveCount(group) - qqDataLength(element);
                SetqqActiveCount(group,active);
                if (qqGroupResolved(element)) {
                    if (0 == active) {
                        ComputeNetDrivingValue(element);
					/* compute driving value up */
                        SetNetEffectiveValues(group);
                    }
                }
                else {
                    ComputeNetDrivingValue(element);
					/* compute driving value up */
                    SetNetEffectiveValue(element);
                }
            }
            else {
                /* should remove element's evaluation process ? */
            }
	} /* if explicit signal */

/* LRM 12.6.2p4:
   "2.  The value of each implicit signal of the form S'Stable(T) or S'Quiet(T)
	is set to True"
	- current handled in VK_CreateImplicitSignal
*/


	/* : must initialize all S'Delayed(T) with initial value of S */

        if (sc_Delayed == qqSignalClass(qqGroup(element))) {
            tPrefixDataHandle    imp_data;
            VK_tSignalOffset     offset;
            tSignalElementHandle prefix_element;

	    /* initial value is initial value of base signal */
            imp_data       = ImplicitData(element);
            prefix_element = SignalElementHandle(qqPrefixSignalStart(imp_data)
                                                 + SignalOffset(element));

            SetDrivingValue(element,qqEffectiveValuePtr(prefix_element));
            SetNetEffectiveValue(element);
	}

/* LRM 12.6.2p5:
   "3.  The value of each implicit GUARD signal is set to the result of 
	evaluating the corresponding guard expression."
	- execute internal process for each guard signal
	- process list is sorted, so we'll evaluate in the right order
*/

        if (sc_Guard == qqSignalClass(qqGroup(element))) {

		/* ?? handle breakpoints/stepping in (under) guard expression
			evaluation ?? */

	    proc_data_guard = 
		(tProcData_Guard_Ptr)qqProcessData(qqEvalProcess(element));

            qqDrivingValuePtr(element)->t_int = 
                                 (*proc_data_guard->evaluation_function)(
			           proc_data_guard->evaluation_context);
					/* call guard evaluation function with
					   its context data (both are 
					   registered from the generated code
					 */

	    SetNetEffectiveValue(element);
	}

        index += qqDataLength(element);
    } /* while (for each signal) */

/* Now that all signals are initialized, write initial values to trace file */
    /* for each signal */
    index = 1;
    while (index <= ScalarSignalCount) {
	element = SignalElementHandle(index);
        TraceSignalInitial(element);
        index  += qqDataLength(element);
    }


/* LRM 12.6.2p6:
   "4.  Each process in the model is executed until it suspends."

	- also execute internal equivalent processes for half of 'Delayed
	- execute each user process (representing process statements)
*/

/* Note: Processes for process statements and for 'Delayed can be 
	executed in any order. */


	/* : execute equivalent processes for 'Delayed (second half) */

    for (proc_scan=TempFirstItem(DelayedProcessList); 
	    ! TempNullItem(proc_scan); proc_scan = TempNextItem(proc_scan)) {

	CurrentProcess = ProcValue(proc_scan);
	
	/* (no breakpoints on 'Delayed processes; they have no direct VHDL
	   code and not indirect VHDL code (e.g., resolution functions)) */

	EvaluateDelayed(CurrentProcess);
					/* directly call function for second
					   half of 'Delayed evaluation */
    } /* for */

    CurrentProcess = NULL;


	/* : execute processes for (equivalent) process statements in model */

    for (proc_scan=TempFirstItem(UserProcessList); ! TempNullItem(proc_scan); 
		proc_scan = TempNextItem(proc_scan)) {

	CurrentProcess = ProcValue(proc_scan);
	if (DB.break_any_process || qqDebugBit(CurrentProcess)) {
					/* break on process */
	    DB.next_step_flag = True;	/* implement by breaking on next VHDL
					   statement */
	}

	RunProcess((VK_tPCBP) qqProcessData(CurrentProcess));
					/* run process with process data */

	DB.next_step_flag = False;	/* reset flag in case no debug 
					   callbacks for this process */
	InternalDebug(bp_Suspend, NULL);

    }

    CurrentProcess = NULL;

/* ?? Trace END of first simulation cycle */

/* LRM 12.6.3, para. 7 : 
	"At the beginning of simulation, current time is assumed to bs 0ns." 
	- handled above
*/
} /* Simulate_Initialize */


/* *******************************************************************
*
* Simulate_Terminate - terminate simulation 
*
* HISTORY:
*	13-NOV-89 DSB	Created
*
******************************************************************* */

void Simulate_Terminate()
{
/**/
    FinishTraceFile();
} /* Simulate_Terminate */


/*****************************************************************************
*
* AddImplicitProcess - add an implicit evaluation process to the
*                      ImplicitProcessList
*
* DESCRIPTION:
*       The list is sorted so that 's.. is processed before 's..'s..
*
* HISTORY:
*	02-JAN-92 DKC	Created
*
*****************************************************************************/

void AddImplicitProcess(process)
VK_tProcessHandle process;
{ 
    VK_tInteger       number;
    TempItem          scan;  
    VK_tProcessHandle scan_proc;
/**/
    number = qqNumber(process);
    scan   = TempFirstItem(ImplicitProcessList);

    while (!TempNullItem(scan)) {
        scan_proc = ProcValue(scan);
        if (qqNumber(scan_proc) > number) {
            TempAddPrev(scan,(TempNode)process);
            return;
        }
        scan = TempNextItem(scan);
    }

    TempAddLast(ImplicitProcessList,(TempNode)process);

} /* AddImplicitProcess */


/* *******************************************************************
*
* SimulateModel - run simulation
*
* HISTORY:
*	27-SEP-89 DSB	Created
*	29-SEP-89 DSB	...
*	30-SEP-89 DSB	Added initialization code
*	20-OCT-89 DSB	Adding timed wait support
*	15-JUN-90 DSB	Added GetCommands for interactive simulation
*	13-JUL-90 DSB	Added WaitFn, WaitContext
* 	28-Sep-90 GJB	Renamed TriggerProcess to TriggerProcessTimeOut
*	18-MAR-91 WAG	Split process execution into two phases: one for
*			kernel processes and one for user processes.
*	03-APR-91 WAG	W0023.  Cleaned up code indentation.  Deviated slightly
*			from coding style standards due to depth of code
*			hierarchy.
*	14-MAY-91 DSB	W0053+: split out DelayedProcessList; call 
*			VC_RunProcess; etc.
*	21-MAY-91 DSB	Added cast on qqProcessData
*	10-JUN-91 DSB	Applied FreeTimeBuffer, etc.
*       29-OCT-91 DKC   Modified to handle non-full driver vector (for large
*                       types)
*
******************************************************************* */

void SimulateModel()
{
    TempNode               temp_node;    
    TempItem               temp_item;
    tDriverElementHandle   driver;
    tAbsTimeBuf            next_time;
    TempItem               proc_scan;
    VK_tProcessHandle      process;
    tSignalNumber          index;
    tTempBuf80             buffer;
    tTempBuf80             sim_time_buf;
    VK_tBoolean            time_advanced,
                           end_of_time;
    VK_tInteger            events;
    TempItem               event_item;
    tEventHandle           event_node;
    tProcData_Implicit_Ptr proc_data;
/**/
    /* 1: Perform initialization part fo simulation */

    StartTraceFile();			/* create trace file; write Header */

    TraceTimeAdvance(&SimTime);		/* to initialize trace time to zero */

    SetErrorStatus(KE_Init);

    if (GF.slave) {
        RD_WriteStatus(ss_Initializing);
    }
    Simulate_Initialize();		/* perform initialization phase */
    
    DB.is_after_init = True;
    InternalDebug(bp_AfterInitialization, NULL);
    

    SetErrorStatus(KE_Simul);
    
    if (GF.slave) {
       RD_WriteStatus(ss_Simulating);
    }

        /* Initialization is time: 0 cycle: 0 */
    InternalDebug(bp_Cycle, NULL);
    
	/* 2: Simulate */
    events = 0;
    for (end_of_time = FALSE; !end_of_time ;) {

/* LRM 12.6.3p9: ... Simulation is complete when time advances to TIME'High. */

      if ((UTIME_LESSTHAN(MaxTime, SimTime)) ||
	      (TIME_EQUAL(MaxTime, SimTime))) {
	    SetErrorStatus(KE_TimeHi);
            events      = 0;
            end_of_time = TRUE;
      }
      else  if (SimCycleCount >= MaxCycles) {
	    tTempBuf80 max_cycles;
	    sprintf(max_cycles,"%d", MaxCycles);	/* convert to ascii */
            SetErrorStatus(KE_CycleLimit, max_cycles);
            events      = 0;
            end_of_time = TRUE;
      }
      else {
       
	SimCycleCount++;
	TraceSimCycle();
	LocalAssertionCount = 0;
	LocalErrorCount     = 0;

	/* : 1: "If no driver is active, then simulation time advances to the
	   next time at which a driver becomes active or a process resumes.  
	   Simulation is complete when time advances to TIME'High." */
		/* : 1a: advance simulation time */

        for (events = 0;;) {

	    if (TempIsEmpty(EventTimeQueue)) {
                event_item = NULL;
	    }
            else {
                event_item = TempFirstItem(EventTimeQueue);
                event_node = EventValue(event_item);
            }

	    while (NULL != event_item && 
                   TIME_EQUAL(SimTime, qqTime(event_node))) {
		time_advanced = False;
                switch (qqEventClass(event_node)) {
                    case ev_DriverEvent:
                        driver = (tDriverElementHandle)(qqData(event_node));
                        SetqqScheduled (driver,NULL);
                        SetDriverActive(driver);
                        events++;
                        break;
                    case ev_EvalImplicit:
		        process = (VK_tProcessHandle)(qqData(event_node));
                        SetqqScheduled(process,NULL);
                        SetqqActivated(process,FALSE);
                        proc_data = 
                                (tProcData_Implicit_Ptr)qqProcessData(process);
                        SetqqEvaluating(
                           qqElements(qqImplicitSignalHandle(proc_data)),TRUE);
                        AddImplicitProcess(process);
                        events++;
                        break;
                    case ev_ProcessWakeUp:
		        process = (VK_tProcessHandle)(qqData(event_node));
                        SetqqScheduled(process,NULL);
                        SetqqTimedOut (process,TRUE);
                        TriggerProcess(process);
                        events++;
                        break;                
                }

        	DequeueEvent(event_item); /* - destroys event_item & _node */

                if (TempIsEmpty(EventTimeQueue)) {
                    event_item = NULL;
                }
                else {
                    event_item = TempFirstItem(EventTimeQueue);
                    event_node = EventValue(event_item);
	        }
	    }

            if (0 == events) {
	        if (NULL == event_item) {
	            STIME_HIGH(SimTime);
	            TraceTimeAdvance(&SimTime);
                    end_of_time = TRUE;
                    break;
	        }
                else {
		    DeltaCount = 0;		/* reset delta count */
		    TIME_COPY(SimTime, qqTime(event_node));
	            TraceTimeAdvance(&SimTime);
		    time_advanced = True;
                }
	    }
            else {
		DeltaCount++;		/* increment delta count */
                break;
            }
	}

    	if (GF.verbose) {
    	    UTIME_FORMAT(sim_time_buf, SimTime);
    	    sprintf(buffer,
                    "cycle =%4d; time =%7s %s + %2d delta; events = %4d",
	    	    SimCycleCount, sim_time_buf, BaseUnit, 
                    DeltaCount-1, EventCount);
            SetErrorStatus(KE_Cycle, buffer);
    	}

		/* : Time Advanced */
	if (time_advanced) {	    
            InternalDebug(bp_Time, &SimTime);
	}
	

	if (0 != events) {

	    /* : 2: "Each active explicit signal in the model is updated.  
		(Events may occur on signals as a result.)" */

	    /* implement as:
		for each active driver, update driver, then trigger processing
			of net 

		for each active net, compute net values, trigger 
			explicit-signal processes and implicit-signal processes
	     */

	    while (!TempIsEmpty(ActiveDriverList)) {

                TempRemoveFirst(ActiveDriverList,temp_node);
		driver = (tDriverElementHandle)temp_node;

 		temp_item = TempFirstItem(qqWaveformTimes(driver));
		temp_node = TempValue(TempFirstItem(qqWaveformValues(driver)));

		EventCount++;

		if (temp_node == NULL) {
		    SetqqDriverNull(driver, True);
		}
		else {
		    SetqqDriverNull(driver, False);
		    SetCurrentValue(driver, (tScalarUnionPtr)temp_node);
		}

		TempRemoveFirst(qqWaveformValues(driver), temp_node);
		DeAllocTempSpace(temp_node);

		TempRemoveFirst(qqWaveformTimes(driver), temp_node);
		DeAllocTempSpace(temp_node);

		temp_item = TempFirstItem(qqWaveformTimes(driver));
		if (! TempNullItem(temp_item)) {
		    TIME_COPY(next_time,*(tAbsTimePtr) TempValue(temp_item));
		    SetqqScheduled(driver,QueueEvent(&next_time,
                                                     ev_DriverEvent,driver));
		}

		SetSignalActive(SignalElementHandle(qqParentElement(driver)));
                            /* - activates processes associated with signal */

	    } /* for each active driver */


	    /* : 3: "Each implicit signal in the model is updated.  
		(Events may occur on signals as a result.)" */

		/* Note: this now processes explicit signals and implicit
			signals */


	    do {
                while (!TempIsEmpty(EvalProcessList)) {
                    TempRemoveFirst (EvalProcessList, temp_node);
		    EventCount++;
  	            CurrentProcess = (VK_tProcessHandle)temp_node;
                    VERIFY_ERROR(!qqActivated(CurrentProcess));
                    SetqqActivated(CurrentProcess,TRUE);
		    switch (qqProcessKind(CurrentProcess)) {
		        case pc_Explicit:    
                            EvaluateExplicit(CurrentProcess);     break;
		        case pc_Transaction: 
                            EvaluateTransaction(CurrentProcess);  break;
		        case pc_Quiet:       
                            EvaluateQuiet(CurrentProcess,FALSE);  break;
		        case pc_Stable:      
                            EvaluateStable(CurrentProcess,FALSE); break;
		        case pc_Guard:       
                            EvaluateGuard(CurrentProcess);        break;
		        case pc_Delayed:       
                            EvaluateDelayed(CurrentProcess);      break;
		        default:
		            ReportInternalError(
			      "Unexpected process kind in eval. process list",
				"", __FILE__, __LINE__);
			    break;
   		    } /* switch */
                    
		    DB.next_step_flag = False; 
                                           /* reset flag in case no debug 
					      callbacks for this process    */
					   /* ?? this is not quite right ?? */
					   /* ?? plus new stuff: guard and
					      explicit can call VHDL; others
					       cannot ?? */
                }

                /* once everything else is done evaluate 
                   'quiet & 'stable implicits */
	        while (!TempIsEmpty(ImplicitProcessList)) {
                    TempRemoveFirst (ImplicitProcessList, temp_node);
		    EventCount++;
  	            CurrentProcess = (VK_tProcessHandle)temp_node;
                    if (!qqActivated(CurrentProcess)) {
                        SetqqTriggerCycle(CurrentProcess,SimCycleCount);
                        SetqqActivated   (CurrentProcess,TRUE);
		        switch (qqProcessKind(CurrentProcess)) {
		            case pc_Quiet:
		                EvaluateQuiet(CurrentProcess,TRUE);
		                break;
		            case pc_Stable:
		                EvaluateStable(CurrentProcess,TRUE);
			        break;
		            default:
		                ReportInternalError(
		                "Unexpected process kind in imp. process list",
			        "", __FILE__, __LINE__);
			        break;
		        } /* switch */
                        if (!TempIsEmpty(EvalProcessList)) {
                           break;
                        }
                    }
                    else {
                        VERIFY_ERROR(qqTriggerCycle(CurrentProcess)
                                     == SimCycleCount);
                    }
                }

            } while (!TempIsEmpty(EvalProcessList));

	    /* : 4: "For each process P, if P is currently sensitive to a 
		signal S, and an event has occurred on S in this simulation 
		cycle, then P resumes." */
		/* implemented in signal loop: signal event (or transactions)
		   mark processes to resume by setting trigger cycle */

	    /* : 5: "Each process that has just resumed is executed until it 
		suspends." */

	    while (!TempIsEmpty(ActiveProcessList)) {

                TempRemoveFirst(ActiveProcessList,temp_node);
		CurrentProcess = (VK_tProcessHandle)temp_node;

                if (!qqActivated(CurrentProcess)) {

                    if (NULL == qqWaitFn(CurrentProcess) ||
                        qqTimedOut(CurrentProcess)       ||
                        (*qqWaitFn(CurrentProcess))
                                          (qqWaitContext(CurrentProcess))) {

                        SetqqActivated(CurrentProcess,TRUE); 
                        SetqqTimedOut (CurrentProcess,FALSE);

    		        if (DB.break_any_process || 
                            qqDebugBit(CurrentProcess)) {
					/* break on process */
		            DB.next_step_flag = True;
					/* implement by breaking on next VHDL
					   statement */
		        }

		        RunProcess(qqProcessData(CurrentProcess));
					/* run process with process data */

		        DB.next_step_flag = False;
					/* reset flag in case no debug 
					   callbacks for this process */
		        InternalDebug(bp_Suspend, NULL);
                    }
		}
                else {
                    VERIFY_ERROR(qqTriggerCycle(CurrentProcess)
                                 == SimCycleCount);
                }
	    }
	    
	    CurrentProcess = NULL;
	}

      }
      /* : end of simulation cycle */
      InternalDebug(bp_Cycle, NULL);
	
    }

    SetErrorStatus(KE_Complete);
    if (GF.slave) {
	RD_WriteStatus(ss_Terminated);
    }
    if (GF.interactive) {
	DB.is_after_sim = True;
	GetCommands();
    }
    Simulate_Terminate();		/* perform termination phase */
} /* SimulateModel */



#if 0
/* *******************************************************************
*
* RtnName - <description of function or procedure>
*
* HISTORY:
*	??-JUN-90 DSB	Created
*
******************************************************************* */


<static> Fntype RtnName(parm)				/* return value desc. if not void */
tParmType parm;			/* mode: description */
{
    type local;				/* description */
    type local;				/* description */
/**/

} /* RtnName */


#endif

