static char SCCS_ID[] = "@(#)TKTemp.c	42.2 1/13/92";
/* ******************************************************************
* 
* Copyright 1987-1989 by CAD Language Systems, Inc.  All rights reserved. 
* 
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* CODE FILE: TKTemp.c
* 
* DESCRIPTION:
* 	Miscellaneous routines for kernel related code.
*	?? rename this to something like TKUtils.c
* 
* HISTORY:
* 	24-Aug-90 RM	Created
* 	10-Sep-90 RM	Added Alloc routines.
*	02-APR-91 WAG	W0015.  Included TKMisc.h.
*	25-APR-91 AWH	WOO21: Renamed to TK...
*	02-MAY-91 DSB	Cleaning up generally
*	16-MAY-91 DSB	Moved TKSymTab.c, much of TKMisc.c to here
*	16-MAY-91 DSB	Renamed string_match to StringMatch, 
*			partial_string_match to StringMatchPrefix
*	16-MAY-91 DSB	Converting to unsigned absolute time
*	08-JAN-92 DKC	Removed time & value buffer (de)allocation routines
*
* SCCS ID: @(#)TKTemp.c	42.2 1/13/92
* 
****************************************************************** */


#include "TKTemp.h"
#include "TKGlobals.h"		/* for GF, etc. */
#include "TKDebug.h"		/* for DB */
#include "TKSim.h"		/* for ss_Terminated */
#include "VKCodeIntf.h"		/* for VK_GetCallerLARP, etc. */
#include "TKIO.h"		/* for DisplayText()... */
#include "TKSymbUtils.h"	/* for su_IdentifyPosition()... */
#include "TKRecord.h"		/* for RD_WriteStatus()... */

/* NEED ERROR MSG HANDLERS HERE !! */
#include <stdio.h>

#undef SetErrorStatus
#define SetErrorStatus(a, b) \
	fprintf(stderr, "Error handler not implemented yet, error is: %s.\n", b)

char UppercaseTable[256] = {
    '\000','\001','\002','\003','\004','\005','\006','\007', /* NUL..BEL */
    '\010','\011','\012','\013','\014','\015','\016','\017', /* BS ..SI  */
    '\020','\021','\022','\023','\024','\025','\026','\027', /* DLS..ETB */
    '\030','\031','\032','\033','\034','\035','\036','\037', /* CAN..US  */
    '\040','\041','\042','\043','\044','\045','\046','\047', /* ' '..''' */
    '\050','\051','\052','\053','\054','\055','\056','\057', /* '('..'/' */
    '\060','\061','\062','\063','\064','\065','\066','\067', /* '0'..'7' */
    '\070','\071','\072','\073','\074','\075','\076','\077', /* '8'..'?' */
    '\100','\101','\102','\103','\104','\105','\106','\107', /* '@'..'G' */
    '\110','\111','\112','\113','\114','\115','\116','\117', /* 'H'..'O' */
    '\120','\121','\122','\123','\124','\125','\126','\127', /* 'P'..'W' */
    '\130','\131','\132','\133','\134','\135','\136','\137', /* 'X'..'_' */
    '\140','\101','\102','\103','\104','\105','\106','\107', /* '`'..'g' */
    '\110','\111','\112','\113','\114','\115','\116','\117', /* 'h'..'o' */
    '\120','\121','\122','\123','\124','\125','\126','\127', /* 'p'..'w' */
    '\130','\131','\132','\173','\174','\175','\176','\177', /* 'x'..DEL */
    '\200','\201','\202','\203','\204','\205','\206','\207', /* */
    '\210','\211','\212','\213','\214','\215','\216','\217', /* */
    '\220','\221','\222','\223','\224','\225','\226','\227', /* */
    '\230','\231','\232','\233','\234','\235','\236','\237', /* */
    '\240','\241','\242','\243','\244','\245','\246','\247', /* */
    '\250','\251','\252','\253','\254','\255','\256','\257', /* */
    '\260','\261','\262','\263','\264','\265','\266','\267', /* */
    '\270','\271','\272','\273','\274','\275','\276','\277', /* */
    '\300','\301','\302','\303','\304','\305','\306','\307', /* */
    '\310','\311','\312','\313','\314','\315','\316','\317', /* */
    '\320','\321','\322','\323','\324','\325','\326','\327', /* */
    '\330','\331','\332','\333','\334','\335','\336','\337', /* */
    '\340','\341','\342','\343','\344','\345','\346','\347', /* */
    '\350','\351','\352','\353','\354','\355','\356','\357', /* */
    '\360','\361','\362','\363','\364','\365','\366','\367', /* */
    '\370','\371','\372','\373','\374','\375','\376','\377'  /* */
  };


/************************************************************************
*
* StringMatch
*
* INPUTS:
*	s1, s2	Strings to compare
*
* ALGORITHM:
*	Do a case-insensitive comparison.
*
* HISTORY:
*	06-FEB-89 PBG	Created
*	16-MAR-89 PBG	Changed to use UppercaseTable
*
************************************************************************/
VK_tBoolean StringMatch(s1, s2)
VK_tCString s1;
VK_tCString s2;
{
    unsigned char *t1;
    unsigned char *t2;
    unsigned int c1;
/**/
    t1 = (unsigned char *) s1;
    t2 = (unsigned char *) s2;

    /* Comment out check for null pointer	*/

/*    if (t1 == NULL) {				*/
/*	return t2 == NULL || *t2 == '\0';	*/
/*    }						*/
/*    else if (t2 == NULL) {			*/
/*	return *t1 == '\0';			*/
/*    }						*/

    
    while (True) {
	if ((c1 = (unsigned int) *t1++) == 0) {
	    return *t2 == '\0';
	}

	if (UppercaseTable[c1] != UppercaseTable[(unsigned int) *t2++]) {
	    return False;
	}

    }
} /* StringMatch */


/************************************************************************
*
* StringMatchPrefix
*
* INPUTS:
*	s1, s2 	Strings to compare
*
* ALGORITHM:
*	Do a case-insensitive comparison.  Return True if s1 is 
*	a prefix of s2.  Return False otherwise.
*
* HISTORY:
*	19-APR-89 PBG	Created
************************************************************************/
VK_tBoolean StringMatchPrefix(s1, s2)
VK_tCString s1;
VK_tCString s2;
{
    unsigned char *t1;
    unsigned char *t2;
    unsigned int c1;
    unsigned int c2;
/**/
    t1 = (unsigned char *) s1;
    t2 = (unsigned char *) s2;

    while (True) {
	if ((c1 = (unsigned int) *t1++) == 0) {
	    return True;
	}

	if ((c2 = (unsigned int) *t2++) == 0) {
	    return False;
	}

	if (UppercaseTable[c1] != UppercaseTable[c2]) {
	    return False;
	}

    }
} /* StringMatchPrefix */


/* ?? TEMPORARY SEMI-PROTECTED STRING OPERATIONS (COPIED FROM CODE 
	GENERATOR) ?? */	
/************************************************************************
*
* TempStrCat - strcat with error checking
*
* HISTORY:
* 	17-OCT-90 DSB	Created
*
************************************************************************/
Boolean1 TempStrCat(buffer, buf_size, string)
				/* returns True if successful */
char buffer[];			/* in: buffer to which to append */
int buf_size;			/* in: total buffer size */
StringN string;			/* in: string to append */
{
    Boolean1 result = False;
/**/
    if (strlen(buffer) + strlen(string) + 1 > buf_size) {
/* * *	SetErrorStatus(VCGE_LimitStrOver, buffer, string); * * */
	result = False;
    }
    else {
	strcat(buffer, string);
	result = True;
    }
    return result;
} /* TempStrCat */


/************************************************************************
*
* TempStrCpy - strcpy with error checking
*
* HISTORY:
* 	17-OCT-90 DSB	Created
*
************************************************************************/
Boolean1 TempStrCpy(buffer, buf_size, string)
				/* returns True if successful */
char buffer[];			/* in: buffer to set */
int buf_size;			/* in: total buffer size */
StringN string;			/* in: string to stuff */
{
    Boolean1 result = False;
/**/
    if (strlen(string) + 1 > buf_size) {
/* * *	SetErrorStatus(VCGE_LimitStrOver, buffer, string); * * */
			/* ?? error message is not tailored for this ?? */
	result = False;
    }
    else {
	strcpy(buffer, string);
	result = True;
    }
    return result;
} /* TempStrCpy */



/*****************************************************************************
*
* ResizeStrBuf - Resize a static string buffer.
*
* DESCRIPTION:
*
* HISTORY:
*	10-NOV-91 DKC	Created
*
*****************************************************************************/

ResizeStrBuf(str_buff, req_size)
StaticStrBufPtr str_buff;
int req_size;
{
/**/
    if (str_buff->buffer_size == 0) {
        str_buff->buffer_size = req_size;
        AllocateMemory(str_buff->string, char, req_size);
        str_buff->string[0] = '\0';
    }
    else {
        str_buff->buffer_size = req_size;
        ReallocateMemory(str_buff->string, char, req_size);
    }
       
} /* ResizeStrBuf */


/*****************************************************************************
*
* StaticStrCat - For use with resizable buffer
*
* DESCRIPTION:
*
* HISTORY:
*	10-NOV-91 DKC	Created
*
*****************************************************************************/

Boolean1 StaticStrCat(str_buff,string)
StaticStrBufPtr str_buff;
StringN string;
{
    while (!TempStrCat(str_buff->string,str_buff->buffer_size,string)) {
        if (str_buff->resizable) {
           ResizeStrBuf(str_buff,str_buff->buffer_size + strlen(string) +1);
        }
        else {
           return (FALSE);
        }
    }

    return TRUE;
/**/
} /* StaticStrCat */


/*****************************************************************************
*
* StaticStrCpy - Copy to Static String
*
* DESCRIPTION:
*
* HISTORY:
*	10-NOV-91 DKC	Created
*
*****************************************************************************/

StaticStrCpy(str_buff,string)
StaticStrBufPtr str_buff;
StringN string;
{
    if (0 == str_buff->buffer_size) {
        if (str_buff->resizable) {
            ResizeStrBuf(str_buff,strlen(string) +1);
        }
        else {
           return (FALSE);
        }
    }

    str_buff->string[0] = '\0';

    return StaticStrCat (str_buff,string);
/**/
} /* StaticStrCpy */

/* *********************************************************************
*
* CopyPrivStr - allocate new space and copy string to it
*
* HISTORY:
*	26-FEB-90 RM	Created
* 	24-Aug-90 RM	Modified for use with kernel routines.
*	02-APR-91 WAG	W0015.  Replaced malloc call with AllocateMemory.
*	19-APR-91 DSB	Kludged bug: handle null pointer as empty string.
*
********************************************************************* */
 
VK_tCString CopyPrivStr(str)
VK_tCString str;
{
    VK_tCString ptr;
/**/
    if (str == (VK_tCString) NULL) {
        SetErrorStatus(GE_PCError, "null pointer in CopyPrivStr");
	AllocateMemory(ptr, char, strlen("") + 1);
        ptr = "";		/* for now, return empty string */
    }
    else {
	AllocateMemory(ptr, char, strlen(str) + 1);
        if (ptr == (VK_tCString) NULL) {
            SetErrorStatus(GE_PCError, "out of memory is CopyPrivStr");
        }
        else {
            /* even if it is a null string */
            strcpy(ptr, str);
        }
    }
    return ptr;
}  /* CopyPrivStr */



/* ?? merge with CopyPrivStr ?? */
/* *******************************************************************
*
* DuplicateString -
*
* HISTORY:
*	21-JAN-91 AWH	Split from Show Processes.
*	01-APR-91 WAG	W0015.  Changed VerifyMalloc to AllocateMemory.
*
******************************************************************* */

VK_tCString DuplicateString(original)
VK_tCString original;
{
    Integer4 new_len;
    VK_tCString new_string;   
/**/
    if ( original && *original ) {	/* ?? make it look boolean ?? */
	new_len = strlen(original);
	AllocateMemory(new_string, char, new_len + 1);
	strcpy(new_string, original);
	return new_string;
    }
    else {
	return NULL;
    }
    
} /* DuplicateString */



/* *******************************************************************
*
* iAllocateMemory - allocate memory from the heap
*
* HISTORY:
*	27-MAR-91 AWH	Created
*	01-APR-91 WAG	Added casting to the malloc call.
*       14-NOV-91 DKC   Added zero option
*
******************************************************************* */

void * iAllocateMemory(size,zero)
Integer4 size;
int      zero;
{
    void * pointer;				
/**/
    pointer = (void *) malloc(size);
    
    if (NULL == pointer) {
	ReportInternalError("Out of memory", "", "",0);
    }

    if (zero) {
        bzero (pointer,size);
    }

    return pointer;
    
} /* iAllocateMemory */



/* *******************************************************************
*
* iFreeMemory - Free memory allocated from the heap
*
* HISTORY:
*	27-MAR-91 AWH	Created
*
******************************************************************* */

void iFreeMemory(pointer)
void * pointer;
{
/**/
    free(pointer);
        
} /* iFreeMemory */


/* *******************************************************************
*
* iReallocateMemory - extend allocate memory from the heap
*
* HISTORY:
*	27-MAR-91 AWH	Created
*	01-APR-91 WAG	Added casting to the realloc call.
*
******************************************************************* */

void * iReallocateMemory(pointer, size)
void * pointer;
Integer4 size;
{
/**/
    pointer = (void *) realloc(pointer, size);
    
    if (NULL == pointer) {
	ReportInternalError("Out of memory", "", "",0);
    }
    return pointer;
    
} /* iReallocateMemory */



/* *******************************************************************
*
* TryTraceback - simple test to demonstrate trackback traversal
*
* HISTORY:
*	17-MAY-90 DSB	Created
*
******************************************************************* */
void TryTraceback(current_region_data)
VK_tLARHeaderPtr current_region_data;	/* current region data */
{
    VK_tLARHeaderPtr loop_LARP;
    VK_tIARHeaderPtr temp_IARP;

    VK_tName library;
    VK_tName primary;
    VK_tName secondary;
    VK_tName source_file;
    VK_tLineNumber line_number;
    VK_tSymbInfoHandle region_info;

    tTempBuf256 lex_name_buf;
    tTempBuf256 line_buf;
static int StopRecursion = 0;
/**/
    if (StopRecursion != 0) {		/* if traceback reported error, don't
					   do traceback for that error */
	return;
    }
    StopRecursion = 1;

    DisplayText("--VHDL region stack traceback");
    loop_LARP = current_region_data;
    while (NULL != loop_LARP) {
	su_IdentifyPosition(loop_LARP, &library, &primary, &secondary, 
		&source_file, &line_number, &region_info);
					/* identify position from stuffed
					   LAR fields */

	FormatLexicalName(lex_name_buf, sizeof(lex_name_buf), region_info);

	sprintf(line_buf, "  --line %d in %s", line_number, lex_name_buf);
	DisplayText(line_buf);

	temp_IARP = VK_GetIARP(loop_LARP);
	if (NULL == temp_IARP) {
	    loop_LARP = NULL;
	}
	else {
	    loop_LARP = VK_GetCallerLARP(temp_IARP);
	}
    } /* while */
    DisplayText("--end of traceback");
    StopRecursion = 0;
} /* TryTraceback */



/* *******************************************************************
*
* ReportInternalError - report internal error and exit
*
* HISTORY:
*	...
*	23-JUL-91 DSB	Renamed .errors to .error_occurred, etc.
*
******************************************************************* */
void ReportInternalError(message, extra, file , line)
VK_tCString message;		/* in: error message */
VK_tCString extra;		/* in: extra message */
VK_tCString file;		/* in: C source file */
Integer4 line;		/* in: line number */
{
    tTempBuf256 buffer;
static int StopRecursion = 0;
/**/
    if (StopRecursion != 0) {		/* if error reported error, cut loop */
	return;
    }
    StopRecursion = 1;

    GF.error_occurred = True;
    GF.warning_occurred = True;
    DB.is_after_elab = True;
    DB.is_after_init = True;
    DB.is_after_sim = True;
    
    strcpy(buffer, message);
    strcat(buffer, " ");
    strcat(buffer, extra);

    ReportKernelError(buffer, "INTERNAL", file, line);

    EarlyTerminate(FALSE);
 
    StopRecursion = 1;
} /* ReportInternalError */


/* Added line and file args to be consistent with VERIFY_WARN macro. 
   -MNP 910917 */

void TempVerifyWarn(cond_str, line, file)
char *cond_str;
int line;
char *file;
{
#define MESSAGE_FORMAT "Warning: verify failed: '%s'\n"
#define MESSAGE_SIZE 1024
    tTempBuf1024 buffer; 
/**/
    if (strlen(cond_str) < (MESSAGE_SIZE - sizeof(MESSAGE_FORMAT))) {
   	 sprintf(buffer, "Warning: verify failed: '%s'\n", cond_str);
     }
    else {
        sprintf(buffer, "warning: verify failed: '<NIY>'\n");
    }
    DisplayText(buffer);
    
} /* TempVerifyWarn */


/* *******************************************************************
*
* ReportVerifyFailed - report verify failed
*
******************************************************************* */
void ReportVerifyFailed(condition, file, line)
VK_tCString condition;		/* in: boolean condition */
VK_tCString file;		/* in: C source file */
Integer4 line;		/* in: line number */
{
    tTempBuf256 buffer;
/**/
    sprintf(buffer, "verify failed (%s)" , condition);
    ReportInternalError(buffer, "", file, line);
} /* ReportVerifyFailed */



/* *******************************************************************
*
* ReportVerifyMemoryFailed - report verify memory operation failed
*
******************************************************************* */
void ReportVerifyMemoryFailed(operation, allocation, file, line)
VK_tCString operation;		/* in: memory function */
VK_tCString allocation;		/* in: type allocated */
VK_tCString file;		/* in: C source file */
Integer4 line;		/* in: line number */
{
    tTempBuf256 buffer;
/**/
    sprintf(buffer, "%s failed (%s)", operation, allocation);
    ReportInternalError(buffer, "", file, line);
} /* ReportVerifyMemoryFailed */


/* *******************************************************************
*
* TerminateKernel - terminate simulation
*
* HISTORY:
*	27-SEP-89 DSB	Created
*
******************************************************************* */

void TerminateKernel()
{
/**/
    SetReporting(False);
    CloseDLS();
    ExitProgram();
} /* TerminateKernel */
 
	

/* ?? move this to ?? module; let TKMisc.[ch] correspond to VKMisc.h ?? */
/* *******************************************************************
*
* EarlyTerminate - based on error flags terminate
*
* HISTORY:
*	22-OCT-90	Created
*	23-JUL-91 DSB	Renamed .errors to .error_occurred, etc.
*
******************************************************************* */

void EarlyTerminate(summarize)
int summarize;
{
/**/
    if (GF.error_occurred || GF.warning_occurred) {
	
	if (GF.interactive) {
	    GetCommands();
			/* ?? probably don't continue until exit command ?? */
                        /* ?? should do a jump back - rather than recurse ?? */
	}

        if (GF.slave) {
	    RD_WriteStatus(ss_Terminated);
	}
       
        if (summarize) {
            char  errors[32],
                  warns [32];

            sprintf(warns,GF.warning_occurred ? "%d Warning%s" : "",
                    TotalWarningCount, 1 == TotalWarningCount ? "" : "s");

            sprintf(errors,GF.error_occurred ? "%d Error%s" : "",
                    TotalErrorCount, 1 == TotalErrorCount ? "" : "s");

            fprintf(stdout,"Simulation Terminating: %s%s%s\n",
                           errors, 
                           GF.error_occurred && GF.warning_occurred ? " and "
                                         			    : "",
                           warns);
                                  
        }
       
        TerminateKernel();
    }
} /* EarlyTerminate */



/* ?? move this to ?? module; let TKMisc.[ch] correspond to VKMisc.h ?? */
/* *******************************************************************
*
* ExitProgram - determine exit return code based on globals and exit
*
* HISTORY:
*	22-OCT-90 AWH	Created
*	23-JUL-91 DSB	Renamed .errors to .error_occurred, etc.
*
******************************************************************* */
void ExitProgram()
{
/**/
/* ?? 
* We probably should distinguish between the following error classes:

- Normal:  Don't quit; return success code
1 - Normal execution (no errors; no assertions above assertion warning level)

- Warnings: Don't quit (normally); return warning code
2 - VHDL assertion above assertion warning level and below assertion abort 
	level (usually Warning)

- Non-fatal errors: Quit (usually); return non-fatal error code
3 - VHDL assertion above assertion abort level (usually Error and Fatal)
4 - Non-fatal VHDL  error (run-time check from code or from kernel)

- Fatal errors: Quit (always?); return fatal error code
4 - Fatal VHDL error (run-time check from code or from kernel)

- Fatal internal errors: Quit (always); return internal fatal error code 
	(different code indicate bug in kernel or RVCG system)
5 - Fatal internal error

* Configurability:
- assertion warning level should be adjustable eventually
- assertion abort level should be adjustable eventually (a little sooner)
- normal continution level might be adjustable (i.e., continue after VHDL
	error assertion as far as possible)
- for debugging, allow ...

*/

    if (GF.error_occurred) {
	if (GF.slave) {
	    RD_WriteTerminated(VK_ErrorExit);
	}
	exit(VK_ErrorExit);
    }
    else if (GF.warning_occurred) {
	if (GF.slave) {
	    RD_WriteTerminated(VK_WarningExit);
	}
	exit(VK_WarningExit);
    }
    else {
	if (GF.slave) {
	    RD_WriteTerminated(VK_GoodExit);
	}
	exit(VK_GoodExit);
    }
} /* ExitProgram*/



/* ?? MAYBE move this to ?? module; let TKMisc.[ch] correspond to VKMisc.h ?? */
/* *******************************************************************
*
* ReportKernelStatus - report simulation error from kernel
*
* NOTE: As of 03-JAN-91, VK_ReportError and ReportKernelError are
*	virtually identical. 
*
* HISTORY:
*	11-APR-90 DSB	Created
*	09-OCT-90 DSB	Added extra data and source file parameters
*	14-OCT-90 AWH	Added processing of source_file and extra parameters
*	03-JAN-91 DSB	Split VK_ReportError from ReportKernelError
*	16-MAY-91 DSB	Added GetLastBreakpoint for source/line info.
*	17-MAY-91 DSB	Applied su_IdentifyPosition
*	17-MAY-91 DSB	Added temporary TryTraceback
*	28-MAY-91 DSB	Added space ("%s(%s)" => "%s (%s)")
*	23-JUL-91 DSB	Renamed .errors to .error_occurred, etc.
*	12-DEC-91 DKC	Changed name to Report...Status and added severity
*
******************************************************************* */

void ReportKernelStatus(severity,message, extra, source_file, line_number)
tErrorSeverity severity;
VK_tCString    message;		/* main error message */
VK_tCString    extra;		/* extra information */
VK_tCString    source_file;	/* source file name */
int            line_number;	/* VHDL source file line number */
{
    VK_tLARHeaderPtr use_region_data;
    tTempBuf80 sim_time;
    VK_tCString last_library, last_primary, last_secondary, last_source_file;
    int last_line_number;
    VK_tSymbInfoHandle last_region_info;
/**/
#ifdef REMOVE_WHEN_VERIFIED
    /* get source_file and line_number from previous trace call */
    GetLastBreakpoint(&last_library, &last_primary, &last_secondary, 
	&last_source_file, &last_line_number);
#endif

    GetLastTracepoint(&use_region_data);
					/* use last traced region */
	
    su_IdentifyPosition(use_region_data, &last_library, &last_primary, 
	&last_secondary, &last_source_file, &last_line_number,
	&last_region_info);		/* identify position from stuffed
					   LAR fields */

    if ((source_file == NULL || *source_file == '\0') && line_number == 0) {
	source_file = last_source_file;
	line_number = last_line_number;
    }

    if (NULL == message ) {
	message = "<NULL>";
    }
    if (NULL == extra) {
	extra = "";
    }
    if ( ! GF.slave) {
	UTIME_FORMAT(sim_time, SimTime);
        fprintf(stdout, 
	    "               Error: at time = %s %s + %d,\n", 
    	    sim_time, BaseUnit, DeltaCount);

        fprintf(stdout, 
	    "                 from line %d of file %s,\n", 
	    line_number, (NULL == source_file) ? "<NULL>" : source_file);

        if ('\0' == extra[0]) {
            fprintf(stdout, 
    	        "                 %s\n",  message);
        }
        else {
	    fprintf(stdout, 
	        "                 %s (%s)\n",  message, extra);
        }
    } /* ( ! GF.slave) */
  
    if (es_Fatal == severity || es_Error == severity) {
        TotalErrorCount++;
        LocalErrorCount++;
        GF.error_occurred = True;
    }
    else if (es_Warning == severity) {
        TotalWarningCount++;
        LocalWarningCount++;
        GF.warning_occurred = True;
    }

    TraceError(message, extra, source_file, line_number, 0  /* , proc_buf */);
	/* ?? need to add additional data to trace call and trace record ?? */

    if (GF.dump) {
	TryTraceback(use_region_data);
    }

    if (es_Fatal == severity) {
        EarlyTerminate(FALSE);      /* terminate based on global flags */
    }

} /* ReportKernelStatus */


/* *******************************************************************
*
* AllocTempSpace - allocate size bytes.
*
* HISTORY:
* 	10-Sep-90 RM	Created
*	02-APR-91 WAG	W0015.  Replaced malloc call with AllocateMemory.
*
******************************************************************* */

char * AllocTempSpace(size)
int size;
{
    char *ptr;
/**/
    if (size <= 0) {
        SetErrorStatus("bad size", "AllocTempSpace");
        return (NULL);
    }
    else {
	AllocateMemory(ptr, char, size);
        if (ptr == NULL) {
            SetErrorStatus("no space", "AllocTempSpace");
            return NULL;
	}
        else {
            return ptr;
        }
    }
} /* AllocTempSpace */




/* *******************************************************************
*
* DeAllocTempSpace
*
* HISTORY:
* 	10-Sep-90 RM	Created
*	02-APR-91 WAG	W0015.  Replaced free call with FreeMemory.
*
******************************************************************* */

void  DeAllocTempSpace(ptr)
char *ptr;
{
/**/
     FreeMemory(ptr);
} /* DeAllocTempSpace */


#if 0
/* *******************************************************************
*
* RtnName - <description of function or procedure>
*
* HISTORY:
*	0?-NOV-89 DSB	Created
*
******************************************************************* */

#define rtn "RtnName"
<static> Fntype RtnName(parm, parm)
tParmType parm;			/* in: description */
tParmType parm;			/* in: description */
{
/**/

} /* RtnName */
#endif
