#ifndef VKI_H
#define VKI_H
/* *******************************************************************
*
* Copyright (c) 1989-1991 by CAD Language Systems, Inc.  All rights reserved.
*
* This file contains CLSI Confidential Information.
* Handle in accordance with contractual confidentiality requirements.
*
* HEADER FILE: VKI.h
*
* DESCRIPTION:  
*	Top-level header file for default implementation of VHDL Kernel 
*	Interface.
*
*   	Note:  For information on the VKI, see document DN 0462, 
*	"Retargetable VHDL Code Generator VHDL Kernel Interface Specification."
*
* HISTORY:
*	25-AUG-89 DSB	Created
*	19-MAR-91 DSB	Reorganizing modules.
*
* SCCS ID: @(#)VKI.h	42.2 1/13/92
*
******************************************************************* */

#include "VKConfig.h"		/* host detection and option selection */

			/* main type declarations: */
#include "VKBasicTypes.h"	/* VHDL types; common and handle types */
#include "VKSymbTypes.h"	/* symbolic information types */
#include "VKCodeIntf.h"		/* interface to generated code data and
				   functions */

			/* symbolic information functions: */
#include "VKRegister.h"		/* symbolic info. definition registration */
#include "VKTrace.h"		/* instance registration and exec. tracing */

			/* VHDL operation functions: */
#include "VKElaborate.h"	/* design entity instantiation operations */
#include "VKSignals.h"		/* signal creation and operations */
#include "VKProcesses.h"	/* process creation and operations */
#include "VKFiles.h"		/* file creation and operations */
#include "VKMisc.h"		/* miscellaneous types and operations */

#endif /* VKI_H */
