##############################################################################
#
# Copyright (c) 1991 by CAD Language Systems, Inc.  All rights reserved.
#
# This file contains CLSI Confidential Information.
# Handle in accordance with contractual confidentiality requirements.
#
# FILE: kernel.make - 
#
# DESCRIPTION:
#
# HISTORY:
#	02-APR-91 WAG	Removed FWTrace.o from libKernel.a;
#			updated various dependencies.
#	09-SEP-91 AWH	Handcrafted to work withPaulG's Makefile
#			system.
#
# SCCS ID: @(#)kernel.make	42.1 1/10/92
#
##############################################################################
CC = gcc -c -DANSI_FN_PROTOS
src = $(cgk_src)/
obj = $(cgk_obj)/
kernellib = $(obj)libKernel$(libsfx)
tbxlib = $(tbx_obj)/libTBX$(libsfx)

CFLAGS = $(GLOBAL_CFLAGS) -I$(spi_defs) -I$(vcg_cmn) -I$(tbx_defs) 
LINKFLAGS = $(GLOBAL_LINKFLAGS)
spilib = $(SPILink)


OBJECTS = \
	$(obj)TKData$(objsfx) \
	$(obj)TKTemp$(objsfx) \
	$(obj)TKSim$(objsfx) \
	$(obj)TKProcesses$(objsfx) \
	$(obj)TKSignals$(objsfx) \
	$(obj)TKRegister$(objsfx) \
	$(obj)TKSymbUtils$(objsfx) \
	$(obj)TKIO$(objsfx) \
	$(obj)TKCommand$(objsfx) \
	$(obj)TKDebug$(objsfx) \
	$(obj)TKDebugUtils$(objsfx) \
	$(obj)TKElaborate$(objsfx) \
	$(obj)TKErrors$(objsfx) \
	$(obj)TKFiles$(objsfx) \
	$(obj)TKFileUtils$(objsfx) \
	$(obj)TKGlobals$(objsfx) \
	$(obj)TKListFns$(objsfx) \
	$(obj)TKMain$(objsfx) \
	$(obj)TKMisc$(objsfx) \
	$(obj)TKParams$(objsfx) \
	$(obj)TKRegions$(objsfx) \
	$(obj)TKRecord$(objsfx) \
	$(obj)CmdProcessor$(objsfx) \
	$(obj)ParseCommand$(objsfx)

#
default:	$(kernellib) \
		$(obj)fmtwave$(debugsuffix)

$(obj)fmtwave$(debugsuffix): \
		$(obj)FWMain$(objsfx) \
		$(obj)FWMisc$(objsfx) \
		$(obj)FWTrace$(objsfx) \
		$(obj)FWUtils$(objsfx) \
		$(obj)TKRecord$(objsfx) \
		$(obj)TKListFns$(objsfx) \
		$(obj)TKGlobals$(objsfx) \
		$(obj)TKData$(objsfx) \
		$(DEBUGFNS)
	$(LINK) \
		$(LINKFLAGS) \
		$(obj)FWMain$(objsfx) \
		$(obj)FWMisc$(objsfx) \
		$(obj)FWTrace$(objsfx) \
		$(obj)FWUtils$(objsfx) \
		$(obj)TKRecord$(objsfx) \
		$(obj)TKListFns$(objsfx) \
		$(obj)TKGlobals$(objsfx) \
		$(obj)TKData$(objsfx) \
		$(tbxlib) \
		$(DEBUGFNS) \
		$(spilib)

$(kernellib): $(OBJECTS) $(DEBUGFNS) 
	$(AR) $@ $?
	$(RANLIB) $@

#
# Extract modules from the toolbox
$(obj)ParseCommand$(objsfx) : $(tbxlib)
	cd $(obj); \
	ar x $(tbxlib) ParseCommand$(objsfx)

 $(obj)DebugFns$(objsfx) : $(tbxlib)
	cd $(obj); \
	ar x $(tbxlib) DebugFns$(objsfx)


#
# special targets
#

$(src)TKErrorCodes.g : $(src)TKErrorMap.g
	# No Action
$(src)TKErrorMap.g : TKErrors.txt
	-$(tbx_exe)/GenErrFiles $(src)TKErrors.txt $(src)TKErrorMap.g \
	 $(src)TKErrorCodes.g

clean :
	$(CLEAN) $(OBJECTS1) $(OBJECTS2) \
	$(obj)FWMain$(objsfx) \
	$(obj)ParseCommand$(objsfx) \
	$(obj)DebugFns$(objsfx) \
	$(kernellib) $(fmtwavelib) \
	$(obj)fmtwave$(debugsuffix) \
	$(src)TKErrorCodes.g $(src)TKErrorMap.g 

gendep : $(src)TKErrorCodes.g $(src)TKErrorMap.g 
	$(dt_pmake)/UpdateMakefile.sh\
        kernel.make $(src) -ignoreothers -action "src=$(src)" 
	






# GenDependencies -- Beginning of Dependencies --

$(obj)CmdProcessor$(objsfx) : \
		$(src)CmdProcessor.c \
		$(src)CmdProcessor.h \
		$(src)VKBasicTypes.h \
		$(src)VKConfig.h 
	$(CC) $(src)CmdProcessor.c -o $@ $(CFLAGS)

$(obj)FWMain$(objsfx) : \
		$(src)FWCommon.h \
		$(src)FWMain.c \
		$(src)FWMisc.h \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKIO.h \
		$(src)TKListFns.h \
		$(src)TKRegions.h \
		$(src)TKStructs.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)FWMain.c -o $@ $(CFLAGS)

$(obj)FWMisc$(objsfx) : \
		$(src)FWCommon.h \
		$(src)FWMisc.c \
		$(src)FWMisc.h \
		$(src)FWTrace.h \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKDebug.h \
		$(src)TKIO.h \
		$(src)TKListFns.h \
		$(src)TKRecord.h \
		$(src)TKRegions.h \
		$(src)TKSignals.h \
		$(src)TKSim.h \
		$(src)TKStructs.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)FWMisc.c -o $@ $(CFLAGS)

$(obj)FWTrace$(objsfx) : \
		$(src)FWCommon.h \
		$(src)FWMisc.h \
		$(src)FWTrace.c \
		$(src)FWTrace.h \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKDebug.h \
		$(src)TKListFns.h \
		$(src)TKRecord.h \
		$(src)TKRegions.h \
		$(src)TKSignals.h \
		$(src)TKSim.h \
		$(src)TKStructs.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)FWTrace.c -o $@ $(CFLAGS)

$(obj)FWUtils$(objsfx) : \
		$(src)FWUtils.c \
		$(src)FWUtils.h 
	$(CC) $(src)FWUtils.c -o $@ $(CFLAGS)

$(obj)TKCommand$(objsfx) : \
		$(src)CmdProcessor.h \
		$(src)TKCommand.c \
		$(src)TKCommand.h \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKDebug.h \
		$(src)TKDebugUtils.h \
		$(src)TKGlobals.h \
		$(src)TKIO.h \
		$(src)TKListFns.h \
		$(src)TKRegions.h \
		$(src)TKSignals.h \
		$(src)TKSim.h \
		$(src)TKStructs.h \
		$(src)TKSymbUtils.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKCommand.c -o $@ $(CFLAGS)

$(obj)TKData$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.c \
		$(src)TKData.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKData.c -o $@ $(CFLAGS)

$(obj)TKDebug$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKDebug.c \
		$(src)TKDebug.h \
		$(src)TKGlobals.h \
		$(src)TKIO.h \
		$(src)TKListFns.h \
		$(src)TKRecord.h \
		$(src)TKRegions.h \
		$(src)TKSignals.h \
		$(src)TKSim.h \
		$(src)TKStructs.h \
		$(src)TKSymbUtils.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKDebug.c -o $@ $(CFLAGS)

$(obj)TKDebugUtils$(objsfx) : \
		$(src)Copyright.h \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKDebugUtils.c \
		$(src)TKDebugUtils.h \
		$(src)TKFileUtils.h \
		$(src)TKGlobals.h \
		$(src)TKListFns.h \
		$(src)TKRegions.h \
		$(src)TKSignals.h \
		$(src)TKStructs.h \
		$(src)TKSymbUtils.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKDebugUtils.c -o $@ $(CFLAGS)

$(obj)TKElaborate$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKDebug.h \
		$(src)TKElaborate.c \
		$(src)TKGlobals.h \
		$(src)TKListFns.h \
		$(src)TKRegions.h \
		$(src)TKSignals.h \
		$(src)TKSim.h \
		$(src)TKStructs.h \
		$(src)TKSymbUtils.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKElaborate.c -o $@ $(CFLAGS)

$(obj)TKErrors$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKErrorCodes.g \
		$(src)TKErrorMap.g \
		$(src)TKErrors.c \
		$(src)TKErrors.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKErrors.c -o $@ $(CFLAGS)

$(obj)TKFileUtils$(objsfx) : \
		$(src)Copyright.h \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKFileUtils.c \
		$(src)TKFileUtils.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKFileUtils.c -o $@ $(CFLAGS)

$(obj)TKFiles$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKFiles.c \
		$(src)TKFiles.h \
		$(src)TKListFns.h \
		$(src)TKRegions.h \
		$(src)TKRegister.h \
		$(src)TKStructs.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKFiles.c -o $@ $(CFLAGS)

$(obj)TKGlobals$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKGlobals.c \
		$(src)TKGlobals.h \
		$(src)TKListFns.h \
		$(src)TKRegions.h \
		$(src)TKSignals.h \
		$(src)TKSim.h \
		$(src)TKStructs.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKGlobals.c -o $@ $(CFLAGS)

$(obj)TKIO$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKDebug.h \
		$(src)TKGlobals.h \
		$(src)TKIO.c \
		$(src)TKIO.h \
		$(src)TKListFns.h \
		$(src)TKRecord.h \
		$(src)TKRegions.h \
		$(src)TKRegister.h \
		$(src)TKSignals.h \
		$(src)TKSim.h \
		$(src)TKStructs.h \
		$(src)TKSymbUtils.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKIO.c -o $@ $(CFLAGS)

$(obj)TKListFns$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKErrorCodes.g \
		$(src)TKErrors.h \
		$(src)TKListFns.c \
		$(src)TKListFns.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKListFns.c -o $@ $(CFLAGS)

$(obj)TKMain$(objsfx) : \
		$(src)TKCommand.h \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKDebug.h \
		$(src)TKElaborate.h \
		$(src)TKErrorCodes.g \
		$(src)TKErrors.h \
		$(src)TKFiles.h \
		$(src)TKGlobals.h \
		$(src)TKIO.h \
		$(src)TKListFns.h \
		$(src)TKMain.c \
		$(src)TKParams.h \
		$(src)TKRecord.h \
		$(src)TKRegions.h \
		$(src)TKSignals.h \
		$(src)TKSim.h \
		$(src)TKStructs.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKElaborate.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKMain.c -o $@ $(CFLAGS)

$(obj)TKMisc$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKDebug.h \
		$(src)TKGlobals.h \
		$(src)TKIO.h \
		$(src)TKListFns.h \
		$(src)TKMisc.c \
		$(src)TKRegions.h \
		$(src)TKSignals.h \
		$(src)TKSim.h \
		$(src)TKStructs.h \
		$(src)TKSymbUtils.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKMisc.c -o $@ $(CFLAGS)

$(obj)TKParams$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKParams.c \
		$(src)TKParams.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKParams.c -o $@ $(CFLAGS)

$(obj)TKProcesses$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKGlobals.h \
		$(src)TKIO.h \
		$(src)TKListFns.h \
		$(src)TKProcesses.c \
		$(src)TKProcesses.h \
		$(src)TKRegions.h \
		$(src)TKSignals.h \
		$(src)TKSim.h \
		$(src)TKStructs.h \
		$(src)TKSymbUtils.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKProcesses.c -o $@ $(CFLAGS)

$(obj)TKRecord$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKDebug.h \
		$(src)TKGlobals.h \
		$(src)TKListFns.h \
		$(src)TKRecord.c \
		$(src)TKRecord.h \
		$(src)TKRegions.h \
		$(src)TKSignals.h \
		$(src)TKSim.h \
		$(src)TKStructs.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKRecord.c -o $@ $(CFLAGS)

$(obj)TKRegions$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKGlobals.h \
		$(src)TKListFns.h \
		$(src)TKRegions.c \
		$(src)TKRegions.h \
		$(src)TKSignals.h \
		$(src)TKStructs.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKRegions.c -o $@ $(CFLAGS)

$(obj)TKRegister$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKDebug.h \
		$(src)TKGlobals.h \
		$(src)TKListFns.h \
		$(src)TKRecord.h \
		$(src)TKRegions.h \
		$(src)TKRegister.c \
		$(src)TKRegister.h \
		$(src)TKSignals.h \
		$(src)TKSim.h \
		$(src)TKStructs.h \
		$(src)TKSymbUtils.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKRegister.c -o $@ $(CFLAGS)

$(obj)TKSignals$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKGlobals.h \
		$(src)TKIO.h \
		$(src)TKListFns.h \
		$(src)TKProcesses.h \
		$(src)TKRegions.h \
		$(src)TKRegister.h \
		$(src)TKSignals.c \
		$(src)TKSignals.h \
		$(src)TKSim.h \
		$(src)TKStructs.h \
		$(src)TKSymbUtils.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKSignals.c -o $@ $(CFLAGS)

$(obj)TKSim$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKDebug.h \
		$(src)TKErrorCodes.g \
		$(src)TKErrors.h \
		$(src)TKGlobals.h \
		$(src)TKIO.h \
		$(src)TKListFns.h \
		$(src)TKRecord.h \
		$(src)TKRegions.h \
		$(src)TKSignals.h \
		$(src)TKSim.c \
		$(src)TKSim.h \
		$(src)TKStructs.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKSim.c -o $@ $(CFLAGS)

$(obj)TKSymbUtils$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKGlobals.h \
		$(src)TKIO.h \
		$(src)TKListFns.h \
		$(src)TKRegions.h \
		$(src)TKSignals.h \
		$(src)TKStructs.h \
		$(src)TKSymbUtils.c \
		$(src)TKSymbUtils.h \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKSymbUtils.c -o $@ $(CFLAGS)

$(obj)TKTemp$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKData.h \
		$(src)TKDebug.h \
		$(src)TKGlobals.h \
		$(src)TKIO.h \
		$(src)TKListFns.h \
		$(src)TKRecord.h \
		$(src)TKRegions.h \
		$(src)TKSignals.h \
		$(src)TKSim.h \
		$(src)TKStructs.h \
		$(src)TKSymbUtils.h \
		$(src)TKTemp.c \
		$(src)TKTemp.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKTemp.c -o $@ $(CFLAGS)

$(obj)TKTemplate$(objsfx) : \
		$(src)TKCommon.h \
		$(src)TKTemplate.c \
		$(src)TKTemplate.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKTemplate.c -o $@ $(CFLAGS)

$(obj)TKUnitInfo$(objsfx) : \
		$(src)TKUnitInfo.c \
		$(src)TKUnitInfo.h \
		$(src)VKBasicTypes.h \
		$(src)VKCodeIntf.h \
		$(src)VKConfig.h \
		$(src)VKFiles.h \
		$(src)VKI.h \
		$(src)VKMisc.h \
		$(src)VKProcesses.h \
		$(src)VKRegister.h \
		$(src)VKSignals.h \
		$(src)VKSymbTypes.h \
		$(src)VKTrace.h 
	$(CC) $(src)TKUnitInfo.c -o $@ $(CFLAGS)

$(obj)wts$(objsfx) : \
		$(src)wts.c 
	$(CC) $(src)wts.c -o $@ $(CFLAGS)

