--##*************************************************************************
--
--+ File: RVCG:[work/tests/project/step_tests]step01.vhdl
--
--+ Copyright: (c) 1991 by CAD Language Systems, Inc. All rights reserved.
--
--+ LRM_Version: IEEE Std. 1076-1987 (incl. "Sense of the VASG" I)
--
--+ Subsets: None
--
--+ Description: 
--
--+ Test_point -  (None)
--
--+ Test_objective - 
--
--+ References: 
--
--+ Instructions: 
--
--+ Keywords: 
--
--+ Test_Results: 
--
--+ Test_Type: 
--
--+ History: AWH/CLSI 12-Apr-91 - Test header automatically added
--
--+ Comments: 
--***********************************************************     
-- Begin test: >>>
---------------------------------------------------------------------------
-- This is part of CLSI's Retargetable VHDL Code Generator.
--
-- File: Step01.vhdl
--
-- Test case: Minimal Example
--
-- VHDL Kernel Interface features exercised:
--	process creation
--	assertion violation
--	permanent wait
---------------------------------------------------------------------------

entity step01 is
end step01; -- entity


architecture a of step01 is
begin
-- Test 1: processes should execute
-- Test 2: assertion violations should be reported
-- Test 3: permanent wait should never wake up

  P1:
    process					-- create process
    begin
	assert FALSE				-- force assertion violation
	    report "PASS: Step01 test 1a: One process process executes"
	    severity NOTE;


	assert FALSE 				-- force assertion violation
	    report "PASS: Step01 test 2a: This is a test (note)"
						-- print this message
	    severity NOTE;			-- with this severity

	assert FALSE 				-- force assertion violation
	    report "PASS: Step01 test 2b: This is a test (warning)"
						-- print this message
	    severity WARNING;			-- with this severity

	assert FALSE 				-- force assertion violation
	    report "PASS: Step01 test 2c: This is a test (error)"
						-- print this message
	    severity ERROR;			-- with this severity

	assert FALSE 				-- force assertion violation
	    report "PASS: Step01 test 2d: This is a test (failure)"
						-- print this message
	    severity FAILURE;			-- with this severity

	wait;					-- wait forever
	assert FALSE
	    report "FAIL: Step01 test 3: 'wait;' did not suspend permanently."
	    severity FAILURE;
    end process;

  P2:
    process					-- create one process
    begin
	assert FALSE
	    report "PASS: Step01 test 1b: Other process executes"
	    severity NOTE;

	-- Note: It does not matter which process executes first. (The order 
	--	of process execution is not defined by the LRM, and dependence
	--	on the execution order is not allowed.)

	wait;					-- wait forever
    end process;

end a; -- architecture
