--##*************************************************************************
--
--+ File: RVCG:[work/tests/project/step_tests]step02.vhdl
--
--+ Copyright: (c) 1991 by CAD Language Systems, Inc. All rights reserved.
--
--+ LRM_Version: IEEE Std. 1076-1987 (incl. "Sense of the VASG" I)
--
--+ Subsets: None
--
--+ Description: 
--
--+ Test_point -  (None)
--
--+ Test_objective - 
--
--+ References: 
--
--+ Instructions: 
--
--+ Keywords: 
--
--+ Test_Results: 
--
--+ Test_Type: 
--
--+ History: AWH/CLSI 12-Apr-91 - Test header automatically added
--
--+ Comments: 
--***********************************************************     
-- Begin test: >>>
---------------------------------------------------------------------------
-- This is part of CLSI's Retargetable VHDL Code Generator.
--
-- File: Step02.vhdl
--
-- Test case: Simple Signal Assignments
--
-- VHDL Kernel Interface features exercised:
--	signal creation, with initial value
--	reading signal (initial value only because no waits yet)
--	driver creation
--	signal future value scheduling
---------------------------------------------------------------------------

entity step02 is
end step02; -- entity


architecture a of step02 is
    signal Bool_1 : BOOLEAN;		-- default initial value of FALSE
    signal Bool_2 : BOOLEAN := TRUE;	-- explicit initial value of TRUE

					-- next first have initial value FALSE
    signal delta_1 : BOOLEAN;
    signal inertial_1 : BOOLEAN;
    signal transport_1 : BOOLEAN;
    signal inertial_2 : BOOLEAN;
    signal transport_2 : BOOLEAN;

begin
-- Test 1: that initial values are set
    process				-- check initial values of signals
    begin
	assert not Bool_1 report 
		"FAIL: Step02 test 1a:  Initial value of Bool_1 is not FALSE";
					-- can check initial value of Bool_1
	assert Bool_2 report
		"FAIL: Step02 test 1b:  Initial value of Bool_2 is not TRUE";
					-- can check initial value of Bool_2
	wait;				-- wait forever
    end process;

-- Test 2: simple "delta" delay
-- Test 3, 5: simple inertial delay
-- Test 4, 6: simple transport delay
    process
    begin
	delta_1	   <= 		 TRUE after 0 ns;
						-- rise at 0ns + 1 cycle

	inertial_1  <= 		 TRUE after 10 ns;	-- rise at 10 ns
	transport_1 <= transport TRUE after 10 ns;	-- rise at 10 ns
					-- Note: In this example, there is no
					--	difference between transport 
					--	and inertial delay

	inertial_2  <= 		 FALSE after 20 ns;	-- stay low at 20 ns
	transport_2 <= transport FALSE after 20 ns;	-- stay low at 20 ns
					-- Note: In this example, there is no
					--	difference between transport 
					--	and inertial delay

	assert FALSE
	 report	"CHECK: Step02 test 2: that delta_1 rises at 0 ns + 1 cycle" 
		severity NOTE;
	assert FALSE 
		report "CHECK: Step02 test 3: that inertial_1 rises at 10 ns" 
		severity NOTE;
	assert FALSE 
		report "CHECK: Step02 test 4: that transport_1 rises at 10 ns" 
		severity NOTE;

	assert FALSE 
	 report "CHECK: Step02 test 5: that inertial_2 remains low at 20 ns" 
		severity NOTE;
	assert FALSE 
	 report "CHECK: Step02 test 6: that transport_2 remains low at 20 ns" 
		severity NOTE;
					-- Note: A VHDL transaction occurs
					--	at 20 ns, event though there is
					-- 	no VHDL event.


	wait;					-- wait forever
    end process;

end a; -- architecture
