--##*************************************************************************
--
--+ File: RVCG:[work/tests/project/step_tests]step03.vhdl
--
--+ Copyright: (c) 1991 by CAD Language Systems, Inc. All rights reserved.
--
--+ LRM_Version: IEEE Std. 1076-1987 (incl. "Sense of the VASG" I)
--
--+ Subsets: None
--
--+ Description: 
--
--+ Test_point -  (None)
--
--+ Test_objective - 
--
--+ References: 
--
--+ Instructions: 
--
--+ Keywords: 
--
--+ Test_Results: 
--
--+ Test_Type: 
--
--+ History: AWH/CLSI 12-Apr-91 - Test header automatically added
--
--+ Comments: 
--***********************************************************     
-- Begin test: >>>
---------------------------------------------------------------------------
-- This is part of CLSI's Retargetable VHDL Code Generator.
--
-- File: Step03.vhdl
--
-- Test case: Simple Signal Assignments
--
-- VHDL Kernel Interface features exercised:
--	multiple-element waveforms
---------------------------------------------------------------------------

entity step03 is
end step03; -- entity


architecture a of step03 is
    signal deltaN : BOOLEAN;
    signal inertialN : BOOLEAN;
    signal transportN : BOOLEAN;

    signal int_signal : INTEGER := 0;

					-- arbitrary scalar types
    type enum_type is ('0', '1', 'B', 'a', 'A', A, long_literal);
    signal enum_signal : enum_type;		-- initial value is '0'

    signal time_signal : TIME := 0 ns;

begin
    process				-- assign various waveforms
    begin
-- Test 1: multiple elements with initial delta delay
	deltaN		<= 		TRUE after 0 ns, FALSE after 20 ns;
					-- should rise at 0 ns + 1 cycle
					-- should fall at 20 ns

-- Test 2: multiple elements with initial inertial delay
	inertialN	<= 		TRUE after 10 ns, FALSE after 20 ns;
					-- should rise at 10 ns
					-- should fall at 20 ns
			
-- Test 3: multiple elements with initial transport delay
	transportN	<= transport	TRUE after 10 ns, FALSE after 20 ns;
					-- should rise at 10 ns
					-- should fall at 20 ns


-- Test 4: signal of integer type
	int_signal  <= 1 after 10 ns, 2 after 20 ns, 99 after 30 ns;

-- Test 5: signal of enumeration type
	enum_signal <= 
		'1' after 20 ns, 'B' after 30 ns, 
		'a' after 40 ns, 'A' after 50 ns, A after 60 ns, 
		long_literal after 70 ns;
					-- enum_lit_1 = '0' initially
					-- then other values

-- Test 6: signal of physical type
	time_signal <= 	1 fs after 10 ns, 1 ps after 20 ns, 
			1 ns after 30 ns, 1 us after 40 ns;
	    -- 1 ps = 1000 fs, 1 ns = 1,000,000 fs, and 1 us = 1,000,000,000 fs

	assert False
	    report "CHECK: Step03 tests: that signal rise and fall correctly" 
	    severity NOTE;
	wait;					-- wait forever
    end process;

end a; -- architecture
