--##*************************************************************************
--
--+ File: RVCG:[work/tests/project/step_tests]step04.vhdl
--
--+ Copyright: (c) 1991 by CAD Language Systems, Inc. All rights reserved.
--
--+ LRM_Version: IEEE Std. 1076-1987 (incl. "Sense of the VASG" I)
--
--+ Subsets: None
--
--+ Description: 
--
--+ Test_point -  (None)
--
--+ Test_objective - 
--
--+ References: 
--
--+ Instructions: 
--
--+ Keywords: 
--
--+ Test_Results: 
--
--+ Test_Type: 
--
--+ History: AWH/CLSI 12-Apr-91 - Test header automatically added
--
--+ Comments: 
--***********************************************************     
-- Begin test: >>>
---------------------------------------------------------------------------
-- This is part of CLSI's Retargetable VHDL Code Generator.
--
-- File: Step04.vhdl
--
-- Test case: Simple Wait on Event
--
-- VHDL Kernel Interface features exercised:
--	set process sensitivity
--	wait on event
---------------------------------------------------------------------------

entity step04 is
end step04; -- entity


architecture a of step04 is
    signal clock1, clock2 : BIT := '0';
    signal sense_p1, sense_p2, sense_p3 : BIT;
 
begin
					-- first set up some waveforms
    clock1	<= '1' after 10 ns, '0' after 20 ns,
		   '1' after 30 ns, '0' after 40 ns;
    clock2	<= '1' after 15 ns, '0' after 25 ns,
		   '1' after 35 ns, '0' after 45 ns;

-- Test 1: wait on one signal, then wait forever
 P1:
    process
    begin
	wait on clock1;			-- wait for '0' after 10 ns
	assert clock1 = '1'
	    report "FAIL: Step04 test 1a: wait on clock1 failed";
	sense_p1 <= clock1 after 1 ns;	-- copy value (to sense signal)

	wait;				-- forever
	assert clock1 = '1'
	    report "FAIL: Step04 test 1b: wait forever failed";
    end process;


-- Test 2: wait on one signal, repeated
    assert FALSE
	report 
	  "CHECK: Step04 test 2: check that sense_p2 follows clock1 after 1 ns"
	severity NOTE;
 P2:
    process
    begin
	wait on clock1;			-- wait for any change 
	sense_p2 <= clock1 after 1 ns;	-- copy value (to sense signal)
    end process;

-- Test 3: wait on set of signals, repeated
    assert FALSE
	report 
	  "CHECK: Step04 test 3: check that sense_p3 follows clock1 or clock 2 after 2 ns"
	severity NOTE;
 P3:
    process				-- wait on multiple signals
    begin
	wait on clock1, clock2;		-- wait for change on either
	sense_p3 <= clock1 and clock2 after 2 ns;
					-- (to sense signal)
    end process;

end a; -- architecture
