--##*************************************************************************
--
--+ File: RVCG:[work/tests/project/step_tests]step05.vhdl
--
--+ Copyright: (c) 1991 by CAD Language Systems, Inc. All rights reserved.
--
--+ LRM_Version: IEEE Std. 1076-1987 (incl. "Sense of the VASG" I)
--
--+ Subsets: None
--
--+ Description: 
--
--+ Test_point -  (None)
--
--+ Test_objective - 
--
--+ References: 
--
--+ Instructions: 
--
--+ Keywords: 
--
--+ Test_Results: 
--
--+ Test_Type: 
--
--+ History: AWH/CLSI 12-Apr-91 - Test header automatically added
--
--+ Comments: 
--***********************************************************     
-- Begin test: >>>
---------------------------------------------------------------------------
-- This is part of CLSI's Retargetable VHDL Code Generator.
--
-- File: Step05.vhdl
--
-- Test case: STD.Standard.NOW (Read Simulation Time)
--
-- VHDL Kernel Interface features exercised:
--	read simulation time
---------------------------------------------------------------------------

entity step05 is
end step05; -- entity


architecture a of step05 is
    signal S : BIT;
    signal T : TIME := 0 ns;
 
begin
 P1:
    process
    begin
-- Test 1: NOW should be zero during simulation initialization
	if NOW = 0 ns then
	    assert FALSE report "PASS: Step05 test 1" severity NOTE;
	else
	    assert FALSE
	    	report "FAIL: Step05 test 1: initial time is not zero";
	end if;
	T <= NOW;			-- will take effect one cycle late

-- Test 2: NOW should not change between cycles if time does not advance
	S <= not S;
	wait on S;			-- 0 ns plus one sim. cycle (delta)

	if NOW = 0 ns then
	    assert FALSE report "PASS: Step05 test 1" severity NOTE;
	else
	    assert FALSE
		report "FAIL: Step05 test 2: time is not still zero";
	end if;
	T <= NOW;

-- Test 3: NOW should change if time advances
	S <= not S after 10 ns;
	wait on S;			-- 10 ns (plus zero delta)

	if NOW = 10 ns then
	    assert FALSE report "PASS: Step05 test 1" severity NOTE;
	else
	    assert FALSE report "FAIL: Step05 test 3: time is not 10 ns";
	end if;
	T <= NOW;

-- Test 4: NOW should change if time advances
	S <= not s after 1 us;
	wait on S;			-- 1010 ns (plus zero delta)

	if NOW = 10 ns + 1 us then
	    assert FALSE report "PASS: Step05 test 1" severity NOTE;
	else
	    assert FALSE
	    	report "FAIL: Step05 test 4 failed time is not 1 us + 10 ns";
	end if;
	T <= NOW;

	wait;				-- forever
    end process;

end a; -- architecture
