--##*************************************************************************
--
--+ File: RVCG:[work/tests/project/step_tests]step10.vhdl
--
--+ Copyright: (c) 1991 by CAD Language Systems, Inc. All rights reserved.
--
--+ LRM_Version: IEEE Std. 1076-1987 (incl. "Sense of the VASG" I)
--
--+ Subsets: None
--
--+ Description: 
--
--+ Test_point -  (None)
--
--+ Test_objective - 
--
--+ References: 
--
--+ Instructions: 
--
--+ Keywords: 
--
--+ Test_Results: 
--
--+ Test_Type: 
--
--+ History: AWH/CLSI 12-Apr-91 - Test header automatically added
--
--+ Comments: 
--***********************************************************     
-- Begin test: >>>
---------------------------------------------------------------------------
-- This is part of CLSI's Retargetable VHDL Code Generator.
--
-- File: Step10.vhdl
--
-- Test case: Implicit Signals
--
-- VHDL Kernel Interface features exercised:
--	create implicit signals 'Transaction, 'Quiet, 'Stable, 'Delayed
--	read signal for implicit signals
---------------------------------------------------------------------------

entity step10 is
end step10; -- entity


architecture a of step10 is
    signal done : BIT := '0';
    signal clock : BIT := '0';

begin
    process
    begin
	clock <= 
		'0' after 100 ns, 
		'1' after 110 ns,
		'1' after 120 ns,
		'0' after 200 ns, 
		'1' after 230 ns,
		'1' after 260 ns,
		'0' after 300 ns, 
		'1' after 320 ns,
		'1' after 340 ns;	-- set up some non-delta waveforms

					-- do some delta-delayed transactions

	wait for 500 ns - NOW;		-- time is 500 ns
	clock <= '0' after 0 ns;	-- change at 500 ns + 1 cycle

	wait for 0 ns;			-- time is now 500 ns + 1 cycle
	clock <= '1' after 0 ns;	-- change at 500 ns + 2 cycles
	

	wait for 1000 ns - NOW;
	done <= '1';
	wait;
    end process;

 P1:
    process(clock)
	variable sink_bool : BOOLEAN;
	variable sink_bit : BIT;
    begin
					-- create various implicit signals
					-- by refering to them
	sink_bit  := clock'TRANSACTION;
	sink_bool := clock'QUIET(0 ns);
	sink_bool := clock'STABLE(0 ns);
	sink_bit  := clock'DELAYED(0 ns);

	sink_bool := clock'QUIET(20 ns);
	sink_bool := clock'STABLE(20 ns);
	sink_bit  := clock'DELAYED(20 ns);

	sink_bool := clock'STABLE'STABLE;

	sink_bool := clock'STABLE'DELAYED(1 ns);
    end process;


-- Test1: Self test for clock'QUIET(0 ns)
check_quiet_0:
    process
	variable okay : BOOLEAN;
    begin
	okay := TRUE;
	if clock'QUIET /= TRUE then
	    okay := FALSE;
	    assert FALSE report	"FAIL: Step10 test 1a: 'QUIET is wrong";
	end if;

	loop -- UNTIL TRUE

	    wait on done, clock'QUIET;
	    if NOW /= 100 ns or clock'QUIET /= FALSE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1b: 'QUIET is wrong";
		exit;
	    end if;
	    wait on done, clock'QUIET;
	    if NOW /= 100 ns or clock'QUIET /= TRUE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1b: 'QUIET is wrong";
		exit;
	    end if;
    
	    wait on done, clock'QUIET;
	    if NOW /= 110 ns or clock'QUIET /= FALSE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1c: 'QUIET is wrong";
		exit;
	    end if;
	    wait on done, clock'QUIET;
	    if NOW /= 110 ns or clock'QUIET /= TRUE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1c: 'QUIET is wrong";
		exit;
	    end if;

	    wait on done, clock'QUIET;
	    if NOW /= 120 ns or clock'QUIET /= FALSE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1d: 'QUIET is wrong";
		exit;
	    end if;
	    wait on done, clock'QUIET;
	    if NOW /= 120 ns or clock'QUIET /= TRUE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1d: 'QUIET is wrong";
		exit;
	    end if;
    
	    wait on done, clock'QUIET;
	    if NOW /= 200 ns or clock'QUIET /= FALSE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1e: 'QUIET is wrong";
		exit;
	    end if;
	    wait on done, clock'QUIET;
	    if NOW /= 200 ns or clock'QUIET /= TRUE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1e: 'QUIET is wrong";
		exit;
	    end if;
    
	    wait on done, clock'QUIET;
	    if NOW /= 230 ns or clock'QUIET /= FALSE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1f: 'QUIET is wrong";
		exit;
	    end if;
	    wait on done, clock'QUIET;
	    if NOW /= 230 ns or clock'QUIET /= TRUE then
		okay := FALSE;
		exit;
		assert FALSE report "FAIL: Step10 test 1f: 'QUIET is wrong";
	    end if;
    
	    wait on done, clock'QUIET;
	    if NOW /= 260 ns or clock'QUIET /= FALSE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1g: 'QUIET is wrong";
		exit;
	    end if;
	    wait on done, clock'QUIET;
	    if NOW /= 260 ns or clock'QUIET /= TRUE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1g: 'QUIET is wrong";
		exit;
	    end if;
    
	    wait on done, clock'QUIET;
	    if NOW /= 300 ns or clock'QUIET /= FALSE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1h: 'QUIET is wrong";
		exit;
	    end if;
	    wait on done, clock'QUIET;
	    if NOW /= 300 ns or clock'QUIET /= TRUE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1h: 'QUIET is wrong";
		exit;
	    end if;
    
	    wait on done, clock'QUIET;
	    if NOW /= 320 ns or clock'QUIET /= FALSE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1i: 'QUIET is wrong";
		exit;
	    end if;
	    wait on done, clock'QUIET;
	    if NOW /= 320 ns or clock'QUIET /= TRUE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1i: 'QUIET is wrong";
		exit;
	    end if;
    
	    wait on done, clock'QUIET;
	    if NOW /= 340 ns or clock'QUIET /= FALSE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1j: 'QUIET is wrong";
		exit;
	    end if;
	    wait on done, clock'QUIET;
	    if NOW /= 340 ns or clock'QUIET /= TRUE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1j: 'QUIET is wrong";
		exit;
	    end if;
    
	    wait on done, clock'QUIET;
					-- should go FALSE at 500 ns + 0 cycles
	    if NOW /= 500 ns or clock'QUIET /= FALSE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1k: 'QUIET is wrong";
		exit;
	    end if;
	    wait for 0 ns;
					-- should be FALSE at 500 ns + 1 cycle
	    if NOW /= 500 ns or clock'QUIET /= FALSE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1l: 'QUIET is wrong";
		exit;
	    end if;
	    wait on done, clock'QUIET;
					-- should go TRUE at 500 ns + 2 cycles
	    if NOW /= 500 ns or clock'QUIET /= TRUE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1m: 'QUIET is wrong";
		exit;
	    end if;
    
	    wait on done, clock'QUIET;
	    if NOW /= 1000 ns or clock'QUIET /= TRUE then
		okay := FALSE;
		assert FALSE report "FAIL: Step10 test 1n: 'QUIET is wrong";
		exit;
	    end if;

	    exit;
	end loop;

	if okay then
	    assert FALSE report "PASS: Step10 tests 1a-1n" severity NOTE;
	end if;
	wait;	
    end process;

-- Tests 2-x: check output waveforms for other signals

end a; -- architecture
