--##*************************************************************************
--
--+ File: RVCG:[work/tests/project/step_tests]step11.vhdl
--
--+ Copyright: (c) 1991 by CAD Language Systems, Inc. All rights reserved.
--
--+ LRM_Version: IEEE Std. 1076-1987 (incl. "Sense of the VASG" I)
--
--+ Subsets: None
--
--+ Description: 
--
--+ Test_point -  (None)
--
--+ Test_objective - 
--
--+ References: 
--
--+ Instructions: 
--
--+ Keywords: 
--
--+ Test_Results: 
--
--+ Test_Type: 
--
--+ History: AWH/CLSI 12-Apr-91 - Test header automatically added
--
--+ Comments: 
--***********************************************************     
-- Begin test: >>>
---------------------------------------------------------------------------
-- This is part of CLSI's Retargetable VHDL Code Generator.
--
-- File: Step11.vhdl
--
-- Test case: Guard Expressions and Implicit GUARD Signals
--
-- VHDL Kernel Interface features exercised:
--	create implicit guard signal
---------------------------------------------------------------------------

entity step11 is
end step11;


architecture a of step11 is


begin
 G1:
  block
    signal input : INTEGER := -2;
    signal latch : INTEGER := -1;
    signal clock : BIT := '0';
  begin
    input <= 1 after 25 ns, 2 after 75 ns, 3 after 150 ns;
					-- set up sample input for latch

    clock <= 				-- set up clock for latch, etc.
	'1' after  50 ns,
	'0' after 100 ns, 
	'1' after 150 ns,
	'0' after 200 ns, 
	'1' after 250 ns,
	'0' after 300 ns, 
	'1' after 350 ns;


-- Test 1: check that simple guard works
  B:
    block (clock = '1')
    begin
	latch <= guarded input after 5 ns;	-- latch input on high clock
      compare:
-- BOOLEAN waveform for GUARD should match BIT waveform for clock
	assert GUARD = ('1' = clock) 
		report "FAIL: Step11 test 1: GUARD doesn't match expression";
    end block;

  end block;

 Gn:
  block
    signal clock1 : BIT := '0';
    signal clock2 : BIT := '0';
  begin

    clock1 <= 
	'1' after  50 ns,
	'0' after 100 ns, 
	'1' after 150 ns,
	'0' after 200 ns, 
	'1' after 250 ns,
	'0' after 300 ns, 
	'1' after 350 ns;

    clock2 <= 
	'1' after  55 ns,
	'0' after 105 ns, 
	'1' after 155 ns,
	'0' after 205 ns, 
	'1' after 255 ns,
	'0' after 305 ns, 
	'1' after 355 ns;

-- Test 2: check that multi-signal guard works
  B:
    block ((clock1 xor clock2) = '1')
    begin
      compare:
-- BOOLEAN waveform for GUARD should match XOR of clock waveforms
	assert GUARD = ('1' = (clock1 xor clock2)) 
		report "FAIL: Step11 test 2: GUARD doesn't match expression";
    end block;

  end block;

 Gi:
  block
    signal clock : BIT := '0';
  begin

    clock <= 
	'1' after  50 ns,
	'0' after 100 ns, 
	'1' after 150 ns,
	'0' after 200 ns, 
	'1' after 250 ns,
	'0' after 300 ns, 
	'1' after 350 ns;

-- Test 3: check that implicit signal in guard expression works
  B:
    block (clock = '1' and not clock'STABLE)
    begin
      compare:
-- BOOLEAN waveform for GUARD should match ...
	assert GUARD = (clock = '1' and not clock'STABLE) report 
	    "FAIL: Step11 test 3: GUARD doesn't match guard expression";
    end block;

  end block;

end a; -- architecture
