--##*************************************************************************
--
--+ File: RVCG:[work/tests/project/step_tests]step14.vhdl
--
--+ Copyright: (c) 1991 by CAD Language Systems, Inc. All rights reserved.
--
--+ LRM_Version: IEEE Std. 1076-1987 (incl. "Sense of the VASG" I)
--
--+ Subsets: None
--
--+ Description: 
--
--+ Test_point -  (None)
--
--+ Test_objective - 
--
--+ References: 
--
--+ Instructions: 
--
--+ Keywords: 
--
--+ Test_Results: 
--
--+ Test_Type: 
--
--+ History: AWH/CLSI 12-Apr-91 - Test header automatically added
--
--+ Comments: 
--***********************************************************     
-- Begin test: >>>
---------------------------------------------------------------------------
-- This is part of CLSI's Retargetable VHDL Code Generator.
--
-- File: Step14.vhdl
--
-- Test case: Simple Vector Signals
--
-- VHDL Kernel Interface features exercised:
--  vector signal creation, with initial value
--  reading signal (initial value only because no waits yet)
--  driver creation
--  signal future value scheduling
---------------------------------------------------------------------------

entity step14 is
end step14;

architecture a of step14 is

    type anon_array is array (INTEGER range <>) of BOOLEAN;
    subtype Bool_V is anon_array(1 to 4);
                                -- constants...
    constant False_V : Bool_V := (others => FALSE);
    constant True_V  : Bool_V := (others => TRUE);

                                -- default initial value;
    signal Bool_1 : Bool_V;
                                -- explicit initial value;
    signal Bool_2 : Bool_V := True_V;

begin
                                -- Assign future values to vectors
    Bool_1(2 to 3) <= TRUE & FALSE after 10ns;
    Bool_1(4)      <= TRUE         after 10ns;
    Bool_2(3 to 4) <= FALSE & TRUE after 10ns;

    process
    begin
                                -- Test 1: that initial values are set
        assert FALSE report "TEST: Step14 test 1: for initial values."
            severity NOTE;

        if not (Bool_1 = False_V) then
            assert FALSE
                report "FAIL: Step14 test 1: bad default value for Bool_1.";
        elsif not (Bool_2 = True_V) then
            assert FALSE
                report "FAIL: Step14 test 1: bad explicit value for Bool_2.";
        else
            assert FALSE
                report "PASS: Step14 test 1" severity NOTE;
        end if;

                                -- Test 2: reading of slices and elements
        assert FALSE
            report "TEST: Step14 test 2: reading slices and elements."
            severity NOTE;

        if not (Bool_1(2) = FALSE) then
            assert FALSE
                report "FAIL: Step14 test 2: bad access to Bool_1(2).";
        elsif not (Bool_2(2 to 3) = TRUE & TRUE) then
            assert FALSE
                report "FAIL: Step14 test 2: bad access to Bool_2(2 to 3).";
        else
            assert FALSE
                report "PASS: Step14 test 2" severity NOTE;
        end if;

                                -- Test 3: check assignment to vectors
        wait for 10ns - NOW;

        assert FALSE report "TEST: Step14 test 3: assignment to vectors."
            severity NOTE;

        if not (Bool_1(1 to 3) = (FALSE, TRUE, FALSE)) then
            assert FALSE
                report "FAIL: Step14 test 3: bad assignment to Bool_1(2 to 3)";
        elsif not (Bool_1(4) = TRUE) then
            assert FALSE
                report "FAIL: Step14 test 3: bad assignment to Bool_1(4)";
        elsif not (Bool_2 = (TRUE, TRUE, FALSE, TRUE)) then
            assert FALSE
                report "FAIL: Step14 test 3: bad assignment to Bool_2(3 to 4)";
        else
            assert FALSE
                report "PASS: Step14 test 3" severity NOTE;
        end if;

        wait;                       -- wait forever
    end process;

end a;
