--##*************************************************************************
--
--+ File: RVCG:[work/tests/project/step_tests]step15.vhdl
--
--+ Copyright: (c) 1991 by CAD Language Systems, Inc. All rights reserved.
--
--+ LRM_Version: IEEE Std. 1076-1987 (incl. "Sense of the VASG" I)
--
--+ Subsets: None
--
--+ Description: 
--
--+ Test_point -  (None)
--
--+ Test_objective - 
--
--+ References: 
--
--+ Instructions: 
--
--+ Keywords: 
--
--+ Test_Results: 
--
--+ Test_Type: 
--
--+ History: AWH/CLSI 12-Apr-91 - Test header automatically added
--
--+ Comments: 
--***********************************************************     
-- Begin test: >>>
---------------------------------------------------------------------------
-- This is part of CLSI's Retargetable VHDL Code Generator.
--
-- File: Step15.vhdl
--
-- Test case: Dynamic Sensitivity to Vector Signals
--
-- VHDL Kernel Interface features exercised:
--  wait on event
---------------------------------------------------------------------------

entity step15 is
end step15;

architecture a of step15 is
    signal S, S1, S2: BIT_VECTOR (2 downto 0);

begin
                                -- assign future values of S
    S(2) <= '1' after 40ns;
    S(1) <= '1' after 20ns, '0' after 40ns, '1' after 60ns;
    S(0) <= '1' after 10ns, '0' after 20ns, '1' after 30ns, '0' after 40ns,
            '1' after 50ns, '0' after 60ns, '1' after 70ns;

                                -- assign future values of S1
    S1(2) <= '1' after 20ns, '0' after 25ns;
    S1(1) <= '1' after 30ns, '0' after 35ns;
    S1(0) <= '1' after 10ns, '0' after 15ns;
    
                                -- assign future values of S2
    S2(2) <= '1' after 20ns, '0' after 40 ns;
    S2(1) <= '1' after 15ns, '0' after 35 ns;
    S2(0) <= '1' after 10ns, '0' after 30 ns;

-- Test 1: two waits with same sensitivity to the same signal element

    T1: process
    begin

        assert FALSE
            report "TEST: Step15 test 1: waits on the same signal element."
            severity NOTE;

        wait on S(1);           -- wait for first event on S(1)

        if not (S(1) = '1') then
            assert FALSE
                report "FAIL: Step15 test 1a: wait on S(1) failed.";
        elsif not (NOW = 20ns) then
            assert FALSE
                report "FAIL: Step15 test 1a: wait on S(1) failed.";
        else
            assert FALSE
                report "PASS: Step15 test 1a" severity NOTE;
        end if;

        wait on S(1);           -- wait for next event on S(1)

        if not (S(1) = '0') then
            assert FALSE
                report "FAIL: Step15 test 1b: wait on S(1) failed.";
        elsif not (NOW = 40ns) then
            assert FALSE
                report "FAIL: Step15 test 1b: wait on S(1) failed.";
        else
            assert FALSE
                report "PASS: Step15 test 1b" severity NOTE;
        end if;

        wait;                   -- wait forever
    end process;

-- Test 2: two waits with different sensitivity to a single signal element

    T2: process
    begin

        assert FALSE
            report "TEST: Step15 test 2: waits on different signal elements."
            severity NOTE;

        wait on S(2);           -- wait on first event on S(2)

        if not (S(2) = '1') then
            assert FALSE
                report "FAIL: Step15 test 2a: wait on S(2) failed.";
        elsif not (NOW = 40ns) then
            assert FALSE
                report "FAIL: Step15 test 2a: wait on S(2) failed.";
        else
            assert FALSE
                report "PASS: Step15 test 2a" severity NOTE;
        end if;

        wait on S(0);           -- wait on next event on S(0)

        if not (S(0) = '1') then
            assert FALSE
                report "FAIL: Step15 test 2b: wait on S(0) failed.";
        elsif not (NOW = 50ns) then
            assert FALSE
                report "FAIL: Step15 test 2b: wait on S(0) failed.";
        else
            assert FALSE
                report "PASS: Step15 test 2b" severity NOTE;
        end if;
        
        wait;                   -- wait forever
    end process;

-- Test 3: two waits with sensitivity to multiple signal elements and slices

    T3: process
    begin

        assert FALSE
            report "TEST: Step15 test 3: waits on mult. elements and slices."
            severity NOTE;

        wait on S1(1), S1(0);   -- wait on multiple elements

        if not (S1 = B"001") then
            assert FALSE
                report "FAIL: Step15 test 3a: wait on S1(1), S1(0) failed.";
        elsif not (NOW = 10ns) then
            assert FALSE
                report "FAIL: Step15 test 3a: wait on S1(1), S1(0) failed.";
        else
            assert FALSE
                report "PASS: Step15 test 3a" severity NOTE;
        end if;

        wait on S1(2 downto 1); -- wait on a slice
                                -- NOTE: we are no longer sensitive to S(0)
        if not (S1 = ('1', '0', '0')) then
            assert FALSE
                report "FAIL: Step15 test 3b: wait on S1(2 downto 1) failed.";
        elsif not (NOW = 20ns) then
            assert FALSE
                report "FAIL: Step15 test 3b: wait on S1(2 downto 1) failed.";
        else
            assert FALSE
                report "PASS: Step15 test 3b" severity NOTE;
        end if;
        
        wait;                   -- wait forever
    end process;

-- Test 4: three waits with sensitivity to the entire vector

    T4: process
    begin
    
        assert FALSE report "TEST: Step15 test 4: waits on an entire vector."
            severity NOTE;

        wait on S2;             -- wait for first event on S2

        if not (S2 = ('0', '0', '1')) then
            assert FALSE
                report "FAIL: Step15 4a: didn't trigger on S(0).";
        elsif not (NOW = 10ns) then
            assert FALSE
                report "FAIL: Step15 4a: didn't trigger on S(0).";
        else
            assert FALSE
                report "PASS: Step15 4a" severity NOTE;
        end if;

        wait on S2;             -- wait for second event on S2

        if not (S2 = B"011") then
            assert FALSE
                report "FAIL: Step15 4b: didn't trigger on S(1).";
        elsif not (NOW = 15ns) then
            assert FALSE
                report "FAIL: Step15 4b: didn't trigger on S(1).";
        else
            assert FALSE
                report "PASS: Step15 4b" severity NOTE;
        end if;

        wait on S2;             -- wait for third event on S2

        if not (S2 = ('1', '1', '1')) then
            assert FALSE
                report "FAIL: Step15 4c: didn't trigger on S(2).";
        elsif not (NOW = 20ns) then
            assert FALSE
                report "FAIL: Step15 4c: didn't trigger on S(2).";
        else
            assert FALSE
                report "PASS: Step15 4c" severity NOTE;
        end if;

        wait;                   -- wait forever
    end process;
end a;
