--##*************************************************************************
--
--+ File: RVCG:[work/tests/project/step_tests]step19.vhdl
--
--+ Copyright: (c) 1991 by CAD Language Systems, Inc. All rights reserved.
--
--+ LRM_Version: IEEE Std. 1076-1987 (incl. "Sense of the VASG" I)
--
--+ Subsets: None
--
--+ Description: 
--
--+ Test_point -  (None)
--
--+ Test_objective - 
--
--+ References: 
--
--+ Instructions: 
--
--+ Keywords: 
--
--+ Test_Results: 
--
--+ Test_Type: 
--
--+ History: AWH/CLSI 12-Apr-91 - Test header automatically added
--
--+ Comments: 
--***********************************************************     
-- Begin test: >>>
---------------------------------------------------------------------------
--
-- File: Step19.vhdl
--
-- Test case: Unguarded vector signal resolution
--
-- VHDL Kernel Interface exercised:
--  simple resolution
--  resolution from overlapping drivers
---------------------------------------------------------------------------

entity step19 is
end step19;

architecture a of step19 is
    type Int_Vector is array (INTEGER range <>) of INTEGER;

    function resolve (input: Int_Vector) return INTEGER is
        variable sum: INTEGER;
    begin
        sum := 0;
        for i in input'RANGE loop
            sum := sum + input(i);
        end loop;
        return sum;
    end;

    subtype resolved_int is resolve INTEGER;
    type resolved_int_array is array(1 to 5) of resolved_int;

    signal S : resolved_int_array := (others => 1);
begin

                                -- assign future values of vector signals
    S(2 to 4)   <= (others => -1)       after 10ns;
    S(1 to 3)   <= (others => 3)        after 20ns;
    S(3 to 5)   <= (-1, others => 3)    after 30ns;
    
    P: process

        procedure Verify(test: STRING; IV: Int_Vector(1 to 5)) is
            variable okay: BOOLEAN := TRUE;
        begin
            for i in IV'RANGE loop
                if not (S(i) = IV(i)) then
                    assert FALSE
                        report "FAIL: Step19 test " & test & ": S(" &
            			CHARACTER'VAL(i + CHARACTER'POS('0')) &
                                ") didn't resolve correctly.";
                    okay := FALSE;
                end if;
            end loop;
            if okay then
                assert FALSE
                    report "PASS: Step19 test " & test severity NOTE;
            end if;
        end;

    begin
    
        Verify("1", (1, 2, 3, 2, 1));

        wait for 10ns - NOW;
        Verify("2", (1, 0, 1, 0, 1));

        wait for 20ns - NOW;
        Verify("3", (3, 2, 3, 0, 1));

        wait for 30ns - NOW;
        Verify("4", (3, 2, 1, 2, 3));

        wait;                   -- wait forever
    end process;

end a;
